    PROGRAM f07anfe

!      F07ANF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04dbf, zgesv
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, ldb, n
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
       CHARACTER (1)                   :: clabs(1), rlabs(1)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07ANF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ldb = n
       ALLOCATE (a(lda,n),b(ldb),ipiv(n))

!      Read A and B from data file

       READ (nin,*) (a(i,1:n),i=1,n)
       READ (nin,*) b(1:n)

!      Solve the equations Ax = b for x

!      The NAG name equivalent of zgesv is f07anf
       CALL zgesv(n,1,a,lda,ipiv,b,ldb,info)

       IF (info==0) THEN

!         Print solution

          WRITE (nout,*) 'Solution'
          WRITE (nout,99999) b(1:n)

!         Print details of factorization

          WRITE (nout,*)
          FLUSH (nout)

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04dbf('General',' ',n,n,a,lda,'Bracketed','F7.4', &
             'Details of factorization','Integer',rlabs,'Integer',clabs,80,0, &
             ifail)

!         Print pivot indices

          WRITE (nout,*)
          WRITE (nout,*) 'Pivot indices'
          WRITE (nout,99998) ipiv(1:n)
       ELSE
          WRITE (nout,99997) 'The (', info, ',', info, ')', &
             ' element of the factor U is zero'
       END IF

99999  FORMAT ((3X,4(' (',F7.4,',',F7.4,')':)))
99998  FORMAT (1X,7I11)
99997  FORMAT (1X,A,I3,A,I3,A,A)
    END PROGRAM f07anfe
