    PROGRAM f07befe

!      F07BEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dgbtrf, dgbtrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
       CHARACTER (1), PARAMETER        :: trans = 'N'
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, k, kl, ku, ldab,  &
                                          ldb, n, nrhs
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ab(:,:), b(:,:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Intrinsic Functions ..
       INTRINSIC                          max, min
!      .. Executable Statements ..
       WRITE (nout,*) 'F07BEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs, kl, ku
       ldab = 2*kl + ku + 1
       ldb = n
       ALLOCATE (ab(ldab,n),b(ldb,nrhs),ipiv(n))

!      Read A and B from data file

       k = kl + ku + 1
       READ (nin,*) ((ab(k+i-j,j),j=max(i-kl,1),min(i+ku,n)),i=1,n)
       READ (nin,*) (b(i,1:nrhs),i=1,n)

!      Factorize A
!      The NAG name equivalent of dgbtrf is f07bdf
       CALL dgbtrf(n,n,kl,ku,ab,ldab,ipiv,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Compute solution
!         The NAG name equivalent of dgbtrs is f07bef
          CALL dgbtrs(trans,n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)

!         Print solution

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

       ELSE
          WRITE (nout,*) 'The factor U is singular'
       END IF

    END PROGRAM f07befe
