    PROGRAM f07fafe

!      F07FAF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dposv, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07FAF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ALLOCATE (a(lda,n),b(n))

!      Read the upper triangular part of A from data file

       READ (nin,*) (a(i,i:n),i=1,n)

!      Read b from data file

       READ (nin,*) b(1:n)

!      Solve the equations Ax = b for x
!      The NAG name equivalent of dposv is f07faf
       CALL dposv('Upper',n,1,a,lda,b,n,info)

       IF (info==0) THEN

!         Print solution

          WRITE (nout,*) 'Solution'
          WRITE (nout,99999) b(1:n)

!         Print details of factorization

          WRITE (nout,*)
          FLUSH (nout)

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('Upper','Non-unit diagonal',n,n,a,lda, &
             'Cholesky factor U',ifail)

       ELSE
          WRITE (nout,99998) 'The leading minor of order ', info, &
             ' is not positive definite'
       END IF

99999  FORMAT ((3X,7F11.4))
99998  FORMAT (1X,A,I3,A)
    END PROGRAM f07fafe
