    PROGRAM f07fefe

!      F07FEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dpotrf, dpotrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, ldb, n, nrhs
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07FEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs
       lda = n
       ldb = n
       ALLOCATE (a(lda,n),b(ldb,nrhs))

!      Read A and B from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF
       READ (nin,*) (b(i,1:nrhs),i=1,n)

!      Factorize A
!      The NAG name equivalent of dpotrf is f07fdf
       CALL dpotrf(uplo,n,a,lda,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Compute solution
!         The NAG name equivalent of dpotrs is f07fef
          CALL dpotrs(uplo,n,nrhs,a,lda,b,ldb,info)

!         Print solution

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)
       ELSE
          WRITE (nout,*) 'A is not positive definite'
       END IF

    END PROGRAM f07fefe
