    PROGRAM f07fgfe

!      F07FGF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dlansy => f06rcf, dpocon, dpotrf, nag_wp, x02ajf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: anorm, rcond
       INTEGER                         :: i, info, lda, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), work(:)
       INTEGER, ALLOCATABLE            :: iwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07FGF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ALLOCATE (a(lda,n),work(3*n),iwork(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF

!      Compute norm of A
!      f06rcf is the NAG name equivalent of the LAPACK auxiliary dlansy
       anorm = dlansy('1-norm',uplo,n,a,lda,work)

!      Factorize A
!      The NAG name equivalent of dpotrf is f06fdf
       CALL dpotrf(uplo,n,a,lda,info)

       WRITE (nout,*)
       IF (info==0) THEN

!         Estimate condition number

!         The NAG name equivalent of dpocon is f07fgf
          CALL dpocon(uplo,n,a,lda,anorm,rcond,work,iwork,info)

          IF (rcond>=x02ajf()) THEN
             WRITE (nout,99999) 'Estimate of condition number =', &
                1.0_nag_wp/rcond
          ELSE
             WRITE (nout,*) 'A is singular to working precision'
          END IF
       ELSE
          WRITE (nout,*) 'A is not positive definite'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07fgfe
