    PROGRAM f07gufe

!      F07GUF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x02ajf, zlanhp => f06udf, zppcon, zpptrf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: anorm, rcond
       INTEGER                         :: i, info, j, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: ap(:), work(:)
       REAL (KIND=nag_wp), ALLOCATABLE :: rwork(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07GUF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n

       ALLOCATE (ap(n*(n+1)/2),work(2*n),rwork(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) ((ap(i+j*(j-1)/2),j=i,n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) ((ap(i+(2*n-j)*(j-1)/2),j=1,i),i=1,n)
       END IF

!      Compute norm of A
!      f06udf is the NAG name equivalent of the LAPACK auxiliary zlanhp
       anorm = zlanhp('1-norm',uplo,n,ap,rwork)

!      Factorize A
!      The NAG name equivalent of zpptrf is f07grf
       CALL zpptrf(uplo,n,ap,info)

       WRITE (nout,*)
       IF (info==0) THEN

!         Estimate condition number

!         The NAG name equivalent of zppcon is f07guf
          CALL zppcon(uplo,n,ap,anorm,rcond,work,rwork,info)

          IF (rcond>=x02ajf()) THEN
             WRITE (nout,99999) 'Estimate of condition number =', &
                1.0_nag_wp/rcond
          ELSE
             WRITE (nout,*) 'A is singular to working precision'
          END IF
       ELSE
          WRITE (nout,*) 'A is not positive definite'
       END IF

99999  FORMAT (1X,A,1P,E10.2)
    END PROGRAM f07gufe
