    PROGRAM f07hrfe

!      F07HRF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04dff, zpbtrf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, kd, ldab, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: ab(:,:)
       CHARACTER (1)                   :: clabs(1), rlabs(1)
!      .. Intrinsic Functions ..
       INTRINSIC                          max, min
!      .. Executable Statements ..
       WRITE (nout,*) 'F07HRF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, kd
       ldab = kd + 1
       ALLOCATE (ab(ldab,n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          DO i = 1, n
             READ (nin,*) (ab(kd+1+i-j,j),j=i,min(n,i+kd))
          END DO
       ELSE IF (uplo=='L') THEN
          DO i = 1, n
             READ (nin,*) (ab(1+i-j,j),j=max(1,i-kd),i)
          END DO
       END IF

!      Factorize A
!      The NAG name equivalent of zpbtrf is f07hrf
       CALL zpbtrf(uplo,n,kd,ab,ldab,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Print factor

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          IF (uplo=='U') THEN

             CALL x04dff(n,n,0,kd,ab,ldab,'Bracketed','F7.4','Factor', &
                'Integer',rlabs,'Integer',clabs,80,0,ifail)

          ELSE IF (uplo=='L') THEN

             CALL x04dff(n,n,kd,0,ab,ldab,'Bracketed','F7.4','Factor', &
                'Integer',rlabs,'Integer',clabs,80,0,ifail)

          END IF

       ELSE
          WRITE (nout,*) 'A is not positive definite'
       END IF

    END PROGRAM f07hrfe
