    PROGRAM f07mefe

!      F07MEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsytrf, dsytrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, ldb, lwork, n,  &
                                          nrhs
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:), work(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07MEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs
       lda = n
       ldb = n
       lwork = 64*n
       ALLOCATE (a(lda,n),b(ldb,nrhs),work(lwork),ipiv(n))

!      Read A and B from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF
       READ (nin,*) (b(i,1:nrhs),i=1,n)

!      Factorize A
!      The NAG name equivalent of dsytrf is f07mdf
       CALL dsytrf(uplo,n,a,lda,ipiv,work,lwork,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Compute solution
!         The NAG name equivalent of dsytrs is f07mef
          CALL dsytrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)

!         Print solution

!         ifail: behaviour on error exit
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

       ELSE
          WRITE (nout,*) 'The factor D is singular'
       END IF

    END PROGRAM f07mefe
