    PROGRAM f11mffe

!      F11MFF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : f11mdf, f11mef, f11mff, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       REAL (KIND=nag_wp), PARAMETER   :: one = 1.E0_nag_wp
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: flop, thresh
       INTEGER                         :: i, ifail, j, ldb, n, nnz, nnzl,      &
                                          nnzu, nrhs, nzlmx, nzlumx, nzumx
       CHARACTER (1)                   :: spec, trans
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:), b(:,:), lval(:), uval(:)
       INTEGER, ALLOCATABLE            :: icolzp(:), il(:), iprm(:),           &
                                          irowix(:), iu(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F11MFF Example Program Results'
       FLUSH (nout)
!      Skip heading in data file
       READ (nin,*)

!      Read order of matrix and number of right hand sides

       READ (nin,*) n, nrhs
       ldb = n

       ALLOCATE (b(ldb,nrhs),icolzp(n+1),iprm(7*n))

!      Read the matrix A

       READ (nin,*) icolzp(1:n+1)

       nnz = icolzp(n+1) - 1

       ALLOCATE (a(nnz),lval(8*nnz),uval(8*nnz),il(7*n+8*nnz+4),irowix(nnz), &
          iu(2*n+8*nnz+1))

       DO i = 1, nnz
          READ (nin,*) a(i), irowix(i)
       END DO

!      Read the right hand sides

       DO j = 1, nrhs
          READ (nin,*) b(1:n,j)
       END DO

!      Calculate COLAMD permutation

       spec = 'M'

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL f11mdf(spec,n,icolzp,irowix,iprm,ifail)

!      Factorise

       thresh = one
       ifail = 0
       nzlmx = 8*nnz
       nzlumx = 8*nnz
       nzumx = 8*nnz

       CALL f11mef(n,irowix,a,iprm,thresh,nzlmx,nzlumx,nzumx,il,lval,iu,uval, &
          nnzl,nnzu,flop,ifail)

!      Solve

       trans = 'N'

       ifail = 0
       CALL f11mff(trans,n,iprm,il,lval,iu,uval,nrhs,b,ldb,ifail)

!      Output results
       WRITE (nout,*)
       FLUSH (nout)

       CALL x04caf('G',' ',n,nrhs,b,ldb,'Solutions',ifail)

    END PROGRAM f11mffe
