    PROGRAM g02bmfe

!      G02BMF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g02bmf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, ldcnt, ldrz, ldsspz, ldx,  &
                                          m, n, ncases, nvars
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: cnt(:,:), rz(:,:), sspz(:,:),        &
                                          std(:), x(:,:), xbar(:), xmiss(:)
       INTEGER, ALLOCATABLE            :: kvar(:), miss(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'G02BMF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Read in the problem size
       READ (nin,*) n, m, nvars

       ldcnt = nvars
       ldrz = nvars
       ldsspz = nvars
       ldx = n
       ALLOCATE (cnt(ldcnt,nvars),rz(ldrz,nvars),sspz(ldsspz,nvars), &
          std(nvars),x(ldx,m),xbar(nvars),xmiss(m),kvar(nvars),miss(m))

!      Read in data
       READ (nin,*) (x(i,1:m),i=1,n)

!      Read in missing value flags
       READ (nin,*) miss(1:m)
       READ (nin,*) xmiss(1:m)

!      Read in column IDs
       READ (nin,*) kvar(1:nvars)

!      Display data
       WRITE (nout,99999) 'Number of variables (columns) =', m
       WRITE (nout,99999) 'Number of cases     (rows)    =', n
       WRITE (nout,*)
       WRITE (nout,*) 'Data matrix is:-'
       WRITE (nout,*)
       WRITE (nout,99998) (i,i=1,m)
       WRITE (nout,99997) (i,x(i,1:m),i=1,n)
       WRITE (nout,*)

!      Calculate summary statistics
       ifail = 0
       CALL g02bmf(n,m,x,ldx,miss,xmiss,nvars,kvar,xbar,std,sspz,ldsspz,rz, &
          ldrz,ncases,cnt,ldcnt,ifail)

!      Display results
       WRITE (nout,*) 'Variable   Mean    St. dev.'
       WRITE (nout,99995) (kvar(i),xbar(i),std(i),i=1,nvars)
       WRITE (nout,*)
       WRITE (nout,*) 'Sums of squares and cross-products about' // ' zero'
       WRITE (nout,99998) kvar(1:nvars)
       WRITE (nout,99996) (kvar(i),sspz(i,1:nvars),i=1,nvars)
       WRITE (nout,*)
       WRITE (nout,*) 'Correlation-like coefficients'
       WRITE (nout,99998) kvar(1:nvars)
       WRITE (nout,99996) (kvar(i),rz(i,1:nvars),i=1,nvars)
       WRITE (nout,*)
       WRITE (nout,99999) &
          'Minimum number of cases used for any pair of variables:', ncases
       WRITE (nout,*)
       WRITE (nout,*) 'Numbers used for each pair are:'
       WRITE (nout,99998) kvar(1:nvars)
       WRITE (nout,99996) (kvar(i),cnt(i,1:nvars),i=1,nvars)

99999  FORMAT (1X,A,I5)
99998  FORMAT (1X,4I12)
99997  FORMAT (1X,I3,4F12.4)
99996  FORMAT (1X,I3,3F12.4)
99995  FORMAT (1X,I5,2F11.4)
    END PROGRAM g02bmfe
