    PROGRAM g05lqfe

!      G05LQF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g05kbf, g05lqf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: n = 5, nmix = 3, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: ifail, igen
!      .. Local Arrays ..
       REAL (KIND=nag_wp)              :: a(nmix), wgt(nmix), x(n)
       INTEGER                         :: iseed(4)
!      .. Executable Statements ..
       WRITE (nout,*) 'G05LQF Example Program Results'
       WRITE (nout,*)
!      Initialize the seed to a repeatable sequence
       iseed(1) = 1762543
       iseed(2) = 9324783
       iseed(3) = 42344
       iseed(4) = 742355
!      IGEN identifies the stream.
       igen = 1
       CALL g05kbf(igen,iseed)

       a(1) = 1.0E0_nag_wp
       a(2) = 5.0E0_nag_wp
       a(3) = 2.0E0_nag_wp

       wgt(1) = 0.5E0_nag_wp
       wgt(2) = 0.3E0_nag_wp
       wgt(3) = 0.2E0_nag_wp

       ifail = 1
       CALL g05lqf(nmix,a,wgt,n,x,igen,iseed,ifail)

       IF (ifail==0) THEN

          WRITE (nout,99999) x

       ELSE
          WRITE (nout,99998) ifail
       END IF

99999  FORMAT (1X,F10.4)
99998  FORMAT (1X,' ** G05LQF returned with IFAIL = ',I5)
    END PROGRAM g05lqfe
