    PROGRAM g05mdfe

!      G05MDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g05kbf, g05mdf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: n = 10, nout = 6, nr = 1
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: a
       INTEGER                         :: i, ifail, igen
!      .. Local Arrays ..
       REAL (KIND=nag_wp)              :: r(nr)
       INTEGER                         :: iseed(4), x(n)
!      .. Executable Statements ..
       WRITE (nout,*) 'G05MDF Example Program Results'
       WRITE (nout,*)
!      Set the distribution parameter A
       a = 0.9999E0_nag_wp
!      Initialize the seed to a repeatable sequence
       iseed(1) = 1762543
       iseed(2) = 9324783
       iseed(3) = 42344
       iseed(4) = 742355
!      IGEN identifies the stream.
       igen = 1
       CALL g05kbf(igen,iseed)
       ifail = 1
!      Generate integers and store in X
!      Use MODE=3 because A > 0.95
       CALL g05mdf(3,a,n,x,igen,iseed,r,nr,ifail)

       IF (ifail==0) THEN

          WRITE (nout,99999) (x(i),i=1,n)

       ELSE
          WRITE (nout,99998) ifail
       END IF

99999  FORMAT (1X,I12)
99998  FORMAT (1X,' ** G05MDF returned with IFAIL = ',I5)
    END PROGRAM g05mdfe
