    PROGRAM x04dbfe

!      X04DBF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : nag_wp, x04dbf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nmax = 4, nout = 6
       INTEGER, PARAMETER              :: lda = nmax
       CHARACTER (7), PARAMETER        :: clabs(nmax) = (/  'Un     ',         &
                                          'Deux   ',  'Trois  ',  'Quatre '  /)
       CHARACTER (7), PARAMETER        :: rlabs(nmax) = (/  'Uno    ',         &
                                          'Due    ',  'Tre    ',  'Quattro'  /)
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: aa
       INTEGER                         :: i, ifail, indent, j, ncols
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp)           :: a(lda,nmax)
!      .. Intrinsic Functions ..
       INTRINSIC                          cmplx, real
!      .. Executable Statements ..
       WRITE (nout,*) 'X04DBF Example Program Results'

       WRITE (nout,*)
       FLUSH (nout)

!      Generate an array of data

       DO j = 1, nmax

          DO i = 1, lda
             aa = real(10*i+j,kind=nag_wp)
             a(i,j) = cmplx(aa,-aa,kind=nag_wp)
          END DO

       END DO

       ncols = 80
       indent = 0

!      Print (nmax-1) by nmax rectangular matrix with default format and integer
!      row and column labels, and bracketed complex elements

       ifail = 0
       CALL x04dbf('General',' ',nmax-1,nmax,a,lda,'Bracketed',' ', &
          'Example 1:','Integer',rlabs,'Integer',clabs,ncols,indent,ifail)

       WRITE (nout,*)
       FLUSH (nout)

!      Print nmax by nmax upper triangular matrix with user-supplied format
!      and row and column labels, and complex elements with real part
!      above imaginary part

       ifail = 0
       CALL x04dbf('Upper','Non-unit',nmax,nmax,a,lda,'Above','F8.2', &
          'Example 2:','Character',rlabs,'Character',clabs,ncols,indent,ifail)

       WRITE (nout,*)
       FLUSH (nout)

!      Print (nmax-1) by nmax lower triangular matrix in MATLAB format
!      Row and column labelling and USEFRM are ignored

       ifail = 0
       CALL x04dbf('Lower','Unit',nmax-1,nmax,a,lda,' ','MATLABF8.2','A',' ', &
          rlabs,' ',clabs,ncols,indent,ifail)

    END PROGRAM x04dbfe
