    Module nag_blas_ib

!     NAG COPYRIGHT 2011.

!     .. Use Statements ..
      Use nag_precisions, Only: wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine drotg(a,b,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b
          Real (Kind=wp), Intent (Out) :: c, s
        End Subroutine drotg
      End Interface
      Interface
        Subroutine drotmg(d1,d2,x1,x2,param)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: d1, d2, x1, x2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: param(5)
        End Subroutine drotmg
      End Interface
      Interface
        Function ddot(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: ddot
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Function ddot
      End Interface
      Interface
        Subroutine daxpy(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine daxpy
      End Interface
      Interface
        Subroutine dscal(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dscal
      End Interface
      Interface
        Subroutine dcopy(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dcopy
      End Interface
      Interface
        Subroutine dswap(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine dswap
      End Interface
      Interface
        Function dnrm2(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: dnrm2
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function dnrm2
      End Interface
      Interface
        Function dasum(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: dasum
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function dasum
      End Interface
      Interface
        Subroutine drot(n,x,incx,y,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine drot
      End Interface
      Interface
        Subroutine drotm(n,x,incx,y,incy,param)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: param(5)
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine drotm
      End Interface
      Interface
        Function ddoti(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: ddoti
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function ddoti
      End Interface
      Interface
        Subroutine daxpyi(nz,a,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine daxpyi
      End Interface
      Interface
        Subroutine dgthr(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
          Real (Kind=wp), Intent (In) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine dgthr
      End Interface
      Interface
        Subroutine dgthrz(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine dgthrz
      End Interface
      Interface
        Subroutine dsctr(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine dsctr
      End Interface
      Interface
        Subroutine droti(nz,x,indx,y,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine droti
      End Interface
      Interface
        Function zdotu(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: zdotu
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Function zdotu
      End Interface
      Interface
        Function zdotc(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: zdotc
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Function zdotc
      End Interface
      Interface
        Subroutine zaxpy(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zaxpy
      End Interface
      Interface
        Subroutine zscal(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine zscal
      End Interface
      Interface
        Subroutine zcopy(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zcopy
      End Interface
      Interface
        Subroutine zswap(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine zswap
      End Interface
      Interface
        Function zdotui(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: zdotui
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function zdotui
      End Interface
      Interface
        Function zdotci(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: zdotci
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function zdotci
      End Interface
      Interface
        Subroutine zaxpyi(nz,a,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: a
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine zaxpyi
      End Interface
      Interface
        Subroutine zgthr(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
          Complex (Kind=wp), Intent (In) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine zgthr
      End Interface
      Interface
        Subroutine zgthrz(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine zgthrz
      End Interface
      Interface
        Subroutine zsctr(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine zsctr
      End Interface
      Interface
        Subroutine zdscal(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine zdscal
      End Interface
      Interface
        Function dznrm2(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: dznrm2
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function dznrm2
      End Interface
      Interface
        Function dzasum(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: dzasum
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function dzasum
      End Interface
      Interface
        Function idamax(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: idamax
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function idamax
      End Interface
      Interface
        Function izamax(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: izamax
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function izamax
      End Interface
      Interface
        Subroutine dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dgemv
      End Interface
      Interface
        Subroutine dgbmv(trans,m,n,kl,ku,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, kl, ku, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dgbmv
      End Interface
      Interface
        Subroutine dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dsymv
      End Interface
      Interface
        Subroutine dsbmv(uplo,n,k,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, k, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dsbmv
      End Interface
      Interface
        Subroutine dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine dspmv
      End Interface
      Interface
        Subroutine dtrmv(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtrmv
      End Interface
      Interface
        Subroutine dtbmv(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtbmv
      End Interface
      Interface
        Subroutine dtpmv(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtpmv
      End Interface
      Interface
        Subroutine dtrsv(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtrsv
      End Interface
      Interface
        Subroutine dtbsv(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtbsv
      End Interface
      Interface
        Subroutine dtpsv(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine dtpsv
      End Interface
      Interface
        Subroutine dger(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine dger
      End Interface
      Interface
        Subroutine dsyr(uplo,n,alpha,x,incx,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine dsyr
      End Interface
      Interface
        Subroutine dspr(uplo,n,alpha,x,incx,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine dspr
      End Interface
      Interface
        Subroutine dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine dsyr2
      End Interface
      Interface
        Subroutine dspr2(uplo,n,alpha,x,incx,y,incy,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine dspr2
      End Interface
      Interface
        Subroutine zgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zgemv
      End Interface
      Interface
        Subroutine zgbmv(trans,m,n,kl,ku,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, kl, ku, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zgbmv
      End Interface
      Interface
        Subroutine zhemv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zhemv
      End Interface
      Interface
        Subroutine zhbmv(uplo,n,k,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, k, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zhbmv
      End Interface
      Interface
        Subroutine zhpmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine zhpmv
      End Interface
      Interface
        Subroutine ztrmv(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztrmv
      End Interface
      Interface
        Subroutine ztbmv(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztbmv
      End Interface
      Interface
        Subroutine ztpmv(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztpmv
      End Interface
      Interface
        Subroutine ztrsv(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztrsv
      End Interface
      Interface
        Subroutine ztbsv(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztbsv
      End Interface
      Interface
        Subroutine ztpsv(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine ztpsv
      End Interface
      Interface
        Subroutine zgeru(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine zgeru
      End Interface
      Interface
        Subroutine zgerc(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine zgerc
      End Interface
      Interface
        Subroutine zher(uplo,n,alpha,x,incx,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine zher
      End Interface
      Interface
        Subroutine zhpr(uplo,n,alpha,x,incx,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine zhpr
      End Interface
      Interface
        Subroutine zher2(uplo,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine zher2
      End Interface
      Interface
        Subroutine zhpr2(uplo,n,alpha,x,incx,y,incy,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine zhpr2
      End Interface
      Interface
        Subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine dgemm
      End Interface
      Interface
        Subroutine dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine dsymm
      End Interface
      Interface
        Subroutine dtrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtrmm
      End Interface
      Interface
        Subroutine dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtrsm
      End Interface
      Interface
        Subroutine dsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine dsyrk
      End Interface
      Interface
        Subroutine dsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine dsyr2k
      End Interface
      Interface
        Subroutine zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zgemm
      End Interface
      Interface
        Subroutine zhemm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zhemm
      End Interface
      Interface
        Subroutine ztrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztrmm
      End Interface
      Interface
        Subroutine ztrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztrsm
      End Interface
      Interface
        Subroutine zherk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zherk
      End Interface
      Interface
        Subroutine zher2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Real (Kind=wp), Intent (In) :: beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zher2k
      End Interface
      Interface
        Subroutine zsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zsymm
      End Interface
      Interface
        Subroutine zsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zsyrk
      End Interface
      Interface
        Subroutine zsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine zsyr2k
      End Interface
    End Module nag_blas_ib
