    Module nag_c_ib

!     NAG COPYRIGHT 2011.

!     .. Use Statements ..
      Use nag_precisions, Only: wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine c02aff(a,n,scal,z,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: scal
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(2,n+1)
          Real (Kind=wp), Intent (Out) :: w(4*(n+1)), z(2,n)
        End Subroutine c02aff
      End Interface
      Interface
        Subroutine c02agf(a,n,scal,z,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: scal
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n+1)
          Real (Kind=wp), Intent (Out) :: w(2*(n+1)), z(2,n)
        End Subroutine c02agf
      End Interface
      Interface
        Subroutine c02ahf(ar,ai,br,bi,cr,ci,zsm,zlg,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: ai, ar, bi, br, ci, cr
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: zlg(2), zsm(2)
        End Subroutine c02ahf
      End Interface
      Interface
        Subroutine c02ajf(a,b,c,zsm,zlg,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, c
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: zlg(2), zsm(2)
        End Subroutine c02ajf
      End Interface
      Interface
        Subroutine c02akf(u,r,s,t,zeror,zeroi,errest,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: r, s, t, u
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: errest(3), zeroi(3), zeror(3)
        End Subroutine c02akf
      End Interface
      Interface
        Subroutine c02alf(e,a,b,c,d,zeror,zeroi,errest,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, c, d, e
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: errest(4), zeroi(4), zeror(4)
        End Subroutine c02alf
      End Interface
      Interface
        Subroutine c02amf(u,r,s,t,zeror,zeroi,errest,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: r, s, t, u
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: errest(3), zeroi(3), zeror(3)
        End Subroutine c02amf
      End Interface
      Interface
        Subroutine c02anf(e,a,b,c,d,zeror,zeroi,errest,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: a, b, c, d, e
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: errest(4), zeroi(4), zeror(4)
        End Subroutine c02anf
      End Interface
      Interface
        Subroutine c05adf(a,b,eps,eta,f,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, eps, eta
          Real (Kind=wp), Intent (Out) :: x
          Integer, Intent (Inout) :: ifail
!         .. Interface Blocks ..
          Interface
            Function f(xx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: xx
            End Function f
          End Interface
        End Subroutine c05adf
      End Interface
      Interface
        Subroutine c05agf(x,h,eps,eta,f,a,b,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: a, b
          Real (Kind=wp), Intent (In) :: eps, eta, h
          Real (Kind=wp), Intent (Inout) :: x
          Integer, Intent (Inout) :: ifail
!         .. Interface Blocks ..
          Interface
            Function f(xx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: xx
            End Function f
          End Interface
        End Subroutine c05agf
      End Interface
      Interface
        Subroutine c05ajf(x,eps,eta,f,nfmax,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps, eta
          Real (Kind=wp), Intent (Inout) :: x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nfmax
!         .. Interface Blocks ..
          Interface
            Function f(xx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: xx
            End Function f
          End Interface
        End Subroutine c05ajf
      End Interface
      Interface
        Subroutine c05auf(x,h,eps,eta,f,a,b,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: a, b
          Real (Kind=wp), Intent (In) :: eps, eta, h
          Real (Kind=wp), Intent (Inout) :: x
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Function f(x,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: x
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Function f
          End Interface
        End Subroutine c05auf
      End Interface
      Interface
        Subroutine c05avf(x,fx,h,boundl,boundu,y,c,ind,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: boundl, boundu, fx
          Real (Kind=wp), Intent (Inout) :: h, x, y
          Integer, Intent (Inout) :: ifail, ind
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(11)
        End Subroutine c05avf
      End Interface
      Interface
        Subroutine c05awf(x,eps,eta,f,nfmax,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps, eta
          Real (Kind=wp), Intent (Inout) :: x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nfmax
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Function f(x,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: x
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Function f
          End Interface
        End Subroutine c05awf
      End Interface
      Interface
        Subroutine c05axf(x,fx,tol,ir,scal,c,ind,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fx, scal, tol
          Real (Kind=wp), Intent (Inout) :: x
          Integer, Intent (Inout) :: ifail, ind
          Integer, Intent (In) :: ir
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(26)
        End Subroutine c05axf
      End Interface
      Interface
        Subroutine c05ayf(a,b,eps,eta,f,x,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, eps, eta
          Real (Kind=wp), Intent (Out) :: x
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Function f(x,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: f
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: x
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Function f
          End Interface
        End Subroutine c05ayf
      End Interface
      Interface
        Subroutine c05azf(x,y,fx,tolx,ir,c,ind,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fx, tolx
          Real (Kind=wp), Intent (Inout) :: x, y
          Integer, Intent (Inout) :: ifail, ind
          Integer, Intent (In) :: ir
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(17)
        End Subroutine c05azf
      End Interface
      Interface
        Function c05baf(x,branch,offset,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: c05baf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (In) :: branch
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: offset
        End Function c05baf
      End Interface
      Interface
        Subroutine c05bbf(branch,offset,z,w,resid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Out) :: w
          Complex (Kind=wp), Intent (In) :: z
          Real (Kind=wp), Intent (Out) :: resid
          Integer, Intent (In) :: branch
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: offset
        End Subroutine c05bbf
      End Interface
      Interface
        Subroutine c05nbf(fcn,n,x,fvec,xtol,wa,lwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lwa, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fvec(n)
          Real (Kind=wp), Intent (In) :: wa(1)
          Real (Kind=wp), Intent (Inout) :: x(n)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fvec(n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine fcn
          End Interface
        End Subroutine c05nbf
      End Interface
      Interface
        Subroutine c05ncf(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,diag,mode, &
            factor,nprint,nfev,fjac,ldfjac,r,lr,qtf,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsfcn, factor, xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, lr, maxfev, ml, mode, mu, n, nprint
          Integer, Intent (Out) :: nfev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), x(n)
          Real (Kind=wp), Intent (Out) :: fvec(n), qtf(n), r(n*(n+1)/2)
          Real (Kind=wp), Intent (In) :: w(1,1)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fvec(n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine fcn
          End Interface
        End Subroutine c05ncf
      End Interface
      Interface
        Subroutine c05ndf(irevcm,n,x,fvec,xtol,ml,mu,epsfcn,diag,mode,factor, &
            fjac,ldfjac,r,lr,qtf,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsfcn, factor, xtol
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldfjac, lr, ml, mode, mu, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), fvec(n), &
            qtf(n), r(n*(n+1)/2), w(n,4), x(n)
        End Subroutine c05ndf
      End Interface
      Interface
        Subroutine c05pba(fcn,n,x,fvec,fjac,ldfjac,xtol,wa,lwa,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, lwa, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: fvec(n)
          Real (Kind=wp), Intent (In) :: wa(1)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,ldfjac,iflag,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), fvec(n), &
                ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05pba
      End Interface
      Interface
        Subroutine c05pbf(fcn,n,x,fvec,fjac,ldfjac,xtol,wa,lwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, lwa, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), x(n)
          Real (Kind=wp), Intent (Out) :: fvec(n)
          Real (Kind=wp), Intent (In) :: wa(1)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), fvec(n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine fcn
          End Interface
        End Subroutine c05pbf
      End Interface
      Interface
        Subroutine c05pca(fcn,n,x,fvec,fjac,ldfjac,xtol,maxfev,diag,mode, &
            factor,nprint,nfev,njev,r,lr,qtf,w,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, lr, maxfev, mode, n, nprint
          Integer, Intent (Out) :: nfev, njev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), ruser(*), &
            x(n)
          Real (Kind=wp), Intent (Out) :: fvec(n), qtf(n), r(n*(n+1)/2)
          Real (Kind=wp), Intent (In) :: w(1,1)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,ldfjac,iflag,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), fvec(n), &
                ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05pca
      End Interface
      Interface
        Subroutine c05pcf(fcn,n,x,fvec,fjac,ldfjac,xtol,maxfev,diag,mode, &
            factor,nprint,nfev,njev,r,lr,qtf,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, lr, maxfev, mode, n, nprint
          Integer, Intent (Out) :: nfev, njev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), x(n)
          Real (Kind=wp), Intent (Out) :: fvec(n), qtf(n), r(n*(n+1)/2)
          Real (Kind=wp), Intent (In) :: w(1,1)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), fvec(n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine fcn
          End Interface
        End Subroutine c05pcf
      End Interface
      Interface
        Subroutine c05pda(irevcm,n,x,fvec,fjac,ldfjac,xtol,diag,mode,factor,r, &
            lr,qtf,w,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldfjac, lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), fvec(n), &
            qtf(n), r(n*(n+1)/2), rwsav(10), w(n,4), x(n)
          Integer, Intent (Inout) :: iwsav(15)
          Logical, Intent (Inout) :: lwsav(2)
        End Subroutine c05pda
      End Interface
      Interface
        Subroutine c05pdf(irevcm,n,x,fvec,fjac,ldfjac,xtol,diag,mode,factor,r, &
            lr,qtf,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldfjac, lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(ldfjac,n), fvec(n), &
            qtf(n), r(n*(n+1)/2), w(n,4), x(n)
        End Subroutine c05pdf
      End Interface
      Interface
        Subroutine c05qbf(fcn,n,x,fvec,xtol,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fvec(n)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,iuser,ruser,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fvec(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05qbf
      End Interface
      Interface
        Subroutine c05qcf(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,mode,diag, &
            factor,nprint,nfev,fjac,r,qtf,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsfcn, factor, xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxfev, ml, mode, mu, n, nprint
          Integer, Intent (Out) :: nfev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: fjac(n,n), fvec(n), qtf(n), &
            r(n*(n+1)/2)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,iuser,ruser,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fvec(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05qcf
      End Interface
      Interface
        Subroutine c05qdf(irevcm,n,x,fvec,xtol,ml,mu,epsfcn,mode,diag,factor, &
            fjac,r,qtf,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsfcn, factor, xtol
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ml, mode, mu, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(n,n), fvec(n), &
            qtf(n), r(n*(n+1)/2), rwsav(4*n+10), x(n)
          Integer, Intent (Inout) :: iwsav(17)
        End Subroutine c05qdf
      End Interface
      Interface
        Subroutine c05qsf(fcn,n,x,fvec,xtol,init,rcomm,lrcomm,icomm,licomm, &
            iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: licomm, lrcomm, n
          Logical, Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fvec(n)
          Real (Kind=wp), Intent (Inout) :: rcomm(lrcomm), ruser(*), x(n)
          Integer, Intent (Inout) :: icomm(licomm), iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,lindf,indf,x,fvec,iuser,ruser,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: lindf, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fvec(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (In) :: indf(lindf)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05qsf
      End Interface
      Interface
        Subroutine c05rbf(fcn,n,x,fvec,fjac,xtol,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fjac(n,n), fvec(n)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,iuser,ruser,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(n,n), fvec(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05rbf
      End Interface
      Interface
        Subroutine c05rcf(fcn,n,x,fvec,fjac,xtol,maxfev,mode,diag,factor, &
            nprint,nfev,njev,r,qtf,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxfev, mode, n, nprint
          Integer, Intent (Out) :: nfev, njev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: fjac(n,n), fvec(n), qtf(n), &
            r(n*(n+1)/2)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine fcn(n,x,fvec,fjac,iuser,ruser,iflag)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(n,n), fvec(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine fcn
          End Interface
        End Subroutine c05rcf
      End Interface
      Interface
        Subroutine c05rdf(irevcm,n,x,fvec,fjac,xtol,mode,diag,factor,r,qtf, &
            iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: factor, xtol
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: diag(n), fjac(n,n), fvec(n), &
            qtf(n), r(n*(n+1)/2), rwsav(4*n+10), x(n)
          Integer, Intent (Inout) :: iwsav(17)
        End Subroutine c05rdf
      End Interface
      Interface
        Subroutine c05zaf(m,n,x,fvec,fjac,ldfjac,xp,fvecp,mode,err)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldfjac, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: err(*), xp(*)
          Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), fvecp(m), &
            x(n)
        End Subroutine c05zaf
      End Interface
      Interface
        Subroutine c05zdf(mode,m,n,x,fvec,fjac,xp,fvecp,err,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: err(m), xp(n)
          Real (Kind=wp), Intent (In) :: fjac(m,n), fvec(m), fvecp(m), x(n)
        End Subroutine c05zdf
      End Interface
      Interface
        Subroutine c06baf(seqn,ncall,result,abserr,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abserr, result
          Real (Kind=wp), Intent (In) :: seqn
          Integer, Intent (Inout) :: ifail, ncall
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(lwork)
        End Subroutine c06baf
      End Interface
      Interface
        Function c06dbf(x,c,n,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: c06dbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (In) :: n, s
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(n)
        End Function c06dbf
      End Interface
      Interface
        Subroutine c06dcf(x,lx,xmin,xmax,c,n,s,res,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lx, n, s
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(n), x(lx)
          Real (Kind=wp), Intent (Out) :: res(lx)
        End Subroutine c06dcf
      End Interface
      Interface
        Subroutine c06eaf(x,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(n)
        End Subroutine c06eaf
      End Interface
      Interface
        Subroutine c06ebf(x,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(n)
        End Subroutine c06ebf
      End Interface
      Interface
        Subroutine c06ecf(x,y,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
        End Subroutine c06ecf
      End Interface
      Interface
        Subroutine c06ekf(job,x,y,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: job, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
        End Subroutine c06ekf
      End Interface
      Interface
        Subroutine c06faf(x,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Inout) :: x(n)
        End Subroutine c06faf
      End Interface
      Interface
        Subroutine c06fbf(x,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Inout) :: x(n)
        End Subroutine c06fbf
      End Interface
      Interface
        Subroutine c06fcf(x,y,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
        End Subroutine c06fcf
      End Interface
      Interface
        Subroutine c06fff(ndim,l,nd,n,x,y,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, lwork, n, ndim
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
          Integer, Intent (In) :: nd(ndim)
        End Subroutine c06fff
      End Interface
      Interface
        Subroutine c06fjf(ndim,nd,n,x,y,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lwork, n, ndim
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
          Integer, Intent (In) :: nd(ndim)
        End Subroutine c06fjf
      End Interface
      Interface
        Subroutine c06fkf(job,x,y,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: job, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Inout) :: x(n), y(n)
        End Subroutine c06fkf
      End Interface
      Interface
        Subroutine c06fpf(m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n)
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06fpf
      End Interface
      Interface
        Subroutine c06fqf(m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n)
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06fqf
      End Interface
      Interface
        Subroutine c06frf(m,n,x,y,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n), y(m*n)
          Real (Kind=wp), Intent (Out) :: work(2*m*n)
        End Subroutine c06frf
      End Interface
      Interface
        Subroutine c06fuf(m,n,x,y,init,trigm,trign,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trigm(2*m), trign(2*n), x(m*n), &
            y(m*n)
          Real (Kind=wp), Intent (Out) :: work(2*m*n)
        End Subroutine c06fuf
      End Interface
      Interface
        Subroutine c06fxf(n1,n2,n3,x,y,init,trign1,trign2,trign3,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n1, n2, n3
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trign1(2*n1), trign2(2*n2), &
            trign3(2*n3), x(n1*n2*n3), y(n1*n2*n3)
          Real (Kind=wp), Intent (Out) :: work(2*n1*n2*n3)
        End Subroutine c06fxf
      End Interface
      Interface
        Subroutine c06gbf(x,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(n)
        End Subroutine c06gbf
      End Interface
      Interface
        Subroutine c06gcf(y,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: y(n)
        End Subroutine c06gcf
      End Interface
      Interface
        Subroutine c06gqf(m,n,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(m*n)
        End Subroutine c06gqf
      End Interface
      Interface
        Subroutine c06gsf(m,n,x,u,v,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: u(m*n), v(m*n)
          Real (Kind=wp), Intent (In) :: x(m*n)
        End Subroutine c06gsf
      End Interface
      Interface
        Subroutine c06haf(m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n)
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06haf
      End Interface
      Interface
        Subroutine c06hbf(m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*(n+1))
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06hbf
      End Interface
      Interface
        Subroutine c06hcf(direct,m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct, init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n)
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06hcf
      End Interface
      Interface
        Subroutine c06hdf(direct,m,n,x,init,trig,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct, init
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: trig(2*n), x(m*n)
          Real (Kind=wp), Intent (Out) :: work(m*n)
        End Subroutine c06hdf
      End Interface
      Interface
        Subroutine c06laf(fun,n,t,valinv,errest,relerr,alphab,tfac,mxterm, &
            nterms,na,alow,ahigh,nfeval,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ahigh, alow
          Real (Kind=wp), Intent (In) :: alphab, relerr, tfac
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: mxterm, n
          Integer, Intent (Out) :: na, nfeval, nterms
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: errest(n), valinv(n), &
            work(4*mxterm+2)
          Real (Kind=wp), Intent (In) :: t(n)
!         .. Interface Blocks ..
          Interface
            Subroutine fun(pr,pi,fr,fi)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fi, fr
              Real (Kind=wp), Intent (In) :: pi, pr
            End Subroutine fun
          End Interface
        End Subroutine c06laf
      End Interface
      Interface
        Subroutine c06lbf(f,sigma0,sigma,b,epstol,mmax,m,acoef,errvec,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: b, sigma
          Real (Kind=wp), Intent (In) :: epstol, sigma0
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: m
          Integer, Intent (In) :: mmax
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: acoef(mmax), errvec(8)
!         .. Interface Blocks ..
          Interface
            Function f(s)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Complex (Kind=wp) :: f
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: s
            End Function f
          End Interface
        End Subroutine c06lbf
      End Interface
      Interface
        Subroutine c06lcf(t,sigma,b,m,acoef,errvec,finv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: b, sigma, t
          Real (Kind=wp), Intent (Out) :: finv
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: acoef(m), errvec(8)
        End Subroutine c06lcf
      End Interface
      Interface
        Subroutine c06paf(direct,x,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(n+2)
        End Subroutine c06paf
      End Interface
      Interface
        Subroutine c06pcf(direct,x,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(n)
        End Subroutine c06pcf
      End Interface
      Interface
        Subroutine c06pff(direct,ndim,l,nd,n,x,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, lwork, n, ndim
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: nd(ndim)
        End Subroutine c06pff
      End Interface
      Interface
        Subroutine c06pjf(direct,ndim,nd,n,x,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lwork, n, ndim
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: nd(ndim)
        End Subroutine c06pjf
      End Interface
      Interface
        Subroutine c06pkf(job,x,y,n,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: job, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(n), y(n)
        End Subroutine c06pkf
      End Interface
      Interface
        Subroutine c06ppf(direct,m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(m*(n+2))
        End Subroutine c06ppf
      End Interface
      Interface
        Subroutine c06pqf(direct,n,m,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x((n+2)*m)
        End Subroutine c06pqf
      End Interface
      Interface
        Subroutine c06prf(direct,m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(m*n)
        End Subroutine c06prf
      End Interface
      Interface
        Subroutine c06psf(direct,n,m,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(n*m)
        End Subroutine c06psf
      End Interface
      Interface
        Subroutine c06puf(direct,m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(m*n)
        End Subroutine c06puf
      End Interface
      Interface
        Subroutine c06pxf(direct,n1,n2,n3,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n1, n2, n3
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(*), x(n1*n2*n3)
        End Subroutine c06pxf
      End Interface
      Interface
        Subroutine c06raf(m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(m*(n+2))
        End Subroutine c06raf
      End Interface
      Interface
        Subroutine c06rbf(m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(m*(n+3))
        End Subroutine c06rbf
      End Interface
      Interface
        Subroutine c06rcf(direct,m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(m*(n+2))
        End Subroutine c06rcf
      End Interface
      Interface
        Subroutine c06rdf(direct,m,n,x,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(*), x(m*(n+2))
        End Subroutine c06rdf
      End Interface
      Interface
        Subroutine c09aaf(wavnam,wtrans,mode,n,nwl,nf,nwc,icomm,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Integer, Intent (Out) :: nf, nwc, nwl
          Character (1), Intent (In) :: mode, wtrans
          Character (*), Intent (In) :: wavnam
!         .. Array Arguments ..
          Integer, Intent (Out) :: icomm(100)
        End Subroutine c09aaf
      End Interface
      Interface
        Subroutine c09abf(wavnam,wtrans,mode,m,n,nwl,nf,nwct,nwcn,icomm,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Integer, Intent (Out) :: nf, nwcn, nwct, nwl
          Character (1), Intent (In) :: mode, wtrans
          Character (*), Intent (In) :: wavnam
!         .. Array Arguments ..
          Integer, Intent (Out) :: icomm(180)
        End Subroutine c09abf
      End Interface
      Interface
        Subroutine c09baf(wavnam,wparam,n,x,nscal,scales,c,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nscal, wparam
          Character (*), Intent (In) :: wavnam
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(nscal,n)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (In) :: scales(nscal)
        End Subroutine c09baf
      End Interface
      Interface
        Subroutine c09caf(n,x,lenc,ca,cd,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lenc, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ca(lenc), cd(lenc)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: icomm(100)
        End Subroutine c09caf
      End Interface
      Interface
        Subroutine c09cbf(lenc,ca,cd,n,y,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lenc, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ca(lenc), cd(lenc)
          Real (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icomm(100)
        End Subroutine c09cbf
      End Interface
      Interface
        Subroutine c09ccf(n,x,lenc,c,nwl,dwtlev,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lenc, n, nwl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(lenc)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Out) :: dwtlev(nwl+1)
          Integer, Intent (Inout) :: icomm(100)
        End Subroutine c09ccf
      End Interface
      Interface
        Subroutine c09cdf(nwl,lenc,c,n,y,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lenc, n, nwl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(lenc)
          Real (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icomm(100)
        End Subroutine c09cdf
      End Interface
      Interface
        Subroutine c09eaf(m,n,a,lda,ca,ldca,ch,ldch,cv,ldcv,cd,ldcd,icomm, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldca, ldcd, ldch, ldcv, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n)
          Real (Kind=wp), Intent (Inout) :: ca(ldca,*), cd(ldcd,*), &
            ch(ldch,*), cv(ldcv,*)
          Integer, Intent (In) :: icomm(180)
        End Subroutine c09eaf
      End Interface
      Interface
        Subroutine c09ebf(m,n,ca,ldca,ch,ldch,cv,ldcv,cd,ldcd,b,ldb,icomm, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, ldca, ldcd, ldch, ldcv, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ldb,n)
          Real (Kind=wp), Intent (In) :: ca(ldca,*), cd(ldcd,*), ch(ldch,*), &
            cv(ldcv,*)
          Integer, Intent (In) :: icomm(180)
        End Subroutine c09ebf
      End Interface
      Interface
        Subroutine c09ecf(m,n,a,lda,lenc,c,nwl,dwtlvm,dwtlvn,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, lenc, m, n, nwl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n)
          Real (Kind=wp), Intent (Out) :: c(lenc)
          Integer, Intent (Out) :: dwtlvm(nwl), dwtlvn(nwl)
          Integer, Intent (Inout) :: icomm(180)
        End Subroutine c09ecf
      End Interface
      Interface
        Subroutine c09edf(nwl,lenc,c,m,n,b,ldb,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, lenc, m, n, nwl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ldb,n)
          Real (Kind=wp), Intent (In) :: c(lenc)
          Integer, Intent (In) :: icomm(180)
        End Subroutine c09edf
      End Interface
    End Module nag_c_ib
