    Module nag_e_ib

!     NAG COPYRIGHT 2011.

!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine e01aaf(a,b,c,n1,n2,n,x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (In) :: n, n1, n2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n1), b(n1)
          Real (Kind=wp), Intent (Out) :: c(n2)
        End Subroutine e01aaf
      End Interface
      Interface
        Subroutine e01abf(n,p,a,g,n1,n2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, n1, n2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n1)
          Real (Kind=wp), Intent (Out) :: g(n2)
        End Subroutine e01abf
      End Interface
      Interface
        Subroutine e01aef(m,xmin,xmax,x,y,ip,n,itmin,itmax,a,wrk,lwrk,iwrk, &
            liwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itmax, itmin, liwrk, lwrk, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(n), wrk(lwrk)
          Real (Kind=wp), Intent (In) :: x(m), y(n)
          Integer, Intent (In) :: ip(m)
          Integer, Intent (Out) :: iwrk(liwrk)
        End Subroutine e01aef
      End Interface
      Interface
        Subroutine e01baf(m,x,y,lamda,c,lck,wrk,lwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lck, lwrk, m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(lck), lamda(lck), wrk(lwrk)
          Real (Kind=wp), Intent (In) :: x(m), y(m)
        End Subroutine e01baf
      End Interface
      Interface
        Subroutine e01bef(n,x,f,d,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: d(n)
          Real (Kind=wp), Intent (In) :: f(n), x(n)
        End Subroutine e01bef
      End Interface
      Interface
        Subroutine e01bff(n,x,f,d,m,px,pf,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(n), f(n), px(m), x(n)
          Real (Kind=wp), Intent (Out) :: pf(m)
        End Subroutine e01bff
      End Interface
      Interface
        Subroutine e01bgf(n,x,f,d,m,px,pf,pd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(n), f(n), px(m), x(n)
          Real (Kind=wp), Intent (Out) :: pd(m), pf(m)
        End Subroutine e01bgf
      End Interface
      Interface
        Subroutine e01bhf(n,x,f,d,a,b,pint,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Real (Kind=wp), Intent (Out) :: pint
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(n), f(n), x(n)
        End Subroutine e01bhf
      End Interface
      Interface
        Subroutine e01daf(mx,my,x,y,f,px,py,lamda,mu,c,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: mx, my
          Integer, Intent (Out) :: px, py
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(mx*my), lamda(mx+4), mu(my+4), &
            wrk((mx+6)*(my+6))
          Real (Kind=wp), Intent (In) :: f(mx*my), x(mx), y(my)
        End Subroutine e01daf
      End Interface
      Interface
        Subroutine e01raf(n,x,f,m,a,u,iw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: m
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(n), u(n)
          Real (Kind=wp), Intent (In) :: f(n), x(n)
          Integer, Intent (Out) :: iw(n)
        End Subroutine e01raf
      End Interface
      Interface
        Subroutine e01rbf(m,a,u,x,f,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(m), u(m)
        End Subroutine e01rbf
      End Interface
      Interface
        Subroutine e01saf(m,x,y,f,triang,grads,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(m), y(m)
          Real (Kind=wp), Intent (Out) :: grads(2,m)
          Integer, Intent (Out) :: triang(7*m)
        End Subroutine e01saf
      End Interface
      Interface
        Subroutine e01sbf(m,x,y,f,triang,grads,px,py,pf,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pf
          Real (Kind=wp), Intent (In) :: px, py
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), grads(2,m), x(m), y(m)
          Integer, Intent (In) :: triang(7*m)
        End Subroutine e01sbf
      End Interface
      Interface
        Subroutine e01sgf(m,x,y,f,nw,nq,iq,liq,rq,lrq,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, nq, nw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(m), y(m)
          Real (Kind=wp), Intent (Out) :: rq(lrq)
          Integer, Intent (Out) :: iq(liq)
        End Subroutine e01sgf
      End Interface
      Interface
        Subroutine e01shf(m,x,y,f,iq,liq,rq,lrq,n,u,v,q,qx,qy,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), rq(lrq), u(n), v(n), x(m), y(m)
          Real (Kind=wp), Intent (Out) :: q(n), qx(n), qy(n)
          Integer, Intent (In) :: iq(liq)
        End Subroutine e01shf
      End Interface
      Interface
        Subroutine e01tgf(m,x,y,z,f,nw,nq,iq,liq,rq,lrq,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, nq, nw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(m), y(m), z(m)
          Real (Kind=wp), Intent (Out) :: rq(lrq)
          Integer, Intent (Out) :: iq(liq)
        End Subroutine e01tgf
      End Interface
      Interface
        Subroutine e01thf(m,x,y,z,f,iq,liq,rq,lrq,n,u,v,w,q,qx,qy,qz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), rq(lrq), u(n), v(n), w(n), &
            x(m), y(m), z(m)
          Real (Kind=wp), Intent (Out) :: q(n), qx(n), qy(n), qz(n)
          Integer, Intent (In) :: iq(liq)
        End Subroutine e01thf
      End Interface
      Interface
        Subroutine e01tkf(m,x,f,nw,nq,iq,rq,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, nq, nw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(4,m)
          Real (Kind=wp), Intent (Out) :: rq(15*m+9)
          Integer, Intent (Out) :: iq(2*m+1)
        End Subroutine e01tkf
      End Interface
      Interface
        Subroutine e01tlf(m,x,f,iq,rq,n,xe,q,qx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), rq(15*m+9), x(4,m), xe(4,n)
          Real (Kind=wp), Intent (Out) :: q(n), qx(4,n)
          Integer, Intent (In) :: iq(2*m+1)
        End Subroutine e01tlf
      End Interface
      Interface
        Subroutine e01tmf(m,x,f,nw,nq,iq,rq,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, nq, nw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(5,m)
          Real (Kind=wp), Intent (Out) :: rq(21*m+11)
          Integer, Intent (Out) :: iq(2*m+1)
        End Subroutine e01tmf
      End Interface
      Interface
        Subroutine e01tnf(m,x,f,iq,rq,n,xe,q,qx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), rq(21*m+11), x(5,m), xe(5,n)
          Real (Kind=wp), Intent (Out) :: q(n), qx(5,n)
          Integer, Intent (In) :: iq(2*m+1)
        End Subroutine e01tnf
      End Interface
      Interface
        Subroutine e01zmf(m,n,x,f,nw,nq,iq,liq,rq,lrq,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, n, nq, nw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), x(n,m)
          Real (Kind=wp), Intent (Out) :: rq(lrq)
          Integer, Intent (Out) :: iq(liq)
        End Subroutine e01zmf
      End Interface
      Interface
        Subroutine e01znf(m,n,x,f,iq,liq,rq,lrq,num,xe,q,qx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liq, lrq, m, n, num
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: f(m), rq(lrq), x(n,m), xe(n,num)
          Real (Kind=wp), Intent (Out) :: q(num), qx(n,num)
          Integer, Intent (In) :: iq(liq)
        End Subroutine e01znf
      End Interface
      Interface
        Subroutine e02acf(x,y,n,a,m1,ref)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ref
          Integer, Intent (In) :: m1, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(m1)
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine e02acf
      End Interface
      Interface
        Subroutine e02adf(m,kplus1,lda,x,y,w,work1,work2,a,s,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kplus1, lda, m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,kplus1)
          Real (Kind=wp), Intent (Out) :: s(kplus1), work1(3*m), &
            work2(2*kplus1)
          Real (Kind=wp), Intent (In) :: w(m), x(m), y(m)
        End Subroutine e02adf
      End Interface
      Interface
        Subroutine e02aef(nplus1,a,xcap,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Real (Kind=wp), Intent (In) :: xcap
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nplus1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nplus1)
        End Subroutine e02aef
      End Interface
      Interface
        Subroutine e02aff(nplus1,f,a,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nplus1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(nplus1)
          Real (Kind=wp), Intent (In) :: f(nplus1)
        End Subroutine e02aff
      End Interface
      Interface
        Subroutine e02agf(m,kplus1,lda,xmin,xmax,x,y,w,mf,xf,yf,lyf,ip,a,s, &
            np1,wrk,lwrk,iwrk,liwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kplus1, lda, liwrk, lwrk, lyf, m, mf
          Integer, Intent (Out) :: np1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,kplus1)
          Real (Kind=wp), Intent (Out) :: s(kplus1), wrk(lwrk)
          Real (Kind=wp), Intent (In) :: w(m), x(m), xf(mf), y(m), yf(lyf)
          Integer, Intent (In) :: ip(mf)
          Integer, Intent (Out) :: iwrk(liwrk)
        End Subroutine e02agf
      End Interface
      Interface
        Subroutine e02ahf(np1,xmin,xmax,a,ia1,la,patm1,adif,iadif1,ladif, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: patm1
          Real (Kind=wp), Intent (In) :: xmax, xmin
          Integer, Intent (In) :: ia1, iadif1, la, ladif, np1
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la)
          Real (Kind=wp), Intent (Out) :: adif(ladif)
        End Subroutine e02ahf
      End Interface
      Interface
        Subroutine e02ajf(np1,xmin,xmax,a,ia1,la,qatm1,aint,iaint1,laint, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: qatm1, xmax, xmin
          Integer, Intent (In) :: ia1, iaint1, la, laint, np1
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la)
          Real (Kind=wp), Intent (Out) :: aint(laint)
        End Subroutine e02ajf
      End Interface
      Interface
        Subroutine e02akf(np1,xmin,xmax,a,ia1,la,x,result,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: result
          Real (Kind=wp), Intent (In) :: x, xmax, xmin
          Integer, Intent (In) :: ia1, la, np1
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la)
        End Subroutine e02akf
      End Interface
      Interface
        Subroutine e02baf(m,ncap7,x,y,w,lamda,work1,work2,c,ss,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, ncap7
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ncap7), work1(m), work2(4*ncap7)
          Real (Kind=wp), Intent (Inout) :: lamda(ncap7)
          Real (Kind=wp), Intent (In) :: w(m), x(m), y(m)
        End Subroutine e02baf
      End Interface
      Interface
        Subroutine e02bbf(ncap7,lamda,c,x,s,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ncap7
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ncap7), lamda(ncap7)
        End Subroutine e02bbf
      End Interface
      Interface
        Subroutine e02bcf(ncap7,lamda,c,x,left,s,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: left, ncap7
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ncap7), lamda(ncap7)
          Real (Kind=wp), Intent (Out) :: s(4)
        End Subroutine e02bcf
      End Interface
      Interface
        Subroutine e02bdf(ncap7,lamda,c,dint,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dint
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ncap7
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ncap7), lamda(ncap7)
        End Subroutine e02bdf
      End Interface
      Interface
        Subroutine e02bef(start,m,x,y,w,s,nest,n,lamda,c,fp,wrk,lwrk,iwrk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fp
          Real (Kind=wp), Intent (In) :: s
          Integer, Intent (Inout) :: ifail, n
          Integer, Intent (In) :: lwrk, m, nest
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(nest)
          Real (Kind=wp), Intent (Inout) :: lamda(nest), wrk(lwrk)
          Real (Kind=wp), Intent (In) :: w(m), x(m), y(m)
          Integer, Intent (Inout) :: iwrk(nest)
        End Subroutine e02bef
      End Interface
      Interface
        Subroutine e02caf(m,n,k,l,x,y,f,w,mtot,a,na,xmin,xmax,nux,inuxp1,nuy, &
            inuyp1,work,nwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: inuxp1, inuyp1, k, l, mtot, n, na, nwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(na), work(nwork)
          Real (Kind=wp), Intent (In) :: f(mtot), nux(inuxp1), nuy(inuyp1), &
            w(mtot), x(mtot), xmax(n), xmin(n), y(n)
          Integer, Intent (In) :: m(n)
        End Subroutine e02caf
      End Interface
      Interface
        Subroutine e02cbf(mfirst,mlast,k,l,x,xmin,xmax,y,ymin,ymax,ff,a,na, &
            work,nwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmin, y, ymax, ymin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, l, mfirst, mlast, na, nwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(na), x(mlast)
          Real (Kind=wp), Intent (Out) :: ff(mlast), work(nwork)
        End Subroutine e02cbf
      End Interface
      Interface
        Subroutine e02daf(m,px,py,x,y,f,w,lamda,mu,point,npoint,dl,c,nc,ws, &
            nws,eps,sigma,rank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Real (Kind=wp), Intent (Out) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, nc, npoint, nws, px, py
          Integer, Intent (Out) :: rank
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(nc), dl(nc), ws(nws)
          Real (Kind=wp), Intent (In) :: f(m), w(m), x(m), y(m)
          Real (Kind=wp), Intent (Inout) :: lamda(px), mu(py)
          Integer, Intent (In) :: point(npoint)
        End Subroutine e02daf
      End Interface
      Interface
        Subroutine e02dcf(start,mx,x,my,y,f,s,nxest,nyest,nx,lamda,ny,mu,c,fp, &
            wrk,lwrk,iwrk,liwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fp
          Real (Kind=wp), Intent (In) :: s
          Integer, Intent (Inout) :: ifail, nx, ny
          Integer, Intent (In) :: liwrk, lwrk, mx, my, nxest, nyest
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c((nxest-4)*(nyest-4))
          Real (Kind=wp), Intent (In) :: f(mx*my), x(mx), y(my)
          Real (Kind=wp), Intent (Inout) :: lamda(nxest), mu(nyest), wrk(lwrk)
          Integer, Intent (Inout) :: iwrk(liwrk)
        End Subroutine e02dcf
      End Interface
      Interface
        Subroutine e02ddf(start,m,x,y,f,w,s,nxest,nyest,nx,lamda,ny,mu,c,fp, &
            rank,wrk,lwrk,iwrk,liwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fp
          Real (Kind=wp), Intent (In) :: s
          Integer, Intent (Inout) :: ifail, nx, ny
          Integer, Intent (In) :: liwrk, lwrk, m, nxest, nyest
          Integer, Intent (Out) :: rank
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c((nxest-4)*(nyest-4))
          Real (Kind=wp), Intent (In) :: f(m), w(m)
          Real (Kind=wp), Intent (Inout) :: lamda(nxest), mu(nyest), &
            wrk(lwrk), x(m), y(m)
          Integer, Intent (Out) :: iwrk(liwrk)
        End Subroutine e02ddf
      End Interface
      Interface
        Subroutine e02def(m,px,py,x,y,lamda,mu,c,ff,wrk,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, px, py
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c((px-4)*(py-4)), lamda(px), mu(py), &
            x(m), y(m)
          Real (Kind=wp), Intent (Out) :: ff(m), wrk(py-4)
          Integer, Intent (Out) :: iwrk(py-4)
        End Subroutine e02def
      End Interface
      Interface
        Subroutine e02dff(mx,my,px,py,x,y,lamda,mu,c,ff,wrk,lwrk,iwrk,liwrk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liwrk, lwrk, mx, my, px, py
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c((px-4)*(py-4)), lamda(px), mu(py), &
            x(mx), y(my)
          Real (Kind=wp), Intent (Out) :: ff(mx*my), wrk(lwrk)
          Integer, Intent (Out) :: iwrk(liwrk)
        End Subroutine e02dff
      End Interface
      Interface
        Subroutine e02dhf(mx,my,px,py,x,y,lamda,mu,c,nux,nuy,z,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: mx, my, nux, nuy, px, py
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c((px-4)*(py-4)), lamda(px), mu(py), &
            x(mx), y(my)
          Real (Kind=wp), Intent (Out) :: z(mx*my)
        End Subroutine e02dhf
      End Interface
      Interface
        Subroutine e02gaf(m,a,lda,b,nplus2,toler,x,resid,irank,iter,iwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: resid
          Real (Kind=wp), Intent (In) :: toler
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irank, iter
          Integer, Intent (In) :: lda, m, nplus2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,nplus2), b(m)
          Real (Kind=wp), Intent (Out) :: x(nplus2)
          Integer, Intent (Out) :: iwork(m)
        End Subroutine e02gaf
      End Interface
      Interface
        Subroutine e02gbf(m,n,mpl,e,lde,f,x,mxs,monit,iprint,k,el1n,indx,w,iw, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: el1n
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iprint, iw, lde, m, mpl, mxs, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: e(lde,mpl), x(n)
          Real (Kind=wp), Intent (In) :: f(mpl)
          Real (Kind=wp), Intent (Out) :: w(iw)
          Integer, Intent (Out) :: indx(mpl)
!         .. Interface Blocks ..
          Interface
            Subroutine monit(n,x,niter,k,el1n)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: el1n
              Integer, Intent (In) :: k, n, niter
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine monit
          End Interface
        End Subroutine e02gbf
      End Interface
      Interface
        Subroutine e02gcf(m,n,sda,lda,a,b,tol,relerr,x,resmax,irank,iter, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: relerr
          Real (Kind=wp), Intent (Out) :: resmax
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irank, iter
          Integer, Intent (In) :: lda, m, n, sda
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,sda), b(m)
          Real (Kind=wp), Intent (Out) :: x(n)
        End Subroutine e02gcf
      End Interface
      Interface
        Subroutine e02raf(ia,ib,c,ic,a,b,w,jw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ia, ib, ic, jw
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(ia), b(ib), w(jw)
          Real (Kind=wp), Intent (In) :: c(ic)
        End Subroutine e02raf
      End Interface
      Interface
        Subroutine e02rbf(a,ia,b,ib,x,ans,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ans
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (In) :: ia, ib
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(ia), b(ib)
        End Subroutine e02rbf
      End Interface
      Interface
        Subroutine e02zaf(px,py,lamda,mu,m,x,y,point,npoint,adres,nadres, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, nadres, npoint, px, py
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: lamda(px), mu(py), x(m), y(m)
          Integer, Intent (Out) :: adres(nadres), point(npoint)
        End Subroutine e02zaf
      End Interface
      Interface
        Subroutine e04aba(funct,e1,e2,a,b,maxcal,x,f,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b, e1, e2
          Real (Kind=wp), Intent (Out) :: f, x
          Integer, Intent (Inout) :: ifail, maxcal
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(xc,fc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Real (Kind=wp), Intent (In) :: xc
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct
          End Interface
        End Subroutine e04aba
      End Interface
      Interface
        Subroutine e04abf(funct,e1,e2,a,b,maxcal,x,f,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b, e1, e2
          Real (Kind=wp), Intent (Out) :: f, x
          Integer, Intent (Inout) :: ifail, maxcal
!         .. Interface Blocks ..
          Interface
            Subroutine funct(xc,fc)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Real (Kind=wp), Intent (In) :: xc
            End Subroutine funct
          End Interface
        End Subroutine e04abf
      End Interface
      Interface
        Subroutine e04bba(funct,e1,e2,a,b,maxcal,x,f,g,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b, e1, e2
          Real (Kind=wp), Intent (Out) :: f, g, x
          Integer, Intent (Inout) :: ifail, maxcal
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(xc,fc,gc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc, gc
              Real (Kind=wp), Intent (In) :: xc
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct
          End Interface
        End Subroutine e04bba
      End Interface
      Interface
        Subroutine e04bbf(funct,e1,e2,a,b,maxcal,x,f,g,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b, e1, e2
          Real (Kind=wp), Intent (Out) :: f, g, x
          Integer, Intent (Inout) :: ifail, maxcal
!         .. Interface Blocks ..
          Interface
            Subroutine funct(xc,fc,gc)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc, gc
              Real (Kind=wp), Intent (In) :: xc
            End Subroutine funct
          End Interface
        End Subroutine e04bbf
      End Interface
      Interface
        Subroutine e04cbf(n,x,f,tolf,tolx,funct,monit,maxcal,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Real (Kind=wp), Intent (In) :: tolf, tolx
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxcal, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(n,xc,fc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct
          End Interface
          Interface
            Subroutine monit(fmin,fmax,sim,n,ncall,serror,vratio,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: fmax, fmin, serror, vratio
              Integer, Intent (In) :: n, ncall
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: sim(n+1,n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monit
          End Interface
        End Subroutine e04cbf
      End Interface
      Interface
        Subroutine e04cbk(fmin,fmax,sim,n,ncall,serror,vratio,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fmax, fmin, serror, vratio
          Integer, Intent (In) :: n, ncall
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Real (Kind=wp), Intent (In) :: sim(n+1,n)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e04cbk
      End Interface
      Interface
        Subroutine e04cca(n,x,f,tol,iw,w1,w2,w3,w4,w5,w6,funct,monit,maxcal, &
            iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iw, maxcal, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w1(n), w2(n), w3(n), w4(n), w5(iw), &
            w6(iw,n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(n,xc,fc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct
          End Interface
          Interface
            Subroutine monit(fmin,fmax,sim,n,nvert,ncall,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: fmax, fmin
              Integer, Intent (In) :: n, ncall, nvert
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: sim(nvert,n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monit
          End Interface
        End Subroutine e04cca
      End Interface
      Interface
        Subroutine e04ccf(n,x,f,tol,iw,w1,w2,w3,w4,w5,w6,funct,monit,maxcal, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iw, maxcal, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: w1(n), w2(n), w3(n), w4(n), w5(iw), &
            w6(iw,n)
          Real (Kind=wp), Intent (Inout) :: x(n)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(n,xc,fc)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: xc(n)
            End Subroutine funct
          End Interface
          Interface
            Subroutine monit(fmin,fmax,sim,n,nvert,ncall)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: fmax, fmin
              Integer, Intent (In) :: n, ncall, nvert
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: sim(nvert,n)
            End Subroutine monit
          End Interface
        End Subroutine e04ccf
      End Interface
      Interface
        Subroutine e04dga(n,objfun,iter,objf,objgrd,x,iwork,work,iuser,ruser, &
            lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: objgrd(n), work(13*n)
          Real (Kind=wp), Intent (Inout) :: ruser(*), rwsav(475), x(n)
          Integer, Intent (Inout) :: iuser(*), iwsav(610)
          Integer, Intent (Out) :: iwork(n+1)
          Logical, Intent (Inout) :: lwsav(120)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04dga
      End Interface
      Interface
        Subroutine e04dgf(n,objfun,iter,objf,objgrd,x,iwork,work,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: objgrd(n), work(13*n)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (Out) :: iwork(n+1)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04dgf
      End Interface
      Interface
        Subroutine e04dja(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04dja
      End Interface
      Interface
        Subroutine e04djf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04djf
      End Interface
      Interface
        Subroutine e04dka(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04dka
      End Interface
      Interface
        Subroutine e04dkf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04dkf
      End Interface
      Interface
        Subroutine e04fcf(m,n,lsqfun,lsqmon,iprint,maxcal,eta,xtol,stepmx,x, &
            fsumsq,fvec,fjac,ldfjac,s,v,ldv,niter,nf,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iprint, ldfjac, ldv, liw, lw, m, maxcal, n
          Integer, Intent (Out) :: nf, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), v(ldv,n), w(lw), &
            x(n)
          Real (Kind=wp), Intent (Out) :: fvec(m), s(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
          Interface
            Subroutine lsqmon(m,n,xc,fvec,fjac,ldfjac,s,igrade,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: igrade, ldfjac, liw, lw, m, n, nf, niter
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), s(n), &
                xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqmon
          End Interface
        End Subroutine e04fcf
      End Interface
      Interface
        Subroutine e04fdz(m,n,xc,fvec,fjac,ldfjac,s,igrade,niter,nf,iw,liw,w, &
            lw)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: igrade, ldfjac, liw, lw, m, n, nf, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), s(n), xc(n)
          Real (Kind=wp), Intent (Inout) :: w(lw)
          Integer, Intent (Inout) :: iw(liw)
        End Subroutine e04fdz
      End Interface
      Interface
        Subroutine e04fyf(m,n,lsfun1,x,fsumsq,w,lw,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w(lw)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine lsfun1(m,n,xc,fvec,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine lsfun1
          End Interface
        End Subroutine e04fyf
      End Interface
      Interface
        Subroutine e04gbf(m,n,lsqlin,lsqfun,lsqmon,iprint,maxcal,eta,xtol, &
            stepmx,x,fsumsq,fvec,fjac,ldfjac,s,v,ldv,niter,nf,iw,liw,w,lw, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iprint, ldfjac, ldv, liw, lw, m, maxcal, n
          Integer, Intent (Out) :: nf, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), v(ldv,n), w(lw), &
            x(n)
          Real (Kind=wp), Intent (Out) :: fvec(m), s(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqlin(selct)
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Out) :: selct
            End Subroutine lsqlin
          End Interface
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,fjac,ldfjac,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
          Interface
            Subroutine lsqmon(m,n,xc,fvec,fjac,ldfjac,s,igrade,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: igrade, ldfjac, liw, lw, m, n, nf, niter
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), s(n), &
                xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqmon
          End Interface
        End Subroutine e04gbf
      End Interface
      Interface
        Subroutine e04fcv(selct)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: selct
        End Subroutine e04fcv
      End Interface
      Interface
        Subroutine e04hev(selct)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: selct
        End Subroutine e04hev
      End Interface
      Interface
        Subroutine e04gdf(m,n,lsqfun,lsqmon,iprint,maxcal,eta,xtol,stepmx,x, &
            fsumsq,fvec,fjac,ldfjac,s,v,ldv,niter,nf,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iprint, ldfjac, ldv, liw, lw, m, maxcal, n
          Integer, Intent (Out) :: nf, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), v(ldv,n), w(lw), &
            x(n)
          Real (Kind=wp), Intent (Out) :: fvec(m), s(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,fjac,ldfjac,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
          Interface
            Subroutine lsqmon(m,n,xc,fvec,fjac,ldfjac,s,igrade,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: igrade, ldfjac, liw, lw, m, n, nf, niter
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), s(n), &
                xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqmon
          End Interface
        End Subroutine e04gdf
      End Interface
      Interface
        Subroutine e04gyf(m,n,lsfun2,x,fsumsq,w,lw,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w(lw)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine lsfun2(m,n,xc,fvec,fjac,ldfjac,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfjac, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), ruser(*)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine lsfun2
          End Interface
        End Subroutine e04gyf
      End Interface
      Interface
        Subroutine e04gzf(m,n,lsfun2,x,fsumsq,w,lw,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w(lw)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine lsfun2(m,n,xc,fvec,fjac,ldfjac,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfjac, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), ruser(*)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine lsfun2
          End Interface
        End Subroutine e04gzf
      End Interface
      Interface
        Subroutine e04hcf(n,funct,x,f,g,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liw, lw, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: g(n)
          Real (Kind=wp), Intent (Inout) :: w(lw)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(iflag,n,xc,fc,gc,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine funct
          End Interface
        End Subroutine e04hcf
      End Interface
      Interface
        Subroutine e04hdf(n,funct,h,x,g,hesl,lh,hesd,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lh, liw, lw, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: g(n), hesd(n), hesl(lh)
          Real (Kind=wp), Intent (Inout) :: w(lw)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(iflag,n,xc,fc,gc,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine funct
          End Interface
          Interface
            Subroutine h(iflag,n,xc,fhesl,lh,fhesd,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: lh, liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fhesd(n), w(lw)
              Real (Kind=wp), Intent (Out) :: fhesl(lh)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine h
          End Interface
        End Subroutine e04hdf
      End Interface
      Interface
        Subroutine e04hef(m,n,lsqfun,lsqhes,lsqmon,iprint,maxcal,eta,xtol, &
            stepmx,x,fsumsq,fvec,fjac,ldfjac,s,v,ldv,niter,nf,iw,liw,w,lw, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iprint, ldfjac, ldv, liw, lw, m, maxcal, n
          Integer, Intent (Out) :: nf, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), v(ldv,n), w(lw), &
            x(n)
          Real (Kind=wp), Intent (Out) :: fvec(m), s(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,fjac,ldfjac,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
          Interface
            Subroutine lsqhes(iflag,m,n,fvec,xc,b,lb,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: lb, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: b(lb)
              Real (Kind=wp), Intent (In) :: fvec(m), xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqhes
          End Interface
          Interface
            Subroutine lsqmon(m,n,xc,fvec,fjac,ldfjac,s,igrade,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: igrade, ldfjac, liw, lw, m, n, nf, niter
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: fjac(ldfjac,n), fvec(m), s(n), &
                xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqmon
          End Interface
        End Subroutine e04hef
      End Interface
      Interface
        Subroutine e04hyf(m,n,lsfun2,lshes2,x,fsumsq,w,lw,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w(lw)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine lsfun2(m,n,xc,fvec,fjac,ldfjac,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfjac, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), ruser(*)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine lsfun2
          End Interface
          Interface
            Subroutine lshes2(m,n,fvec,xc,b,lb,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: lb, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: b(lb)
              Real (Kind=wp), Intent (In) :: fvec(m), xc(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine lshes2
          End Interface
        End Subroutine e04hyf
      End Interface
      Interface
        Subroutine e04jcf(objfun,n,npt,x,bl,bu,rhobeg,rhoend,monfun,maxcal,f, &
            nf,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Real (Kind=wp), Intent (In) :: rhobeg, rhoend
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxcal, n, npt
          Integer, Intent (Out) :: nf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(n), bu(n)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(n,x,f,iuser,ruser,inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: f
              Integer, Intent (Out) :: inform
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine monfun(n,nf,x,f,rho,iuser,ruser,inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: f, rho
              Integer, Intent (Out) :: inform
              Integer, Intent (In) :: n, nf
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monfun
          End Interface
        End Subroutine e04jcf
      End Interface
      Interface
        Subroutine e04jcp(n,nf,x,f,rho,iuser,ruser,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: f, rho
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: n, nf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e04jcp
      End Interface
      Interface
        Subroutine e04jyf(n,ibound,funct1,bl,bu,x,f,iw,liw,w,lw,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, liw, lw, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: w(lw)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (Out) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct1(n,xc,fc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct1
          End Interface
        End Subroutine e04jyf
      End Interface
      Interface
        Subroutine e04kdf(n,funct,monit,iprint,maxcal,eta,xtol,delta,stepmx, &
            ibound,bl,bu,x,hesl,lh,hesd,istate,f,g,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: delta, eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, iprint, lh, liw, lw, maxcal, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), w(lw), x(n)
          Real (Kind=wp), Intent (Out) :: g(n), hesd(n), hesl(lh)
          Integer, Intent (Out) :: istate(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(iflag,n,xc,fc,gc,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine funct
          End Interface
          Interface
            Subroutine monit(n,xc,fc,gc,istate,gpjnrm,cond,posdef,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: cond, fc, gpjnrm
              Integer, Intent (In) :: liw, lw, n, nf, niter
              Logical, Intent (In) :: posdef
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: gc(n), xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (In) :: istate(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine monit
          End Interface
        End Subroutine e04kdf
      End Interface
      Interface
        Subroutine e04kyf(n,ibound,funct2,bl,bu,x,f,g,iw,liw,w,lw,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, liw, lw, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: g(n), w(lw)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (Out) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct2(n,xc,fc,gc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct2
          End Interface
        End Subroutine e04kyf
      End Interface
      Interface
        Subroutine e04kzf(n,ibound,funct2,bl,bu,x,f,g,iw,liw,w,lw,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, liw, lw, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: g(n), w(lw)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (Out) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct2(n,xc,fc,gc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct2
          End Interface
        End Subroutine e04kzf
      End Interface
      Interface
        Subroutine e04lbf(n,funct,h,monit,iprint,maxcal,eta,xtol,stepmx, &
            ibound,bl,bu,x,hesl,lh,hesd,istate,f,g,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta, stepmx, xtol
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, iprint, lh, liw, lw, maxcal, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), w(lw), x(n)
          Real (Kind=wp), Intent (Out) :: g(n), hesd(n), hesl(lh)
          Integer, Intent (Out) :: istate(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct(iflag,n,xc,fc,gc,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine funct
          End Interface
          Interface
            Subroutine h(iflag,n,xc,fhesl,lh,fhesd,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: lh, liw, lw, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fhesd(n), w(lw)
              Real (Kind=wp), Intent (Out) :: fhesl(lh)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine h
          End Interface
          Interface
            Subroutine monit(n,xc,fc,gc,istate,gpjnrm,cond,posdef,niter,nf,iw, &
                liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: cond, fc, gpjnrm
              Integer, Intent (In) :: liw, lw, n, nf, niter
              Logical, Intent (In) :: posdef
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: gc(n), xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (In) :: istate(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine monit
          End Interface
        End Subroutine e04lbf
      End Interface
      Interface
        Subroutine e04lyf(n,ibound,funct2,hess2,bl,bu,x,f,g,iw,liw,w,lw,iuser, &
            ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: f
          Integer, Intent (In) :: ibound, liw, lw, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), ruser(*), x(n)
          Real (Kind=wp), Intent (Out) :: g(n), w(lw)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (Out) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine funct2(n,xc,fc,gc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: fc
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: gc(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine funct2
          End Interface
          Interface
            Subroutine hess2(n,xc,heslc,lh,hesdc,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: lh, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: hesdc(n), heslc(lh)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine hess2
          End Interface
        End Subroutine e04lyf
      End Interface
      Interface
        Subroutine e04mfa(n,nclin,a,lda,bl,bu,cvec,istate,x,iter,obj,ax, &
            clamda,iwork,liwork,work,lwork,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, liwork, lwork, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin), bu(n+nclin), &
            cvec(*)
          Real (Kind=wp), Intent (Out) :: ax(max(1,nclin)), clamda(n+nclin), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: rwsav(475), x(n)
          Integer, Intent (Inout) :: istate(n+nclin), iwsav(610)
          Integer, Intent (Out) :: iwork(liwork)
          Logical, Intent (Inout) :: lwsav(120)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04mfa
      End Interface
      Interface
        Subroutine e04mff(n,nclin,a,lda,bl,bu,cvec,istate,x,iter,obj,ax, &
            clamda,iwork,liwork,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, liwork, lwork, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin), bu(n+nclin), &
            cvec(*)
          Real (Kind=wp), Intent (Out) :: ax(max(1,nclin)), clamda(n+nclin), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (Inout) :: istate(n+nclin)
          Integer, Intent (Out) :: iwork(liwork)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04mff
      End Interface
      Interface
        Subroutine e04mga(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04mga
      End Interface
      Interface
        Subroutine e04mgf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04mgf
      End Interface
      Interface
        Subroutine e04mha(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04mha
      End Interface
      Interface
        Subroutine e04mhf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04mhf
      End Interface
      Interface
        Subroutine e04mzf(infile,maxn,maxm,maxnnz,xbldef,xbudef,mpslst,n,m, &
            nnz,iobj,ncolh,a,ha,ka,bl,bu,start,names,nname,crname,xs,istate, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xbldef, xbudef
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: infile, maxm, maxn, maxnnz
          Integer, Intent (Out) :: iobj, m, n, ncolh, nname, nnz
          Logical, Intent (In) :: mpslst
          Character (1), Intent (Out) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(maxnnz), bl(maxn+maxm), &
            bu(maxn+maxm), xs(maxn+maxm)
          Integer, Intent (Out) :: ha(maxnnz), istate(maxn+maxm), ka(maxn+1)
          Character (8), Intent (Out) :: crname(maxn+maxm)
          Character (8), Intent (Inout) :: names(5)
        End Subroutine e04mzf
      End Interface
      Interface
        Subroutine e04nca(m,n,nclin,ldc,lda,c,bl,bu,cvec,istate,kx,x,a,b,iter, &
            obj,clamda,iwork,liwork,work,lwork,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldc, liwork, lwork, m, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(*), rwsav(475), x(n)
          Real (Kind=wp), Intent (In) :: bl(n+nclin), bu(n+nclin), c(ldc,*), &
            cvec(*)
          Real (Kind=wp), Intent (Out) :: clamda(n+nclin), work(lwork)
          Integer, Intent (Inout) :: istate(n+nclin), iwsav(610), kx(n)
          Integer, Intent (Out) :: iwork(liwork)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04nca
      End Interface
      Interface
        Subroutine e04ncf(m,n,nclin,ldc,lda,c,bl,bu,cvec,istate,kx,x,a,b,iter, &
            obj,clamda,iwork,liwork,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldc, liwork, lwork, m, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(*), x(n)
          Real (Kind=wp), Intent (In) :: bl(n+nclin), bu(n+nclin), c(ldc,*), &
            cvec(*)
          Real (Kind=wp), Intent (Out) :: clamda(n+nclin), work(lwork)
          Integer, Intent (Inout) :: istate(n+nclin), kx(n)
          Integer, Intent (Out) :: iwork(liwork)
        End Subroutine e04ncf
      End Interface
      Interface
        Subroutine e04nda(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04nda
      End Interface
      Interface
        Subroutine e04ndf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04ndf
      End Interface
      Interface
        Subroutine e04nea(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04nea
      End Interface
      Interface
        Subroutine e04nef(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04nef
      End Interface
      Interface
        Subroutine e04nfa(n,nclin,a,lda,bl,bu,cvec,h,ldh,qphess,istate,x,iter, &
            obj,ax,clamda,iwork,liwork,work,lwork,iuser,ruser,lwsav,iwsav, &
            rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldh, liwork, lwork, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin), bu(n+nclin), &
            cvec(*), h(ldh,*)
          Real (Kind=wp), Intent (Out) :: ax(max(1,nclin)), clamda(n+nclin), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: ruser(*), rwsav(475), x(n)
          Integer, Intent (Inout) :: istate(n+nclin), iuser(*), iwsav(610)
          Integer, Intent (Out) :: iwork(liwork)
          Logical, Intent (Inout) :: lwsav(120)
!         .. Interface Blocks ..
          Interface
            Subroutine qphess(n,jthcol,h,ldh,x,hx,iuser,ruser,iwsav)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: jthcol, ldh, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: h(ldh,*), x(n)
              Real (Kind=wp), Intent (Out) :: hx(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*), iwsav(610)
            End Subroutine qphess
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04nfa
      End Interface
      Interface
        Subroutine e54nfu(n,jthcol,h,ldh,x,hx,iuser,ruser,iwsav)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: jthcol, ldh, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: h(ldh,*), x(n)
          Real (Kind=wp), Intent (Out) :: hx(n)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*), iwsav(610)
        End Subroutine e54nfu
      End Interface
      Interface
        Subroutine e04nff(n,nclin,a,lda,bl,bu,cvec,h,ldh,qphess,istate,x,iter, &
            obj,ax,clamda,iwork,liwork,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldh, liwork, lwork, n, nclin
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin), bu(n+nclin), &
            cvec(*), h(ldh,*)
          Real (Kind=wp), Intent (Out) :: ax(max(1,nclin)), clamda(n+nclin), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (Inout) :: istate(n+nclin)
          Integer, Intent (Out) :: iwork(liwork)
!         .. Interface Blocks ..
          Interface
            Subroutine qphess(n,jthcol,h,ldh,x,hx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: jthcol, ldh, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: h(ldh,*), x(n)
              Real (Kind=wp), Intent (Out) :: hx(n)
            End Subroutine qphess
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04nff
      End Interface
      Interface
        Subroutine e04nfu(n,jthcol,h,ldh,x,hx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: jthcol, ldh, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: h(ldh,*), x(n)
          Real (Kind=wp), Intent (Out) :: hx(n)
        End Subroutine e04nfu
      End Interface
      Interface
        Subroutine e04nga(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04nga
      End Interface
      Interface
        Subroutine e04ngf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04ngf
      End Interface
      Interface
        Subroutine e04nha(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04nha
      End Interface
      Interface
        Subroutine e04nhf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04nhf
      End Interface
      Interface
        Subroutine e04nka(n,m,nnz,iobj,ncolh,qphx,a,ha,ka,bl,bu,start,names, &
            nname,crname,ns,xs,istate,miniz,minz,ninf,sinf,obj,clamda,iz, &
            leniz,z,lenz,iuser,ruser,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj, sinf
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, leniz, lenz, m, n, ncolh, nname, nnz
          Integer, Intent (Out) :: miniz, minz, ninf
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(nnz), bl(n+m), bu(n+m), &
            ruser(*), rwsav(285), xs(n+m)
          Real (Kind=wp), Intent (Out) :: clamda(n+m), z(lenz)
          Integer, Intent (In) :: ha(nnz), ka(n+1)
          Integer, Intent (Inout) :: istate(n+m), iuser(*), iwsav(380)
          Integer, Intent (Out) :: iz(leniz)
          Logical, Intent (Inout) :: lwsav(20)
          Character (8), Intent (In) :: crname(nname), names(5)
!         .. Interface Blocks ..
          Interface
            Subroutine qphx(nstate,ncolh,x,hx,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ncolh, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: hx(ncolh)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(ncolh)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine qphx
          End Interface
        End Subroutine e04nka
      End Interface
      Interface
        Subroutine e54nku(nstate,ncolh,x,hx,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ncolh, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: hx(ncolh)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Real (Kind=wp), Intent (In) :: x(ncolh)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e54nku
      End Interface
      Interface
        Subroutine e04nkf(n,m,nnz,iobj,ncolh,qphx,a,ha,ka,bl,bu,start,names, &
            nname,crname,ns,xs,istate,miniz,minz,ninf,sinf,obj,clamda,iz, &
            leniz,z,lenz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj, sinf
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, leniz, lenz, m, n, ncolh, nname, nnz
          Integer, Intent (Out) :: miniz, minz, ninf
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(nnz), bl(n+m), bu(n+m), xs(n+m)
          Real (Kind=wp), Intent (Out) :: clamda(n+m), z(lenz)
          Integer, Intent (In) :: ha(nnz), ka(n+1)
          Integer, Intent (Inout) :: istate(n+m)
          Integer, Intent (Out) :: iz(leniz)
          Character (8), Intent (In) :: crname(nname), names(5)
!         .. Interface Blocks ..
          Interface
            Subroutine qphx(nstate,ncolh,x,hx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ncolh, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: hx(ncolh)
              Real (Kind=wp), Intent (In) :: x(ncolh)
            End Subroutine qphx
          End Interface
        End Subroutine e04nkf
      End Interface
      Interface
        Subroutine e04nku(nstate,ncolh,x,hx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ncolh, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: hx(ncolh)
          Real (Kind=wp), Intent (In) :: x(ncolh)
        End Subroutine e04nku
      End Interface
      Interface
        Subroutine e04nla(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(285)
          Integer, Intent (Inout) :: iwsav(380)
          Logical, Intent (Inout) :: lwsav(20)
        End Subroutine e04nla
      End Interface
      Interface
        Subroutine e04nlf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04nlf
      End Interface
      Interface
        Subroutine e04nma(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(285)
          Integer, Intent (Inout) :: iwsav(380)
          Logical, Intent (Inout) :: lwsav(20)
        End Subroutine e04nma
      End Interface
      Interface
        Subroutine e04nmf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04nmf
      End Interface
      Interface
        Subroutine e04npf(cw,lencw,iw,leniw,rw,lenrw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lencw, leniw, lenrw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rw(lenrw)
          Integer, Intent (Out) :: iw(leniw)
          Character (8), Intent (Out) :: cw(lencw)
        End Subroutine e04npf
      End Interface
      Interface
        Subroutine e04nqf(start,qphx,m,n,ne,nname,lenc,ncolh,iobj,objadd,prob, &
            acol,inda,loca,bl,bu,c,names,helast,hs,x,pi,rc,ns,ninf,sinf,obj, &
            cw,lencw,iw,leniw,rw,lenrw,cuser,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj, sinf
          Real (Kind=wp), Intent (In) :: objadd
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, lenc, lencw, leniw, lenrw, m, n, &
            ncolh, ne, nname
          Integer, Intent (Out) :: ninf
          Character (8), Intent (In) :: prob
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: acol(ne), bl(n+m), bu(n+m), &
            c(max(1,lenc)), ruser(*), rw(lenrw), x(n+m)
          Real (Kind=wp), Intent (Out) :: pi(m), rc(n+m)
          Integer, Intent (In) :: helast(n+m), inda(ne), loca(n+1)
          Integer, Intent (Inout) :: hs(n+m), iuser(*), iw(leniw)
          Character (8), Intent (Inout) :: cuser(*), cw(lencw)
          Character (8), Intent (In) :: names(nname)
!         .. Interface Blocks ..
          Interface
            Subroutine qphx(ncolh,x,hx,nstate,cuser,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ncolh, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: hx(ncolh)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(ncolh)
              Integer, Intent (Inout) :: iuser(*)
              Character (8), Intent (Inout) :: cuser(*)
            End Subroutine qphx
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04nqf
      End Interface
      Interface
        Subroutine e04nsh(ncolh,x,hx,nstate,cuser,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ncolh, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: hx(ncolh)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Real (Kind=wp), Intent (In) :: x(ncolh)
          Integer, Intent (Inout) :: iuser(*)
          Character (8), Intent (Inout) :: cuser(*)
        End Subroutine e04nsh
      End Interface
      Interface
        Subroutine e04nrf(ispecs,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ispecs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04nrf
      End Interface
      Interface
        Subroutine e04nsf(string,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04nsf
      End Interface
      Interface
        Subroutine e04ntf(string,ivalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04ntf
      End Interface
      Interface
        Subroutine e04nuf(string,rvalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04nuf
      End Interface
      Interface
        Subroutine e04nxf(string,ivalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04nxf
      End Interface
      Interface
        Subroutine e04nyf(string,rvalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04nyf
      End Interface
      Interface
        Subroutine e04uca(n,nclin,ncnln,lda,ldcj,ldr,a,bl,bu,confun,objfun, &
            iter,istate,c,cjac,clamda,objf,objgrd,r,x,iwork,liwork,work,lwork, &
            iuser,ruser,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldcj, ldr, liwork, lwork, n, nclin, &
            ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Out) :: c(max(1,ncnln)), objgrd(n), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,*), &
            clamda(n+nclin+ncnln), r(ldr,n), ruser(*), rwsav(475), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iuser(*), &
            iwsav(610)
          Integer, Intent (Out) :: iwork(liwork)
          Logical, Intent (Inout) :: lwsav(120)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: objgrd(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04uca
      End Interface
      Interface
        Subroutine e04ucf(n,nclin,ncnln,lda,ldcj,ldr,a,bl,bu,confun,objfun, &
            iter,istate,c,cjac,clamda,objf,objgrd,r,x,iwork,liwork,work,lwork, &
            iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldcj, ldr, liwork, lwork, n, nclin, &
            ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Out) :: c(max(1,ncnln)), objgrd(n), &
            work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,*), &
            clamda(n+nclin+ncnln), r(ldr,n), ruser(*), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iuser(*)
          Integer, Intent (Out) :: iwork(liwork)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: objgrd(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04ucf
      End Interface
      Interface
        Subroutine e04udm(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldcj, n, ncnln, nstate
          Integer, Intent (Inout) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ncnln)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (In) :: needc(ncnln)
        End Subroutine e04udm
      End Interface
      Interface
        Subroutine e04uda(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04uda
      End Interface
      Interface
        Subroutine e04udf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04udf
      End Interface
      Interface
        Subroutine e04uea(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04uea
      End Interface
      Interface
        Subroutine e04uef(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04uef
      End Interface
      Interface
        Subroutine e04ufa(irevcm,n,nclin,ncnln,lda,ldcj,ldr,a,bl,bu,iter, &
            istate,c,cjac,clamda,objf,objgrd,r,x,needc,iwork,liwork,work, &
            lwork,cwsav,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: objf
          Integer, Intent (Inout) :: ifail, irevcm, iter
          Integer, Intent (In) :: lda, ldcj, ldr, liwork, lwork, n, nclin, &
            ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Inout) :: c(*), cjac(ldcj,*), &
            clamda(n+nclin+ncnln), objgrd(n), r(ldr,n), rwsav(475), &
            work(lwork), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iwork(liwork), &
            iwsav(610)
          Integer, Intent (Out) :: needc(max(1,ncnln))
          Logical, Intent (Inout) :: lwsav(120)
          Character (80), Intent (Inout) :: cwsav(5)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04ufa
      End Interface
      Interface
        Subroutine e04uff(irevcm,n,nclin,ncnln,lda,ldcj,ldr,a,bl,bu,iter, &
            istate,c,cjac,clamda,objf,objgrd,r,x,needc,iwork,liwork,work, &
            lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: objf
          Integer, Intent (Inout) :: ifail, irevcm, iter
          Integer, Intent (In) :: lda, ldcj, ldr, liwork, lwork, n, nclin, &
            ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Inout) :: c(*), cjac(ldcj,*), &
            clamda(n+nclin+ncnln), objgrd(n), r(ldr,n), work(lwork), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iwork(liwork)
          Integer, Intent (Out) :: needc(max(1,ncnln))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04uff
      End Interface
      Interface
        Subroutine e04uga(confun,objfun,n,m,ncnln,nonln,njnln,iobj,nnz,a,ha, &
            ka,bl,bu,start,nname,names,ns,xs,istate,clamda,miniz,minz,ninf, &
            sinf,obj,iz,leniz,z,lenz,iuser,ruser,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj, sinf
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, leniz, lenz, m, n, ncnln, njnln, &
            nname, nnz, nonln
          Integer, Intent (Out) :: miniz, minz, ninf
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(nnz), bl(n+m), bu(n+m), &
            clamda(n+m), ruser(*), rwsav(550), xs(n+m)
          Real (Kind=wp), Intent (Out) :: z(lenz)
          Integer, Intent (In) :: ha(nnz), ka(n+1)
          Integer, Intent (Inout) :: istate(n+m), iuser(*), iwsav(550)
          Integer, Intent (Out) :: iz(leniz)
          Logical, Intent (Inout) :: lwsav(20)
          Character (8), Intent (In) :: names(nname)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,njnln,nnzjac,x,f,fjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: ncnln, njnln, nnzjac, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: f(ncnln)
              Real (Kind=wp), Intent (Inout) :: fjac(nnzjac), ruser(*)
              Real (Kind=wp), Intent (In) :: x(njnln)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,nonln,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: nonln, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: objgrd(nonln), ruser(*)
              Real (Kind=wp), Intent (In) :: x(nonln)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04uga
      End Interface
      Interface
        Subroutine e04ugf(confun,objfun,n,m,ncnln,nonln,njnln,iobj,nnz,a,ha, &
            ka,bl,bu,start,nname,names,ns,xs,istate,clamda,miniz,minz,ninf, &
            sinf,obj,iz,leniz,z,lenz,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj, sinf
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, leniz, lenz, m, n, ncnln, njnln, &
            nname, nnz, nonln
          Integer, Intent (Out) :: miniz, minz, ninf
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(nnz), bl(n+m), bu(n+m), &
            clamda(n+m), ruser(*), xs(n+m)
          Real (Kind=wp), Intent (Out) :: z(lenz)
          Integer, Intent (In) :: ha(nnz), ka(n+1)
          Integer, Intent (Inout) :: istate(n+m), iuser(*)
          Integer, Intent (Out) :: iz(leniz)
          Character (8), Intent (In) :: names(nname)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,njnln,nnzjac,x,f,fjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: ncnln, njnln, nnzjac, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: f(ncnln)
              Real (Kind=wp), Intent (Inout) :: fjac(nnzjac), ruser(*)
              Real (Kind=wp), Intent (In) :: x(njnln)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,nonln,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: nonln, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: objgrd(nonln), ruser(*)
              Real (Kind=wp), Intent (In) :: x(nonln)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04ugf
      End Interface
      Interface
        Subroutine e04ugm(mode,ncnln,njnln,nnzjac,x,f,fjac,nstate,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: mode
          Integer, Intent (In) :: ncnln, njnln, nnzjac, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: f(ncnln)
          Real (Kind=wp), Intent (Inout) :: fjac(nnzjac), ruser(*)
          Real (Kind=wp), Intent (In) :: x(njnln)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e04ugm
      End Interface
      Interface
        Subroutine e04ugn(mode,nonln,x,objf,objgrd,nstate,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: mode
          Integer, Intent (In) :: nonln, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: objgrd(nonln), ruser(*)
          Real (Kind=wp), Intent (In) :: x(nonln)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e04ugn
      End Interface
      Interface
        Subroutine e04uha(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(550)
          Integer, Intent (Inout) :: iwsav(550)
          Logical, Intent (Inout) :: lwsav(20)
        End Subroutine e04uha
      End Interface
      Interface
        Subroutine e04uhf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04uhf
      End Interface
      Interface
        Subroutine e04uja(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(550)
          Integer, Intent (Inout) :: iwsav(550)
          Logical, Intent (Inout) :: lwsav(20)
        End Subroutine e04uja
      End Interface
      Interface
        Subroutine e04ujf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04ujf
      End Interface
      Interface
        Subroutine e04uqa(ioptns,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04uqa
      End Interface
      Interface
        Subroutine e04uqf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine e04uqf
      End Interface
      Interface
        Subroutine e04ura(str,lwsav,iwsav,rwsav,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rwsav(475)
          Integer, Intent (Inout) :: iwsav(610)
          Logical, Intent (Inout) :: lwsav(120)
        End Subroutine e04ura
      End Interface
      Interface
        Subroutine e04urf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine e04urf
      End Interface
      Interface
        Subroutine e04usa(m,n,nclin,ncnln,lda,ldcj,ldfj,ldr,a,bl,bu,y,confun, &
            objfun,iter,istate,c,cjac,f,fjac,clamda,objf,r,x,iwork,liwork, &
            work,lwork,iuser,ruser,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldcj, ldfj, ldr, liwork, lwork, m, n, &
            nclin, ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln), y(m)
          Real (Kind=wp), Intent (Out) :: c(max(1,ncnln)), f(m), work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,*), &
            clamda(n+nclin+ncnln), fjac(ldfj,n), r(ldr,n), ruser(*), &
            rwsav(475), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iuser(*), &
            iwsav(610)
          Integer, Intent (Out) :: iwork(liwork)
          Logical, Intent (Inout) :: lwsav(120)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,m,n,ldfj,needfi,x,f,fjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfj, m, n, needfi, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: f(m)
              Real (Kind=wp), Intent (Inout) :: fjac(ldfj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04usa
      End Interface
      Interface
        Subroutine e04usf(m,n,nclin,ncnln,lda,ldcj,ldfj,ldr,a,bl,bu,y,confun, &
            objfun,iter,istate,c,cjac,f,fjac,clamda,objf,r,x,iwork,liwork, &
            work,lwork,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: lda, ldcj, ldfj, ldr, liwork, lwork, m, n, &
            nclin, ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln), y(m)
          Real (Kind=wp), Intent (Out) :: c(max(1,ncnln)), f(m), work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,*), &
            clamda(n+nclin+ncnln), fjac(ldfj,n), r(ldr,n), ruser(*), x(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iuser(*)
          Integer, Intent (Out) :: iwork(liwork)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,m,n,ldfj,needfi,x,f,fjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfj, m, n, needfi, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: f(m)
              Real (Kind=wp), Intent (Inout) :: fjac(ldfj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04usf
      End Interface
      Interface
        Subroutine e04vgf(cw,lencw,iw,leniw,rw,lenrw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lencw, leniw, lenrw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rw(lenrw)
          Integer, Intent (Out) :: iw(leniw)
          Character (8), Intent (Out) :: cw(lencw)
        End Subroutine e04vgf
      End Interface
      Interface
        Subroutine e04vhf(start,nf,n,nxname,nfname,objadd,objrow,prob,usrfun, &
            iafun,javar,a,lena,nea,igfun,jgvar,leng,neg,xlow,xupp,xnames,flow, &
            fupp,fnames,x,xstate,xmul,f,fstate,fmul,ns,ninf,sinf,cw,lencw,iw, &
            leniw,rw,lenrw,cuser,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: objadd
          Real (Kind=wp), Intent (Out) :: sinf
          Integer, Intent (Inout) :: ifail, ns, objrow
          Integer, Intent (In) :: lena, lencw, leng, leniw, lenrw, n, nea, &
            neg, nf, nfname, nxname, start
          Integer, Intent (Out) :: ninf
          Character (8), Intent (In) :: prob
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lena), flow(nf), fupp(nf), xlow(n), &
            xupp(n)
          Real (Kind=wp), Intent (Inout) :: f(nf), fmul(nf), ruser(*), &
            rw(lenrw), x(n)
          Real (Kind=wp), Intent (Out) :: xmul(n)
          Integer, Intent (Inout) :: fstate(nf), iuser(*), iw(leniw), &
            xstate(n)
          Integer, Intent (In) :: iafun(lena), igfun(leng), javar(lena), &
            jgvar(leng)
          Character (8), Intent (Inout) :: cuser(*), cw(lencw)
          Character (8), Intent (In) :: fnames(nfname), xnames(nxname)
!         .. Interface Blocks ..
          Interface
            Subroutine usrfun(status,n,x,needf,nf,f,needg,leng,g,cuser,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: leng, n, needf, needg, nf
              Integer, Intent (Inout) :: status
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: f(nf), g(leng), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Character (8), Intent (Inout) :: cuser(*)
            End Subroutine usrfun
          End Interface
        End Subroutine e04vhf
      End Interface
      Interface
        Subroutine e04vjf(nf,n,usrfun,iafun,javar,a,lena,nea,igfun,jgvar,leng, &
            neg,x,xlow,xupp,cw,lencw,iw,leniw,rw,lenrw,cuser,iuser,ruser, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lena, lencw, leng, leniw, lenrw, n, nf
          Integer, Intent (Out) :: nea, neg
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(lena)
          Real (Kind=wp), Intent (Inout) :: ruser(*), rw(lenrw)
          Real (Kind=wp), Intent (In) :: x(n), xlow(n), xupp(n)
          Integer, Intent (Out) :: iafun(lena), igfun(leng), javar(lena), &
            jgvar(leng)
          Integer, Intent (Inout) :: iuser(*), iw(leniw)
          Character (8), Intent (Inout) :: cuser(*), cw(lencw)
!         .. Interface Blocks ..
          Interface
            Subroutine usrfun(status,n,x,needf,nf,f,needg,leng,g,cuser,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: leng, n, needf, needg, nf
              Integer, Intent (Inout) :: status
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: f(nf), g(leng), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Character (8), Intent (Inout) :: cuser(*)
            End Subroutine usrfun
          End Interface
        End Subroutine e04vjf
      End Interface
      Interface
        Subroutine e04vkf(ispecs,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ispecs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vkf
      End Interface
      Interface
        Subroutine e04vlf(string,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vlf
      End Interface
      Interface
        Subroutine e04vmf(string,ivalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vmf
      End Interface
      Interface
        Subroutine e04vnf(string,rvalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vnf
      End Interface
      Interface
        Subroutine e04vrf(string,ivalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vrf
      End Interface
      Interface
        Subroutine e04vsf(string,rvalue,cw,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
          Character (8), Intent (Inout) :: cw(*)
        End Subroutine e04vsf
      End Interface
      Interface
        Subroutine e04wbf(rname,cwsav,lcwsav,lwsav,llwsav,iwsav,liwsav,rwsav, &
            lrwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcwsav, liwsav, llwsav, lrwsav
          Character (*), Intent (In) :: rname
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rwsav(lrwsav)
          Integer, Intent (Out) :: iwsav(liwsav)
          Logical, Intent (Out) :: lwsav(llwsav)
          Character (80), Intent (Out) :: cwsav(lcwsav)
        End Subroutine e04wbf
      End Interface
      Interface
        Subroutine e04wcf(iw,leniw,rw,lenrw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: leniw, lenrw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rw(lenrw)
          Integer, Intent (Out) :: iw(leniw)
        End Subroutine e04wcf
      End Interface
      Interface
        Subroutine e04wdf(n,nclin,ncnln,lda,ldcj,ldh,a,bl,bu,confun,objfun, &
            majits,istate,ccon,cjac,clamda,objf,grad,h,x,iw,leniw,rw,lenrw, &
            iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldcj, ldh, leniw, lenrw, n, nclin, &
            ncnln
          Integer, Intent (Out) :: majits
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Inout) :: ccon(max(1,ncnln)), cjac(ldcj,*), &
            clamda(n+nclin+ncnln), h(ldh,*), ruser(*), rw(lenrw), x(n)
          Real (Kind=wp), Intent (Out) :: grad(n)
          Integer, Intent (Inout) :: istate(n+nclin+ncnln), iuser(*), &
            iw(leniw)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,ccon,cjac,nstate, &
                iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: ccon(max(1,ncnln))
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
!             .. Intrinsic Procedures ..
              Intrinsic :: max
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,grad,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: grad(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04wdf
      End Interface
      Interface
        Subroutine e04wdp(mode,ncnln,n,ldcj,needc,x,ccon,cjac,nstate,iuser, &
            ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldcj, n, ncnln, nstate
          Integer, Intent (Inout) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ccon(max(1,ncnln))
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (In) :: needc(ncnln)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine e04wdp
      End Interface
      Interface
        Subroutine e04wef(ispecs,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ispecs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04wef
      End Interface
      Interface
        Subroutine e04wff(string,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04wff
      End Interface
      Interface
        Subroutine e04wgf(string,ivalue,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04wgf
      End Interface
      Interface
        Subroutine e04whf(string,rvalue,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04whf
      End Interface
      Interface
        Subroutine e04wkf(string,ivalue,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04wkf
      End Interface
      Interface
        Subroutine e04wlf(string,rvalue,iw,rw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: string
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rw(*)
          Integer, Intent (Inout) :: iw(*)
        End Subroutine e04wlf
      End Interface
      Interface
        Subroutine e04xaa(msglvl,n,epsrf,x,mode,objfun,ldh,hforw,objf,objgrd, &
            hcntrl,h,iwarn,work,iuser,ruser,info,lwsav,iwsav,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsrf
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail, mode
          Integer, Intent (Out) :: iwarn
          Integer, Intent (In) :: ldh, msglvl, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: h(ldh,*), hforw(n), ruser(*), &
            work(*), x(n)
          Real (Kind=wp), Intent (Out) :: hcntrl(n), objgrd(n)
          Real (Kind=wp), Intent (In) :: rwsav(1)
          Integer, Intent (Out) :: info(n)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (In) :: iwsav(1)
          Logical, Intent (In) :: lwsav(1)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04xaa
      End Interface
      Interface
        Subroutine e04xaf(msglvl,n,epsrf,x,mode,objfun,ldh,hforw,objf,objgrd, &
            hcntrl,h,iwarn,work,iuser,ruser,info,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: epsrf
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail, mode
          Integer, Intent (Out) :: iwarn
          Integer, Intent (In) :: ldh, msglvl, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: h(ldh,*), hforw(n), ruser(*), &
            work(*), x(n)
          Real (Kind=wp), Intent (Out) :: hcntrl(n), objgrd(n)
          Integer, Intent (Out) :: info(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04xaf
      End Interface
      Interface
        Subroutine e04yaf(m,n,lsqfun,x,fvec,fjac,ldfjac,iw,liw,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfjac, liw, lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
          Real (Kind=wp), Intent (Out) :: fvec(m)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,fjac,ldfjac,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
        End Subroutine e04yaf
      End Interface
      Interface
        Subroutine e04ybf(m,n,lsqfun,lsqhes,x,fvec,fjac,ldfjac,b,lb,iw,liw,w, &
            lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lb, ldfjac, liw, lw, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(lb), fvec(m)
          Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iw(liw)
!         .. Interface Blocks ..
          Interface
            Subroutine lsqfun(iflag,m,n,xc,fvec,fjac,ldfjac,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: ldfjac, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: fjac(ldfjac,n), w(lw)
              Real (Kind=wp), Intent (Out) :: fvec(m)
              Real (Kind=wp), Intent (In) :: xc(n)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqfun
          End Interface
          Interface
            Subroutine lsqhes(iflag,m,n,fvec,xc,b,lb,iw,liw,w,lw)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: lb, liw, lw, m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: b(lb)
              Real (Kind=wp), Intent (In) :: fvec(m), xc(n)
              Real (Kind=wp), Intent (Inout) :: w(lw)
              Integer, Intent (Inout) :: iw(liw)
            End Subroutine lsqhes
          End Interface
        End Subroutine e04ybf
      End Interface
      Interface
        Subroutine e04ycf(job,m,n,fsumsq,s,v,ldv,cj,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fsumsq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: job, ldv, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: cj(n), work(n)
          Real (Kind=wp), Intent (In) :: s(n)
          Real (Kind=wp), Intent (Inout) :: v(ldv,n)
        End Subroutine e04ycf
      End Interface
      Interface
        Subroutine e04zca(n,ncnln,ldcjac,confun,objfun,c,cjac,objf,objgrd,x, &
            work,lwork,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcjac, lwork, n, ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ldcjac), objgrd(n), work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n), ruser(*)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcjac,x,c,cjac,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcjac, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ldcjac)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
        End Subroutine e04zca
      End Interface
      Interface
        Subroutine e54vdm(mode,ncnln,n,ldcjac,x,c,cjac,nstate,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldcjac, n, ncnln, nstate
          Integer, Intent (Inout) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ldcjac)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n), ruser(*)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e54vdm
      End Interface
      Interface
        Subroutine e04zcf(n,ncnln,ldcjac,confun,objfun,c,cjac,objf,objgrd,x, &
            work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: objf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcjac, lwork, n, ncnln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ldcjac), objgrd(n), work(lwork)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n)
          Real (Kind=wp), Intent (In) :: x(n)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcjac,x,c,cjac,nstate)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcjac, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ldcjac)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: objgrd(n)
              Real (Kind=wp), Intent (In) :: x(n)
            End Subroutine objfun
          End Interface
        End Subroutine e04zcf
      End Interface
      Interface
        Subroutine e04vdm(mode,ncnln,n,ldcjac,x,c,cjac,nstate)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldcjac, n, ncnln, nstate
          Integer, Intent (Inout) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ldcjac)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine e04vdm
      End Interface
      Interface
        Subroutine e05jaf(n_r,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, n_r
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: comm(lcomm)
        End Subroutine e05jaf
      End Interface
      Interface
        Subroutine e05jbf(n,objfun,ibound,iinit,bl,bu,sdlist,list,numpts, &
            initpt,monit,x,obj,comm,lcomm,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (In) :: ibound, iinit, lcomm, n, sdlist
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bl(n), bu(n), comm(lcomm), &
            list(n,sdlist), ruser(*)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: initpt(n), iuser(*), numpts(n)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(n,x,f,nstate,iuser,ruser,inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: f
              Integer, Intent (Out) :: inform
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine monit(n,ncall,xbest,icount,ninit,list,numpts,initpt, &
                nbaskt,xbaskt,boxl,boxu,nstate,iuser,ruser,inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Out) :: inform
              Integer, Intent (In) :: n, nbaskt, ncall, ninit, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: boxl(n), boxu(n), list(n,ninit), &
                xbaskt(n,nbaskt), xbest(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (In) :: icount(6), initpt(n), numpts(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monit
          End Interface
        End Subroutine e05jbf
      End Interface
      Interface
        Subroutine e05jbk(n,ncall,xbest,icount,ninit,list,numpts,initpt, &
            nbaskt,xbaskt,boxl,boxu,nstate,iuser,ruser,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: n, nbaskt, ncall, ninit, nstate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: boxl(n), boxu(n), list(n,ninit), &
            xbaskt(n,nbaskt), xbest(n)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (In) :: icount(6), initpt(n), numpts(n)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e05jbk
      End Interface
      Interface
        Subroutine e05jcf(iopts,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iopts, lcomm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(lcomm)
        End Subroutine e05jcf
      End Interface
      Interface
        Subroutine e05jdf(optstr,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(lcomm)
        End Subroutine e05jdf
      End Interface
      Interface
        Subroutine e05jef(optstr,cvalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: cvalue, optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(lcomm)
        End Subroutine e05jef
      End Interface
      Interface
        Subroutine e05jff(optstr,ivalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ivalue, lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(lcomm)
        End Subroutine e05jff
      End Interface
      Interface
        Subroutine e05jgf(optstr,rvalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rvalue
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(lcomm)
        End Subroutine e05jgf
      End Interface
      Interface
        Function e05jhf(optstr,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: e05jhf
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(lcomm)
        End Function e05jhf
      End Interface
      Interface
        Subroutine e05jjf(optstr,cvalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (Out) :: cvalue
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(lcomm)
        End Subroutine e05jjf
      End Interface
      Interface
        Subroutine e05jkf(optstr,ivalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(lcomm)
        End Subroutine e05jkf
      End Interface
      Interface
        Subroutine e05jlf(optstr,rvalue,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(lcomm)
        End Subroutine e05jlf
      End Interface
      Interface
        Subroutine e05saf(ndim,npar,xb,fb,bl,bu,objfun,monmod,iopts,opts, &
            iuser,ruser,itt,inform,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fb
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ndim, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(ndim), bu(ndim)
          Real (Kind=wp), Intent (Inout) :: opts(*), ruser(*)
          Real (Kind=wp), Intent (Out) :: xb(ndim)
          Integer, Intent (Inout) :: iopts(*), iuser(*)
          Integer, Intent (Out) :: itt(6)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,ndim,x,objf,vecout,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Inout) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: ndim, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*), vecout(ndim)
              Real (Kind=wp), Intent (In) :: x(ndim)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine monmod(ndim,npar,x,xb,fb,xbest,fbest,itt,iuser,ruser, &
                inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: fb
              Integer, Intent (Inout) :: inform
              Integer, Intent (In) :: ndim, npar
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: fbest(npar), xb(ndim), &
                xbest(ndim,npar)
              Real (Kind=wp), Intent (Inout) :: ruser(*), x(ndim,npar)
              Integer, Intent (In) :: itt(6)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monmod
          End Interface
        End Subroutine e05saf
      End Interface
      Interface
        Subroutine e05sxm(ndim,npar,x,xb,fb,xbest,fbest,itt,iuser,ruser, &
            inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fb
          Integer, Intent (Inout) :: inform
          Integer, Intent (In) :: ndim, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: fbest(npar), xb(ndim), &
            xbest(ndim,npar)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(ndim,npar)
          Integer, Intent (In) :: itt(6)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e05sxm
      End Interface
      Interface
        Subroutine e05sbf(ndim,ncon,npar,xb,fb,cb,bl,bu,xbest,fbest,cbest, &
            objfun,confun,monmod,iopts,opts,iuser,ruser,itt,inform,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fb
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ncon, ndim, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(ndim+ncon), bu(ndim+ncon)
          Real (Kind=wp), Intent (Out) :: cb(ncon), xb(ndim)
          Real (Kind=wp), Intent (Inout) :: cbest(ncon,npar), fbest(npar), &
            opts(*), ruser(*), xbest(ndim,npar)
          Integer, Intent (Inout) :: iopts(*), iuser(*)
          Integer, Intent (Out) :: itt(7)
!         .. Interface Blocks ..
          Interface
            Subroutine objfun(mode,ndim,x,objf,vecout,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Inout) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: ndim, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*), vecout(ndim)
              Real (Kind=wp), Intent (In) :: x(ndim)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine confun(mode,ncon,ndim,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, ncon, ndim, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncon)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,ndim), ruser(*)
              Real (Kind=wp), Intent (In) :: x(ndim)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncon)
            End Subroutine confun
          End Interface
          Interface
            Subroutine monmod(ndim,ncon,npar,x,xb,fb,cb,xbest,fbest,cbest,itt, &
                iuser,ruser,inform)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: fb
              Integer, Intent (Inout) :: inform
              Integer, Intent (In) :: ncon, ndim, npar
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: cb(ncon), cbest(ncon,npar), &
                fbest(npar), xb(ndim), xbest(ndim,npar)
              Real (Kind=wp), Intent (Inout) :: ruser(*), x(ndim,npar)
              Integer, Intent (In) :: itt(7)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monmod
          End Interface
        End Subroutine e05sbf
      End Interface
      Interface
        Subroutine e05szm(mode,ncon,ndim,ldcj,needc,x,c,cjac,nstate,iuser, &
            ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ldcj, ncon, ndim, nstate
          Integer, Intent (Inout) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(ncon)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcj,ndim), ruser(*)
          Real (Kind=wp), Intent (In) :: x(ndim)
          Integer, Intent (Inout) :: iuser(*)
          Integer, Intent (In) :: needc(ncon)
        End Subroutine e05szm
      End Interface
      Interface
        Subroutine e05sym(ndim,ncon,npar,x,xb,fb,cb,xbest,fbest,cbest,itt, &
            iuser,ruser,inform)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fb
          Integer, Intent (Inout) :: inform
          Integer, Intent (In) :: ncon, ndim, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: cb(ncon), cbest(ncon,npar), &
            fbest(npar), xb(ndim), xbest(ndim,npar)
          Real (Kind=wp), Intent (Inout) :: ruser(*), x(ndim,npar)
          Integer, Intent (In) :: itt(7)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e05sym
      End Interface
      Interface
        Subroutine e05ucf(n,nclin,ncnln,a,lda,bl,bu,confun,objfun,npts,x,ldx, &
            start,repeat,nb,objf,objgrd,ldobjd,iter,c,ldc,cjac,ldcjac,sdcjac, &
            r,ldr,sdr,clamda,ldclda,istate,listat,iopts,opts,iuser,ruser,info, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldc, ldcjac, ldclda, ldobjd, ldr, ldx, &
            listat, n, nb, nclin, ncnln, npts, sdcjac, sdr
          Logical, Intent (In) :: repeat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln)
          Real (Kind=wp), Intent (Inout) :: c(ldc,nb), cjac(ldcjac,sdcjac,nb), &
            clamda(ldclda,nb), objgrd(ldobjd,nb), opts(485), r(ldr,sdr,nb), &
            ruser(*), x(ldx,nb)
          Real (Kind=wp), Intent (Out) :: objf(nb)
          Integer, Intent (Out) :: info(nb), istate(listat,nb), iter(nb)
          Integer, Intent (Inout) :: iopts(740), iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcjsl,needc,x,c,cjsl,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcjsl, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjsl(ldcjsl,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,n,x,objf,objgrd,nstate,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Out) :: objf
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: objgrd(n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine start(npts,quas,n,repeat,bl,bu,iuser,ruser,mode)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, npts
              Logical, Intent (In) :: repeat
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: bl(n), bu(n)
              Real (Kind=wp), Intent (Inout) :: quas(n,npts), ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine start
          End Interface
        End Subroutine e05ucf
      End Interface
      Interface
        Subroutine e05ucz(npts,quas,n,repeat,bl,bu,iuser,ruser,mode)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: mode
          Integer, Intent (In) :: n, npts
          Logical, Intent (In) :: repeat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(n), bu(n)
          Real (Kind=wp), Intent (Inout) :: quas(n,npts), ruser(*)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine e05ucz
      End Interface
      Interface
        Subroutine e05usf(m,n,nclin,ncnln,a,lda,bl,bu,y,confun,objfun,npts,x, &
            ldx,start,repeat,nb,objf,f,fjac,ldfjac,sdfjac,iter,c,ldc,cjac, &
            ldcjac,sdcjac,r,ldr,sdr,clamda,ldclda,istate,listat,iopts,opts, &
            iuser,ruser,info,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldc, ldcjac, ldclda, ldfjac, ldr, ldx, &
            listat, m, n, nb, nclin, ncnln, npts, sdcjac, sdfjac, sdr
          Logical, Intent (In) :: repeat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+nclin+ncnln), &
            bu(n+nclin+ncnln), y(m)
          Real (Kind=wp), Intent (Out) :: c(ldc,nb), f(m,nb), objf(nb)
          Real (Kind=wp), Intent (Inout) :: cjac(ldcjac,sdcjac,nb), &
            clamda(ldclda,nb), fjac(ldfjac,sdfjac,nb), opts(485), &
            r(ldr,sdr,nb), ruser(*), x(ldx,nb)
          Integer, Intent (Out) :: info(nb), istate(listat,nb), iter(nb)
          Integer, Intent (Inout) :: iopts(740), iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine confun(mode,ncnln,n,ldcj,needc,x,c,cjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldcj, n, ncnln, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: c(ncnln)
              Real (Kind=wp), Intent (Inout) :: cjac(ldcj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
              Integer, Intent (In) :: needc(ncnln)
            End Subroutine confun
          End Interface
          Interface
            Subroutine objfun(mode,m,n,ldfj,needfi,x,f,fjac,nstate,iuser, &
                ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ldfj, m, n, needfi, nstate
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: f(m)
              Real (Kind=wp), Intent (Inout) :: fjac(ldfj,n), ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine objfun
          End Interface
          Interface
            Subroutine start(npts,quas,n,repeat,bl,bu,iuser,ruser,mode)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: mode
              Integer, Intent (In) :: n, npts
              Logical, Intent (In) :: repeat
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: bl(n), bu(n)
              Real (Kind=wp), Intent (Inout) :: quas(n,npts), ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine start
          End Interface
        End Subroutine e05usf
      End Interface
      Interface
        Subroutine e05zkf(optstr,iopts,liopts,opts,lopts,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liopts, lopts
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: opts(lopts)
          Integer, Intent (Inout) :: iopts(liopts)
        End Subroutine e05zkf
      End Interface
      Interface
        Subroutine e05zlf(optstr,ivalue,rvalue,cvalue,optype,iopts,opts,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue, optype
          Character (*), Intent (Out) :: cvalue
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: opts(*)
          Integer, Intent (In) :: iopts(*)
        End Subroutine e05zlf
      End Interface
    End Module nag_e_ib
