    Module nag_precisions

!     MODULE of precision parameters to be USEd by free-format source.

!     RP = 'reduced precision'
!     WP = 'working precision'
!     HP = 'higher precision'
!     I4B = 4-byte INTEGER

!     Example: for a single-precision implementation
!        RP = KIND(0.0E0)
!        WP = KIND(0.0E0)
!        HP = KIND(0.0D0)
!        I4B = SELECTED_INT_KIND(9)

!     NAG COPYRIGHT 2007.

!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: hp = kind(0.0D0)
      Integer, Parameter               :: i4b = selected_int_kind(9)
      Integer, Parameter               :: rp = kind(0.0)
      Integer, Parameter               :: wp = kind(0.0D0)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: kind, selected_int_kind
    End Module nag_precisions
