    Module nag_f_ib

!     NAG COPYRIGHT 2011.

!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine f01abf(a,lda,n,b,ldb,z,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(ldb,n)
          Real (Kind=wp), Intent (Out) :: z(n)
        End Subroutine f01abf
      End Interface
      Interface
        Subroutine f01adf(n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f01adf
      End Interface
      Interface
        Subroutine f01blf(m,n,t,a,lda,aijmax,irank,inc,d,u,ldu,du,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: t
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irank
          Integer, Intent (In) :: lda, ldu, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), u(ldu,n)
          Real (Kind=wp), Intent (Out) :: aijmax(n), d(m), du(n)
          Integer, Intent (Out) :: inc(n)
        End Subroutine f01blf
      End Interface
      Interface
        Subroutine f01brf(n,nz,a,licn,irn,lirn,icn,pivot,ikeep,iw,w,lblock, &
            grow,abort,idisp,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pivot
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: licn, lirn, n, nz
          Logical, Intent (In) :: grow, lblock
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(licn)
          Real (Kind=wp), Intent (Out) :: w(n)
          Integer, Intent (Inout) :: icn(licn), irn(lirn)
          Integer, Intent (Out) :: idisp(10), ikeep(5*n), iw(8*n)
          Logical, Intent (In) :: abort(4)
        End Subroutine f01brf
      End Interface
      Interface
        Subroutine f01bsf(n,nz,a,licn,ivect,jvect,icn,ikeep,iw,w,grow,eta, &
            rpmin,abort,idisp,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eta
          Real (Kind=wp), Intent (Out) :: rpmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: licn, n, nz
          Logical, Intent (In) :: abort, grow
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(licn)
          Real (Kind=wp), Intent (Out) :: w(n)
          Integer, Intent (Inout) :: icn(licn)
          Integer, Intent (In) :: idisp(2), ikeep(5*n), ivect(nz), jvect(nz)
          Integer, Intent (Out) :: iw(5*n)
        End Subroutine f01bsf
      End Interface
      Interface
        Subroutine f01buf(n,m1,k,a,lda,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, lda, m1, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
          Real (Kind=wp), Intent (Out) :: w(m1)
        End Subroutine f01buf
      End Interface
      Interface
        Subroutine f01bvf(n,ma1,mb1,m3,k,a,lda,b,ldb,v,ldv,w,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, lda, ldb, ldv, m3, ma1, mb1, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(ldb,n), v(ldv,m3)
          Real (Kind=wp), Intent (Out) :: w(m3)
        End Subroutine f01bvf
      End Interface
      Interface
        Subroutine f01ckf(a,b,c,n,p,m,z,iz,opt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iz, m, n, opt, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(n,p), z(iz)
          Real (Kind=wp), Intent (Inout) :: b(n,m), c(m,p)
        End Subroutine f01ckf
      End Interface
      Interface
        Subroutine f01crf(a,m,n,mn,move,lmove,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lmove, m, mn, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(mn)
          Integer, Intent (Out) :: move(lmove)
        End Subroutine f01crf
      End Interface
      Interface
        Subroutine f01ctf(transa,transb,m,n,alpha,a,lda,beta,b,ldb,c,ldc, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f01ctf
      End Interface
      Interface
        Subroutine f01cwf(transa,transb,m,n,alpha,a,lda,beta,b,ldb,c,ldc, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f01cwf
      End Interface
      Interface
        Subroutine f01ecf(n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01ecf
      End Interface
      Interface
        Subroutine f01edf(uplo,n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01edf
      End Interface
      Interface
        Subroutine f01eff(uplo,n,a,lda,f,iuser,ruser,iflag,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(iflag,n,x,fx,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fx(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01eff
      End Interface
      Interface
        Subroutine f01ejf(n,a,lda,imnorm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: imnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01ejf
      End Interface
      Interface
        Subroutine f01ekf(fun,n,a,lda,imnorm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: imnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (*), Intent (In) :: fun
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01ekf
      End Interface
      Interface
        Subroutine f01elf(n,a,lda,f,iuser,ruser,iflag,imnorm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: imnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(iflag,nz,z,fz,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: nz
!             .. Array Arguments ..
              Complex (Kind=wp), Intent (Out) :: fz(nz)
              Complex (Kind=wp), Intent (In) :: z(nz)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01elf
      End Interface
      Interface
        Subroutine f01emf(n,a,lda,f,iuser,ruser,iflag,imnorm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: imnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(m,iflag,nz,z,fz,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: m, nz
!             .. Array Arguments ..
              Complex (Kind=wp), Intent (Out) :: fz(nz)
              Complex (Kind=wp), Intent (In) :: z(nz)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01emf
      End Interface
      Interface
        Subroutine f01fcf(n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01fcf
      End Interface
      Interface
        Subroutine f01fdf(uplo,n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01fdf
      End Interface
      Interface
        Subroutine f01fff(uplo,n,a,lda,f,iuser,ruser,iflag,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(iflag,n,x,fx,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: fx(n)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (In) :: x(n)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01fff
      End Interface
      Interface
        Subroutine f01fjf(n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01fjf
      End Interface
      Interface
        Subroutine f01fkf(fun,n,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (*), Intent (In) :: fun
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
        End Subroutine f01fkf
      End Interface
      Interface
        Subroutine f01flf(n,a,lda,f,iuser,ruser,iflag,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(iflag,nz,z,fz,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: nz
!             .. Array Arguments ..
              Complex (Kind=wp), Intent (Out) :: fz(nz)
              Complex (Kind=wp), Intent (In) :: z(nz)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01flf
      End Interface
      Interface
        Subroutine f01fmf(n,a,lda,f,iuser,ruser,iflag,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iflag
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(m,iflag,nz,z,fz,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: m, nz
!             .. Array Arguments ..
              Complex (Kind=wp), Intent (Out) :: fz(nz)
              Complex (Kind=wp), Intent (In) :: z(nz)
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine f
          End Interface
        End Subroutine f01fmf
      End Interface
      Interface
        Subroutine f01lef(n,a,lambda,b,c,tol,d,ipiv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: lambda, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n), b(n), c(n)
          Real (Kind=wp), Intent (Out) :: d(n)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f01lef
      End Interface
      Interface
        Subroutine f01lhf(n,nbloks,blkstr,a,lena,pivot,tol,kpivot,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: kpivot
          Integer, Intent (In) :: lena, n, nbloks
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lena)
          Integer, Intent (In) :: blkstr(3,nbloks)
          Integer, Intent (Out) :: pivot(n)
        End Subroutine f01lhf
      End Interface
      Interface
        Subroutine f01mcf(n,a,lal,nrow,al,d,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lal, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lal)
          Real (Kind=wp), Intent (Out) :: al(lal), d(n)
          Integer, Intent (Inout) :: nrow(n)
        End Subroutine f01mcf
      End Interface
      Interface
        Subroutine f01qgf(m,n,a,lda,zeta,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: zeta(m)
        End Subroutine f01qgf
      End Interface
      Interface
        Subroutine f01qjf(m,n,a,lda,zeta,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: zeta(m)
        End Subroutine f01qjf
      End Interface
      Interface
        Subroutine f01qkf(wheret,m,n,nrowp,a,lda,zeta,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n, nrowp
          Character (1), Intent (In) :: wheret
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(max(m-1,nrowp-m,1))
          Real (Kind=wp), Intent (In) :: zeta(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f01qkf
      End Interface
      Interface
        Subroutine f01rgf(m,n,a,lda,theta,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: theta(m)
        End Subroutine f01rgf
      End Interface
      Interface
        Subroutine f01rjf(m,n,a,lda,theta,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: theta(m)
        End Subroutine f01rjf
      End Interface
      Interface
        Subroutine f01rkf(wheret,m,n,nrowp,a,lda,theta,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n, nrowp
          Character (1), Intent (In) :: wheret
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: theta(*)
          Complex (Kind=wp), Intent (Out) :: work(max(m-1,nrowp-m,1))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f01rkf
      End Interface
      Interface
        Subroutine f01vaf(uplo,n,a,lda,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
        End Subroutine f01vaf
      End Interface
      Interface
        Subroutine f01vbf(uplo,n,a,lda,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
        End Subroutine f01vbf
      End Interface
      Interface
        Subroutine f01vcf(uplo,n,ap,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
        End Subroutine f01vcf
      End Interface
      Interface
        Subroutine f01vdf(uplo,n,ap,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
        End Subroutine f01vdf
      End Interface
      Interface
        Subroutine f01vef(transr,uplo,n,a,lda,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine f01vef
      End Interface
      Interface
        Subroutine f01vff(transr,uplo,n,a,lda,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine f01vff
      End Interface
      Interface
        Subroutine f01vgf(transr,uplo,n,arf,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine f01vgf
      End Interface
      Interface
        Subroutine f01vhf(transr,uplo,n,arf,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine f01vhf
      End Interface
      Interface
        Subroutine f01vjf(transr,uplo,n,ap,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
          Real (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine f01vjf
      End Interface
      Interface
        Subroutine f01vkf(transr,uplo,n,ap,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
          Complex (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine f01vkf
      End Interface
      Interface
        Subroutine f01vlf(transr,uplo,n,arf,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
          Real (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine f01vlf
      End Interface
      Interface
        Subroutine f01vmf(transr,uplo,n,arf,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
          Complex (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine f01vmf
      End Interface
      Interface
        Subroutine f01zaf(job,uplo,diag,n,a,lda,b,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b((n*(n+1))/2)
        End Subroutine f01zaf
      End Interface
      Interface
        Subroutine f01zbf(job,uplo,diag,n,a,lda,b,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n), b((n*(n+1))/2)
        End Subroutine f01zbf
      End Interface
      Interface
        Subroutine f01zcf(job,m,n,kl,ku,a,lda,b,ldb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, lda, ldb, m, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(ldb,*)
        End Subroutine f01zcf
      End Interface
      Interface
        Subroutine f01zdf(job,m,n,kl,ku,a,lda,b,ldb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, lda, ldb, m, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,n), b(ldb,*)
        End Subroutine f01zdf
      End Interface
      Interface
        Subroutine f02ecf(crit,n,a,lda,wl,wu,mest,m,wr,wi,vr,ldvr,vi,ldvi, &
            work,lwork,iwork,bwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: wl, wu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldvi, ldvr, lwork, mest, n
          Integer, Intent (Out) :: m
          Character (1), Intent (In) :: crit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), vi(ldvi,mest), &
            vr(ldvr,mest)
          Real (Kind=wp), Intent (Out) :: wi(n), work(lwork), wr(n)
          Integer, Intent (Out) :: iwork(n)
          Logical, Intent (Out) :: bwork(n)
        End Subroutine f02ecf
      End Interface
      Interface
        Subroutine f02fjf(n,m,k,noits,tol,dot,image,monit,novecs,x,ldx,d,work, &
            lwork,ruser,lruser,iuser,liuser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail, m, noits
          Integer, Intent (In) :: k, ldx, liuser, lruser, lwork, n, novecs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: d(k), work(lwork)
          Real (Kind=wp), Intent (Inout) :: ruser(lruser), x(ldx,k)
          Integer, Intent (Inout) :: iuser(liuser)
!         .. Interface Blocks ..
          Interface
            Function dot(iflag,n,z,w,ruser,lruser,iuser,liuser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: dot
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liuser, lruser, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(lruser)
              Real (Kind=wp), Intent (In) :: w(n), z(n)
              Integer, Intent (Inout) :: iuser(liuser)
            End Function dot
          End Interface
          Interface
            Subroutine image(iflag,n,z,w,ruser,lruser,iuser,liuser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: liuser, lruser, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(lruser)
              Real (Kind=wp), Intent (Out) :: w(n)
              Real (Kind=wp), Intent (In) :: z(n)
              Integer, Intent (Inout) :: iuser(liuser)
            End Subroutine image
          End Interface
          Interface
            Subroutine monit(istate,nextit,nevals,nevecs,k,f,d)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: istate, k, nevals, nevecs, nextit
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: d(k), f(k)
            End Subroutine monit
          End Interface
        End Subroutine f02fjf
      End Interface
      Interface
        Subroutine f02fjz(istate,nextit,nevals,nevecs,k,f,d)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: istate, k, nevals, nevecs, nextit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(k), f(k)
        End Subroutine f02fjz
      End Interface
      Interface
        Subroutine f02gcf(crit,n,a,lda,wl,wu,mest,m,w,v,ldv,work,lwork,rwork, &
            iwork,bwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: wl, wu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldv, lwork, mest, n
          Integer, Intent (Out) :: m
          Character (1), Intent (In) :: crit
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), v(ldv,mest)
          Complex (Kind=wp), Intent (Out) :: w(n), work(lwork)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Integer, Intent (Out) :: iwork(n)
          Logical, Intent (Out) :: bwork(n)
        End Subroutine f02gcf
      End Interface
      Interface
        Subroutine f02sdf(n,ma1,mb1,a,lda,b,ldb,sym,relep,rmu,vec,d,iwork, &
            work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: relep, rmu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, lwork, ma1, mb1, n
          Logical, Intent (In) :: sym
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(ldb,n), d(30)
          Real (Kind=wp), Intent (Out) :: vec(n), work(lwork)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f02sdf
      End Interface
      Interface
        Subroutine f02wdf(m,n,a,lda,wantb,b,tol,svd,irank,z,sv,wantr,r,ldr, &
            wantpt,pt,ldpt,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irank
          Integer, Intent (In) :: lda, ldpt, ldr, lwork, m, n
          Logical, Intent (Inout) :: svd
          Logical, Intent (In) :: wantb, wantpt, wantr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(m), pt(ldpt,n), &
            r(ldr,n)
          Real (Kind=wp), Intent (Out) :: sv(n), work(lwork), z(n)
        End Subroutine f02wdf
      End Interface
      Interface
        Subroutine f02wgf(m,n,k,ncv,av,nconv,sigma,u,ldu,v,ldv,resid,iuser, &
            ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldu, ldv, m, n, ncv
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: resid(ncv), sigma(ncv)
          Real (Kind=wp), Intent (Inout) :: ruser(*), u(ldu,ncv), v(ldv,ncv)
          Integer, Intent (Inout) :: iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine av(iflag,m,n,x,ax,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (Inout) :: iflag
              Integer, Intent (In) :: m, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ax(*), ruser(*)
              Real (Kind=wp), Intent (In) :: x(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine av
          End Interface
        End Subroutine f02wgf
      End Interface
      Interface
        Subroutine f02wuf(n,a,lda,ncolb,b,ldb,wantq,q,ldq,sv,wantp,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, ldq, n, ncolb
          Logical, Intent (In) :: wantp, wantq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            work(*)
          Real (Kind=wp), Intent (Out) :: sv(n)
        End Subroutine f02wuf
      End Interface
      Interface
        Subroutine f02xuf(n,a,lda,ncolb,b,ldb,wantq,q,ldq,sv,wantp,rwork, &
            cwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, ldq, n, ncolb
          Logical, Intent (In) :: wantp, wantq
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: cwork(max(1,n-1))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Real (Kind=wp), Intent (Out) :: sv(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f02xuf
      End Interface
      Interface
        Subroutine f03aaf(a,lda,n,det,wkspce,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: det
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: wkspce(n)
        End Subroutine f03aaf
      End Interface
      Interface
        Subroutine f03abf(a,lda,n,det,wkspce,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: det
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: wkspce(max(1,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f03abf
      End Interface
      Interface
        Subroutine f03acf(a,lda,n,m,det,rl,ldrl,m1,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: det
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldrl, m, m1, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,m1)
          Real (Kind=wp), Intent (Inout) :: rl(ldrl,m1)
        End Subroutine f03acf
      End Interface
      Interface
        Subroutine f03adf(a,lda,n,detr,deti,wkspce,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: deti, detr
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: wkspce(n)
        End Subroutine f03adf
      End Interface
      Interface
        Subroutine f03aef(n,a,lda,p,d1,id,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d1
          Integer, Intent (Out) :: id
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: p(n)
        End Subroutine f03aef
      End Interface
      Interface
        Subroutine f03aff(n,eps,a,lda,d1,id,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d1
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Out) :: id
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: p(n)
        End Subroutine f03aff
      End Interface
      Interface
        Subroutine f03baf(n,a,lda,ipiv,d,id,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d
          Integer, Intent (Out) :: id
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Integer, Intent (In) :: ipiv(n)
        End Subroutine f03baf
      End Interface
      Interface
        Subroutine f03bff(n,a,lda,d,id,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d
          Integer, Intent (Out) :: id
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
        End Subroutine f03bff
      End Interface
      Interface
        Subroutine f03bhf(uplo,n,kd,ab,ldab,d,id,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d
          Integer, Intent (Out) :: id
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
        End Subroutine f03bhf
      End Interface
      Interface
        Subroutine f03bnf(n,a,lda,ipiv,d,id,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Out) :: d
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Integer, Intent (Out) :: id(2)
          Integer, Intent (In) :: ipiv(n)
        End Subroutine f03bnf
      End Interface
      Interface
        Subroutine f04abf(a,lda,b,ldb,n,m,c,ldc,wkspce,bb,ldbb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, ldbb, ldc, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), bb(ldbb,m), c(ldc,m)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
          Real (Kind=wp), Intent (Out) :: wkspce(n)
        End Subroutine f04abf
      End Interface
      Interface
        Subroutine f04aef(a,lda,b,ldb,n,m,c,ldc,wkspce,aa,ldaa,bb,ldbb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldaa, ldb, ldbb, ldc, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: aa(ldaa,*), bb(ldbb,*), c(ldc,*)
          Real (Kind=wp), Intent (Out) :: wkspce(max(1,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f04aef
      End Interface
      Interface
        Subroutine f04aff(n,ir,a,lda,p,b,ldb,eps,x,ldx,bb,ldbb,k,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir, lda, ldb, ldbb, ldx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), bb(ldbb,ir), p(n), &
            x(ldx,ir)
          Real (Kind=wp), Intent (In) :: b(ldb,ir)
        End Subroutine f04aff
      End Interface
      Interface
        Subroutine f04agf(n,ir,a,lda,p,b,ldb,x,ldx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ir, lda, ldb, ldx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), p(n), x(ldx,ir)
          Real (Kind=wp), Intent (In) :: b(ldb,ir)
        End Subroutine f04agf
      End Interface
      Interface
        Subroutine f04ahf(n,ir,a,lda,aa,ldaa,p,b,ldb,eps,x,ldx,bb,ldbb,k, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir, lda, ldaa, ldb, ldbb, ldx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n), aa(ldaa,n), b(ldb,ir), p(n)
          Real (Kind=wp), Intent (Inout) :: bb(ldbb,ir), x(ldx,ir)
        End Subroutine f04ahf
      End Interface
      Interface
        Subroutine f04ajf(n,ir,a,lda,p,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ir, lda, ldb, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n), p(n)
          Real (Kind=wp), Intent (Inout) :: b(ldb,ir)
        End Subroutine f04ajf
      End Interface
      Interface
        Subroutine f04amf(a,lda,x,ldx,b,ldb,m,n,ir,eps,qr,ldqr,alpha,e,y,z,r, &
            ipiv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir, lda, ldb, ldqr, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n), b(ldb,ir)
          Real (Kind=wp), Intent (Out) :: alpha(n), e(n), r(m), y(n), z(n)
          Real (Kind=wp), Intent (Inout) :: qr(ldqr,n), x(ldx,ir)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04amf
      End Interface
      Interface
        Subroutine f04asf(a,lda,b,n,c,wk1,wk2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: b(max(1,n))
          Real (Kind=wp), Intent (Out) :: c(max(1,n)), wk1(max(1,n)), &
            wk2(max(1,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f04asf
      End Interface
      Interface
        Subroutine f04atf(a,lda,b,n,c,aa,ldaa,wks1,wks2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldaa, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(*)
          Real (Kind=wp), Intent (Inout) :: aa(ldaa,n)
          Real (Kind=wp), Intent (Out) :: c(n), wks1(n), wks2(n)
        End Subroutine f04atf
      End Interface
      Interface
        Subroutine f04axf(n,a,licn,icn,ikeep,rhs,w,mtype,idisp,resid)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: resid
          Integer, Intent (In) :: licn, mtype, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(licn)
          Real (Kind=wp), Intent (Inout) :: rhs(n)
          Real (Kind=wp), Intent (Out) :: w(n)
          Integer, Intent (In) :: icn(licn), idisp(2)
          Integer, Intent (Inout) :: ikeep(5*n)
        End Subroutine f04axf
      End Interface
      Interface
        Subroutine f04baf(n,nrhs,a,lda,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04baf
      End Interface
      Interface
        Subroutine f04bbf(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04bbf
      End Interface
      Interface
        Subroutine f04bcf(n,nrhs,dl,d,du,du2,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
          Real (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04bcf
      End Interface
      Interface
        Subroutine f04bdf(uplo,n,nrhs,a,lda,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine f04bdf
      End Interface
      Interface
        Subroutine f04bef(uplo,n,nrhs,ap,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine f04bef
      End Interface
      Interface
        Subroutine f04bff(uplo,n,kd,nrhs,ab,ldab,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine f04bff
      End Interface
      Interface
        Subroutine f04bgf(n,nrhs,d,e,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), e(*)
        End Subroutine f04bgf
      End Interface
      Interface
        Subroutine f04bhf(uplo,n,nrhs,a,lda,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04bhf
      End Interface
      Interface
        Subroutine f04bjf(uplo,n,nrhs,ap,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04bjf
      End Interface
      Interface
        Subroutine f04caf(n,nrhs,a,lda,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04caf
      End Interface
      Interface
        Subroutine f04cbf(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04cbf
      End Interface
      Interface
        Subroutine f04ccf(n,nrhs,dl,d,du,du2,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
          Complex (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04ccf
      End Interface
      Interface
        Subroutine f04cdf(uplo,n,nrhs,a,lda,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine f04cdf
      End Interface
      Interface
        Subroutine f04cef(uplo,n,nrhs,ap,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine f04cef
      End Interface
      Interface
        Subroutine f04cff(uplo,n,kd,nrhs,ab,ldab,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine f04cff
      End Interface
      Interface
        Subroutine f04cgf(n,nrhs,d,e,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), e(*)
          Real (Kind=wp), Intent (Inout) :: d(*)
        End Subroutine f04cgf
      End Interface
      Interface
        Subroutine f04chf(uplo,n,nrhs,a,lda,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04chf
      End Interface
      Interface
        Subroutine f04cjf(uplo,n,nrhs,ap,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04cjf
      End Interface
      Interface
        Subroutine f04dhf(uplo,n,nrhs,a,lda,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04dhf
      End Interface
      Interface
        Subroutine f04djf(uplo,n,nrhs,ap,ipiv,b,ldb,rcond,errbnd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errbnd, rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f04djf
      End Interface
      Interface
        Subroutine f04fef(n,t,x,wantp,p,wantv,v,vlast,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: vlast
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: wantp, wantv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: p(*), v(*)
          Real (Kind=wp), Intent (In) :: t(0:n)
          Real (Kind=wp), Intent (Out) :: work(n-1), x(n)
        End Subroutine f04fef
      End Interface
      Interface
        Subroutine f04fff(n,t,b,x,wantp,p,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: wantp
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(*), t(0:*)
          Real (Kind=wp), Intent (Inout) :: p(*)
          Real (Kind=wp), Intent (Out) :: work(2*(n-1)), x(n)
        End Subroutine f04fff
      End Interface
      Interface
        Subroutine f04jgf(m,n,a,lda,b,tol,svd,sigma,irank,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: sigma
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irank
          Integer, Intent (In) :: lda, lwork, m, n
          Logical, Intent (Out) :: svd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), b(m)
          Real (Kind=wp), Intent (Out) :: work(lwork)
        End Subroutine f04jgf
      End Interface
      Interface
        Subroutine f04lef(job,n,a,b,c,d,ipiv,y,tol,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: job, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n), b(n), c(n), d(n)
          Real (Kind=wp), Intent (Inout) :: y(n)
          Integer, Intent (In) :: ipiv(n)
        End Subroutine f04lef
      End Interface
      Interface
        Subroutine f04lhf(trans,n,nbloks,blkstr,a,lena,pivot,b,ldb,ir,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir, ldb, lena, n, nbloks
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lena)
          Real (Kind=wp), Intent (Inout) :: b(ldb,ir)
          Integer, Intent (In) :: blkstr(3,nbloks), pivot(n)
        End Subroutine f04lhf
      End Interface
      Interface
        Subroutine f04mcf(n,al,lal,d,nrow,ir,b,ldb,iselct,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir, iselct, lal, ldb, ldx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: al(lal), b(ldb,ir), d(*)
          Real (Kind=wp), Intent (Inout) :: x(ldx,ir)
          Integer, Intent (In) :: nrow(n)
        End Subroutine f04mcf
      End Interface
      Interface
        Subroutine f04mef(n,t,x,v,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: v
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: t(0:n)
          Real (Kind=wp), Intent (Out) :: work(n-1)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f04mef
      End Interface
      Interface
        Subroutine f04mff(n,t,b,x,p,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(*), t(0:*)
          Real (Kind=wp), Intent (Inout) :: work(*), x(*)
        End Subroutine f04mff
      End Interface
      Interface
        Subroutine f04qaf(m,n,b,x,se,aprod,damp,atol,btol,conlim,itnlim, &
            msglvl,itn,anorm,acond,rnorm,arnorm,xnorm,work,ruser,lruser,iuser, &
            liuser,inform,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: acond, anorm, arnorm, rnorm, xnorm
          Real (Kind=wp), Intent (In) :: atol, btol, conlim, damp
          Integer, Intent (Inout) :: ifail, itnlim
          Integer, Intent (Out) :: inform, itn
          Integer, Intent (In) :: liuser, lruser, m, msglvl, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(m), ruser(lruser)
          Real (Kind=wp), Intent (Out) :: se(n), work(n,2), x(n)
          Integer, Intent (Inout) :: iuser(liuser)
!         .. Interface Blocks ..
          Interface
            Subroutine aprod(mode,m,n,x,y,ruser,lruser,iuser,liuser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: liuser, lruser, m, n
              Integer, Intent (Inout) :: mode
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(lruser), x(n), y(m)
              Integer, Intent (Inout) :: iuser(liuser)
            End Subroutine aprod
          End Interface
        End Subroutine f04qaf
      End Interface
      Interface
        Subroutine f04yaf(job,p,sigma,a,lda,svd,irank,sv,cj,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: irank, job, lda, p
          Logical, Intent (In) :: svd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,p)
          Real (Kind=wp), Intent (Out) :: cj(p), work(p)
          Real (Kind=wp), Intent (In) :: sv(p)
        End Subroutine f04yaf
      End Interface
      Interface
        Subroutine f04ycf(icase,n,x,estnrm,work,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: estnrm
          Integer, Intent (Inout) :: icase, ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: work(n), x(n)
          Integer, Intent (Inout) :: iwork(n)
        End Subroutine f04ycf
      End Interface
      Interface
        Subroutine f04zcf(icase,n,x,estnrm,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: estnrm
          Integer, Intent (Inout) :: icase, ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(n), x(n)
        End Subroutine f04zcf
      End Interface
      Interface
        Subroutine f05aaf(a,lda,m,n1,n2,s,cc,icol,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: cc
          Integer, Intent (Out) :: icol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n1, n2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n2)
          Real (Kind=wp), Intent (Out) :: s(n2)
        End Subroutine f05aaf
      End Interface
      Interface
        Subroutine f06aaf(a,b,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b
          Real (Kind=wp), Intent (Out) :: c, s
        End Subroutine f06aaf
      End Interface
      Interface
        Subroutine f06abf(d1,d2,x1,x2,param)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: d1, d2, x1, x2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: param(5)
        End Subroutine f06abf
      End Interface
      Interface
        Subroutine f06baf(a,b,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: a, b
          Real (Kind=wp), Intent (Out) :: c, s
        End Subroutine f06baf
      End Interface
      Interface
        Subroutine f06bcf(t,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: c, s
          Real (Kind=wp), Intent (In) :: t
        End Subroutine f06bcf
      End Interface
      Interface
        Subroutine f06bef(job,x,y,z,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: c, s
          Real (Kind=wp), Intent (Inout) :: x, y, z
          Character (1), Intent (In) :: job
        End Subroutine f06bef
      End Interface
      Interface
        Subroutine f06bhf(x,y,z,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Real (Kind=wp), Intent (Inout) :: x, y, z
        End Subroutine f06bhf
      End Interface
      Interface
        Function f06blf(a,b,fail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06blf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Logical, Intent (Out) :: fail
        End Function f06blf
      End Interface
      Interface
        Function f06bmf(scal,ssq)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06bmf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: scal, ssq
        End Function f06bmf
      End Interface
      Interface
        Function f06bnf(a,b)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06bnf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
        End Function f06bnf
      End Interface
      Interface
        Function f06bpf(a,b,c)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06bpf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, c
        End Function f06bpf
      End Interface
      Interface
        Subroutine f06caf(a,b,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a, b
          Complex (Kind=wp), Intent (Out) :: s
          Real (Kind=wp), Intent (Out) :: c
        End Subroutine f06caf
      End Interface
      Interface
        Subroutine f06cbf(a,b,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a, b
          Complex (Kind=wp), Intent (Out) :: c
          Real (Kind=wp), Intent (Out) :: s
        End Subroutine f06cbf
      End Interface
      Interface
        Subroutine f06ccf(t,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Out) :: s
          Complex (Kind=wp), Intent (In) :: t
          Real (Kind=wp), Intent (Out) :: c
        End Subroutine f06ccf
      End Interface
      Interface
        Subroutine f06cdf(t,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Out) :: c
          Complex (Kind=wp), Intent (In) :: t
          Real (Kind=wp), Intent (Out) :: s
        End Subroutine f06cdf
      End Interface
      Interface
        Subroutine f06chf(x,y,z,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: s
          Complex (Kind=wp), Intent (Inout) :: x, y, z
          Real (Kind=wp), Intent (In) :: c
        End Subroutine f06chf
      End Interface
      Interface
        Function f06clf(a,b,fail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f06clf
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: a, b
          Logical, Intent (Out) :: fail
        End Function f06clf
      End Interface
      Interface
        Subroutine f06dbf(n,con,x,incx)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: con, incx, n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: x(*)
        End Subroutine f06dbf
      End Interface
      Interface
        Subroutine f06dff(n,x,incx,y,incy)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(*)
          Integer, Intent (Inout) :: y(*)
        End Subroutine f06dff
      End Interface
      Interface
        Function f06eaf(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06eaf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Function f06eaf
      End Interface
      Interface
        Subroutine f06ecf(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06ecf
      End Interface
      Interface
        Subroutine f06edf(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06edf
      End Interface
      Interface
        Subroutine f06eff(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06eff
      End Interface
      Interface
        Subroutine f06egf(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06egf
      End Interface
      Interface
        Function f06ejf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ejf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function f06ejf
      End Interface
      Interface
        Function f06ekf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ekf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function f06ekf
      End Interface
      Interface
        Subroutine f06epf(n,x,incx,y,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06epf
      End Interface
      Interface
        Subroutine f06eqf(n,x,incx,y,incy,param)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: param(5)
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06eqf
      End Interface
      Interface
        Function f06erf(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06erf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function f06erf
      End Interface
      Interface
        Subroutine f06etf(nz,a,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06etf
      End Interface
      Interface
        Subroutine f06euf(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
          Real (Kind=wp), Intent (In) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06euf
      End Interface
      Interface
        Subroutine f06evf(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06evf
      End Interface
      Interface
        Subroutine f06ewf(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06ewf
      End Interface
      Interface
        Subroutine f06exf(nz,x,indx,y,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06exf
      End Interface
      Interface
        Function f06faf(n,j,tolx,x,incx,toly,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06faf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tolx, toly
          Integer, Intent (In) :: incx, incy, j, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Function f06faf
      End Interface
      Interface
        Subroutine f06fbf(n,con,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: con
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fbf
      End Interface
      Interface
        Subroutine f06fcf(n,d,incd,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incd, incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fcf
      End Interface
      Interface
        Subroutine f06fdf(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06fdf
      End Interface
      Interface
        Subroutine f06fef(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fef
      End Interface
      Interface
        Subroutine f06fgf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fgf
      End Interface
      Interface
        Subroutine f06fjf(n,x,incx,scal,sumsq)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: scal, sumsq
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06fjf
      End Interface
      Interface
        Function f06fkf(n,w,incw,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06fkf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incw, incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: w(*), x(*)
        End Function f06fkf
      End Interface
      Interface
        Subroutine f06flf(n,x,incx,xmax,xmin)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: xmax, xmin
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06flf
      End Interface
      Interface
        Subroutine f06fpf(n,x,incx,y,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06fpf
      End Interface
      Interface
        Subroutine f06fqf(pivot,direct,n,alpha,x,incx,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: direct, pivot
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c(n), s(n)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fqf
      End Interface
      Interface
        Subroutine f06frf(n,alpha,x,incx,tol,zeta)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: alpha
          Real (Kind=wp), Intent (In) :: tol
          Real (Kind=wp), Intent (Out) :: zeta
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06frf
      End Interface
      Interface
        Subroutine f06fsf(n,alpha,x,incx,tol,z1)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: alpha
          Real (Kind=wp), Intent (In) :: tol
          Real (Kind=wp), Intent (Out) :: z1
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06fsf
      End Interface
      Interface
        Subroutine f06ftf(n,delta,y,incy,zeta,z,incz)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: delta
          Real (Kind=wp), Intent (In) :: zeta
          Integer, Intent (In) :: incy, incz, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: y(*)
          Real (Kind=wp), Intent (In) :: z(*)
        End Subroutine f06ftf
      End Interface
      Interface
        Subroutine f06fuf(n,z,incz,z1,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: alpha
          Real (Kind=wp), Intent (In) :: z1
          Integer, Intent (In) :: incx, incz, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(*)
          Real (Kind=wp), Intent (In) :: z(*)
        End Subroutine f06fuf
      End Interface
      Interface
        Function f06gaf(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f06gaf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Function f06gaf
      End Interface
      Interface
        Function f06gbf(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f06gbf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Function f06gbf
      End Interface
      Interface
        Subroutine f06gcf(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06gcf
      End Interface
      Interface
        Subroutine f06gdf(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06gdf
      End Interface
      Interface
        Subroutine f06gff(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06gff
      End Interface
      Interface
        Subroutine f06ggf(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06ggf
      End Interface
      Interface
        Function f06grf(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f06grf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function f06grf
      End Interface
      Interface
        Function f06gsf(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f06gsf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Function f06gsf
      End Interface
      Interface
        Subroutine f06gtf(nz,a,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: a
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06gtf
      End Interface
      Interface
        Subroutine f06guf(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
          Complex (Kind=wp), Intent (In) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06guf
      End Interface
      Interface
        Subroutine f06gvf(nz,y,x,indx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06gvf
      End Interface
      Interface
        Subroutine f06gwf(nz,x,indx,y)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Integer, Intent (In) :: indx(*)
        End Subroutine f06gwf
      End Interface
      Interface
        Subroutine f06hbf(n,con,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: con
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06hbf
      End Interface
      Interface
        Subroutine f06hcf(n,d,incd,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incd, incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: d(*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06hcf
      End Interface
      Interface
        Subroutine f06hdf(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06hdf
      End Interface
      Interface
        Subroutine f06hgf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06hgf
      End Interface
      Interface
        Subroutine f06hmf(n,cx,incx,cy,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: s
          Real (Kind=wp), Intent (In) :: c
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: cx(*), cy(*)
        End Subroutine f06hmf
      End Interface
      Interface
        Subroutine f06hpf(n,x,incx,y,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06hpf
      End Interface
      Interface
        Subroutine f06hqf(pivot,direct,n,alpha,x,incx,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Inout) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: direct, pivot
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: s(n)
          Complex (Kind=wp), Intent (Inout) :: x(*)
          Real (Kind=wp), Intent (Out) :: c(n)
        End Subroutine f06hqf
      End Interface
      Interface
        Subroutine f06hrf(n,alpha,x,incx,tol,theta)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Inout) :: alpha
          Complex (Kind=wp), Intent (Out) :: theta
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06hrf
      End Interface
      Interface
        Subroutine f06htf(n,delta,y,incy,theta,z,incz)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (Inout) :: delta
          Complex (Kind=wp), Intent (In) :: theta
          Integer, Intent (In) :: incy, incz, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Complex (Kind=wp), Intent (In) :: z(*)
        End Subroutine f06htf
      End Interface
      Interface
        Subroutine f06jdf(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06jdf
      End Interface
      Interface
        Function f06jjf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06jjf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function f06jjf
      End Interface
      Interface
        Function f06jkf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06jkf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function f06jkf
      End Interface
      Interface
        Function f06jlf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: f06jlf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function f06jlf
      End Interface
      Interface
        Function f06jmf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: f06jmf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Function f06jmf
      End Interface
      Interface
        Subroutine f06kcf(n,d,incd,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incd, incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
          Real (Kind=wp), Intent (In) :: d(*)
        End Subroutine f06kcf
      End Interface
      Interface
        Subroutine f06kdf(n,alpha,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06kdf
      End Interface
      Interface
        Subroutine f06kef(n,alpha,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06kef
      End Interface
      Interface
        Subroutine f06kff(n,x,incx,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: y(*)
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06kff
      End Interface
      Interface
        Subroutine f06kjf(n,x,incx,scal,sumsq)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: scal, sumsq
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06kjf
      End Interface
      Interface
        Function f06klf(n,x,incx,tol)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: f06klf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(*)
        End Function f06klf
      End Interface
      Interface
        Subroutine f06kpf(n,x,incx,y,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: x(*), y(*)
        End Subroutine f06kpf
      End Interface
      Interface
        Subroutine f06paf(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06paf
      End Interface
      Interface
        Subroutine f06pbf(trans,m,n,kl,ku,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, kl, ku, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06pbf
      End Interface
      Interface
        Subroutine f06pcf(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06pcf
      End Interface
      Interface
        Subroutine f06pdf(uplo,n,k,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, k, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06pdf
      End Interface
      Interface
        Subroutine f06pef(uplo,n,alpha,ap,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), x(*)
          Real (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06pef
      End Interface
      Interface
        Subroutine f06pff(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06pff
      End Interface
      Interface
        Subroutine f06pgf(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06pgf
      End Interface
      Interface
        Subroutine f06phf(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06phf
      End Interface
      Interface
        Subroutine f06pjf(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06pjf
      End Interface
      Interface
        Subroutine f06pkf(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06pkf
      End Interface
      Interface
        Subroutine f06plf(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06plf
      End Interface
      Interface
        Subroutine f06pmf(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06pmf
      End Interface
      Interface
        Subroutine f06ppf(uplo,n,alpha,x,incx,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06ppf
      End Interface
      Interface
        Subroutine f06pqf(uplo,n,alpha,x,incx,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06pqf
      End Interface
      Interface
        Subroutine f06prf(uplo,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06prf
      End Interface
      Interface
        Subroutine f06psf(uplo,n,alpha,x,incx,y,incy,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06psf
      End Interface
      Interface
        Subroutine f06qff(matrix,m,n,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: matrix
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06qff
      End Interface
      Interface
        Subroutine f06qhf(matrix,m,n,con,diag,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: con, diag
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: matrix
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f06qhf
      End Interface
      Interface
        Subroutine f06qjf(side,trans,n,perm,k,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldb, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: perm(*)
        End Subroutine f06qjf
      End Interface
      Interface
        Subroutine f06qkf(side,trans,n,perm,k,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldb, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: perm(*)
        End Subroutine f06qkf
      End Interface
      Interface
        Subroutine f06qmf(uplo,pivot,direct,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: direct, pivot, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: c(*), s(*)
        End Subroutine f06qmf
      End Interface
      Interface
        Subroutine f06qpf(n,alpha,x,incx,y,incy,a,lda,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Out) :: c(n-1), s(n-1)
          Real (Kind=wp), Intent (In) :: y(*)
        End Subroutine f06qpf
      End Interface
      Interface
        Subroutine f06qqf(n,alpha,x,incx,a,lda,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(*)
          Real (Kind=wp), Intent (Out) :: c(n), s(n)
        End Subroutine f06qqf
      End Interface
      Interface
        Subroutine f06qrf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(k2-1), s(k2-1)
        End Subroutine f06qrf
      End Interface
      Interface
        Subroutine f06qsf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (Out) :: c(k2-1)
        End Subroutine f06qsf
      End Interface
      Interface
        Subroutine f06qtf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(*), s(*)
        End Subroutine f06qtf
      End Interface
      Interface
        Subroutine f06qvf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (In) :: c(*)
        End Subroutine f06qvf
      End Interface
      Interface
        Subroutine f06qwf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (In) :: c(*)
        End Subroutine f06qwf
      End Interface
      Interface
        Subroutine f06qxf(side,pivot,direct,m,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, m, n
          Character (1), Intent (In) :: direct, pivot, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: c(k2-1), s(k2-1)
        End Subroutine f06qxf
      End Interface
      Interface
        Function f06raf(norm,m,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06raf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06raf
      End Interface
      Interface
        Function f06rbf(norm,n,kl,ku,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rbf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rbf
      End Interface
      Interface
        Function f06rcf(norm,uplo,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rcf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rcf
      End Interface
      Interface
        Function f06rdf(norm,uplo,n,ap,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rdf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rdf
      End Interface
      Interface
        Function f06ref(norm,uplo,n,k,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ref
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldab, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ref
      End Interface
      Interface
        Function f06rjf(norm,uplo,diag,m,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rjf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rjf
      End Interface
      Interface
        Function f06rkf(norm,uplo,diag,n,ap,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rkf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rkf
      End Interface
      Interface
        Function f06rlf(norm,uplo,diag,n,k,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rlf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rlf
      End Interface
      Interface
        Function f06rmf(norm,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rmf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06rmf
      End Interface
      Interface
        Function f06rnf(norm,n,dl,d,du)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rnf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), dl(*), du(*)
        End Function f06rnf
      End Interface
      Interface
        Function f06rpf(norm,n,d,e)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06rpf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*)
        End Function f06rpf
      End Interface
      Interface
        Subroutine f06saf(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06saf
      End Interface
      Interface
        Subroutine f06sbf(trans,m,n,kl,ku,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, kl, ku, lda, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06sbf
      End Interface
      Interface
        Subroutine f06scf(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06scf
      End Interface
      Interface
        Subroutine f06sdf(uplo,n,k,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, k, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06sdf
      End Interface
      Interface
        Subroutine f06sef(uplo,n,alpha,ap,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06sef
      End Interface
      Interface
        Subroutine f06sff(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06sff
      End Interface
      Interface
        Subroutine f06sgf(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06sgf
      End Interface
      Interface
        Subroutine f06shf(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06shf
      End Interface
      Interface
        Subroutine f06sjf(uplo,trans,diag,n,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06sjf
      End Interface
      Interface
        Subroutine f06skf(uplo,trans,diag,n,k,a,lda,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, k, lda, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06skf
      End Interface
      Interface
        Subroutine f06slf(uplo,trans,diag,n,ap,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: x(*)
        End Subroutine f06slf
      End Interface
      Interface
        Subroutine f06smf(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06smf
      End Interface
      Interface
        Subroutine f06snf(m,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06snf
      End Interface
      Interface
        Subroutine f06spf(uplo,n,alpha,x,incx,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06spf
      End Interface
      Interface
        Subroutine f06sqf(uplo,n,alpha,x,incx,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06sqf
      End Interface
      Interface
        Subroutine f06srf(uplo,n,alpha,x,incx,y,incy,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06srf
      End Interface
      Interface
        Subroutine f06ssf(uplo,n,alpha,x,incx,y,incy,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: x(*), y(*)
        End Subroutine f06ssf
      End Interface
      Interface
        Subroutine f06taf(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06taf
      End Interface
      Interface
        Subroutine f06tbf(uplo,n,alpha,x,incx,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06tbf
      End Interface
      Interface
        Subroutine f06tcf(uplo,n,alpha,ap,x,incx,beta,y,incy)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incx, incy, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), x(*)
          Complex (Kind=wp), Intent (Inout) :: y(*)
        End Subroutine f06tcf
      End Interface
      Interface
        Subroutine f06tdf(uplo,n,alpha,x,incx,ap)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: x(*)
        End Subroutine f06tdf
      End Interface
      Interface
        Subroutine f06tff(matrix,m,n,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: matrix
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06tff
      End Interface
      Interface
        Subroutine f06thf(matrix,m,n,con,diag,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: con, diag
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: matrix
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f06thf
      End Interface
      Interface
        Subroutine f06tmf(uplo,pivot,direct,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: direct, pivot, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: s(*)
          Real (Kind=wp), Intent (In) :: c(*)
        End Subroutine f06tmf
      End Interface
      Interface
        Subroutine f06tpf(n,alpha,x,incx,y,incy,a,lda,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, incy, lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Out) :: s(n)
          Complex (Kind=wp), Intent (In) :: y(*)
          Real (Kind=wp), Intent (Out) :: c(n-1)
        End Subroutine f06tpf
      End Interface
      Interface
        Subroutine f06tqf(n,alpha,x,incx,a,lda,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: incx, lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(*)
          Complex (Kind=wp), Intent (Out) :: s(n)
          Real (Kind=wp), Intent (Out) :: c(n)
        End Subroutine f06tqf
      End Interface
      Interface
        Subroutine f06trf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: c(k2)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine f06trf
      End Interface
      Interface
        Subroutine f06tsf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (Out) :: c(k2-1)
        End Subroutine f06tsf
      End Interface
      Interface
        Subroutine f06ttf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (Inout) :: c(*)
        End Subroutine f06ttf
      End Interface
      Interface
        Subroutine f06tvf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: c(*)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine f06tvf
      End Interface
      Interface
        Subroutine f06twf(side,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, n
          Character (1), Intent (In) :: side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), s(*)
          Real (Kind=wp), Intent (In) :: c(*)
        End Subroutine f06twf
      End Interface
      Interface
        Subroutine f06txf(side,pivot,direct,m,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, m, n
          Character (1), Intent (In) :: direct, pivot, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: s(*)
          Real (Kind=wp), Intent (In) :: c(*)
        End Subroutine f06txf
      End Interface
      Interface
        Subroutine f06tyf(side,pivot,direct,m,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, m, n
          Character (1), Intent (In) :: direct, pivot, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: c(*)
          Real (Kind=wp), Intent (In) :: s(*)
        End Subroutine f06tyf
      End Interface
      Interface
        Function f06uaf(norm,m,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06uaf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06uaf
      End Interface
      Interface
        Function f06ubf(norm,n,kl,ku,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ubf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ubf
      End Interface
      Interface
        Function f06ucf(norm,uplo,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ucf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ucf
      End Interface
      Interface
        Function f06udf(norm,uplo,n,ap,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06udf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06udf
      End Interface
      Interface
        Function f06uef(norm,uplo,n,k,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06uef
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldab, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06uef
      End Interface
      Interface
        Function f06uff(norm,uplo,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06uff
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06uff
      End Interface
      Interface
        Function f06ugf(norm,uplo,n,ap,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ugf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ugf
      End Interface
      Interface
        Function f06uhf(norm,uplo,n,k,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06uhf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldab, n
          Character (1), Intent (In) :: norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06uhf
      End Interface
      Interface
        Function f06ujf(norm,uplo,diag,m,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ujf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ujf
      End Interface
      Interface
        Function f06ukf(norm,uplo,diag,n,ap,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ukf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ukf
      End Interface
      Interface
        Function f06ulf(norm,uplo,diag,n,k,ab,ldab,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06ulf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06ulf
      End Interface
      Interface
        Function f06umf(norm,n,a,lda,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06umf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06umf
      End Interface
      Interface
        Function f06unf(norm,n,dl,d,du)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06unf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: d(*), dl(*), du(*)
        End Function f06unf
      End Interface
      Interface
        Function f06upf(norm,n,d,e)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06upf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: e(*)
          Real (Kind=wp), Intent (In) :: d(*)
        End Function f06upf
      End Interface
      Interface
        Subroutine f06vjf(side,trans,n,perm,k,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldb, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: perm(*)
        End Subroutine f06vjf
      End Interface
      Interface
        Subroutine f06vkf(side,trans,n,perm,k,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k, ldb, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: perm(*)
        End Subroutine f06vkf
      End Interface
      Interface
        Subroutine f06vxf(side,pivot,direct,m,n,k1,k2,c,s,a,lda)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: k1, k2, lda, m, n
          Character (1), Intent (In) :: direct, pivot, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: c(*), s(*)
        End Subroutine f06vxf
      End Interface
      Interface
        Function f06waf(norm,transr,uplo,n,a,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06waf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06waf
      End Interface
      Interface
        Subroutine f06wbf(transr,side,uplo,trans,diag,m,n,alpha,a,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: ldb, m, n
          Character (1), Intent (In) :: diag, side, trans, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06wbf
      End Interface
      Interface
        Subroutine f06wcf(transr,uplo,trans,n,k,alpha,a,lda,beta,c)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, n
          Character (1), Intent (In) :: trans, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: c(n*(n+1)/2)
        End Subroutine f06wcf
      End Interface
      Interface
        Function f06wnf(norm,transr,uplo,n,a,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f06wnf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function f06wnf
      End Interface
      Interface
        Subroutine f06wpf(transr,side,uplo,trans,diag,m,n,alpha,a,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: ldb, m, n
          Character (1), Intent (In) :: diag, side, trans, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06wpf
      End Interface
      Interface
        Subroutine f06wqf(transr,uplo,trans,n,k,alpha,a,lda,beta,c)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, n
          Character (1), Intent (In) :: trans, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(n*(n+1)/2)
        End Subroutine f06wqf
      End Interface
      Interface
        Subroutine f06yaf(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06yaf
      End Interface
      Interface
        Subroutine f06ycf(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06ycf
      End Interface
      Interface
        Subroutine f06yff(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06yff
      End Interface
      Interface
        Subroutine f06yjf(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06yjf
      End Interface
      Interface
        Subroutine f06ypf(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06ypf
      End Interface
      Interface
        Subroutine f06yrf(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06yrf
      End Interface
      Interface
        Subroutine f06zaf(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: transa, transb
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zaf
      End Interface
      Interface
        Subroutine f06zcf(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zcf
      End Interface
      Interface
        Subroutine f06zff(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06zff
      End Interface
      Interface
        Subroutine f06zjf(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: lda, ldb, m, n
          Character (1), Intent (In) :: diag, side, transa, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f06zjf
      End Interface
      Interface
        Subroutine f06zpf(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zpf
      End Interface
      Interface
        Subroutine f06zrf(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Real (Kind=wp), Intent (In) :: beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zrf
      End Interface
      Interface
        Subroutine f06ztf(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: lda, ldb, ldc, m, n
          Character (1), Intent (In) :: side, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06ztf
      End Interface
      Interface
        Subroutine f06zuf(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zuf
      End Interface
      Interface
        Subroutine f06zwf(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, ldb, ldc, n
          Character (1), Intent (In) :: trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f06zwf
      End Interface
      Interface
        Subroutine f07aaf(n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07aaf
      End Interface
      Interface
        Subroutine f07abf(fact,trans,n,nrhs,a,lda,af,ldaf,ipiv,equed,r,c,b, &
            ldb,x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            c(*), r(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            work(max(1,4*n))
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07abf
      End Interface
      Interface
        Subroutine f07acf(n,nrhs,a,lda,ipiv,b,ldb,x,ldx,work,swork,iter,info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
          Real (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Real (Kind=wp), Intent (Out) :: work(n*nrhs)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07acf
      End Interface
      Interface
        Subroutine f07adf(m,n,a,lda,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f07adf
      End Interface
      Interface
        Subroutine f07aef(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07aef
      End Interface
      Interface
        Subroutine f07aff(m,n,a,lda,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine f07aff
      End Interface
      Interface
        Subroutine f07agf(norm,n,a,lda,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07agf
      End Interface
      Interface
        Subroutine f07ahf(trans,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07ahf
      End Interface
      Interface
        Subroutine f07ajf(n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (In) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07ajf
      End Interface
      Interface
        Subroutine f07anf(n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07anf
      End Interface
      Interface
        Subroutine f07apf(fact,trans,n,nrhs,a,lda,af,ldaf,ipiv,equed,r,c,b, &
            ldb,x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            rwork(max(1,2*n))
          Real (Kind=wp), Intent (Inout) :: c(*), r(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07apf
      End Interface
      Interface
        Subroutine f07aqf(n,nrhs,a,lda,ipiv,b,ldb,x,ldx,work,swork,rwork,iter, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: b(ldb,*)
          Complex (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Complex (Kind=wp), Intent (Out) :: work(n*nrhs)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07aqf
      End Interface
      Interface
        Subroutine f07arf(m,n,a,lda,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f07arf
      End Interface
      Interface
        Subroutine f07asf(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07asf
      End Interface
      Interface
        Subroutine f07atf(m,n,a,lda,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine f07atf
      End Interface
      Interface
        Subroutine f07auf(norm,n,a,lda,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
        End Subroutine f07auf
      End Interface
      Interface
        Subroutine f07avf(trans,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07avf
      End Interface
      Interface
        Subroutine f07awf(n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (In) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07awf
      End Interface
      Interface
        Subroutine f07baf(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07baf
      End Interface
      Interface
        Subroutine f07bbf(fact,trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv, &
            equed,r,c,b,ldb,x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), c(*), r(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            work(max(1,3*n))
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07bbf
      End Interface
      Interface
        Subroutine f07bdf(m,n,kl,ku,ab,ldab,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f07bdf
      End Interface
      Interface
        Subroutine f07bef(trans,n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07bef
      End Interface
      Interface
        Subroutine f07bff(m,n,kl,ku,ab,ldab,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine f07bff
      End Interface
      Interface
        Subroutine f07bgf(norm,n,kl,ku,ab,ldab,ipiv,anorm,rcond,work,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07bgf
      End Interface
      Interface
        Subroutine f07bhf(trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07bhf
      End Interface
      Interface
        Subroutine f07bnf(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07bnf
      End Interface
      Interface
        Subroutine f07bpf(fact,trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv, &
            equed,r,c,b,ldb,x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            rwork(max(1,n))
          Real (Kind=wp), Intent (Inout) :: c(*), r(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07bpf
      End Interface
      Interface
        Subroutine f07brf(m,n,kl,ku,ab,ldab,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f07brf
      End Interface
      Interface
        Subroutine f07bsf(trans,n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07bsf
      End Interface
      Interface
        Subroutine f07btf(m,n,kl,ku,ab,ldab,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine f07btf
      End Interface
      Interface
        Subroutine f07buf(norm,n,kl,ku,ab,ldab,ipiv,anorm,rcond,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07buf
      End Interface
      Interface
        Subroutine f07bvf(trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07bvf
      End Interface
      Interface
        Subroutine f07caf(n,nrhs,dl,d,du,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
        End Subroutine f07caf
      End Interface
      Interface
        Subroutine f07cbf(fact,trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb, &
            x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), dl(*), du(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: df(*), dlf(*), du2(*), duf(*), &
            x(ldx,*)
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07cbf
      End Interface
      Interface
        Subroutine f07cdf(n,dl,d,du,du2,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), dl(*), du(*)
          Real (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07cdf
      End Interface
      Interface
        Subroutine f07cef(trans,n,nrhs,dl,d,du,du2,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07cef
      End Interface
      Interface
        Subroutine f07cgf(norm,n,dl,d,du,du2,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07cgf
      End Interface
      Interface
        Subroutine f07chf(trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), dl(*), dlf(*), &
            du(*), du2(*), duf(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07chf
      End Interface
      Interface
        Subroutine f07cnf(n,nrhs,dl,d,du,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
        End Subroutine f07cnf
      End Interface
      Interface
        Subroutine f07cpf(fact,trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb, &
            x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), d(*), dl(*), du(*)
          Complex (Kind=wp), Intent (Inout) :: df(*), dlf(*), du2(*), duf(*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine f07cpf
      End Interface
      Interface
        Subroutine f07crf(n,dl,d,du,du2,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: d(*), dl(*), du(*)
          Complex (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07crf
      End Interface
      Interface
        Subroutine f07csf(trans,n,nrhs,dl,d,du,du2,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Complex (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07csf
      End Interface
      Interface
        Subroutine f07cuf(norm,n,dl,d,du,du2,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07cuf
      End Interface
      Interface
        Subroutine f07cvf(trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), dl(*), &
            dlf(*), du(*), du2(*), duf(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07cvf
      End Interface
      Interface
        Subroutine f07faf(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine f07faf
      End Interface
      Interface
        Subroutine f07fbf(fact,uplo,n,nrhs,a,lda,af,ldaf,equed,s,b,ldb,x,ldx, &
            rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            s(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07fbf
      End Interface
      Interface
        Subroutine f07fcf(uplo,n,nrhs,a,lda,b,ldb,x,ldx,work,swork,iter,info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
          Real (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Real (Kind=wp), Intent (Out) :: work(n,nrhs)
        End Subroutine f07fcf
      End Interface
      Interface
        Subroutine f07fdf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07fdf
      End Interface
      Interface
        Subroutine f07fef(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07fef
      End Interface
      Interface
        Subroutine f07fff(n,a,lda,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07fff
      End Interface
      Interface
        Subroutine f07fgf(uplo,n,a,lda,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07fgf
      End Interface
      Interface
        Subroutine f07fhf(uplo,n,nrhs,a,lda,af,ldaf,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07fhf
      End Interface
      Interface
        Subroutine f07fjf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07fjf
      End Interface
      Interface
        Subroutine f07fnf(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine f07fnf
      End Interface
      Interface
        Subroutine f07fpf(fact,uplo,n,nrhs,a,lda,af,ldaf,equed,s,b,ldb,x,ldx, &
            rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine f07fpf
      End Interface
      Interface
        Subroutine f07fqf(uplo,n,nrhs,a,lda,b,ldb,x,ldx,work,swork,rwork,iter, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: b(ldb,*)
          Complex (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Complex (Kind=wp), Intent (Out) :: work(n,nrhs)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07fqf
      End Interface
      Interface
        Subroutine f07frf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07frf
      End Interface
      Interface
        Subroutine f07fsf(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07fsf
      End Interface
      Interface
        Subroutine f07ftf(n,a,lda,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07ftf
      End Interface
      Interface
        Subroutine f07fuf(uplo,n,a,lda,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07fuf
      End Interface
      Interface
        Subroutine f07fvf(uplo,n,nrhs,a,lda,af,ldaf,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07fvf
      End Interface
      Interface
        Subroutine f07fwf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07fwf
      End Interface
      Interface
        Subroutine f07gaf(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine f07gaf
      End Interface
      Interface
        Subroutine f07gbf(fact,uplo,n,nrhs,ap,afp,equed,s,b,ldb,x,ldx,rcond, &
            ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: afp(*), ap(*), b(ldb,*), s(*), &
            x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07gbf
      End Interface
      Interface
        Subroutine f07gdf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07gdf
      End Interface
      Interface
        Subroutine f07gef(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07gef
      End Interface
      Interface
        Subroutine f07gff(uplo,n,ap,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07gff
      End Interface
      Interface
        Subroutine f07ggf(uplo,n,ap,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07ggf
      End Interface
      Interface
        Subroutine f07ghf(uplo,n,nrhs,ap,afp,b,ldb,x,ldx,ferr,berr,work,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07ghf
      End Interface
      Interface
        Subroutine f07gjf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07gjf
      End Interface
      Interface
        Subroutine f07gnf(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine f07gnf
      End Interface
      Interface
        Subroutine f07gpf(fact,uplo,n,nrhs,ap,afp,equed,s,b,ldb,x,ldx,rcond, &
            ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), ap(*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine f07gpf
      End Interface
      Interface
        Subroutine f07grf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07grf
      End Interface
      Interface
        Subroutine f07gsf(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07gsf
      End Interface
      Interface
        Subroutine f07gtf(uplo,n,ap,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07gtf
      End Interface
      Interface
        Subroutine f07guf(uplo,n,ap,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07guf
      End Interface
      Interface
        Subroutine f07gvf(uplo,n,nrhs,ap,afp,b,ldb,x,ldx,ferr,berr,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07gvf
      End Interface
      Interface
        Subroutine f07gwf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07gwf
      End Interface
      Interface
        Subroutine f07haf(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine f07haf
      End Interface
      Interface
        Subroutine f07hbf(fact,uplo,n,kd,nrhs,ab,ldab,afb,ldafb,equed,s,b,ldb, &
            x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), s(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07hbf
      End Interface
      Interface
        Subroutine f07hdf(uplo,n,kd,ab,ldab,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*)
        End Subroutine f07hdf
      End Interface
      Interface
        Subroutine f07hef(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07hef
      End Interface
      Interface
        Subroutine f07hff(uplo,n,kd,ab,ldab,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07hff
      End Interface
      Interface
        Subroutine f07hgf(uplo,n,kd,ab,ldab,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07hgf
      End Interface
      Interface
        Subroutine f07hhf(uplo,n,kd,nrhs,ab,ldab,afb,ldafb,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07hhf
      End Interface
      Interface
        Subroutine f07hnf(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine f07hnf
      End Interface
      Interface
        Subroutine f07hpf(fact,uplo,n,kd,nrhs,ab,ldab,afb,ldafb,equed,s,b,ldb, &
            x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine f07hpf
      End Interface
      Interface
        Subroutine f07hrf(uplo,n,kd,ab,ldab,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*)
        End Subroutine f07hrf
      End Interface
      Interface
        Subroutine f07hsf(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07hsf
      End Interface
      Interface
        Subroutine f07htf(uplo,n,kd,ab,ldab,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine f07htf
      End Interface
      Interface
        Subroutine f07huf(uplo,n,kd,ab,ldab,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07huf
      End Interface
      Interface
        Subroutine f07hvf(uplo,n,kd,nrhs,ab,ldab,afb,ldafb,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07hvf
      End Interface
      Interface
        Subroutine f07jaf(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), e(*)
        End Subroutine f07jaf
      End Interface
      Interface
        Subroutine f07jbf(fact,n,nrhs,d,e,df,ef,b,ldb,x,ldx,rcond,ferr,berr, &
            work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), e(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(2*n)
          Real (Kind=wp), Intent (Inout) :: df(*), ef(*), x(ldx,*)
        End Subroutine f07jbf
      End Interface
      Interface
        Subroutine f07jdf(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
        End Subroutine f07jdf
      End Interface
      Interface
        Subroutine f07jef(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: d(*), e(*)
        End Subroutine f07jef
      End Interface
      Interface
        Subroutine f07jgf(n,d,e,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine f07jgf
      End Interface
      Interface
        Subroutine f07jhf(n,nrhs,d,e,df,ef,b,ldb,x,ldx,ferr,berr,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), e(*), ef(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(2*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
        End Subroutine f07jhf
      End Interface
      Interface
        Subroutine f07jnf(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), e(*)
          Real (Kind=wp), Intent (Inout) :: d(*)
        End Subroutine f07jnf
      End Interface
      Interface
        Subroutine f07jpf(fact,n,nrhs,d,e,df,ef,b,ldb,x,ldx,rcond,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), e(*)
          Complex (Kind=wp), Intent (Inout) :: ef(*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Inout) :: df(*)
        End Subroutine f07jpf
      End Interface
      Interface
        Subroutine f07jrf(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: e(*)
          Real (Kind=wp), Intent (Inout) :: d(*)
        End Subroutine f07jrf
      End Interface
      Interface
        Subroutine f07jsf(uplo,n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Complex (Kind=wp), Intent (In) :: e(*)
          Real (Kind=wp), Intent (In) :: d(*)
        End Subroutine f07jsf
      End Interface
      Interface
        Subroutine f07juf(n,d,e,anorm,rcond,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: e(*)
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07juf
      End Interface
      Interface
        Subroutine f07jvf(uplo,n,nrhs,d,e,df,ef,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), e(*), ef(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (In) :: d(*), df(*)
        End Subroutine f07jvf
      End Interface
      Interface
        Subroutine f07kdf(uplo,n,a,lda,piv,rank,tol,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (Out) :: piv(n)
        End Subroutine f07kdf
      End Interface
      Interface
        Subroutine f07krf(uplo,n,a,lda,piv,rank,tol,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (Out) :: piv(n)
        End Subroutine f07krf
      End Interface
      Interface
        Subroutine f07maf(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07maf
      End Interface
      Interface
        Subroutine f07mbf(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: af(ldaf,*), berr(*), ferr(*), &
            x(ldx,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*), iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07mbf
      End Interface
      Interface
        Subroutine f07mdf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07mdf
      End Interface
      Interface
        Subroutine f07mef(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07mef
      End Interface
      Interface
        Subroutine f07mgf(uplo,n,a,lda,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07mgf
      End Interface
      Interface
        Subroutine f07mhf(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07mhf
      End Interface
      Interface
        Subroutine f07mjf(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07mjf
      End Interface
      Interface
        Subroutine f07mnf(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07mnf
      End Interface
      Interface
        Subroutine f07mpf(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: af(ldaf,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: berr(*), ferr(*), rwork(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07mpf
      End Interface
      Interface
        Subroutine f07mrf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: ipiv(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07mrf
      End Interface
      Interface
        Subroutine f07msf(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07msf
      End Interface
      Interface
        Subroutine f07muf(uplo,n,a,lda,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07muf
      End Interface
      Interface
        Subroutine f07mvf(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07mvf
      End Interface
      Interface
        Subroutine f07mwf(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07mwf
      End Interface
      Interface
        Subroutine f07nnf(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07nnf
      End Interface
      Interface
        Subroutine f07npf(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: af(ldaf,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: berr(*), ferr(*), rwork(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07npf
      End Interface
      Interface
        Subroutine f07nrf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f07nrf
      End Interface
      Interface
        Subroutine f07nsf(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07nsf
      End Interface
      Interface
        Subroutine f07nuf(uplo,n,a,lda,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07nuf
      End Interface
      Interface
        Subroutine f07nvf(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07nvf
      End Interface
      Interface
        Subroutine f07nwf(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07nwf
      End Interface
      Interface
        Subroutine f07paf(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07paf
      End Interface
      Interface
        Subroutine f07pbf(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07pbf
      End Interface
      Interface
        Subroutine f07pdf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07pdf
      End Interface
      Interface
        Subroutine f07pef(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07pef
      End Interface
      Interface
        Subroutine f07pgf(uplo,n,ap,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07pgf
      End Interface
      Interface
        Subroutine f07phf(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07phf
      End Interface
      Interface
        Subroutine f07pjf(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07pjf
      End Interface
      Interface
        Subroutine f07pnf(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07pnf
      End Interface
      Interface
        Subroutine f07ppf(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine f07ppf
      End Interface
      Interface
        Subroutine f07prf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07prf
      End Interface
      Interface
        Subroutine f07psf(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07psf
      End Interface
      Interface
        Subroutine f07puf(uplo,n,ap,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07puf
      End Interface
      Interface
        Subroutine f07pvf(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07pvf
      End Interface
      Interface
        Subroutine f07pwf(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07pwf
      End Interface
      Interface
        Subroutine f07qnf(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07qnf
      End Interface
      Interface
        Subroutine f07qpf(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine f07qpf
      End Interface
      Interface
        Subroutine f07qrf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine f07qrf
      End Interface
      Interface
        Subroutine f07qsf(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07qsf
      End Interface
      Interface
        Subroutine f07quf(uplo,n,ap,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07quf
      End Interface
      Interface
        Subroutine f07qvf(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07qvf
      End Interface
      Interface
        Subroutine f07qwf(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine f07qwf
      End Interface
      Interface
        Subroutine f07tef(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07tef
      End Interface
      Interface
        Subroutine f07tgf(norm,uplo,diag,n,a,lda,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07tgf
      End Interface
      Interface
        Subroutine f07thf(uplo,trans,diag,n,nrhs,a,lda,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07thf
      End Interface
      Interface
        Subroutine f07tjf(uplo,diag,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07tjf
      End Interface
      Interface
        Subroutine f07tsf(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07tsf
      End Interface
      Interface
        Subroutine f07tuf(norm,uplo,diag,n,a,lda,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07tuf
      End Interface
      Interface
        Subroutine f07tvf(uplo,trans,diag,n,nrhs,a,lda,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07tvf
      End Interface
      Interface
        Subroutine f07twf(uplo,diag,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine f07twf
      End Interface
      Interface
        Subroutine f07uef(uplo,trans,diag,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07uef
      End Interface
      Interface
        Subroutine f07ugf(norm,uplo,diag,n,ap,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07ugf
      End Interface
      Interface
        Subroutine f07uhf(uplo,trans,diag,n,nrhs,ap,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07uhf
      End Interface
      Interface
        Subroutine f07ujf(uplo,diag,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07ujf
      End Interface
      Interface
        Subroutine f07usf(uplo,trans,diag,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07usf
      End Interface
      Interface
        Subroutine f07uuf(norm,uplo,diag,n,ap,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07uuf
      End Interface
      Interface
        Subroutine f07uvf(uplo,trans,diag,n,nrhs,ap,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07uvf
      End Interface
      Interface
        Subroutine f07uwf(uplo,diag,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine f07uwf
      End Interface
      Interface
        Subroutine f07vef(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07vef
      End Interface
      Interface
        Subroutine f07vgf(norm,uplo,diag,n,kd,ab,ldab,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07vgf
      End Interface
      Interface
        Subroutine f07vhf(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine f07vhf
      End Interface
      Interface
        Subroutine f07vsf(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07vsf
      End Interface
      Interface
        Subroutine f07vuf(norm,uplo,diag,n,kd,ab,ldab,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f07vuf
      End Interface
      Interface
        Subroutine f07vvf(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine f07vvf
      End Interface
      Interface
        Subroutine f07wdf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wdf
      End Interface
      Interface
        Subroutine f07wef(transr,uplo,n,nrhs,a,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07wef
      End Interface
      Interface
        Subroutine f07wjf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wjf
      End Interface
      Interface
        Subroutine f07wkf(transr,uplo,diag,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wkf
      End Interface
      Interface
        Subroutine f07wrf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wrf
      End Interface
      Interface
        Subroutine f07wsf(transr,uplo,n,nrhs,a,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine f07wsf
      End Interface
      Interface
        Subroutine f07wwf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wwf
      End Interface
      Interface
        Subroutine f07wxf(transr,uplo,diag,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine f07wxf
      End Interface
      Interface
        Subroutine f08aaf(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08aaf
      End Interface
      Interface
        Subroutine f08aef(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08aef
      End Interface
      Interface
        Subroutine f08aff(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08aff
      End Interface
      Interface
        Subroutine f08agf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08agf
      End Interface
      Interface
        Subroutine f08ahf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ahf
      End Interface
      Interface
        Subroutine f08ajf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ajf
      End Interface
      Interface
        Subroutine f08akf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08akf
      End Interface
      Interface
        Subroutine f08anf(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08anf
      End Interface
      Interface
        Subroutine f08asf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08asf
      End Interface
      Interface
        Subroutine f08atf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08atf
      End Interface
      Interface
        Subroutine f08auf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08auf
      End Interface
      Interface
        Subroutine f08avf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08avf
      End Interface
      Interface
        Subroutine f08awf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08awf
      End Interface
      Interface
        Subroutine f08axf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08axf
      End Interface
      Interface
        Subroutine f08baf(m,n,nrhs,a,lda,b,ldb,jpvt,rcond,rank,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08baf
      End Interface
      Interface
        Subroutine f08bef(m,n,a,lda,jpvt,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: tau(min(m,n)), work(3*n)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f08bef
      End Interface
      Interface
        Subroutine f08bff(m,n,a,lda,jpvt,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bff
      End Interface
      Interface
        Subroutine f08bhf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bhf
      End Interface
      Interface
        Subroutine f08bkf(side,trans,m,n,k,l,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, l, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bkf
      End Interface
      Interface
        Subroutine f08bnf(m,n,nrhs,a,lda,b,ldb,jpvt,rcond,rank,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bnf
      End Interface
      Interface
        Subroutine f08bsf(m,n,a,lda,jpvt,tau,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: tau(min(m,n)), work(n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine f08bsf
      End Interface
      Interface
        Subroutine f08btf(m,n,a,lda,jpvt,tau,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08btf
      End Interface
      Interface
        Subroutine f08bvf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bvf
      End Interface
      Interface
        Subroutine f08bxf(side,trans,m,n,k,l,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, l, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08bxf
      End Interface
      Interface
        Subroutine f08cef(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cef
      End Interface
      Interface
        Subroutine f08cff(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cff
      End Interface
      Interface
        Subroutine f08cgf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cgf
      End Interface
      Interface
        Subroutine f08chf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08chf
      End Interface
      Interface
        Subroutine f08cjf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cjf
      End Interface
      Interface
        Subroutine f08ckf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ckf
      End Interface
      Interface
        Subroutine f08csf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08csf
      End Interface
      Interface
        Subroutine f08ctf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ctf
      End Interface
      Interface
        Subroutine f08cuf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cuf
      End Interface
      Interface
        Subroutine f08cvf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cvf
      End Interface
      Interface
        Subroutine f08cwf(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cwf
      End Interface
      Interface
        Subroutine f08cxf(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08cxf
      End Interface
      Interface
        Subroutine f08faf(jobz,uplo,n,a,lda,w,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08faf
      End Interface
      Interface
        Subroutine f08fbf(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,work,lwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*), jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fbf
      End Interface
      Interface
        Subroutine f08fcf(job,uplo,n,a,lda,w,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fcf
      End Interface
      Interface
        Subroutine f08fdf(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fdf
      End Interface
      Interface
        Subroutine f08fef(uplo,n,a,lda,d,e,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), d(*), e(*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fef
      End Interface
      Interface
        Subroutine f08fff(uplo,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fff
      End Interface
      Interface
        Subroutine f08fgf(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fgf
      End Interface
      Interface
        Subroutine f08flf(job,m,n,d,sep,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Inout) :: sep(*)
        End Subroutine f08flf
      End Interface
      Interface
        Subroutine f08fnf(jobz,uplo,n,a,lda,w,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), w(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fnf
      End Interface
      Interface
        Subroutine f08fpf(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,work,lwork,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), w(*)
          Integer, Intent (Inout) :: iwork(*), jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fpf
      End Interface
      Interface
        Subroutine f08fqf(job,uplo,n,a,lda,w,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fqf
      End Interface
      Interface
        Subroutine f08frf(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,isuppz,work,lwork,rwork,lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, liwork, lrwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08frf
      End Interface
      Interface
        Subroutine f08fsf(uplo,n,a,lda,d,e,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fsf
      End Interface
      Interface
        Subroutine f08ftf(uplo,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ftf
      End Interface
      Interface
        Subroutine f08fuf(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08fuf
      End Interface
      Interface
        Subroutine f08gaf(jobz,uplo,n,ap,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine f08gaf
      End Interface
      Interface
        Subroutine f08gbf(jobz,range,uplo,n,ap,vl,vu,il,iu,abstol,m,w,z,ldz, &
            work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(8*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08gbf
      End Interface
      Interface
        Subroutine f08gcf(job,uplo,n,ap,w,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08gcf
      End Interface
      Interface
        Subroutine f08gef(uplo,n,ap,d,e,tau,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1), tau(n-1)
        End Subroutine f08gef
      End Interface
      Interface
        Subroutine f08gff(uplo,n,ap,tau,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), tau(*)
          Real (Kind=wp), Intent (Inout) :: q(ldq,*)
          Real (Kind=wp), Intent (Out) :: work(n-1)
        End Subroutine f08gff
      End Interface
      Interface
        Subroutine f08ggf(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), c(ldc,*), work(*)
          Real (Kind=wp), Intent (In) :: tau(*)
        End Subroutine f08ggf
      End Interface
      Interface
        Subroutine f08gnf(jobz,uplo,n,ap,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n-1)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine f08gnf
      End Interface
      Interface
        Subroutine f08gpf(jobz,range,uplo,n,ap,vl,vu,il,iu,abstol,m,w,z,ldz, &
            work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08gpf
      End Interface
      Interface
        Subroutine f08gqf(job,uplo,n,ap,w,z,ldz,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08gqf
      End Interface
      Interface
        Subroutine f08gsf(uplo,n,ap,d,e,tau,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: tau(n-1)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1)
        End Subroutine f08gsf
      End Interface
      Interface
        Subroutine f08gtf(uplo,n,ap,tau,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), tau(*)
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(n-1)
        End Subroutine f08gtf
      End Interface
      Interface
        Subroutine f08guf(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), c(ldc,*), work(*)
          Complex (Kind=wp), Intent (In) :: tau(*)
        End Subroutine f08guf
      End Interface
      Interface
        Subroutine f08haf(jobz,uplo,n,kd,ab,ldab,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n-2)
        End Subroutine f08haf
      End Interface
      Interface
        Subroutine f08hbf(jobz,range,uplo,n,kd,ab,ldab,q,ldq,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, kd, ldab, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(7*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08hbf
      End Interface
      Interface
        Subroutine f08hcf(job,uplo,n,kd,ab,ldab,w,z,ldz,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08hcf
      End Interface
      Interface
        Subroutine f08hef(vect,uplo,n,kd,ab,ldab,d,e,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldq, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1), work(n)
        End Subroutine f08hef
      End Interface
      Interface
        Subroutine f08hnf(jobz,uplo,n,kd,ab,ldab,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine f08hnf
      End Interface
      Interface
        Subroutine f08hpf(jobz,range,uplo,n,kd,ab,ldab,q,ldq,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, kd, ldab, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08hpf
      End Interface
      Interface
        Subroutine f08hqf(job,uplo,n,kd,ab,ldab,w,z,ldz,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08hqf
      End Interface
      Interface
        Subroutine f08hsf(vect,uplo,n,kd,ab,ldab,d,e,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldq, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1)
        End Subroutine f08hsf
      End Interface
      Interface
        Subroutine f08jaf(jobz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*), z(ldz,*)
        End Subroutine f08jaf
      End Interface
      Interface
        Subroutine f08jbf(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz,work, &
            iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(5*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08jbf
      End Interface
      Interface
        Subroutine f08jcf(job,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jcf
      End Interface
      Interface
        Subroutine f08jdf(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jdf
      End Interface
      Interface
        Subroutine f08jef(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*), z(ldz,*)
        End Subroutine f08jef
      End Interface
      Interface
        Subroutine f08jff(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
        End Subroutine f08jff
      End Interface
      Interface
        Subroutine f08jgf(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
        End Subroutine f08jgf
      End Interface
      Interface
        Subroutine f08jhf(compz,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jhf
      End Interface
      Interface
        Subroutine f08jjf(range,order,n,vl,vu,il,iu,abstol,d,e,m,nsplit,w, &
            iblock,isplit,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, n
          Integer, Intent (Out) :: info, m, nsplit
          Character (1), Intent (In) :: order, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: w(n), work(4*n)
          Integer, Intent (Out) :: iblock(n), isplit(n), iwork(3*n)
        End Subroutine f08jjf
      End Interface
      Interface
        Subroutine f08jkf(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifailv, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(5*n)
          Real (Kind=wp), Intent (Inout) :: z(ldz,*)
          Integer, Intent (In) :: iblock(*), isplit(*)
          Integer, Intent (Out) :: ifailv(m), iwork(n)
        End Subroutine f08jkf
      End Interface
      Interface
        Subroutine f08jlf(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jlf
      End Interface
      Interface
        Subroutine f08jsf(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*)
        End Subroutine f08jsf
      End Interface
      Interface
        Subroutine f08juf(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
        End Subroutine f08juf
      End Interface
      Interface
        Subroutine f08jvf(compz,n,d,e,z,ldz,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jvf
      End Interface
      Interface
        Subroutine f08jxf(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifailv, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (In) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(5*n)
          Integer, Intent (In) :: iblock(*), isplit(*)
          Integer, Intent (Out) :: ifailv(m), iwork(n)
        End Subroutine f08jxf
      End Interface
      Interface
        Subroutine f08jyf(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08jyf
      End Interface
      Interface
        Subroutine f08kaf(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kaf
      End Interface
      Interface
        Subroutine f08kbf(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobu, jobvt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), s(*), u(ldu,*), &
            vt(ldvt,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kbf
      End Interface
      Interface
        Subroutine f08kcf(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kcf
      End Interface
      Interface
        Subroutine f08kdf(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Real (Kind=wp), Intent (Out) :: s(min(m,n)), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(8*min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08kdf
      End Interface
      Interface
        Subroutine f08kef(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), d(*), e(*), taup(*), &
            tauq(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kef
      End Interface
      Interface
        Subroutine f08kff(vect,m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kff
      End Interface
      Interface
        Subroutine f08kgf(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kgf
      End Interface
      Interface
        Subroutine f08khf(joba,jobu,jobv,jobr,jobt,jobp,m,n,a,lda,sva,u,ldu,v, &
            ldv,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldv, lwork, m, n
          Character (1), Intent (In) :: joba, jobp, jobr, jobt, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: sva(n), work(lwork)
          Integer, Intent (Out) :: iwork(m+3*n)
        End Subroutine f08khf
      End Interface
      Interface
        Subroutine f08kjf(joba,jobu,jobv,m,n,a,lda,sva,mv,v,ldv,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldv, lwork, m, mv, n
          Character (1), Intent (In) :: joba, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), v(ldv,*), work(lwork)
          Real (Kind=wp), Intent (Out) :: sva(n)
        End Subroutine f08kjf
      End Interface
      Interface
        Subroutine f08knf(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08knf
      End Interface
      Interface
        Subroutine f08kpf(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobu, jobvt
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kpf
      End Interface
      Interface
        Subroutine f08kqf(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,rwork, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kqf
      End Interface
      Interface
        Subroutine f08krf(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,rwork, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Real (Kind=wp), Intent (Out) :: s(min(m,n))
          Integer, Intent (Out) :: iwork(8*min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08krf
      End Interface
      Interface
        Subroutine f08ksf(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), taup(*), tauq(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ksf
      End Interface
      Interface
        Subroutine f08ktf(vect,m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ktf
      End Interface
      Interface
        Subroutine f08kuf(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08kuf
      End Interface
      Interface
        Subroutine f08lef(vect,m,n,ncc,kl,ku,ab,ldab,d,e,q,ldq,pt,ldpt,c,ldc, &
            work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldc, ldpt, ldq, m, n, ncc
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), c(ldc,*), pt(ldpt,*), &
            q(ldq,*)
          Real (Kind=wp), Intent (Out) :: d(min(m,n)), e(min(m,n)-1), &
            work(2*max(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08lef
      End Interface
      Interface
        Subroutine f08lsf(vect,m,n,ncc,kl,ku,ab,ldab,d,e,q,ldq,pt,ldpt,c,ldc, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldc, ldpt, ldq, m, n, ncc
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), c(ldc,*), &
            pt(ldpt,*), q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(max(m,n))
          Real (Kind=wp), Intent (Out) :: d(min(m,n)), e(min(m,n)-1), &
            rwork(max(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08lsf
      End Interface
      Interface
        Subroutine f08mdf(uplo,compq,n,d,e,u,ldu,vt,ldvt,q,iq,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldu, ldvt, n
          Character (1), Intent (In) :: compq, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), q(*), u(ldu,*), &
            vt(ldvt,*), work(*)
          Integer, Intent (Inout) :: iq(*)
          Integer, Intent (Out) :: iwork(8*n)
        End Subroutine f08mdf
      End Interface
      Interface
        Subroutine f08mef(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, ldu, ldvt, n, ncc, ncvt, nru
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,*), d(*), e(*), u(ldu,*), &
            vt(ldvt,*), work(*)
        End Subroutine f08mef
      End Interface
      Interface
        Subroutine f08msf(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, ldu, ldvt, n, ncc, ncvt, nru
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*), u(ldu,*), vt(ldvt,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*)
        End Subroutine f08msf
      End Interface
      Interface
        Subroutine f08naf(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,work, &
            lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), vr(ldvr,*), &
            wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08naf
      End Interface
      Interface
        Subroutine f08nbf(balanc,jobvl,jobvr,sense,n,a,lda,wr,wi,vl,ldvl,vr, &
            ldvr,ilo,ihi,scale,abnrm,rconde,rcondv,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), rconde(*), rcondv(*), &
            scale(*), vl(ldvl,*), vr(ldvr,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nbf
      End Interface
      Interface
        Subroutine f08nef(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nef
      End Interface
      Interface
        Subroutine f08nff(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nff
      End Interface
      Interface
        Subroutine f08ngf(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldc, lwork, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ngf
      End Interface
      Interface
        Subroutine f08nhf(job,n,a,lda,ilo,ihi,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: scale(n)
        End Subroutine f08nhf
      End Interface
      Interface
        Subroutine f08njf(job,side,n,ilo,ihi,scale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: scale(*)
          Real (Kind=wp), Intent (Inout) :: v(ldv,*)
        End Subroutine f08njf
      End Interface
      Interface
        Subroutine f08nnf(jobvl,jobvr,n,a,lda,w,vl,ldvl,vr,ldvr,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), &
            vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nnf
      End Interface
      Interface
        Subroutine f08npf(balanc,jobvl,jobvr,sense,n,a,lda,w,vl,ldvl,vr,ldvr, &
            ilo,ihi,scale,abnrm,rconde,rcondv,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), &
            vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rconde(*), rcondv(*), rwork(*), &
            scale(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08npf
      End Interface
      Interface
        Subroutine f08nsf(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nsf
      End Interface
      Interface
        Subroutine f08ntf(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ntf
      End Interface
      Interface
        Subroutine f08nuf(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldc, lwork, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08nuf
      End Interface
      Interface
        Subroutine f08nvf(job,n,a,lda,ilo,ihi,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: scale(n)
        End Subroutine f08nvf
      End Interface
      Interface
        Subroutine f08nwf(job,side,n,ilo,ihi,scale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: v(ldv,*)
          Real (Kind=wp), Intent (In) :: scale(*)
        End Subroutine f08nwf
      End Interface
      Interface
        Subroutine f08paf(jobvs,sort,select,n,a,lda,sdim,wr,wi,vs,ldvs,work, &
            lwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(wr,wi)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: wi, wr
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08paf
      End Interface
      Interface
        Function f08paz(wr,wi)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: f08paz
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: wi, wr
        End Function f08paz
      End Interface
      Interface
        Subroutine f08pbf(jobvs,sort,select,sense,n,a,lda,sdim,wr,wi,vs,ldvs, &
            rconde,rcondv,work,lwork,iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rconde, rcondv
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, liwork, lwork, n
          Character (1), Intent (In) :: jobvs, sense, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(wr,wi)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: wi, wr
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08pbf
      End Interface
      Interface
        Subroutine f08pef(job,compz,n,ilo,ihi,h,ldh,wr,wi,z,ldz,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldh, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compz, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: h(ldh,*), wi(*), wr(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08pef
      End Interface
      Interface
        Subroutine f08pkf(job,eigsrc,initv,select,n,h,ldh,wr,wi,vl,ldvl,vr, &
            ldvr,mm,m,work,ifaill,ifailr,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldh, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: eigsrc, initv, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: h(ldh,*), wi(*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*), wr(*)
          Real (Kind=wp), Intent (Out) :: work((n+2)*n)
          Integer, Intent (Inout) :: ifaill(*), ifailr(*)
          Logical, Intent (Inout) :: select(*)
        End Subroutine f08pkf
      End Interface
      Interface
        Subroutine f08pnf(jobvs,sort,select,n,a,lda,sdim,w,vs,ldvs,work,lwork, &
            rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(w)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: w
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08pnf
      End Interface
      Interface
        Function f08pnz(w)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: f08pnz
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: w
        End Function f08pnz
      End Interface
      Interface
        Subroutine f08ppf(jobvs,sort,select,sense,n,a,lda,sdim,w,vs,ldvs, &
            rconde,rcondv,work,lwork,rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rconde, rcondv
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sense, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(w)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: w
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ppf
      End Interface
      Interface
        Subroutine f08psf(job,compz,n,ilo,ihi,h,ldh,w,z,ldz,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldh, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compz, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: h(ldh,*), w(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08psf
      End Interface
      Interface
        Subroutine f08pxf(job,eigsrc,initv,select,n,h,ldh,w,vl,ldvl,vr,ldvr, &
            mm,m,work,rwork,ifaill,ifailr,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldh, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: eigsrc, initv, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: h(ldh,*)
          Complex (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(n*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (Inout) :: ifaill(*), ifailr(*)
          Logical, Intent (In) :: select(*)
        End Subroutine f08pxf
      End Interface
      Interface
        Subroutine f08qff(compq,n,t,ldt,q,ldq,ifst,ilst,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifst, ilst
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, ldt, n
          Character (1), Intent (In) :: compq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*)
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine f08qff
      End Interface
      Interface
        Subroutine f08qgf(job,compq,select,n,t,ldt,q,ldq,wr,wi,m,s,sep,work, &
            lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s, sep
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldq, ldt, liwork, lwork, n
          Character (1), Intent (In) :: compq, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08qgf
      End Interface
      Interface
        Subroutine f08qhf(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: scale
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: isgn, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: trana, tranb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f08qhf
      End Interface
      Interface
        Subroutine f08qkf(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: t(ldt,*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Logical, Intent (Inout) :: select(*)
        End Subroutine f08qkf
      End Interface
      Interface
        Subroutine f08qlf(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,s,sep,mm, &
            m,work,ldwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, ldwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: s(*), sep(*), work(ldwork,*)
          Real (Kind=wp), Intent (In) :: t(ldt,*), vl(ldvl,*), vr(ldvr,*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
        End Subroutine f08qlf
      End Interface
      Interface
        Subroutine f08qtf(compq,n,t,ldt,q,ldq,ifst,ilst,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ifst, ilst, ldq, ldt, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*)
        End Subroutine f08qtf
      End Interface
      Interface
        Subroutine f08quf(job,compq,select,n,t,ldt,q,ldq,w,m,s,sep,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s, sep
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldq, ldt, lwork, n
          Character (1), Intent (In) :: compq, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08quf
      End Interface
      Interface
        Subroutine f08qvf(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scal,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: scal
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: isgn, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: trana, tranb
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine f08qvf
      End Interface
      Interface
        Subroutine f08qxf(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: t(ldt,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Logical, Intent (In) :: select(*)
        End Subroutine f08qxf
      End Interface
      Interface
        Subroutine f08qyf(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,s,sep,mm, &
            m,work,ldwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, ldwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: t(ldt,*), vl(ldvl,*), vr(ldvr,*)
          Complex (Kind=wp), Intent (Inout) :: work(ldwork,*)
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*), sep(*)
          Logical, Intent (In) :: select(*)
        End Subroutine f08qyf
      End Interface
      Interface
        Subroutine f08saf(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08saf
      End Interface
      Interface
        Subroutine f08sbf(itype,jobz,range,uplo,n,a,lda,b,ldb,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,lwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, lda, ldb, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08sbf
      End Interface
      Interface
        Subroutine f08scf(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08scf
      End Interface
      Interface
        Subroutine f08sef(itype,uplo,n,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
        End Subroutine f08sef
      End Interface
      Interface
        Subroutine f08snf(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08snf
      End Interface
      Interface
        Subroutine f08spf(itype,jobz,range,uplo,n,a,lda,b,ldb,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,lwork,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, lda, ldb, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08spf
      End Interface
      Interface
        Subroutine f08sqf(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08sqf
      End Interface
      Interface
        Subroutine f08ssf(itype,uplo,n,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine f08ssf
      End Interface
      Interface
        Subroutine f08taf(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine f08taf
      End Interface
      Interface
        Subroutine f08tbf(itype,jobz,range,uplo,n,ap,bp,vl,vu,il,iu,abstol,m, &
            w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(8*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08tbf
      End Interface
      Interface
        Subroutine f08tcf(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08tcf
      End Interface
      Interface
        Subroutine f08tef(itype,uplo,n,ap,bp,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: bp(*)
        End Subroutine f08tef
      End Interface
      Interface
        Subroutine f08tnf(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n-1)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine f08tnf
      End Interface
      Interface
        Subroutine f08tpf(itype,jobz,range,uplo,n,ap,bp,vl,vu,il,iu,abstol,m, &
            w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08tpf
      End Interface
      Interface
        Subroutine f08tqf(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08tqf
      End Interface
      Interface
        Subroutine f08tsf(itype,uplo,n,ap,bp,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: bp(*)
        End Subroutine f08tsf
      End Interface
      Interface
        Subroutine f08uaf(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine f08uaf
      End Interface
      Interface
        Subroutine f08ubf(jobz,range,uplo,n,ka,kb,ab,ldab,bb,ldbb,q,ldq,vl,vu, &
            il,iu,abstol,m,w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ka, kb, ldab, ldbb, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(7*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08ubf
      End Interface
      Interface
        Subroutine f08ucf(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work, &
            lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ucf
      End Interface
      Interface
        Subroutine f08uef(vect,uplo,n,ka,kb,ab,ldab,bb,ldbb,x,ldx,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldx, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: bb(ldbb,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
        End Subroutine f08uef
      End Interface
      Interface
        Subroutine f08uff(uplo,n,kb,bb,ldbb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kb, ldbb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bb(ldbb,*)
        End Subroutine f08uff
      End Interface
      Interface
        Subroutine f08unf(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(3*n), w(n)
        End Subroutine f08unf
      End Interface
      Interface
        Subroutine f08upf(jobz,range,uplo,n,ka,kb,ab,ldab,bb,ldbb,q,ldq,vl,vu, &
            il,iu,abstol,m,w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ka, kb, ldab, ldbb, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            q(ldq,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine f08upf
      End Interface
      Interface
        Subroutine f08uqf(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work, &
            lwork,rwork,lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, liwork, lrwork, &
            lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08uqf
      End Interface
      Interface
        Subroutine f08usf(vect,uplo,n,ka,kb,ab,ldab,bb,ldbb,x,ldx,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldx, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: bb(ldbb,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine f08usf
      End Interface
      Interface
        Subroutine f08utf(uplo,n,kb,bb,ldbb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kb, ldbb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: bb(ldbb,*)
        End Subroutine f08utf
      End Interface
      Interface
        Subroutine f08vaf(jobu,jobv,jobq,m,n,p,k,l,a,lda,b,ldb,alpha,beta,u, &
            ldu,v,ldv,q,ldq,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(3*n,m,p)+n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08vaf
      End Interface
      Interface
        Subroutine f08vef(jobu,jobv,jobq,m,p,n,a,lda,b,ldb,tola,tolb,k,l,u, &
            ldu,v,ldv,q,ldq,iwork,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: tau(n), work(max(3*n,m,p))
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08vef
      End Interface
      Interface
        Subroutine f08vnf(jobu,jobv,jobq,m,n,p,k,l,a,lda,b,ldb,alpha,beta,u, &
            ldu,v,ldv,q,ldq,work,rwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: work(max(3*n,m,p)+n)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), rwork(2*n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08vnf
      End Interface
      Interface
        Subroutine f08vsf(jobu,jobv,jobq,m,p,n,a,lda,b,ldb,tola,tolb,k,l,u, &
            ldu,v,ldv,q,ldq,iwork,rwork,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: tau(n), work(max(3*n,m,p))
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08vsf
      End Interface
      Interface
        Subroutine f08waf(jobvl,jobvr,n,a,lda,b,ldb,alphar,alphai,beta,vl, &
            ldvl,vr,ldvr,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08waf
      End Interface
      Interface
        Subroutine f08wbf(balanc,jobvl,jobvr,sense,n,a,lda,b,ldb,alphar, &
            alphai,beta,vl,ldvl,vr,ldvr,ilo,ihi,lscale,rscale,abnrm,bbnrm, &
            rconde,rcondv,work,lwork,iwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm, bbnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), rconde(*), &
            rcondv(*), vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            lscale(n), rscale(n), work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08wbf
      End Interface
      Interface
        Subroutine f08wef(compq,compz,n,ilo,ihi,a,lda,b,ldb,q,ldq,z,ldz,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine f08wef
      End Interface
      Interface
        Subroutine f08whf(job,n,a,lda,b,ldb,ilo,ihi,lscale,rscale,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), work(*)
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n)
        End Subroutine f08whf
      End Interface
      Interface
        Subroutine f08wjf(job,side,n,ilo,ihi,lscale,rscale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: lscale(*), rscale(*)
          Real (Kind=wp), Intent (Inout) :: v(ldv,*)
        End Subroutine f08wjf
      End Interface
      Interface
        Subroutine f08wnf(jobvl,jobvr,n,a,lda,b,ldb,alpha,beta,vl,ldvl,vr, &
            ldvr,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,8*n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08wnf
      End Interface
      Interface
        Subroutine f08wpf(balanc,jobvl,jobvr,sense,n,a,lda,b,ldb,alpha,beta, &
            vl,ldvl,vr,ldvr,ilo,ihi,lscale,rscale,abnrm,bbnrm,rconde,rcondv, &
            work,lwork,rwork,iwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm, bbnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n), rwork(6*n)
          Real (Kind=wp), Intent (Inout) :: rconde(*), rcondv(*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08wpf
      End Interface
      Interface
        Subroutine f08wsf(compq,compz,n,ilo,ihi,a,lda,b,ldb,q,ldq,z,ldz,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine f08wsf
      End Interface
      Interface
        Subroutine f08wvf(job,n,a,lda,b,ldb,ilo,ihi,lscale,rscale,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n), work(6*n)
        End Subroutine f08wvf
      End Interface
      Interface
        Subroutine f08wwf(job,side,n,ilo,ihi,lscale,rscale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: v(ldv,*)
          Real (Kind=wp), Intent (In) :: lscale(*), rscale(*)
        End Subroutine f08wwf
      End Interface
      Interface
        Subroutine f08xaf(jobvsl,jobvsr,sort,selctg,n,a,lda,b,ldb,sdim,alphar, &
            alphai,beta,vsl,ldvsl,vsr,ldvsr,work,lwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vsl(ldvsl,*), &
            vsr(ldvsr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(ar,ai,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: ai, ar, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xaf
      End Interface
      Interface
        Function f08xaz(ar,ai,b)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: f08xaz
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: ai, ar, b
        End Function f08xaz
      End Interface
      Interface
        Subroutine f08xbf(jobvsl,jobvsr,sort,selctg,sense,n,a,lda,b,ldb,sdim, &
            alphar,alphai,beta,vsl,ldvsl,vsr,ldvsr,rconde,rcondv,work,lwork, &
            iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, liwork, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sense, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vsl(ldvsl,*), &
            vsr(ldvsr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            rconde(2), rcondv(2), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(ar,ai,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: ai, ar, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xbf
      End Interface
      Interface
        Subroutine f08xef(job,compq,compz,n,ilo,ihi,a,lda,b,ldb,alphar,alphai, &
            beta,q,ldq,z,ldz,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xef
      End Interface
      Interface
        Subroutine f08xnf(jobvsl,jobvsr,sort,selctg,n,a,lda,b,ldb,sdim,alpha, &
            beta,vsl,ldvsl,vsr,ldvsr,work,lwork,rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), &
            vsl(ldvsl,*), vsr(ldvsr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,8*n))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(a,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: a, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xnf
      End Interface
      Interface
        Function f08xnz(a,b)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: f08xnz
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: a, b
        End Function f08xnz
      End Interface
      Interface
        Subroutine f08xpf(jobvsl,jobvsr,sort,selctg,sense,n,a,lda,b,ldb,sdim, &
            alpha,beta,vsl,ldvsl,vsr,ldvsr,rconde,rcondv,work,lwork,rwork, &
            iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, liwork, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sense, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), &
            vsl(ldvsl,*), vsr(ldvsr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rconde(2), rcondv(2), &
            rwork(max(1,8*n))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(a,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: a, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xpf
      End Interface
      Interface
        Subroutine f08xsf(job,compq,compz,n,ilo,ihi,a,lda,b,ldb,alpha,beta,q, &
            ldq,z,ldz,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08xsf
      End Interface
      Interface
        Subroutine f08yef(jobu,jobv,jobq,m,p,n,k,l,a,lda,b,ldb,tola,tolb, &
            alpha,beta,u,ldu,v,ldv,q,ldq,work,ncycle,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, ncycle
          Integer, Intent (In) :: k, l, lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), work(2*n)
        End Subroutine f08yef
      End Interface
      Interface
        Subroutine f08yff(wantq,wantz,n,a,lda,b,ldb,q,ldq,z,ldz,ifst,ilst, &
            work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifst, ilst
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldq, ldz, lwork, n
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08yff
      End Interface
      Interface
        Subroutine f08ygf(ijob,wantq,wantz,select,n,a,lda,b,ldb,alphar,alphai, &
            beta,q,ldq,z,ldz,m,pl,pr,dif,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pl, pr
          Integer, Intent (In) :: ijob, lda, ldb, ldq, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), dif(*), &
            q(ldq,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ygf
      End Interface
      Interface
        Subroutine f08yhf(trans,ijob,m,n,a,lda,b,ldb,c,ldc,d,ldd,e,lde,f,ldf, &
            scale,dif,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dif, scale
          Integer, Intent (In) :: ijob, lda, ldb, ldc, ldd, lde, ldf, lwork, &
            m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), d(ldd,*), &
            e(lde,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*), f(ldf,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,m+n+6))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08yhf
      End Interface
      Interface
        Subroutine f08ykf(side,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,mm, &
            m,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: work(6*n)
          Logical, Intent (In) :: select(*)
        End Subroutine f08ykf
      End Interface
      Interface
        Subroutine f08ylf(job,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,s, &
            dif,mm,m,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Real (Kind=wp), Intent (Inout) :: dif(*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08ylf
      End Interface
      Interface
        Subroutine f08ysf(jobu,jobv,jobq,m,p,n,k,l,a,lda,b,ldb,tola,tolb, &
            alpha,beta,u,ldu,v,ldv,q,ldq,work,ncycle,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, ncycle
          Integer, Intent (In) :: k, l, lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n)
        End Subroutine f08ysf
      End Interface
      Interface
        Subroutine f08ytf(wantq,wantz,n,a,lda,b,ldb,q,ldq,z,ldz,ifst,ilst, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ifst, lda, ldb, ldq, ldz, n
          Integer, Intent (Inout) :: ilst
          Integer, Intent (Out) :: info
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine f08ytf
      End Interface
      Interface
        Subroutine f08yuf(ijob,wantq,wantz,select,n,a,lda,b,ldb,alpha,beta,q, &
            ldq,z,ldz,m,pl,pr,dif,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pl, pr
          Integer, Intent (In) :: ijob, lda, ldb, ldq, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: dif(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (In) :: select(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08yuf
      End Interface
      Interface
        Subroutine f08yvf(trans,ijob,m,n,a,lda,b,ldb,c,ldc,d,ldd,e,lde,f,ldf, &
            scale,dif,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dif, scale
          Integer, Intent (In) :: ijob, lda, ldb, ldc, ldd, lde, ldf, lwork, &
            m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), d(ldd,*), &
            e(lde,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*), f(ldf,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(m+n+2)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08yvf
      End Interface
      Interface
        Subroutine f08yxf(side,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,mm, &
            m,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Logical, Intent (In) :: select(*)
        End Subroutine f08yxf
      End Interface
      Interface
        Subroutine f08yyf(job,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,s, &
            dif,mm,m,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: dif(*), s(*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08yyf
      End Interface
      Interface
        Subroutine f08zaf(m,n,p,a,lda,b,ldb,c,d,x,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), c(m), d(p)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08zaf
      End Interface
      Interface
        Subroutine f08zbf(m,n,p,a,lda,b,ldb,d,x,y,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), d(m)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n), y(p)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08zbf
      End Interface
      Interface
        Subroutine f08zef(n,m,p,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: taua(min(n,m)), taub(min(n,p)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08zef
      End Interface
      Interface
        Subroutine f08zff(m,p,n,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: taua(min(m,n)), taub(min(p,n)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08zff
      End Interface
      Interface
        Subroutine f08znf(m,n,p,a,lda,b,ldb,c,d,x,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), c(m), d(p)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08znf
      End Interface
      Interface
        Subroutine f08zpf(m,n,p,a,lda,b,ldb,d,x,y,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), d(m)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n), y(p)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f08zpf
      End Interface
      Interface
        Subroutine f08zsf(n,m,p,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: taua(min(n,m)), taub(min(n,p)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08zsf
      End Interface
      Interface
        Subroutine f08ztf(m,p,n,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: taua(min(m,n)), taub(min(p,n)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine f08ztf
      End Interface
      Interface
        Subroutine f11bdf(method,precon,norm,weight,iterm,n,m,tol,maxitn, &
            anorm,sigmax,monit,lwreq,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm, sigmax, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iterm, lwork, m, maxitn, monit, n
          Integer, Intent (Out) :: lwreq
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: norm, precon, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(lwork)
        End Subroutine f11bdf
      End Interface
      Interface
        Subroutine f11bef(irevcm,u,v,wgt,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: u(*), v(*), work(lwork)
          Real (Kind=wp), Intent (In) :: wgt(*)
        End Subroutine f11bef
      End Interface
      Interface
        Subroutine f11bff(itn,stplhs,stprhs,anorm,sigmax,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: anorm, sigmax, stplhs, stprhs
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: work(lwork)
        End Subroutine f11bff
      End Interface
      Interface
        Subroutine f11brf(method,precon,norm,weight,iterm,n,m,tol,maxitn, &
            anorm,sigmax,monit,lwreq,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm, sigmax, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iterm, lwork, m, maxitn, monit, n
          Integer, Intent (Out) :: lwreq
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: norm, precon, weight
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(lwork)
        End Subroutine f11brf
      End Interface
      Interface
        Subroutine f11bsf(irevcm,u,v,wgt,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: u(*), v(*), work(lwork)
          Real (Kind=wp), Intent (In) :: wgt(*)
        End Subroutine f11bsf
      End Interface
      Interface
        Subroutine f11btf(itn,stplhs,stprhs,anorm,sigmax,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: anorm, sigmax, stplhs, stprhs
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: work(lwork)
        End Subroutine f11btf
      End Interface
      Interface
        Subroutine f11daf(n,nnz,a,la,irow,icol,lfill,dtol,pstrat,milu,ipivp, &
            ipivq,istr,idiag,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: dtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lfill, liwork, n, nnz
          Integer, Intent (Out) :: nnzc, npivm
          Character (1), Intent (In) :: milu, pstrat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(la)
          Integer, Intent (Inout) :: icol(la), ipivp(n), ipivq(n), irow(la)
          Integer, Intent (Out) :: idiag(n), istr(n+1), iwork(liwork)
        End Subroutine f11daf
      End Interface
      Interface
        Subroutine f11dbf(trans,n,a,la,irow,icol,ipivp,ipivq,istr,idiag,check, &
            y,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, n
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), y(n)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(n), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipivp(n), ipivq(n)
        End Subroutine f11dbf
      End Interface
      Interface
        Subroutine f11dcf(method,n,nnz,a,la,irow,icol,ipivp,ipivq,istr,idiag, &
            b,m,tol,maxitn,x,rnorm,itn,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lwork, m, maxitn, n, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(n)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(n), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipivp(n), ipivq(n)
        End Subroutine f11dcf
      End Interface
      Interface
        Subroutine f11ddf(trans,n,nnz,a,irow,icol,rdiag,omega,check,y,x,iwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), rdiag(n), y(n)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(2*n+1)
        End Subroutine f11ddf
      End Interface
      Interface
        Subroutine f11def(method,precon,n,nnz,a,irow,icol,omega,b,m,tol, &
            maxitn,x,rnorm,itn,work,lwork,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega, tol
          Real (Kind=wp), Intent (Out) :: rnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork, m, maxitn, n, nnz
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: precon
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), b(n)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(2*n+1)
        End Subroutine f11def
      End Interface
      Interface
        Subroutine f11dff(n,nnz,a,la,irow,icol,nb,istb,indb,lindb,lfill,dtol, &
            pstrat,milu,ipivp,ipivq,istr,idiag,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lindb, liwork, n, nb, nnz
          Integer, Intent (Out) :: nnzc
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(la)
          Real (Kind=wp), Intent (In) :: dtol(nb)
          Integer, Intent (Inout) :: icol(la), ipivp(lindb), ipivq(lindb), &
            irow(la)
          Integer, Intent (Out) :: idiag(lindb), istr(lindb+1), iwork(liwork), &
            npivm(nb)
          Integer, Intent (In) :: indb(lindb), istb(nb+1), lfill(nb)
          Character (1), Intent (In) :: milu(nb), pstrat(nb)
        End Subroutine f11dff
      End Interface
      Interface
        Subroutine f11dgf(method,n,nnz,a,la,irow,icol,nb,istb,indb,lindb, &
            ipivp,ipivq,istr,idiag,b,m,tol,maxitn,x,rnorm,itn,work,lwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lindb, lwork, m, maxitn, n, nb, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(n)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(lindb), indb(lindb), &
            irow(la), istb(nb+1), istr(lindb+1)
          Integer, Intent (Inout) :: ipivp(lindb), ipivq(lindb)
        End Subroutine f11dgf
      End Interface
      Interface
        Subroutine f11dkf(store,trans,init,niter,n,nnz,a,irow,icol,check,b,x, &
            diag,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, niter, nnz
          Character (1), Intent (In) :: check, init, store, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), b(n)
          Real (Kind=wp), Intent (Inout) :: diag(n)
          Real (Kind=wp), Intent (Out) :: work(n), x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11dkf
      End Interface
      Interface
        Subroutine f11dnf(n,nnz,a,la,irow,icol,lfill,dtol,pstrat,milu,ipivp, &
            ipivq,istr,idiag,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: dtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lfill, liwork, n, nnz
          Integer, Intent (Out) :: nnzc, npivm
          Character (1), Intent (In) :: milu, pstrat
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(la)
          Integer, Intent (Inout) :: icol(la), ipivp(n), ipivq(n), irow(la)
          Integer, Intent (Out) :: idiag(n), istr(n+1), iwork(liwork)
        End Subroutine f11dnf
      End Interface
      Interface
        Subroutine f11dpf(trans,n,a,la,irow,icol,ipivp,ipivq,istr,idiag,check, &
            y,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, n
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(la), y(n)
          Complex (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(n), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipivp(n), ipivq(n)
        End Subroutine f11dpf
      End Interface
      Interface
        Subroutine f11dqf(method,n,nnz,a,la,irow,icol,ipivp,ipivq,istr,idiag, &
            b,m,tol,maxitn,x,rnorm,itn,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lwork, m, maxitn, n, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(la), b(n)
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(n), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipivp(n), ipivq(n)
        End Subroutine f11dqf
      End Interface
      Interface
        Subroutine f11drf(trans,n,nnz,a,irow,icol,rdiag,omega,check,y,x,iwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), rdiag(n), y(n)
          Complex (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(2*n+1)
        End Subroutine f11drf
      End Interface
      Interface
        Subroutine f11dsf(method,precon,n,nnz,a,irow,icol,omega,b,m,tol, &
            maxitn,x,rnorm,itn,work,lwork,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega, tol
          Real (Kind=wp), Intent (Out) :: rnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork, m, maxitn, n, nnz
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: precon
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), b(n)
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(2*n+1)
        End Subroutine f11dsf
      End Interface
      Interface
        Subroutine f11dtf(n,nnz,a,la,irow,icol,nb,istb,indb,lindb,lfill,dtol, &
            pstrat,milu,ipivp,ipivq,istr,idiag,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lindb, liwork, n, nb, nnz
          Integer, Intent (Out) :: nnzc
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(la)
          Real (Kind=wp), Intent (In) :: dtol(nb)
          Integer, Intent (Inout) :: icol(la), ipivp(lindb), ipivq(lindb), &
            irow(la)
          Integer, Intent (Out) :: idiag(lindb), istr(lindb+1), iwork(liwork), &
            npivm(nb)
          Integer, Intent (In) :: indb(lindb), istb(nb+1), lfill(nb)
          Character (1), Intent (In) :: milu(nb), pstrat(nb)
        End Subroutine f11dtf
      End Interface
      Interface
        Subroutine f11duf(method,n,nnz,a,la,irow,icol,nb,istb,indb,lindb, &
            ipivp,ipivq,istr,idiag,b,m,tol,maxitn,x,rnorm,itn,work,lwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lindb, lwork, m, maxitn, n, nb, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(la), b(n)
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), idiag(lindb), indb(lindb), &
            irow(la), istb(nb+1), istr(lindb+1)
          Integer, Intent (Inout) :: ipivp(lindb), ipivq(lindb)
        End Subroutine f11duf
      End Interface
      Interface
        Subroutine f11dxf(store,trans,init,niter,n,nnz,a,irow,icol,check,b,x, &
            diag,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, niter, nnz
          Character (1), Intent (In) :: check, init, store, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), b(n)
          Complex (Kind=wp), Intent (Inout) :: diag(n)
          Complex (Kind=wp), Intent (Out) :: work(n), x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11dxf
      End Interface
      Interface
        Subroutine f11gdf(method,precon,sigcmp,norm,weight,iterm,n,tol,maxitn, &
            anorm,sigmax,sigtol,maxits,monit,lwreq,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm, sigmax, sigtol, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iterm, lwork, maxitn, maxits, monit, n
          Integer, Intent (Out) :: lwreq
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: norm, precon, sigcmp, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(lwork)
        End Subroutine f11gdf
      End Interface
      Interface
        Subroutine f11gef(irevcm,u,v,wgt,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: u(*), v(*), work(lwork)
          Real (Kind=wp), Intent (In) :: wgt(*)
        End Subroutine f11gef
      End Interface
      Interface
        Subroutine f11gff(itn,stplhs,stprhs,anorm,sigmax,its,sigerr,work, &
            lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: anorm, sigerr, sigmax, stplhs, &
            stprhs
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn, its
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: work(lwork)
        End Subroutine f11gff
      End Interface
      Interface
        Subroutine f11grf(method,precon,sigcmp,norm,weight,iterm,n,tol,maxitn, &
            anorm,sigmax,sigtol,maxits,monit,lwreq,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm, sigmax, sigtol, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iterm, lwork, maxitn, maxits, monit, n
          Integer, Intent (Out) :: lwreq
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: norm, precon, sigcmp, weight
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(lwork)
        End Subroutine f11grf
      End Interface
      Interface
        Subroutine f11gsf(irevcm,u,v,wgt,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: u(*), v(*), work(lwork)
          Real (Kind=wp), Intent (In) :: wgt(*)
        End Subroutine f11gsf
      End Interface
      Interface
        Subroutine f11gtf(itn,stplhs,stprhs,anorm,sigmax,its,sigerr,work, &
            lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: anorm, sigerr, sigmax, stplhs, &
            stprhs
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn, its
          Integer, Intent (In) :: lwork
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: work(lwork)
        End Subroutine f11gtf
      End Interface
      Interface
        Subroutine f11jaf(n,nnz,a,la,irow,icol,lfill,dtol,mic,dscale,pstrat, &
            ipiv,istr,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: dscale, dtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lfill, liwork, n, nnz
          Integer, Intent (Out) :: nnzc, npivm
          Character (1), Intent (In) :: mic, pstrat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(la)
          Integer, Intent (Inout) :: icol(la), ipiv(n), irow(la)
          Integer, Intent (Out) :: istr(n+1), iwork(liwork)
        End Subroutine f11jaf
      End Interface
      Interface
        Subroutine f11jbf(n,a,la,irow,icol,ipiv,istr,check,y,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, n
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), y(n)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(la), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipiv(n)
        End Subroutine f11jbf
      End Interface
      Interface
        Subroutine f11jcf(method,n,nnz,a,la,irow,icol,ipiv,istr,b,tol,maxitn, &
            x,rnorm,itn,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lwork, maxitn, n, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(n)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipiv(n)
        End Subroutine f11jcf
      End Interface
      Interface
        Subroutine f11jdf(n,nnz,a,irow,icol,rdiag,omega,check,y,x,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), rdiag(n), y(n)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(n+1)
        End Subroutine f11jdf
      End Interface
      Interface
        Subroutine f11jef(method,precon,n,nnz,a,irow,icol,omega,b,tol,maxitn, &
            x,rnorm,itn,work,lwork,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega, tol
          Real (Kind=wp), Intent (Out) :: rnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork, maxitn, n, nnz
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: precon
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), b(n)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(n+1)
        End Subroutine f11jef
      End Interface
      Interface
        Subroutine f11jnf(n,nnz,a,la,irow,icol,lfill,dtol,mic,dscale,pstrat, &
            ipiv,istr,nnzc,npivm,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: dscale, dtol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lfill, liwork, n, nnz
          Integer, Intent (Out) :: nnzc, npivm
          Character (1), Intent (In) :: mic, pstrat
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(la)
          Integer, Intent (Inout) :: icol(la), ipiv(n), irow(la)
          Integer, Intent (Out) :: istr(n+1), iwork(liwork)
        End Subroutine f11jnf
      End Interface
      Interface
        Subroutine f11jpf(n,a,la,irow,icol,ipiv,istr,check,y,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, n
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(la), y(n)
          Complex (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (In) :: icol(la), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipiv(n)
        End Subroutine f11jpf
      End Interface
      Interface
        Subroutine f11jqf(method,n,nnz,a,la,irow,icol,ipiv,istr,b,tol,maxitn, &
            x,rnorm,itn,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rnorm
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: la, lwork, maxitn, n, nnz
          Character (*), Intent (In) :: method
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(la), b(n)
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: icol(la), irow(la), istr(n+1)
          Integer, Intent (Inout) :: ipiv(n)
        End Subroutine f11jqf
      End Interface
      Interface
        Subroutine f11jrf(n,nnz,a,irow,icol,rdiag,omega,check,y,x,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), y(n)
          Complex (Kind=wp), Intent (Out) :: x(n)
          Real (Kind=wp), Intent (In) :: rdiag(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(n+1)
        End Subroutine f11jrf
      End Interface
      Interface
        Subroutine f11jsf(method,precon,n,nnz,a,irow,icol,omega,b,tol,maxitn, &
            x,rnorm,itn,rdiag,work,lwork,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: omega, tol
          Real (Kind=wp), Intent (Out) :: rnorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itn
          Integer, Intent (In) :: lwork, maxitn, n, nnz
          Character (*), Intent (In) :: method
          Character (1), Intent (In) :: precon
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), b(n)
          Complex (Kind=wp), Intent (Out) :: work(lwork)
          Complex (Kind=wp), Intent (Inout) :: x(n)
          Real (Kind=wp), Intent (Out) :: rdiag(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
          Integer, Intent (Out) :: iwork(n+1)
        End Subroutine f11jsf
      End Interface
      Interface
        Subroutine f11mdf(spec,n,icolzp,irowix,iprm,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: spec
!         .. Array Arguments ..
          Integer, Intent (In) :: icolzp(*), irowix(*)
          Integer, Intent (Inout) :: iprm(7*n)
        End Subroutine f11mdf
      End Interface
      Interface
        Subroutine f11mef(n,irowix,a,iprm,thresh,nzlmx,nzlumx,nzumx,il,lval, &
            iu,uval,nnzl,nnzu,flop,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: flop
          Real (Kind=wp), Intent (In) :: thresh
          Integer, Intent (Inout) :: ifail, nzlumx
          Integer, Intent (In) :: n, nzlmx, nzumx
          Integer, Intent (Out) :: nnzl, nnzu
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
          Real (Kind=wp), Intent (Out) :: lval(nzlumx), uval(nzumx)
          Integer, Intent (Out) :: il(7*n+nzlmx+4), iu(2*n+nzumx+1)
          Integer, Intent (Inout) :: iprm(7*n)
          Integer, Intent (In) :: irowix(*)
        End Subroutine f11mef
      End Interface
      Interface
        Subroutine f11mff(trans,n,iprm,il,lval,iu,uval,nrhs,b,ldb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: lval(*), uval(*)
          Integer, Intent (In) :: il(*), iprm(7*n), iu(*)
        End Subroutine f11mff
      End Interface
      Interface
        Subroutine f11mgf(norm,n,il,lval,iu,uval,anorm,rcond,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: lval(*), uval(*)
          Integer, Intent (In) :: il(*), iu(*)
        End Subroutine f11mgf
      End Interface
      Interface
        Subroutine f11mhf(trans,n,icolzp,irowix,a,iprm,il,lval,iu,uval,nrhs,b, &
            ldb,x,ldx,ferr,berr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*), b(ldb,*), lval(*), uval(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: icolzp(*), il(*), iprm(7*n), irowix(*), &
            iu(*)
        End Subroutine f11mhf
      End Interface
      Interface
        Subroutine f11mkf(trans,n,m,alpha,icolzp,irowix,a,b,ldb,beta,c,ldc, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldb, ldc, m, n
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
          Integer, Intent (In) :: icolzp(*), irowix(*)
        End Subroutine f11mkf
      End Interface
      Interface
        Subroutine f11mlf(norm,anorm,n,icolzp,irowix,a,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: anorm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
          Integer, Intent (In) :: icolzp(*), irowix(*)
        End Subroutine f11mlf
      End Interface
      Interface
        Subroutine f11mmf(n,icolzp,a,iprm,il,lval,iu,uval,rpg,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rpg
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*), lval(*), uval(*)
          Integer, Intent (In) :: icolzp(*), il(*), iprm(7*n), iu(*)
        End Subroutine f11mmf
      End Interface
      Interface
        Subroutine f11xaf(trans,n,nnz,a,irow,icol,check,x,y,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), x(n)
          Real (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11xaf
      End Interface
      Interface
        Subroutine f11xef(n,nnz,a,irow,icol,check,x,y,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nnz), x(n)
          Real (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11xef
      End Interface
      Interface
        Subroutine f11xnf(trans,n,nnz,a,irow,icol,check,x,y,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), x(n)
          Complex (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11xnf
      End Interface
      Interface
        Subroutine f11xsf(n,nnz,a,irow,icol,check,x,y,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Character (1), Intent (In) :: check
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(nnz), x(n)
          Complex (Kind=wp), Intent (Out) :: y(n)
          Integer, Intent (In) :: icol(nnz), irow(nnz)
        End Subroutine f11xsf
      End Interface
      Interface
        Subroutine f11ydf(job,n,nnz,a,irow,icolc,icolu,dup,zer,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, nnz
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: dup, job, zer
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(*)
          Integer, Intent (Inout) :: icolc(n+1), icolu(*), irow(*)
        End Subroutine f11ydf
      End Interface
      Interface
        Subroutine f11yef(n,nnz,use_mask,no_rev,irow,icol,mask,perm,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Logical, Intent (In) :: no_rev, use_mask
!         .. Array Arguments ..
          Integer, Intent (In) :: icol(n+1), irow(nnz), mask(n)
          Integer, Intent (Out) :: perm(n)
        End Subroutine f11yef
      End Interface
      Interface
        Subroutine f11yff(n,nnz,use_mask,irow,icol,mask,perm,bandw,profile, &
            ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: bandw, profile
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nnz
          Logical, Intent (In) :: use_mask
!         .. Array Arguments ..
          Integer, Intent (In) :: icol(n+1), irow(nnz), mask(*), perm(n)
        End Subroutine f11yff
      End Interface
      Interface
        Subroutine f11zaf(n,nnz,a,irow,icol,dup,zer,istr,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, nnz
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: dup, zer
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(*)
          Integer, Intent (Inout) :: icol(*), irow(*)
          Integer, Intent (Out) :: istr(n+1), iwork(n)
        End Subroutine f11zaf
      End Interface
      Interface
        Subroutine f11zbf(n,nnz,a,irow,icol,dup,zer,istr,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, nnz
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: dup, zer
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(*)
          Integer, Intent (Inout) :: icol(*), irow(*)
          Integer, Intent (Out) :: istr(n+1), iwork(n)
        End Subroutine f11zbf
      End Interface
      Interface
        Subroutine f11znf(n,nnz,a,irow,icol,dup,zer,istr,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, nnz
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: dup, zer
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(*)
          Integer, Intent (Inout) :: icol(*), irow(*)
          Integer, Intent (Out) :: istr(n+1), iwork(n)
        End Subroutine f11znf
      End Interface
      Interface
        Subroutine f11zpf(n,nnz,a,irow,icol,dup,zer,istr,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, nnz
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: dup, zer
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(*)
          Integer, Intent (Inout) :: icol(*), irow(*)
          Integer, Intent (Out) :: istr(n+1), iwork(n)
        End Subroutine f11zpf
      End Interface
      Interface
        Subroutine f12aaf(n,nev,ncv,icomm,licomm,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, licomm, n, ncv, nev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: comm(max(1,lcomm))
          Integer, Intent (Out) :: icomm(max(1,licomm))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f12aaf
      End Interface
      Interface
        Subroutine f12abf(irevcm,resid,v,ldv,x,mx,nshift,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldv
          Integer, Intent (Out) :: nshift
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*), mx(*), resid(*), &
            v(ldv,*), x(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12abf
      End Interface
      Interface
        Subroutine f12acf(nconv,dr,di,z,ldz,sigmar,sigmai,resid,v,ldv,comm, &
            icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigmai, sigmar
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldv, ldz
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*), di(*), dr(*), v(ldv,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (In) :: resid(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12acf
      End Interface
      Interface
        Subroutine f12adf(str,icomm,comm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12adf
      End Interface
      Interface
        Subroutine f12aef(niter,nconv,ritzr,ritzi,rzest,icomm,comm)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: nconv, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(*)
          Real (Kind=wp), Intent (Inout) :: ritzi(*), ritzr(*), rzest(*)
          Integer, Intent (In) :: icomm(*)
        End Subroutine f12aef
      End Interface
      Interface
        Subroutine f12aff(n,nev,ncv,icomm,licomm,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, licomm, n, ncv, nev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: comm(max(1,lcomm))
          Integer, Intent (Out) :: icomm(max(1,licomm))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f12aff
      End Interface
      Interface
        Subroutine f12agf(kl,ku,ab,ldab,mb,ldmb,sigmar,sigmai,nconv,dr,di,z, &
            ldz,resid,v,ldv,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigmai, sigmar
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, ldab, ldmb, ldv, ldz
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), mb(ldmb,*)
          Real (Kind=wp), Intent (Inout) :: comm(*), di(*), dr(*), resid(*), &
            v(ldv,*), z(ldz,*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12agf
      End Interface
      Interface
        Subroutine f12anf(n,nev,ncv,icomm,licomm,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, licomm, n, ncv, nev
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: comm(max(1,lcomm))
          Integer, Intent (Out) :: icomm(max(1,licomm))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f12anf
      End Interface
      Interface
        Subroutine f12apf(irevcm,resid,v,ldv,x,mx,nshift,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldv
          Integer, Intent (Out) :: nshift
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: comm(*), mx(*), resid(*), &
            v(ldv,*), x(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12apf
      End Interface
      Interface
        Subroutine f12aqf(nconv,d,z,ldz,sigma,resid,v,ldv,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldv, ldz
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: comm(*), d(*), v(ldv,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (In) :: resid(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12aqf
      End Interface
      Interface
        Subroutine f12arf(str,icomm,comm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: comm(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12arf
      End Interface
      Interface
        Subroutine f12asf(niter,nconv,ritz,rzest,icomm,comm)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: nconv, niter
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: comm(*)
          Complex (Kind=wp), Intent (Inout) :: ritz(*), rzest(*)
          Integer, Intent (In) :: icomm(*)
        End Subroutine f12asf
      End Interface
      Interface
        Subroutine f12faf(n,nev,ncv,icomm,licomm,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, licomm, n, ncv, nev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: comm(max(1,lcomm))
          Integer, Intent (Out) :: icomm(max(1,licomm))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f12faf
      End Interface
      Interface
        Subroutine f12fbf(irevcm,resid,v,ldv,x,mx,nshift,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, irevcm
          Integer, Intent (In) :: ldv
          Integer, Intent (Out) :: nshift
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*), mx(*), resid(*), &
            v(ldv,*), x(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12fbf
      End Interface
      Interface
        Subroutine f12fcf(nconv,d,z,ldz,sigma,resid,v,ldv,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldv, ldz
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*), d(*), v(ldv,*), z(ldz,*)
          Real (Kind=wp), Intent (In) :: resid(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12fcf
      End Interface
      Interface
        Subroutine f12fdf(str,icomm,comm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Character (*), Intent (In) :: str
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: comm(*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12fdf
      End Interface
      Interface
        Subroutine f12fef(niter,nconv,ritz,rzest,icomm,comm)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: nconv, niter
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: comm(*)
          Real (Kind=wp), Intent (Inout) :: ritz(*), rzest(*)
          Integer, Intent (In) :: icomm(*)
        End Subroutine f12fef
      End Interface
      Interface
        Subroutine f12fff(n,nev,ncv,icomm,licomm,comm,lcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lcomm, licomm, n, ncv, nev
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: comm(max(1,lcomm))
          Integer, Intent (Out) :: icomm(max(1,licomm))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine f12fff
      End Interface
      Interface
        Subroutine f12fgf(kl,ku,ab,ldab,mb,ldmb,sigma,nconv,d,z,ldz,resid,v, &
            ldv,comm,icomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, ldab, ldmb, ldv, ldz
          Integer, Intent (Out) :: nconv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), mb(ldmb,*)
          Real (Kind=wp), Intent (Inout) :: comm(*), d(*), resid(*), v(ldv,*), &
            z(ldz,*)
          Integer, Intent (Inout) :: icomm(*)
        End Subroutine f12fgf
      End Interface
      Interface
        Function f16dlf(n,x,incx)
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: f16dlf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Function f16dlf
      End Interface
      Interface
        Subroutine f16dnf(n,x,incx,k,i)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: i, k
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16dnf
      End Interface
      Interface
        Subroutine f16dpf(n,x,incx,k,i)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: i, k
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16dpf
      End Interface
      Interface
        Subroutine f16dqf(n,x,incx,k,i)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: i, k
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16dqf
      End Interface
      Interface
        Subroutine f16drf(n,x,incx,k,i)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: i, k
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Integer, Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16drf
      End Interface
      Interface
        Subroutine f16ehf(n,alpha,x,incx,beta,y,incy,w,incw)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incw, incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: w(1+(n-1)*abs(incw))
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx)), &
            y(1+(n-1)*abs(incy))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16ehf
      End Interface
      Interface
        Function f16elf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f16elf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Function f16elf
      End Interface
      Interface
        Subroutine f16ghf(n,alpha,x,incx,beta,y,incy,w,incw)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incw, incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: w(1+(n-1)*abs(incw))
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx)), &
            y(1+(n-1)*abs(incy))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16ghf
      End Interface
      Interface
        Function f16glf(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: f16glf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Function f16glf
      End Interface
      Interface
        Subroutine f16jnf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jnf
      End Interface
      Interface
        Subroutine f16jpf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jpf
      End Interface
      Interface
        Subroutine f16jqf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jqf
      End Interface
      Interface
        Subroutine f16jrf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jrf
      End Interface
      Interface
        Subroutine f16jsf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jsf
      End Interface
      Interface
        Subroutine f16jtf(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine f16jtf
      End Interface
      Interface
        Function f16rbf(inorm,m,n,kl,ku,ab,ldab)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f16rbf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: inorm, kl, ku, ldab, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
        End Function f16rbf
      End Interface
      Interface
        Function f16ubf(inorm,m,n,kl,ku,ab,ldab)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: f16ubf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: inorm, kl, ku, ldab, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
        End Function f16ubf
      End Interface
    End Module nag_f_ib
