    Module nag_blast_ib

!     NAG COPYRIGHT 2011.

!     .. Use Statements ..
      Use nag_precisions, Only: wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine blas_dwaxpby(n,alpha,x,incx,beta,y,incy,w,incw)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incw, incx, incy, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: w(1+(n-1)*abs(incw))
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx)), &
            y(1+(n-1)*abs(incy))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_dwaxpby
      End Interface
      Interface
        Function blas_dsum(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: blas_dsum
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Function blas_dsum
      End Interface
      Interface
        Subroutine blas_zwaxpby(n,alpha,x,incx,beta,y,incy,w,incw)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: incw, incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: w(1+(n-1)*abs(incw))
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx)), &
            y(1+(n-1)*abs(incy))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_zwaxpby
      End Interface
      Interface
        Function blas_zsum(n,x,incx)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Complex (Kind=wp) :: blas_zsum
!         .. Scalar Arguments ..
          Integer, Intent (In) :: incx, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Function blas_zsum
      End Interface
      Interface
        Subroutine blas_dmax_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_dmax_val
      End Interface
      Interface
        Subroutine blas_dmin_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_dmin_val
      End Interface
      Interface
        Subroutine blas_damax_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_damax_val
      End Interface
      Interface
        Subroutine blas_damin_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_damin_val
      End Interface
      Interface
        Subroutine blas_zamax_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_zamax_val
      End Interface
      Interface
        Subroutine blas_zamin_val(n,x,incx,k,r)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r
          Integer, Intent (In) :: incx, n
          Integer, Intent (Out) :: k
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: x(1+(n-1)*abs(incx))
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine blas_zamin_val
      End Interface
    End Module nag_blast_ib
