    Module nag_g_ib

!     NAG COPYRIGHT 2011.

!     .. Use Statements ..
      Use nag_precisions, Only: wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine g01aaf(n,x,iwt,wt,xmean,s2,s3,s4,xmin,xmax,wtsum,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s2, s3, s4, wtsum, xmax, xmean, xmin
          Integer, Intent (Inout) :: ifail, iwt
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: wt(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g01aaf
      End Interface
      Interface
        Subroutine g01abf(n,x1,x2,iwt,wt,res,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, iwt
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: res(13)
          Real (Kind=wp), Intent (Inout) :: wt(n)
          Real (Kind=wp), Intent (In) :: x1(n), x2(n)
        End Subroutine g01abf
      End Interface
      Interface
        Subroutine g01adf(k,x,ifreq,xmean,s2,s3,s4,n,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s2, s3, s4, xmean
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k
          Integer, Intent (Out) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(k)
          Integer, Intent (In) :: ifreq(k)
        End Subroutine g01adf
      End Interface
      Interface
        Subroutine g01aef(n,k,x,iclass,cb,ifreq,xmin,xmax,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: xmax, xmin
          Integer, Intent (In) :: iclass, k, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cb(k)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Out) :: ifreq(k)
        End Subroutine g01aef
      End Interface
      Interface
        Subroutine g01aff(ldnob,ldpred,m,n,nobs,num,pred,chis,p,npos,ndf,m1, &
            n1,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chis
          Integer, Intent (Inout) :: ifail, num
          Integer, Intent (In) :: ldnob, ldpred, m, n
          Integer, Intent (Out) :: m1, n1, ndf, npos
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: p(21)
          Real (Kind=wp), Intent (Inout) :: pred(ldpred,n)
          Integer, Intent (Inout) :: nobs(ldnob,n)
        End Subroutine g01aff
      End Interface
      Interface
        Subroutine g01agf(x,y,nobs,isort,nstepx,nstepy,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nobs, nstepx, nstepy
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(nobs)
          Real (Kind=wp), Intent (Inout) :: y(nobs)
          Integer, Intent (Out) :: isort(nobs)
        End Subroutine g01agf
      End Interface
      Interface
        Subroutine g01ahf(x,nobs,nstepx,nstepy,istand,iwork,work,lwork,xsort, &
            xbar,xstd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: xbar, xstd
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: istand, lwork, nobs, nstepx, nstepy
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(lwork), xsort(nobs)
          Real (Kind=wp), Intent (In) :: x(nobs)
          Integer, Intent (Out) :: iwork(nobs)
        End Subroutine g01ahf
      End Interface
      Interface
        Subroutine g01ajf(x,n,nstepx,nstepy,itype,ispace,xmin,xmax,xstep,n1, &
            multy,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: xmax, xmin
          Real (Kind=wp), Intent (Out) :: xstep
          Integer, Intent (Inout) :: ifail, ispace, nstepx, nstepy
          Integer, Intent (In) :: itype, n
          Integer, Intent (Out) :: multy, n1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g01ajf
      End Interface
      Interface
        Subroutine g01alf(n,x,iwrk,res,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: res(5)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Out) :: iwrk(n)
        End Subroutine g01alf
      End Interface
      Interface
        Subroutine g01amf(n,rv,nq,q,qv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: q(nq)
          Real (Kind=wp), Intent (Out) :: qv(nq)
          Real (Kind=wp), Intent (Inout) :: rv(n)
        End Subroutine g01amf
      End Interface
      Interface
        Subroutine g01anf(ind,n,rv,nb,eps,np,q,qv,nq,rcomm,lrcomm,icomm, &
            licomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail, ind
          Integer, Intent (In) :: licomm, lrcomm, n, nb, nq
          Integer, Intent (Out) :: np
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: q(*), rv(*)
          Real (Kind=wp), Intent (Inout) :: qv(*), rcomm(lrcomm)
          Integer, Intent (Inout) :: icomm(licomm)
        End Subroutine g01anf
      End Interface
      Interface
        Subroutine g01apf(ind,rv,nb,eps,np,q,qv,nq,rcomm,lrcomm,icomm,licomm, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail, ind
          Integer, Intent (In) :: licomm, lrcomm, nb, nq
          Integer, Intent (Out) :: np
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: q(*), rv(*)
          Real (Kind=wp), Intent (Inout) :: qv(*), rcomm(lrcomm)
          Integer, Intent (Inout) :: icomm(licomm)
        End Subroutine g01apf
      End Interface
      Interface
        Subroutine g01arf(range,prt,n,y,nstepx,nstepy,unit,plot,ldplot,lines, &
            sorty,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: unit
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldplot, n, nstepx, nstepy
          Integer, Intent (Out) :: lines
          Character (1), Intent (In) :: prt, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: sorty(n)
          Real (Kind=wp), Intent (In) :: y(n)
          Integer, Intent (Out) :: iwork(n)
          Character (1), Intent (Inout) :: plot(ldplot,nstepx)
        End Subroutine g01arf
      End Interface
      Interface
        Subroutine g01asf(prt,m,n,x,ldx,nstepx,nstepy,plot,ldplot,work,iwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldplot, ldx, m, nstepx, nstepy
          Character (1), Intent (In) :: prt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(5*m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (Out) :: iwork(ldx)
          Integer, Intent (In) :: n(m)
          Character (1), Intent (Inout) :: plot(ldplot,nstepx)
        End Subroutine g01asf
      End Interface
      Interface
        Subroutine g01bjf(n,p,k,plek,pgtk,peqk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Real (Kind=wp), Intent (Out) :: peqk, pgtk, plek
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, n
        End Subroutine g01bjf
      End Interface
      Interface
        Subroutine g01bkf(rlamda,k,plek,pgtk,peqk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: peqk, pgtk, plek
          Real (Kind=wp), Intent (In) :: rlamda
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k
        End Subroutine g01bkf
      End Interface
      Interface
        Subroutine g01blf(n,l,m,k,plek,pgtk,peqk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: peqk, pgtk, plek
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, l, m, n
        End Subroutine g01blf
      End Interface
      Interface
        Subroutine g01daf(n,pp,etol,errest,work,iw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: errest
          Real (Kind=wp), Intent (In) :: etol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iw, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: pp(n), work(iw)
        End Subroutine g01daf
      End Interface
      Interface
        Subroutine g01dbf(n,pp,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: pp(n)
        End Subroutine g01dbf
      End Interface
      Interface
        Subroutine g01dcf(n,exp1,exp2,sumssq,vec,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: exp1, exp2, sumssq
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: vec(n*(n+1)/2)
        End Subroutine g01dcf
      End Interface
      Interface
        Subroutine g01ddf(x,n,calwts,a,w,pw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pw, w
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: calwts
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g01ddf
      End Interface
      Interface
        Subroutine g01dhf(scores,ties,n,x,r,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: scores, ties
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: r(n)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Out) :: iwrk(n)
        End Subroutine g01dhf
      End Interface
      Interface
        Function g01eaf(tail,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01eaf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01eaf
      End Interface
      Interface
        Function g01ebf(tail,t,df,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01ebf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, t
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01ebf
      End Interface
      Interface
        Function g01ecf(tail,x,df,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01ecf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, x
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01ecf
      End Interface
      Interface
        Function g01edf(tail,f,df1,df2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01edf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df1, df2, f
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01edf
      End Interface
      Interface
        Subroutine g01eef(x,a,b,tol,p,q,pdf,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, tol, x
          Real (Kind=wp), Intent (Out) :: p, pdf, q
          Integer, Intent (Inout) :: ifail
        End Subroutine g01eef
      End Interface
      Interface
        Function g01eff(tail,g,a,b,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01eff
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, g
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01eff
      End Interface
      Interface
        Function g01emf(q,v,ir,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01emf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: q, v
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir
        End Function g01emf
      End Interface
      Interface
        Subroutine g01epf(n,ip,d,pdl,pdu,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: d
          Real (Kind=wp), Intent (Out) :: pdl, pdu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine g01epf
      End Interface
      Interface
        Function g01erf(t,vk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01erf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: t, vk
          Integer, Intent (Inout) :: ifail
        End Function g01erf
      End Interface
      Interface
        Function g01etf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01etf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01etf
      End Interface
      Interface
        Function g01euf(x,rcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01euf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rcomm(322)
        End Function g01euf
      End Interface
      Interface
        Function g01eyf(n,d,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01eyf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: d
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
        End Function g01eyf
      End Interface
      Interface
        Function g01ezf(n1,n2,d,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01ezf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: d
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n1, n2
        End Function g01ezf
      End Interface
      Interface
        Function g01faf(tail,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01faf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01faf
      End Interface
      Interface
        Function g01fbf(tail,p,df,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, p
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
        End Function g01fbf
      End Interface
      Interface
        Function g01fcf(p,df,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fcf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, p
          Integer, Intent (Inout) :: ifail
        End Function g01fcf
      End Interface
      Interface
        Function g01fdf(p,df1,df2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fdf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df1, df2, p
          Integer, Intent (Inout) :: ifail
        End Function g01fdf
      End Interface
      Interface
        Function g01fef(p,a,b,tol,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fef
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, p, tol
          Integer, Intent (Inout) :: ifail
        End Function g01fef
      End Interface
      Interface
        Function g01fff(p,a,b,tol,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fff
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, p, tol
          Integer, Intent (Inout) :: ifail
        End Function g01fff
      End Interface
      Interface
        Function g01fmf(p,v,ir,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01fmf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p, v
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ir
        End Function g01fmf
      End Interface
      Interface
        Function g01ftf(x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01ftf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
        End Function g01ftf
      End Interface
      Interface
        Function g01gbf(t,df,delta,tol,maxit,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01gbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: delta, df, t, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit
        End Function g01gbf
      End Interface
      Interface
        Function g01gcf(x,df,rlamda,tol,maxit,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01gcf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, rlamda, tol, x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit
        End Function g01gcf
      End Interface
      Interface
        Function g01gdf(f,df1,df2,rlamda,tol,maxit,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01gdf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df1, df2, f, rlamda, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit
        End Function g01gdf
      End Interface
      Interface
        Function g01gef(x,a,b,rlamda,tol,maxit,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01gef
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, rlamda, tol, x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit
        End Function g01gef
      End Interface
      Interface
        Function g01haf(x,y,rho,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01haf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rho, x, y
          Integer, Intent (Inout) :: ifail
        End Function g01haf
      End Interface
      Interface
        Function g01hbf(tail,n,a,b,xmu,sig,ldsig,tol,wk,lwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01hbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldsig, lwk, n
          Character (1), Intent (In) :: tail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n), b(n), sig(ldsig,n), xmu(n)
          Real (Kind=wp), Intent (Out) :: wk(lwk)
        End Function g01hbf
      End Interface
      Interface
        Function g01hcf(tail,a,b,df,rho,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01hcf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rho
          Integer, Intent (In) :: df
          Integer, Intent (Inout) :: ifail
          Character (1), Intent (In) :: tail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(2), b(2)
        End Function g01hcf
      End Interface
      Interface
        Subroutine g01jcf(a,mult,rlamda,n,c,p,pdf,tol,maxit,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, tol
          Real (Kind=wp), Intent (Out) :: p, pdf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n), rlamda(n)
          Real (Kind=wp), Intent (Out) :: wrk(n+2*maxit)
          Integer, Intent (In) :: mult(n)
        End Subroutine g01jcf
      End Interface
      Interface
        Subroutine g01jdf(method,n,rlam,d,c,prob,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, d
          Real (Kind=wp), Intent (Out) :: prob
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rlam(n)
          Real (Kind=wp), Intent (Out) :: work(n+1)
        End Subroutine g01jdf
      End Interface
      Interface
        Function g01kaf(x,xmean,xstd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01kaf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x, xmean, xstd
          Integer, Intent (Inout) :: ifail
        End Function g01kaf
      End Interface
      Interface
        Function g01kff(x,a,b,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01kff
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b, x
          Integer, Intent (Inout) :: ifail
        End Function g01kff
      End Interface
      Interface
        Subroutine g01kkf(ilog,lx,x,la,a,lb,b,pdf,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ilog, la, lb, lx
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(lb), x(lx)
          Real (Kind=wp), Intent (Out) :: pdf(*)
          Integer, Intent (Out) :: ivalid(*)
        End Subroutine g01kkf
      End Interface
      Interface
        Subroutine g01kqf(ilog,lx,x,lxmu,xmu,lxstd,xstd,pdf,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ilog, lx, lxmu, lxstd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: pdf(*)
          Real (Kind=wp), Intent (In) :: x(lx), xmu(lxmu), xstd(lxstd)
          Integer, Intent (Out) :: ivalid(*)
        End Subroutine g01kqf
      End Interface
      Interface
        Function g01mbf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01mbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01mbf
      End Interface
      Interface
        Function g01mtf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01mtf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01mtf
      End Interface
      Interface
        Function g01muf(x,rcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01muf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rcomm(322)
        End Function g01muf
      End Interface
      Interface
        Subroutine g01naf(mom,mean,n,a,lda,emu,sigma,ldsig,l,rkum,rmom,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, lda, ldsig, n
          Character (1), Intent (In) :: mean, mom
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n), emu(*), sigma(ldsig,n)
          Real (Kind=wp), Intent (Out) :: rkum(l), wk(3*n*(n+1)/2+n)
          Real (Kind=wp), Intent (Inout) :: rmom(*)
        End Subroutine g01naf
      End Interface
      Interface
        Subroutine g01nbf(case,mean,n,a,lda,b,ldb,c,ldc,ela,emu,sigma,ldsig, &
            l1,l2,lmax,rmom,abserr,eps,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abserr
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l1, l2, lda, ldb, ldc, ldsig, n
          Integer, Intent (Out) :: lmax
          Character (1), Intent (In) :: case, mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,n), b(ldb,n), c(ldc,*), ela(*), &
            emu(*), sigma(ldsig,n)
          Real (Kind=wp), Intent (Out) :: rmom(l2-l1+1), wk(3*n*n+(8+l2)*n)
        End Subroutine g01nbf
      End Interface
      Interface
        Function g01ptf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01ptf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01ptf
      End Interface
      Interface
        Function g01qtf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01qtf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01qtf
      End Interface
      Interface
        Function g01rtf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g01rtf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function g01rtf
      End Interface
      Interface
        Subroutine g01saf(ltail,tail,lx,x,lxmu,xmu,lxstd,xstd,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ltail, lx, lxmu, lxstd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: p(*)
          Real (Kind=wp), Intent (In) :: x(lx), xmu(lxmu), xstd(lxstd)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01saf
      End Interface
      Interface
        Subroutine g01sbf(ltail,tail,lt,t,ldf,df,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf, lt, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df(ldf), t(lt)
          Real (Kind=wp), Intent (Out) :: p(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01sbf
      End Interface
      Interface
        Subroutine g01scf(ltail,tail,lx,x,ldf,df,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf, ltail, lx
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df(ldf), x(lx)
          Real (Kind=wp), Intent (Out) :: p(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01scf
      End Interface
      Interface
        Subroutine g01sdf(ltail,tail,lf,f,ldf1,df1,ldf2,df2,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf1, ldf2, lf, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df1(ldf1), df2(ldf2), f(lf)
          Real (Kind=wp), Intent (Out) :: p(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01sdf
      End Interface
      Interface
        Subroutine g01sef(ltail,tail,lbeta,beta,la,a,lb,b,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lb, lbeta, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(lb), beta(lbeta)
          Real (Kind=wp), Intent (Out) :: p(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01sef
      End Interface
      Interface
        Subroutine g01sff(ltail,tail,lg,g,la,a,lb,b,p,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lb, lg, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(lb), g(lg)
          Real (Kind=wp), Intent (Out) :: p(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01sff
      End Interface
      Interface
        Subroutine g01sjf(ln,n,lp,p,lk,k,plek,pgtk,peqk,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lk, ln, lp
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(lp)
          Real (Kind=wp), Intent (Out) :: peqk(*), pgtk(*), plek(*)
          Integer, Intent (Out) :: ivalid(*)
          Integer, Intent (In) :: k(lk), n(ln)
        End Subroutine g01sjf
      End Interface
      Interface
        Subroutine g01skf(ll,l,lk,k,plek,pgtk,peqk,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lk, ll
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: l(ll)
          Real (Kind=wp), Intent (Out) :: peqk(*), pgtk(*), plek(*)
          Integer, Intent (Out) :: ivalid(*)
          Integer, Intent (In) :: k(lk)
        End Subroutine g01skf
      End Interface
      Interface
        Subroutine g01slf(ln,n,ll,l,lm,m,lk,k,plek,pgtk,peqk,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lk, ll, lm, ln
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: peqk(*), pgtk(*), plek(*)
          Integer, Intent (Out) :: ivalid(*)
          Integer, Intent (In) :: k(lk), l(ll), m(lm), n(ln)
        End Subroutine g01slf
      End Interface
      Interface
        Subroutine g01taf(ltail,tail,lp,p,lxmu,xmu,lxstd,xstd,x,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lp, ltail, lxmu, lxstd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(lp), xmu(lxmu), xstd(lxstd)
          Real (Kind=wp), Intent (Out) :: x(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01taf
      End Interface
      Interface
        Subroutine g01tbf(ltail,tail,lp,p,ldf,df,t,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf, lp, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df(ldf), p(lp)
          Real (Kind=wp), Intent (Out) :: t(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01tbf
      End Interface
      Interface
        Subroutine g01tcf(ltail,tail,lp,p,ldf,df,x,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf, lp, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df(ldf), p(lp)
          Real (Kind=wp), Intent (Out) :: x(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01tcf
      End Interface
      Interface
        Subroutine g01tdf(ltail,tail,lp,p,ldf1,df1,ldf2,df2,f,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf1, ldf2, lp, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: df1(ldf1), df2(ldf2), p(lp)
          Real (Kind=wp), Intent (Out) :: f(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01tdf
      End Interface
      Interface
        Subroutine g01tef(ltail,tail,lp,p,la,a,lb,b,tol,beta,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lb, lp, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(lb), p(lp)
          Real (Kind=wp), Intent (Out) :: beta(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01tef
      End Interface
      Interface
        Subroutine g01tff(ltail,tail,lp,p,la,a,lb,b,tol,g,ivalid,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: la, lb, lp, ltail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(la), b(lb), p(lp)
          Real (Kind=wp), Intent (Out) :: g(*)
          Integer, Intent (Out) :: ivalid(*)
          Character (1), Intent (In) :: tail(ltail)
        End Subroutine g01tff
      End Interface
      Interface
        Subroutine g01zuf(rkappa,beta2,mode,xl,xu,rcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: beta2, rkappa
          Real (Kind=wp), Intent (Out) :: xl, xu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rcomm(322)
        End Subroutine g01zuf
      End Interface
      Interface
        Subroutine g02aaf(g,ldg,n,errtol,maxits,maxit,x,ldx,iter,feval,nrmgrd, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: errtol
          Real (Kind=wp), Intent (Out) :: nrmgrd
          Integer, Intent (Out) :: feval, iter
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldg, ldx, maxit, maxits, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: g(ldg,n), x(ldx,n)
        End Subroutine g02aaf
      End Interface
      Interface
        Subroutine g02abf(g,ldg,n,opt,alpha,w,errtol,maxits,maxit,x,ldx,iter, &
            feval,nrmgrd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, errtol
          Real (Kind=wp), Intent (Out) :: nrmgrd
          Integer, Intent (Out) :: feval, iter
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldg, ldx, maxit, maxits, n
          Character (1), Intent (In) :: opt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: g(ldg,n), w(n), x(ldx,n)
        End Subroutine g02abf
      End Interface
      Interface
        Subroutine g02aef(g,ldg,n,k,errtol,maxit,x,ldx,iter,feval,nrmpgd, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: errtol
          Real (Kind=wp), Intent (Out) :: nrmpgd
          Integer, Intent (Out) :: feval, iter
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldg, ldx, maxit, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: g(ldg,n), x(ldx,k)
        End Subroutine g02aef
      End Interface
      Interface
        Subroutine g02baf(n,m,x,ldx,xbar,std,ssp,ldssp,r,ldr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldssp, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,m), ssp(ldssp,m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
        End Subroutine g02baf
      End Interface
      Interface
        Subroutine g02bbf(n,m,x,ldx,miss,xmiss,xbar,std,ssp,ldssp,r,ldr, &
            ncases,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldssp, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,m), ssp(ldssp,m), xmiss(m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02bbf
      End Interface
      Interface
        Subroutine g02bcf(n,m,x,ldx,miss,xmiss,xbar,std,ssp,ldssp,r,ldr, &
            ncases,cnt,ldcnt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcnt, ldr, ldssp, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cnt(ldcnt,m), r(ldr,m), &
            ssp(ldssp,m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m), xmiss(m)
          Integer, Intent (In) :: miss(m)
        End Subroutine g02bcf
      End Interface
      Interface
        Subroutine g02bdf(n,m,x,ldx,xbar,std,sspz,ldsspz,rz,ldrz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldrz, ldsspz, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rz(ldrz,m), sspz(ldsspz,m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
        End Subroutine g02bdf
      End Interface
      Interface
        Subroutine g02bef(n,m,x,ldx,miss,xmiss,xbar,std,sspz,ldsspz,rz,ldrz, &
            ncases,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldrz, ldsspz, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rz(ldrz,m), sspz(ldsspz,m), &
            xmiss(m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02bef
      End Interface
      Interface
        Subroutine g02bff(n,m,x,ldx,miss,xmiss,xbar,std,sspz,ldsspz,rz,ldrz, &
            ncases,cnt,ldcnt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcnt, ldrz, ldsspz, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cnt(ldcnt,m), rz(ldrz,m), &
            sspz(ldsspz,m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m), xmiss(m)
          Integer, Intent (In) :: miss(m)
        End Subroutine g02bff
      End Interface
      Interface
        Subroutine g02bgf(n,m,x,ldx,nvars,kvar,xbar,std,ssp,ldssp,r,ldr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldssp, ldx, m, n, nvars
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,nvars), ssp(ldssp,nvars)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (In) :: kvar(nvars)
        End Subroutine g02bgf
      End Interface
      Interface
        Subroutine g02bhf(n,m,x,ldx,miss,xmiss,mistyp,nvars,kvar,xbar,std,ssp, &
            ldssp,r,ldr,ncases,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldssp, ldx, m, mistyp, n, nvars
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,nvars), ssp(ldssp,nvars), &
            xmiss(m)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (In) :: kvar(nvars)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02bhf
      End Interface
      Interface
        Subroutine g02bjf(n,m,x,ldx,miss,xmiss,nvars,kvar,xbar,std,ssp,ldssp, &
            r,ldr,ncases,cnt,ldcnt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcnt, ldr, ldssp, ldx, m, n, nvars
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cnt(ldcnt,nvars), r(ldr,nvars), &
            ssp(ldssp,nvars)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m), xmiss(m)
          Integer, Intent (In) :: kvar(nvars), miss(m)
        End Subroutine g02bjf
      End Interface
      Interface
        Subroutine g02bkf(n,m,x,ldx,nvars,kvar,xbar,std,sspz,ldsspz,rz,ldrz, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldrz, ldsspz, ldx, m, n, nvars
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rz(ldrz,nvars), sspz(ldsspz,nvars)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (In) :: kvar(nvars)
        End Subroutine g02bkf
      End Interface
      Interface
        Subroutine g02blf(n,m,x,ldx,miss,xmiss,mistyp,nvars,kvar,xbar,std, &
            sspz,ldsspz,rz,ldrz,ncases,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldrz, ldsspz, ldx, m, mistyp, n, nvars
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rz(ldrz,nvars), &
            sspz(ldsspz,nvars), xmiss(m)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (In) :: kvar(nvars)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02blf
      End Interface
      Interface
        Subroutine g02bmf(n,m,x,ldx,miss,xmiss,nvars,kvar,xbar,std,sspz, &
            ldsspz,rz,ldrz,ncases,cnt,ldcnt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldcnt, ldrz, ldsspz, ldx, m, n, nvars
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cnt(ldcnt,nvars), rz(ldrz,nvars), &
            sspz(ldsspz,nvars)
          Real (Kind=wp), Intent (Out) :: std(nvars), xbar(nvars)
          Real (Kind=wp), Intent (In) :: x(ldx,m), xmiss(m)
          Integer, Intent (In) :: kvar(nvars), miss(m)
        End Subroutine g02bmf
      End Interface
      Interface
        Subroutine g02bnf(n,m,x,ldx,itype,rr,ldrr,kworka,kworkb,work1,work2, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, ldrr, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rr(ldrr,m), x(ldx,m)
          Real (Kind=wp), Intent (Out) :: work1(m), work2(m)
          Integer, Intent (Out) :: kworka(n), kworkb(n)
        End Subroutine g02bnf
      End Interface
      Interface
        Subroutine g02bpf(n,m,x,ldx,miss,xmiss,itype,rr,ldrr,ncases,incase, &
            kworka,kworkb,kworkc,work1,work2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, ldrr, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rr(ldrr,m), x(ldx,m), xmiss(m)
          Real (Kind=wp), Intent (Out) :: work1(m), work2(m)
          Integer, Intent (Out) :: incase(n), kworka(n), kworkb(n), kworkc(n)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02bpf
      End Interface
      Interface
        Subroutine g02bqf(n,m,x,ldx,itype,rr,ldrr,kworka,kworkb,work1,work2, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, ldrr, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rr(ldrr,m)
          Real (Kind=wp), Intent (Out) :: work1(n), work2(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (Out) :: kworka(n), kworkb(n)
        End Subroutine g02bqf
      End Interface
      Interface
        Subroutine g02brf(n,m,x,ldx,miss,xmiss,itype,rr,ldrr,ncases,incase, &
            kworka,kworkb,kworkc,work1,work2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, ldrr, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rr(ldrr,m), xmiss(m)
          Real (Kind=wp), Intent (Out) :: work1(n), work2(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (Out) :: incase(n), kworka(n), kworkb(n), kworkc(n)
          Integer, Intent (Inout) :: miss(m)
        End Subroutine g02brf
      End Interface
      Interface
        Subroutine g02bsf(n,m,x,ldx,miss,xmiss,itype,rr,ldrr,ncases,cnt,ldcnt, &
            kworka,kworkb,kworkc,kworkd,work1,work2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, ldcnt, ldrr, ldx, m, n
          Integer, Intent (Out) :: ncases
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cnt(ldcnt,m), rr(ldrr,m)
          Real (Kind=wp), Intent (Out) :: work1(n), work2(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m), xmiss(m)
          Integer, Intent (Out) :: kworka(n), kworkb(n), kworkc(n), kworkd(n)
          Integer, Intent (In) :: miss(m)
        End Subroutine g02bsf
      End Interface
      Interface
        Subroutine g02btf(mean,m,wt,x,incx,sw,xbar,c,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: sw
          Real (Kind=wp), Intent (In) :: wt
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: incx, m
          Character (1), Intent (In) :: mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c((m*m+m)/2), xbar(m)
          Real (Kind=wp), Intent (In) :: x(m*incx)
        End Subroutine g02btf
      End Interface
      Interface
        Subroutine g02buf(mean,weight,n,m,x,ldx,wt,sw,wmean,c,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: sw
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n
          Character (1), Intent (In) :: mean, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: c((m*m+m)/2), wmean(m)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
        End Subroutine g02buf
      End Interface
      Interface
        Subroutine g02bwf(m,r,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r((m*m+m)/2)
        End Subroutine g02bwf
      End Interface
      Interface
        Subroutine g02bxf(weight,n,m,x,ldx,wt,xbar,std,v,ldv,r,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldv, ldx, m, n
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldv,m), v(ldv,m)
          Real (Kind=wp), Intent (Out) :: std(m), xbar(m)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
        End Subroutine g02bxf
      End Interface
      Interface
        Subroutine g02byf(m,ny,nx,isz,r,ldr,p,ldp,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldp, ldr, m, nx, ny
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: p(ldp,ny)
          Real (Kind=wp), Intent (In) :: r(ldr,m)
          Real (Kind=wp), Intent (Out) :: wk(ny*nx+nx*(nx+1)/2)
          Integer, Intent (In) :: isz(m)
        End Subroutine g02byf
      End Interface
      Interface
        Subroutine g02caf(n,x,y,result,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: result(20)
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine g02caf
      End Interface
      Interface
        Subroutine g02cbf(n,x,y,result,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: result(20)
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine g02cbf
      End Interface
      Interface
        Subroutine g02ccf(n,x,y,xmiss,ymiss,result,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmiss, ymiss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: result(21)
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine g02ccf
      End Interface
      Interface
        Subroutine g02cdf(n,x,y,xmiss,ymiss,result,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmiss, ymiss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: result(21)
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine g02cdf
      End Interface
      Interface
        Subroutine g02cef(n,xbar,std,ssp,ldssp,r,ldr,m,korder,xbar2,std2,ssp2, &
            ldssp2,r2,ldr2,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldr2, ldssp, ldssp2, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: r(ldr,n), ssp(ldssp,n), std(n), &
            xbar(n)
          Real (Kind=wp), Intent (Inout) :: r2(ldr2,m), ssp2(ldssp2,m)
          Real (Kind=wp), Intent (Out) :: std2(m), xbar2(m)
          Integer, Intent (In) :: korder(m)
        End Subroutine g02cef
      End Interface
      Interface
        Subroutine g02cff(n,korder,xbar,std,ssp,ldssp,r,ldr,kwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldssp, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,n), ssp(ldssp,n), std(n), &
            xbar(n)
          Integer, Intent (In) :: korder(n)
          Integer, Intent (Out) :: kwork(n)
        End Subroutine g02cff
      End Interface
      Interface
        Subroutine g02cgf(n,k1,k,xbar,ssp,ldssp,r,ldr,result,coef,ldcoef,con, &
            rinv,ldrinv,c,ldc,wkz,ldwkz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, k1, ldc, ldcoef, ldr, ldrinv, ldssp, &
            ldwkz, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,k), coef(ldcoef,3), &
            r(ldr,k1), rinv(ldrinv,k), wkz(ldwkz,k)
          Real (Kind=wp), Intent (Out) :: con(3), result(13)
          Real (Kind=wp), Intent (In) :: ssp(ldssp,k1), xbar(k1)
        End Subroutine g02cgf
      End Interface
      Interface
        Subroutine g02chf(n,k1,k,sspz,ldsspz,rz,ldrz,result,coef,ldcoef,rznv, &
            ldrznv,cz,ldcz,wkz,ldwkz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, k1, ldcoef, ldcz, ldrz, ldrznv, ldsspz, &
            ldwkz, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: coef(ldcoef,3), cz(ldcz,k), &
            rz(ldrz,k1), rznv(ldrznv,k), wkz(ldwkz,k)
          Real (Kind=wp), Intent (Out) :: result(13)
          Real (Kind=wp), Intent (In) :: sspz(ldsspz,k1)
        End Subroutine g02chf
      End Interface
      Interface
        Subroutine g02daf(mean,weight,n,x,ldx,m,isx,ip,y,wt,rss,idf,b,se,cov, &
            res,h,q,ldq,svd,irank,p,tol,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rss
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldq, ldx, m, n
          Logical, Intent (Out) :: svd
          Character (1), Intent (In) :: mean, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), h(n), &
            p(2*ip+ip*ip), res(n), se(ip), wk(5*(ip-1)+ip*ip)
          Real (Kind=wp), Intent (Inout) :: q(ldq,ip+1)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02daf
      End Interface
      Interface
        Subroutine g02dcf(update,mean,weight,m,isx,q,ldq,ip,x,ix,y,wt,rss,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: rss
          Real (Kind=wp), Intent (In) :: wt, y
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ix, ldq, m
          Character (1), Intent (In) :: mean, update, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,ip+1)
          Real (Kind=wp), Intent (Out) :: wk(3*ip)
          Real (Kind=wp), Intent (In) :: x(*)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02dcf
      End Interface
      Interface
        Subroutine g02ddf(n,ip,q,ldq,rss,idf,b,se,cov,svd,irank,p,tol,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: rss
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldq, n
          Logical, Intent (Out) :: svd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), se(ip), &
            wk(ip*ip+(ip-1)*5)
          Real (Kind=wp), Intent (Inout) :: p(ip*ip+2*ip)
          Real (Kind=wp), Intent (In) :: q(ldq,ip+1)
        End Subroutine g02ddf
      End Interface
      Interface
        Subroutine g02def(weight,n,ip,q,ldq,p,wt,x,rss,tol,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rss
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldq, n
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: p(ip+1), q(ldq,ip+2)
          Real (Kind=wp), Intent (In) :: wt(*), x(n)
        End Subroutine g02def
      End Interface
      Interface
        Subroutine g02dff(ip,q,ldq,indx,rss,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: rss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indx, ip, ldq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,ip+1)
          Real (Kind=wp), Intent (Out) :: wk(2*ip)
        End Subroutine g02dff
      End Interface
      Interface
        Subroutine g02dgf(weight,n,wt,rss,ip,irank,cov,q,ldq,svd,p,y,b,se,res, &
            wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: rss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, irank, ldq, n
          Logical, Intent (In) :: svd
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), res(n), se(ip)
          Real (Kind=wp), Intent (Inout) :: cov(ip*(ip+1)/2), q(ldq,ip+1)
          Real (Kind=wp), Intent (In) :: p(*), wk(5*(ip-1)+ip*ip), wt(*), y(n)
        End Subroutine g02dgf
      End Interface
      Interface
        Subroutine g02dkf(ip,iconst,p,c,ldc,b,rss,idf,se,cov,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rss
          Integer, Intent (In) :: iconst, idf, ip, ldc
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ip)
          Real (Kind=wp), Intent (In) :: c(ldc,iconst), p(ip*ip+2*ip)
          Real (Kind=wp), Intent (Out) :: cov(ip*(ip+1)/2), se(ip), &
            wk(2*ip*ip+ip*iconst+2*iconst*iconst+4*iconst)
        End Subroutine g02dkf
      End Interface
      Interface
        Subroutine g02dnf(ip,irank,b,cov,p,f,est,stat,sestat,t,tol,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: sestat, stat, t
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, irank
          Logical, Intent (Out) :: est
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ip), cov(ip*(ip+1)/2), f(ip), &
            p(ip*ip+2*ip)
          Real (Kind=wp), Intent (Out) :: wk(ip)
        End Subroutine g02dnf
      End Interface
      Interface
        Subroutine g02eaf(mean,weight,n,m,x,ldx,vname,isx,y,wt,nmod,modl, &
            ldmodl,rss,nterms,mrank,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldmodl, ldx, m, n
          Integer, Intent (Out) :: nmod
          Character (1), Intent (In) :: mean, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rss(ldmodl), wk(n*(m+1))
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
          Integer, Intent (Out) :: mrank(ldmodl), nterms(ldmodl)
          Character (*), Intent (Inout) :: modl(ldmodl,m)
          Character (*), Intent (In) :: vname(m)
        End Subroutine g02eaf
      End Interface
      Interface
        Subroutine g02ecf(mean,n,sigsq,tss,nmod,nterms,rss,rsq,cp,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigsq, tss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nmod
          Character (1), Intent (In) :: mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: cp(nmod), rsq(nmod)
          Real (Kind=wp), Intent (In) :: rss(nmod)
          Integer, Intent (In) :: nterms(nmod)
        End Subroutine g02ecf
      End Interface
      Interface
        Subroutine g02eef(istep,mean,weight,n,m,x,ldx,vname,isx,maxip,y,wt, &
            fin,addvar,newvar,chrss,f,model,nterm,rss,idf,ifr,free,exss,q,ldq, &
            p,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chrss, f
          Real (Kind=wp), Intent (In) :: fin
          Real (Kind=wp), Intent (Inout) :: rss
          Integer, Intent (Inout) :: idf, ifail, ifr, istep, nterm
          Integer, Intent (In) :: ldq, ldx, m, maxip, n
          Logical, Intent (Out) :: addvar
          Character (1), Intent (In) :: mean, weight
          Character (*), Intent (Out) :: newvar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: exss(maxip), wk(2*maxip)
          Real (Kind=wp), Intent (Inout) :: p(maxip+1), q(ldq,maxip+2)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
          Character (*), Intent (Inout) :: free(maxip), model(maxip)
          Character (*), Intent (In) :: vname(m)
        End Subroutine g02eef
      End Interface
      Interface
        Subroutine g02eff(m,n,wmean,c,sw,isx,fin,fout,tau,b,se,rsq,rms,df, &
            monlev,monfun,iuser,ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: fin, fout, sw, tau
          Real (Kind=wp), Intent (Out) :: rms, rsq
          Integer, Intent (Out) :: df
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, monlev, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(m+1), se(m+1)
          Real (Kind=wp), Intent (In) :: c((m+1)*(m+2)/2), wmean(m+1)
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: isx(m), iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine monfun(flag,var,val,iuser,ruser)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: val
              Integer, Intent (In) :: var
              Character (1), Intent (In) :: flag
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Integer, Intent (Inout) :: iuser(*)
            End Subroutine monfun
          End Interface
        End Subroutine g02eff
      End Interface
      Interface
        Subroutine g02efh(flag,var,val,iuser,ruser)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: val
          Integer, Intent (In) :: var
          Character (1), Intent (In) :: flag
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ruser(*)
          Integer, Intent (Inout) :: iuser(*)
        End Subroutine g02efh
      End Interface
      Interface
        Subroutine g02faf(n,ip,nres,res,h,rms,sres,ldsres,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rms
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldsres, n, nres
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: h(nres), res(nres)
          Real (Kind=wp), Intent (Inout) :: sres(ldsres,4)
        End Subroutine g02faf
      End Interface
      Interface
        Subroutine g02fcf(n,ip,res,d,pdl,pdu,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d, pdl, pdu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: res(n)
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine g02fcf
      End Interface
      Interface
        Subroutine g02gaf(link,mean,offset,weight,n,x,ldx,m,isx,ip,y,wt,s,a, &
            rss,idf,b,irank,se,cov,v,ldv,tol,maxit,iprint,eps,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, eps, tol
          Real (Kind=wp), Intent (Out) :: rss
          Real (Kind=wp), Intent (Inout) :: s
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldv, ldx, m, maxit, n
          Character (1), Intent (In) :: link, mean, offset, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), se(ip), &
            wk((ip*ip+3*ip+22)/2)
          Real (Kind=wp), Intent (Inout) :: v(ldv,ip+7)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02gaf
      End Interface
      Interface
        Subroutine g02gbf(link,mean,offset,weight,n,x,ldx,m,isx,ip,y,t,wt,dev, &
            idf,b,irank,se,cov,v,ldv,tol,maxit,iprint,eps,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: eps, tol
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldv, ldx, m, maxit, n
          Character (1), Intent (In) :: link, mean, offset, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), se(ip), &
            wk((ip*ip+3*ip+22)/2)
          Real (Kind=wp), Intent (In) :: t(n), wt(*), x(ldx,m), y(n)
          Real (Kind=wp), Intent (Inout) :: v(ldv,ip+7)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02gbf
      End Interface
      Interface
        Subroutine g02gcf(link,mean,offset,weight,n,x,ldx,m,isx,ip,y,wt,a,dev, &
            idf,b,irank,se,cov,v,ldv,tol,maxit,iprint,eps,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, eps, tol
          Real (Kind=wp), Intent (Out) :: dev
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldv, ldx, m, maxit, n
          Character (1), Intent (In) :: link, mean, offset, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), se(ip), &
            wk((ip*ip+3*ip+22)/2)
          Real (Kind=wp), Intent (Inout) :: v(ldv,ip+7)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02gcf
      End Interface
      Interface
        Subroutine g02gdf(link,mean,offset,weight,n,x,ldx,m,isx,ip,y,wt,s,a, &
            dev,idf,b,irank,se,cov,v,ldv,tol,maxit,iprint,eps,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, eps, tol
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (Inout) :: s
          Integer, Intent (Out) :: idf, irank
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldv, ldx, m, maxit, n
          Character (1), Intent (In) :: link, mean, offset, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip), cov(ip*(ip+1)/2), se(ip), &
            wk((ip*ip+3*ip+22)/2)
          Real (Kind=wp), Intent (Inout) :: v(ldv,ip+7)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02gdf
      End Interface
      Interface
        Subroutine g02gkf(ip,iconst,v,ldv,c,ldc,b,s,se,cov,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: s
          Integer, Intent (In) :: iconst, ip, ldc, ldv
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ip)
          Real (Kind=wp), Intent (In) :: c(ldc,iconst), v(ldv,ip+7)
          Real (Kind=wp), Intent (Out) :: cov(ip*(ip+1)/2), se(ip), &
            wk(2*ip*ip+ip*iconst+2*iconst*iconst+4*iconst)
        End Subroutine g02gkf
      End Interface
      Interface
        Subroutine g02gnf(ip,irank,b,cov,v,ldv,f,est,stat,sestat,z,tol,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: sestat, stat, z
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, irank, ldv
          Logical, Intent (Out) :: est
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ip), cov(ip*(ip+1)/2), f(ip), &
            v(ldv,ip+7)
          Real (Kind=wp), Intent (Out) :: wk(ip)
        End Subroutine g02gnf
      End Interface
      Interface
        Subroutine g02gpf(errfn,link,mean,offset,weight,n,x,ldx,m,isx,ip,t, &
            off,wt,s,a,b,cov,vfobs,eta,seeta,pred,sepred,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, s
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldx, m, n
          Logical, Intent (In) :: vfobs
          Character (1), Intent (In) :: errfn, link, mean, offset, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ip), cov(ip*(ip+1)/2), off(*), &
            t(*), wt(*), x(ldx,m)
          Real (Kind=wp), Intent (Out) :: eta(n), pred(n), seeta(n), sepred(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02gpf
      End Interface
      Interface
        Subroutine g02haf(indw,ipsi,isigma,indc,n,m,x,ldx,y,cpsi,h1,h2,h3, &
            cucv,dchi,theta,sigma,c,ldc,rs,wgt,tol,maxit,nitmon,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cpsi, cucv, dchi, h1, h2, h3, tol
          Real (Kind=wp), Intent (Inout) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indc, indw, ipsi, isigma, ldc, ldx, m, &
            maxit, n, nitmon
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,m), theta(m), x(ldx,m), y(n)
          Real (Kind=wp), Intent (Out) :: rs(n), wgt(n), work(4*n+m*(n+m))
        End Subroutine g02haf
      End Interface
      Interface
        Subroutine g02hbf(ucv,n,m,x,ldx,a,z,bl,bd,tol,maxit,nitmon,nit,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: bd, bl, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, maxit, n, nitmon
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(m*(m+1)/2)
          Real (Kind=wp), Intent (Out) :: wk(m*(m+1)/2), z(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
!         .. Interface Blocks ..
          Interface
            Function ucv(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: ucv
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function ucv
          End Interface
        End Subroutine g02hbf
      End Interface
      Interface
        Subroutine g02hdf(chi,psi,psip0,beta,indw,isigma,n,m,x,ldx,y,wgt, &
            theta,k,sigma,rs,tol,eps,maxit,nitmon,nit,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: beta, eps, psip0, tol
          Real (Kind=wp), Intent (Inout) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indw, isigma, ldx, m, maxit, n, nitmon
          Integer, Intent (Out) :: k, nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rs(n), wk((m+4)*n)
          Real (Kind=wp), Intent (Inout) :: theta(m), wgt(n), x(ldx,m), y(n)
!         .. Interface Blocks ..
          Interface
            Function chi(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: chi
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function chi
          End Interface
          Interface
            Function psi(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: psi
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function psi
          End Interface
        End Subroutine g02hdf
      End Interface
      Interface
        Function g02hdz(t)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g02hdz
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: t
        End Function g02hdz
      End Interface
      Interface
        Subroutine g02hff(psi,psp,indw,indc,sigma,n,m,x,ldx,rs,wgt,c,ldc,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: sigma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indc, indw, ldc, ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,m)
          Real (Kind=wp), Intent (In) :: rs(n), wgt(n), x(ldx,m)
          Real (Kind=wp), Intent (Out) :: wk(m*(n+m+1)+2*n)
!         .. Interface Blocks ..
          Interface
            Function psi(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: psi
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function psi
          End Interface
          Interface
            Function psp(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: psp
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function psp
          End Interface
        End Subroutine g02hff
      End Interface
      Interface
        Subroutine g02hkf(n,m,x,ldx,eps,cov,theta,maxit,nitmon,tol,nit,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, maxit, n, nitmon
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: cov(m*(m+1)/2), theta(m), &
            wk(n+m*(m+5)/2)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
        End Subroutine g02hkf
      End Interface
      Interface
        Subroutine g02hlf(ucv,ruser,indm,n,m,x,ldx,cov,a,wt,theta,bl,bd,maxit, &
            nitmon,tol,nit,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: bd, bl, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indm, ldx, m, maxit, n, nitmon
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(m*(m+1)/2), ruser(*), theta(m)
          Real (Kind=wp), Intent (Out) :: cov(m*(m+1)/2), wk(2*m), wt(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
!         .. Interface Blocks ..
          Interface
            Subroutine ucv(t,ruser,u,ud,w,wd)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
              Real (Kind=wp), Intent (Out) :: u, ud, w, wd
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
            End Subroutine ucv
          End Interface
        End Subroutine g02hlf
      End Interface
      Interface
        Subroutine g02hmf(ucv,ruser,indm,n,m,x,ldx,cov,a,wt,theta,bl,bd,maxit, &
            nitmon,tol,nit,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: bd, bl, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indm, ldx, m, maxit, n, nitmon
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(m*(m+1)/2), ruser(*), theta(m)
          Real (Kind=wp), Intent (Out) :: cov(m*(m+1)/2), wk(2*m), wt(n)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
!         .. Interface Blocks ..
          Interface
            Subroutine ucv(t,ruser,u,w)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
              Real (Kind=wp), Intent (Out) :: u, w
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
            End Subroutine ucv
          End Interface
        End Subroutine g02hmf
      End Interface
      Interface
        Subroutine g02jaf(n,ncol,lddat,dat,levels,yvid,cwid,nfv,fvid,fint,nrv, &
            rvid,nvpr,vpr,rint,svid,gamma,nff,nrf,df,reml,lb,b,se,maxit,tol, &
            warn,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: reml
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: cwid, fint, lb, lddat, maxit, n, ncol, nfv, &
            nrv, nvpr, rint, svid, yvid
          Integer, Intent (Out) :: df, nff, nrf, warn
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(lb), se(lb)
          Real (Kind=wp), Intent (In) :: dat(lddat,ncol)
          Real (Kind=wp), Intent (Inout) :: gamma(nvpr+2)
          Integer, Intent (In) :: fvid(nfv), levels(ncol), rvid(nrv), vpr(nrv)
        End Subroutine g02jaf
      End Interface
      Interface
        Subroutine g02jbf(n,ncol,lddat,dat,levels,yvid,cwid,nfv,fvid,fint,nrv, &
            rvid,nvpr,vpr,rint,svid,gamma,nff,nrf,df,ml,lb,b,se,maxit,tol, &
            warn,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ml
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: cwid, fint, lb, lddat, maxit, n, ncol, nfv, &
            nrv, nvpr, rint, svid, yvid
          Integer, Intent (Out) :: df, nff, nrf, warn
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(lb), se(lb)
          Real (Kind=wp), Intent (In) :: dat(lddat,ncol)
          Real (Kind=wp), Intent (Inout) :: gamma(nvpr+2)
          Integer, Intent (In) :: fvid(nfv), levels(ncol), rvid(nrv), vpr(nrv)
        End Subroutine g02jbf
      End Interface
      Interface
        Subroutine g02jcf(weight,n,ncol,dat,lddat,levels,y,wt,fixed,lfixed, &
            nrndm,rndm,ldrndm,nff,nlsv,nrf,rcomm,lrcomm,icomm,licomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lddat, ldrndm, lfixed, licomm, lrcomm, n, &
            ncol, nrndm
          Integer, Intent (Out) :: nff, nlsv, nrf
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: dat(lddat,ncol), wt(*), y(n)
          Real (Kind=wp), Intent (Out) :: rcomm(lrcomm)
          Integer, Intent (In) :: fixed(lfixed), levels(ncol), &
            rndm(ldrndm,nrndm)
          Integer, Intent (Out) :: icomm(licomm)
        End Subroutine g02jcf
      End Interface
      Interface
        Subroutine g02jdf(lvpr,vpr,nvpr,gamma,effn,rnkx,ncov,lnlike,lb,id, &
            ldid,b,se,czz,ldczz,cxx,ldcxx,cxz,ldcxz,rcomm,icomm,iopt,liopt, &
            ropt,lropt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: lnlike
          Integer, Intent (Out) :: effn, ncov, rnkx
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lb, ldcxx, ldcxz, ldczz, ldid, liopt, lropt, &
            lvpr, nvpr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(lb), se(lb)
          Real (Kind=wp), Intent (Inout) :: cxx(ldcxx,*), cxz(ldcxz,*), &
            czz(ldczz,*), gamma(nvpr+1)
          Real (Kind=wp), Intent (In) :: rcomm(*), ropt(lropt)
          Integer, Intent (In) :: icomm(*), iopt(liopt), vpr(lvpr)
          Integer, Intent (Out) :: id(ldid,lb)
        End Subroutine g02jdf
      End Interface
      Interface
        Subroutine g02jef(lvpr,vpr,nvpr,gamma,effn,rnkx,ncov,lnlike,lb,id, &
            ldid,b,se,czz,ldczz,cxx,ldcxx,cxz,ldcxz,rcomm,icomm,iopt,liopt, &
            ropt,lropt,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: lnlike
          Integer, Intent (Out) :: effn, ncov, rnkx
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lb, ldcxx, ldcxz, ldczz, ldid, liopt, lropt, &
            lvpr, nvpr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(lb), se(lb)
          Real (Kind=wp), Intent (Inout) :: cxx(ldcxx,*), cxz(ldcxz,*), &
            czz(ldczz,*), gamma(nvpr+1)
          Real (Kind=wp), Intent (In) :: rcomm(*), ropt(lropt)
          Integer, Intent (In) :: icomm(*), iopt(liopt), vpr(lvpr)
          Integer, Intent (Out) :: id(ldid,lb)
        End Subroutine g02jef
      End Interface
      Interface
        Subroutine g02kaf(n,m,x,ldx,isx,ip,tau,y,h,opt,niter,tol,nep,orig,b, &
            vif,res,rss,df,optloo,perr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: h
          Real (Kind=wp), Intent (Out) :: nep, rss
          Real (Kind=wp), Intent (In) :: tau, tol
          Integer, Intent (Out) :: df
          Integer, Intent (Inout) :: ifail, niter
          Integer, Intent (In) :: ip, ldx, m, n, opt, optloo, orig
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(ip+1), perr(5), res(n), vif(ip)
          Real (Kind=wp), Intent (In) :: x(ldx,m), y(n)
          Integer, Intent (In) :: isx(m)
        End Subroutine g02kaf
      End Interface
      Interface
        Subroutine g02kbf(n,m,x,ldx,isx,ip,y,lh,h,nep,wantb,b,ldb,wantvf,vf, &
            ldvf,lpec,pec,pe,ldpe,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldb, ldpe, ldvf, ldx, lh, lpec, m, n, &
            wantb, wantvf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), pe(ldpe,*), vf(ldvf,*)
          Real (Kind=wp), Intent (In) :: h(lh), x(ldx,m), y(n)
          Real (Kind=wp), Intent (Out) :: nep(lh)
          Integer, Intent (In) :: isx(m)
          Character (1), Intent (In) :: pec(lpec)
        End Subroutine g02kbf
      End Interface
      Interface
        Subroutine g02laf(n,mx,x,ldx,isx,ip,my,y,ldy,xbar,ybar,iscale,xstd, &
            ystd,maxfac,xres,ldxres,yres,ldyres,w,ldw,p,ldp,t,ldt,c,ldc,u,ldu, &
            xcv,ycv,ldycv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iscale, ldc, ldp, ldt, ldu, ldw, ldx, &
            ldxres, ldy, ldycv, ldyres, maxfac, mx, my, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,maxfac), p(ldp,maxfac), &
            t(ldt,maxfac), u(ldu,maxfac), w(ldw,maxfac), xres(ldxres,ip), &
            xstd(ip), ycv(ldycv,my), yres(ldyres,my), ystd(my)
          Real (Kind=wp), Intent (In) :: x(ldx,mx), y(ldy,my)
          Real (Kind=wp), Intent (Out) :: xbar(ip), xcv(maxfac), ybar(my)
          Integer, Intent (In) :: isx(mx)
        End Subroutine g02laf
      End Interface
      Interface
        Subroutine g02lbf(n,mx,x,ldx,isx,ip,my,y,ldy,xbar,ybar,iscale,xstd, &
            ystd,maxfac,maxit,tau,xres,ldxres,yres,ldyres,w,ldw,p,ldp,t,ldt,c, &
            ldc,u,ldu,xcv,ycv,ldycv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tau
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iscale, ldc, ldp, ldt, ldu, ldw, ldx, &
            ldxres, ldy, ldycv, ldyres, maxfac, maxit, mx, my, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,maxfac), p(ldp,maxfac), &
            t(ldt,maxfac), u(ldu,maxfac), w(ldw,maxfac), xres(ldxres,ip), &
            xstd(ip), ycv(ldycv,my), yres(ldyres,my), ystd(my)
          Real (Kind=wp), Intent (In) :: x(ldx,mx), y(ldy,my)
          Real (Kind=wp), Intent (Out) :: xbar(ip), xcv(maxfac), ybar(my)
          Integer, Intent (In) :: isx(mx)
        End Subroutine g02lbf
      End Interface
      Interface
        Subroutine g02lcf(ip,my,maxfac,nfact,p,ldp,c,ldc,w,ldw,rcond,b,ldb, &
            orig,xbar,ybar,iscale,xstd,ystd,ob,ldob,vipopt,ycv,ldycv,vip, &
            ldvip,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iscale, ldb, ldc, ldob, ldp, ldvip, ldw, &
            ldycv, maxfac, my, nfact, orig, vipopt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,my), ob(ldob,my), &
            vip(ldvip,vipopt)
          Real (Kind=wp), Intent (In) :: c(ldc,maxfac), p(ldp,maxfac), &
            w(ldw,maxfac), xbar(ip), xstd(ip), ybar(my), ycv(ldycv,my), &
            ystd(my)
        End Subroutine g02lcf
      End Interface
      Interface
        Subroutine g02ldf(ip,my,orig,xbar,ybar,iscale,xstd,ystd,b,ldb,n,mz, &
            isz,z,ldz,yhat,ldyhat,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iscale, ldb, ldyhat, ldz, my, mz, n, &
            orig
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,my), xbar(ip), xstd(ip), &
            ybar(my), ystd(my), z(ldz,mz)
          Real (Kind=wp), Intent (Inout) :: yhat(ldyhat,my)
          Integer, Intent (In) :: isz(mz)
        End Subroutine g02ldf
      End Interface
      Interface
        Subroutine g02qff(n,m,x,y,ntau,tau,df,b,bl,bu,info,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: df
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n, ntau
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(m,ntau), bl(m,ntau), bu(m,ntau)
          Real (Kind=wp), Intent (In) :: tau(ntau), x(n,m), y(n)
          Integer, Intent (Out) :: info(ntau)
        End Subroutine g02qff
      End Interface
      Interface
        Subroutine g02qgf(sorder,intcpt,weight,n,m,dat,lddat,isx,ip,y,wt,ntau, &
            tau,df,b,bl,bu,ch,res,iopts,opts,state,info,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: df
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, lddat, m, n, ntau, sorder
          Character (1), Intent (In) :: intcpt, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ip,ntau), bl(ip,*), bu(ip,*), &
            ch(ip,ip,*), res(n,*)
          Real (Kind=wp), Intent (In) :: dat(lddat,*), opts(*), tau(ntau), &
            wt(*), y(n)
          Integer, Intent (Out) :: info(ntau)
          Integer, Intent (In) :: iopts(*), isx(m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g02qgf
      End Interface
      Interface
        Subroutine g02zkf(optstr,iopts,liopts,opts,lopts,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liopts, lopts
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: opts(lopts)
          Integer, Intent (Inout) :: iopts(liopts)
        End Subroutine g02zkf
      End Interface
      Interface
        Subroutine g02zlf(optstr,ivalue,rvalue,cvalue,optype,iopts,opts,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rvalue
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ivalue, optype
          Character (*), Intent (Out) :: cvalue
          Character (*), Intent (In) :: optstr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: opts(*)
          Integer, Intent (In) :: iopts(*)
        End Subroutine g02zlf
      End Interface
      Interface
        Subroutine g03aaf(matrix,std,weight,n,m,x,ldx,isx,s,wt,nvar,e,lde,p, &
            ldp,v,ldv,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lde, ldp, ldv, ldx, m, n, nvar
          Character (1), Intent (In) :: matrix, std, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: e(lde,6), p(ldp,nvar), s(m), &
            v(ldv,nvar)
          Real (Kind=wp), Intent (In) :: wk(1), wt(*), x(ldx,m)
          Integer, Intent (In) :: isx(m)
        End Subroutine g03aaf
      End Interface
      Interface
        Subroutine g03acf(weight,n,m,x,ldx,isx,nx,ing,ng,wt,nig,cvm,ldcvm,e, &
            lde,ncv,cvx,ldcvx,tol,irankx,wk,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: irankx, ncv
          Integer, Intent (In) :: iwk, ldcvm, ldcvx, lde, ldx, m, n, ng, nx
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cvm(ldcvm,nx), cvx(ldcvx,ng-1), &
            e(lde,6)
          Real (Kind=wp), Intent (Out) :: wk(iwk)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
          Integer, Intent (In) :: ing(n), isx(m)
          Integer, Intent (Out) :: nig(ng)
        End Subroutine g03acf
      End Interface
      Interface
        Subroutine g03adf(weight,n,m,z,ldz,isz,nx,ny,wt,e,lde,ncv,cvx,ldcvx, &
            mcv,cvy,ldcvy,tol,wk,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwk, ldcvx, ldcvy, lde, ldz, m, mcv, n, nx, &
            ny
          Integer, Intent (Out) :: ncv
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cvx(ldcvx,mcv), cvy(ldcvy,mcv), &
            e(lde,6)
          Real (Kind=wp), Intent (Out) :: wk(iwk)
          Real (Kind=wp), Intent (In) :: wt(*), z(ldz,m)
          Integer, Intent (In) :: isz(m)
        End Subroutine g03adf
      End Interface
      Interface
        Subroutine g03baf(stand,g,nvar,k,fl,ldfl,flr,r,ldr,acc,maxit,iter,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: acc, g
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: iter
          Integer, Intent (In) :: k, ldfl, ldr, maxit, nvar
          Character (1), Intent (In) :: stand
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fl(ldfl,k), flr(ldfl,k), r(ldr,k)
          Real (Kind=wp), Intent (Out) :: wk(2*nvar+k*k+5*(k-1))
        End Subroutine g03baf
      End Interface
      Interface
        Subroutine g03bcf(stand,pscale,n,m,x,ldx,y,ldy,yhat,r,ldr,alpha,rss, &
            res,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: alpha, rss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldr, ldx, ldy, m, n
          Character (1), Intent (In) :: pscale, stand
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(ldr,m), x(ldx,m), y(ldy,m), &
            yhat(ldy,m)
          Real (Kind=wp), Intent (Out) :: res(n), wk(m*m+7*m)
        End Subroutine g03bcf
      End Interface
      Interface
        Subroutine g03bdf(stand,n,m,x,ldx,ro,ldro,power,fp,ldfp,r,ldr,phi, &
            ldphi,fs,ldfs,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: power
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfp, ldfs, ldphi, ldr, ldro, ldx, m, n
          Character (1), Intent (In) :: stand
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fp(ldfp,m), fs(ldfs,m), &
            phi(ldphi,m), r(ldr,m)
          Real (Kind=wp), Intent (In) :: ro(ldro,m), x(ldx,m)
        End Subroutine g03bdf
      End Interface
      Interface
        Subroutine g03caf(matrix,weight,n,m,x,ldx,nvar,isx,nfac,wt,e,stat,com, &
            psi,res,fl,ldfl,iop,iwk,wk,lwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfl, ldx, lwk, m, n, nfac, nvar
          Character (1), Intent (In) :: matrix, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: com(nvar), e(nvar), psi(nvar), &
            res(nvar*(nvar-1)/2), stat(4), wk(lwk)
          Real (Kind=wp), Intent (Inout) :: fl(ldfl,nfac)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
          Integer, Intent (In) :: iop(5), isx(m)
          Integer, Intent (Out) :: iwk(4*nvar+2)
        End Subroutine g03caf
      End Interface
      Interface
        Subroutine g03ccf(method,rotate,nvar,nfac,fl,ldfl,psi,e,r,ldr,fs,ldfs, &
            wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldfl, ldfs, ldr, nfac, nvar
          Character (1), Intent (In) :: method, rotate
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: e(nvar), fl(ldfl,nfac), psi(nvar), &
            r(ldr,*)
          Real (Kind=wp), Intent (Inout) :: fs(ldfs,nfac)
          Real (Kind=wp), Intent (Out) :: wk(nvar)
        End Subroutine g03ccf
      End Interface
      Interface
        Subroutine g03daf(weight,n,m,x,ldx,isx,nvar,ing,ng,wt,nig,gmn,ldgmn, &
            det,gc,stat,df,sig,wk,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: df, sig, stat
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldgmn, ldx, m, n, ng, nvar
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: det(ng), gc((ng+1)*nvar*(nvar+1)/2), &
            wk(n*(nvar+1))
          Real (Kind=wp), Intent (Inout) :: gmn(ldgmn,nvar)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
          Integer, Intent (In) :: ing(n), isx(m)
          Integer, Intent (Out) :: iwk(ng), nig(ng)
        End Subroutine g03daf
      End Interface
      Interface
        Subroutine g03dbf(equal,mode,nvar,ng,gmn,ldgmn,gc,nobs,m,isx,x,ldx,d, &
            ldd,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldd, ldgmn, ldx, m, ng, nobs, nvar
          Character (1), Intent (In) :: equal, mode
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(ldd,ng)
          Real (Kind=wp), Intent (In) :: gc((ng+1)*nvar*(nvar+1)/2), &
            gmn(ldgmn,nvar), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: wk(2*nvar)
          Integer, Intent (In) :: isx(*)
        End Subroutine g03dbf
      End Interface
      Interface
        Subroutine g03dcf(typ,equal,priors,nvar,ng,nig,gmn,ldgmn,gc,det,nobs, &
            m,isx,x,ldx,prior,p,ldp,iag,atiq,ati,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldgmn, ldp, ldx, m, ng, nobs, nvar
          Logical, Intent (In) :: atiq
          Character (1), Intent (In) :: equal, priors, typ
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ati(ldp,*), p(ldp,ng), prior(ng)
          Real (Kind=wp), Intent (In) :: det(ng), gc((ng+1)*nvar*(nvar+1)/2), &
            gmn(ldgmn,nvar), x(ldx,m)
          Real (Kind=wp), Intent (Out) :: wk(2*nvar)
          Integer, Intent (Out) :: iag(nobs)
          Integer, Intent (In) :: isx(m), nig(ng)
        End Subroutine g03dcf
      End Interface
      Interface
        Subroutine g03eaf(update,dist,scal,n,m,x,ldx,isx,s,d,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n
          Character (1), Intent (In) :: dist, scal, update
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(n*(n-1)/2), s(m)
          Real (Kind=wp), Intent (In) :: x(ldx,m)
          Integer, Intent (In) :: isx(m)
        End Subroutine g03eaf
      End Interface
      Interface
        Subroutine g03ecf(method,n,d,ilc,iuc,cd,iord,dord,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: method, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: cd(n-1), dord(n)
          Real (Kind=wp), Intent (Inout) :: d(n*(n-1)/2)
          Integer, Intent (Out) :: ilc(n-1), iord(n), iuc(n-1), iwk(2*n)
        End Subroutine g03ecf
      End Interface
      Interface
        Subroutine g03eff(weight,n,m,x,ldx,isx,nvar,k,cmeans,ldc,wt,inc,nic, &
            css,csw,maxit,iwk,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldc, ldx, m, maxit, n, nvar
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cmeans(ldc,nvar)
          Real (Kind=wp), Intent (Out) :: css(k), csw(k), wk(n+2*k)
          Real (Kind=wp), Intent (In) :: wt(*), x(ldx,m)
          Integer, Intent (Out) :: inc(n), iwk(n+3*k), nic(k)
          Integer, Intent (In) :: isx(m)
        End Subroutine g03eff
      End Interface
      Interface
        Subroutine g03ehf(orient,n,dord,dmin,dstep,nsym,c,lenc,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: dmin, dstep
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lenc, n, nsym
          Character (1), Intent (In) :: orient
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: dord(n)
          Character (*), Intent (Out) :: c(lenc)
        End Subroutine g03ehf
      End Interface
      Interface
        Subroutine g03ejf(n,cd,iord,dord,k,dlevel,ic,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: dlevel
          Integer, Intent (Inout) :: ifail, k
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: cd(n-1), dord(n)
          Integer, Intent (Out) :: ic(n)
          Integer, Intent (In) :: iord(n)
        End Subroutine g03ejf
      End Interface
      Interface
        Subroutine g03faf(roots,n,d,ndim,x,ldx,eval,wk,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, n, ndim
          Character (1), Intent (In) :: roots
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(n*(n-1)/2)
          Real (Kind=wp), Intent (Out) :: eval(n), wk(n*(n+17)/2-1)
          Real (Kind=wp), Intent (Inout) :: x(ldx,ndim)
          Integer, Intent (Out) :: iwk(5*n)
        End Subroutine g03faf
      End Interface
      Interface
        Subroutine g03fcf(typ,n,ndim,d,x,ldx,stress,dfit,iter,iopt,wk,iwk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: stress
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iopt, iter, ldx, n, ndim
          Character (1), Intent (In) :: typ
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(n*(n-1)/2)
          Real (Kind=wp), Intent (Out) :: dfit(2*n*(n-1)), wk(15*n*ndim)
          Real (Kind=wp), Intent (Inout) :: x(ldx,ndim)
          Integer, Intent (Out) :: iwk(n*(n-1)/2+n*ndim+5)
        End Subroutine g03fcf
      End Interface
      Interface
        Subroutine g03zaf(n,m,x,ldx,nvar,isx,s,e,z,ldz,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, ldz, m, n, nvar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: e(m), s(m), x(ldx,m)
          Real (Kind=wp), Intent (Inout) :: z(ldz,nvar)
          Integer, Intent (In) :: isx(m)
        End Subroutine g03zaf
      End Interface
      Interface
        Subroutine g04agf(y,n,k,lsub,nobs,l,ngp,gbar,sgbar,gm,ss,idf,f,fp, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: gm
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, l, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: f(2), fp(2), gbar(k), sgbar(l), &
            ss(4)
          Real (Kind=wp), Intent (In) :: y(n)
          Integer, Intent (Out) :: idf(4), ngp(k)
          Integer, Intent (In) :: lsub(k), nobs(l)
        End Subroutine g04agf
      End Interface
      Interface
        Subroutine g04bbf(n,y,iblock,nt,it,gmean,bmean,tmean,tabl,ldtabl,c, &
            ldc,irep,r,ef,tol,irdf,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: gmean
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: iblock, irdf, ldc, ldtabl, n, nt
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: bmean(abs(iblock)), ef(nt), r(n), &
            tmean(nt), wk(3*nt)
          Real (Kind=wp), Intent (Inout) :: c(ldc,nt), tabl(ldtabl,5)
          Real (Kind=wp), Intent (In) :: y(n)
          Integer, Intent (Out) :: irep(nt)
          Integer, Intent (In) :: it(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: abs
        End Subroutine g04bbf
      End Interface
      Interface
        Subroutine g04bcf(nrep,nrow,ncol,y,nt,it,gmean,tmean,tabl,ldtabl,c, &
            ldc,irep,rpmean,rmean,cmean,r,ef,tol,irdf,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: gmean
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: irdf, ldc, ldtabl, ncol, nrep, nrow, nt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,nt), tabl(ldtabl,5)
          Real (Kind=wp), Intent (Out) :: cmean(nrep*ncol), ef(nt), &
            r(nrep*nrow*ncol), rmean(nrep*nrow), rpmean(nrep), tmean(nt), &
            wk(3*nt)
          Real (Kind=wp), Intent (In) :: y(nrep*nrow*ncol)
          Integer, Intent (Out) :: irep(nt)
          Integer, Intent (In) :: it(*)
        End Subroutine g04bcf
      End Interface
      Interface
        Subroutine g04caf(n,y,nfac,lfac,nblock,inter,irdf,mterm,table,itotal, &
            tmean,maxt,e,imean,semean,bmean,r,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: inter, irdf, maxt, mterm, n, nblock, nfac
          Integer, Intent (Out) :: itotal
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: bmean(nblock+1), e(maxt), r(n), &
            semean(mterm), table(mterm,5), tmean(maxt)
          Real (Kind=wp), Intent (In) :: y(n)
          Integer, Intent (Out) :: imean(mterm), iwk(n+3*nfac)
          Integer, Intent (In) :: lfac(nfac)
        End Subroutine g04caf
      End Interface
      Interface
        Subroutine g04daf(nt,tmean,irep,rms,rdf,nc,ct,ldct,est,tabl,ldtabl, &
            tol,usetx,tx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rdf, rms, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldct, ldtabl, nc, nt
          Logical, Intent (In) :: usetx
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ct(ldct,nc), tmean(nt), tx(nt)
          Real (Kind=wp), Intent (Out) :: est(nc)
          Real (Kind=wp), Intent (Inout) :: tabl(ldtabl,*)
          Integer, Intent (In) :: irep(nt)
        End Subroutine g04daf
      End Interface
      Interface
        Subroutine g04dbf(typ,nt,tmean,rdf,c,ldc,clevel,cil,ciu,isig,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel, rdf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, nt
          Character (1), Intent (In) :: typ
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,nt), tmean(nt)
          Real (Kind=wp), Intent (Out) :: cil(nt*(nt-1)/2), ciu(nt*(nt-1)/2)
          Integer, Intent (Out) :: isig(nt*(nt-1)/2)
        End Subroutine g04dbf
      End Interface
      Interface
        Subroutine g04eaf(typ,n,levels,ifact,x,ldx,v,rep,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, levels, n
          Character (1), Intent (In) :: typ
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rep(levels)
          Real (Kind=wp), Intent (In) :: v(*)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ifact(n)
        End Subroutine g04eaf
      End Interface
      Interface
        Subroutine g05hkf(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,rvec,igen, &
            iseed,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, num
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: rvec(40), rwsav(9)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05hkf
      End Interface
      Interface
        Subroutine g05hlf(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,rvec,igen, &
            iseed,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, num
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: rvec(40), rwsav(9)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05hlf
      End Interface
      Interface
        Subroutine g05hmf(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,rvec,igen, &
            iseed,rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df, gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, num
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: rvec(40), rwsav(9)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05hmf
      End Interface
      Interface
        Subroutine g05hnf(dist,num,ip,iq,theta,df,ht,et,fcall,rvec,igen,iseed, &
            rwsav,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: df
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, num
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: rvec(40), rwsav(9)
          Real (Kind=wp), Intent (In) :: theta(2*iq+ip+1)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05hnf
      End Interface
      Interface
        Function g05kaf(igen,iseed)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g05kaf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: igen
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iseed(4)
        End Function g05kaf
      End Interface
      Interface
        Subroutine g05kbf(igen,iseed)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: igen
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05kbf
      End Interface
      Interface
        Subroutine g05kcf(igen,iseed)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: igen
!         .. Array Arguments ..
          Integer, Intent (Out) :: iseed(4)
        End Subroutine g05kcf
      End Interface
      Interface
        Function g05kef(p,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: g05kef
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iseed(4)
        End Function g05kef
      End Interface
      Interface
        Subroutine g05kff(genid,subid,seed,lseed,state,lstate,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: genid, lseed, subid
          Integer, Intent (Inout) :: ifail, lstate
!         .. Array Arguments ..
          Integer, Intent (In) :: seed(lseed)
          Integer, Intent (Inout) :: state(lstate)
        End Subroutine g05kff
      End Interface
      Interface
        Subroutine g05kgf(genid,subid,state,lstate,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: genid, subid
          Integer, Intent (Inout) :: ifail, lstate
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(lstate)
        End Subroutine g05kgf
      End Interface
      Interface
        Subroutine g05khf(n,k,state,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05khf
      End Interface
      Interface
        Subroutine g05kjf(n,state,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05kjf
      End Interface
      Interface
        Subroutine g05kkf(n,state,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05kkf
      End Interface
      Interface
        Subroutine g05laf(xmu,var,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: var, xmu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05laf
      End Interface
      Interface
        Subroutine g05lbf(df,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, igen, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lbf
      End Interface
      Interface
        Subroutine g05lcf(df,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, igen, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lcf
      End Interface
      Interface
        Subroutine g05ldf(df1,df2,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df1, df2, igen, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05ldf
      End Interface
      Interface
        Subroutine g05lef(a,b,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lef
      End Interface
      Interface
        Subroutine g05lff(a,b,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lff
      End Interface
      Interface
        Subroutine g05lgf(a,b,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lgf
      End Interface
      Interface
        Subroutine g05lhf(xmin,xmax,xmed,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmed, xmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lhf
      End Interface
      Interface
        Subroutine g05ljf(a,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05ljf
      End Interface
      Interface
        Subroutine g05lkf(xmu,var,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: var, xmu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lkf
      End Interface
      Interface
        Subroutine g05llf(xmed,semiqr,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: semiqr, xmed
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05llf
      End Interface
      Interface
        Subroutine g05lmf(a,b,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lmf
      End Interface
      Interface
        Subroutine g05lnf(a,b,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lnf
      End Interface
      Interface
        Subroutine g05lpf(vk,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: vk
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lpf
      End Interface
      Interface
        Subroutine g05lqf(nmix,a,wgt,n,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n, nmix
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nmix)
          Real (Kind=wp), Intent (Inout) :: wgt(nmix)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lqf
      End Interface
      Interface
        Subroutine g05lxf(mode,df,m,xmu,c,ldc,n,x,ldx,igen,iseed,r,lr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, igen, ldc, ldx, lr, m, mode, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m), xmu(m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lxf
      End Interface
      Interface
        Subroutine g05lyf(mode,m,xmu,c,ldc,n,x,ldx,igen,iseed,r,lr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ldc, ldx, lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m), xmu(m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lyf
      End Interface
      Interface
        Subroutine g05lzf(mode,n,xmu,c,ldc,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ldc, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,n), xmu(n)
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05lzf
      End Interface
      Interface
        Subroutine g05maf(a,b,n,x,igen,iseed,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: a, b, igen, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05maf
      End Interface
      Interface
        Subroutine g05mbf(mode,p,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mbf
      End Interface
      Interface
        Subroutine g05mcf(mode,m,p,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, m, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mcf
      End Interface
      Interface
        Subroutine g05mdf(mode,a,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mdf
      End Interface
      Interface
        Subroutine g05mef(m,vlamda,x,igen,iseed,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: vlamda(m)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(m)
        End Subroutine g05mef
      End Interface
      Interface
        Subroutine g05mjf(mode,m,p,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, m, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mjf
      End Interface
      Interface
        Subroutine g05mkf(mode,lambda,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: lambda
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mkf
      End Interface
      Interface
        Subroutine g05mlf(mode,ns,np,m,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, m, mode, n, np, nr, ns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mlf
      End Interface
      Interface
        Subroutine g05mrf(mode,m,k,p,n,x,ldx,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, k, ldx, m, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(k)
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4), x(ldx,k)
        End Subroutine g05mrf
      End Interface
      Interface
        Subroutine g05mzf(mode,p,np,ip1,itype,n,x,igen,iseed,r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip1, itype, mode, n, np, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(np)
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05mzf
      End Interface
      Interface
        Subroutine g05naf(index,n,igen,iseed,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: index(n), iseed(4)
        End Subroutine g05naf
      End Interface
      Interface
        Subroutine g05nbf(ipop,n,isampl,m,igen,iseed,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, m, n
!         .. Array Arguments ..
          Integer, Intent (In) :: ipop(n)
          Integer, Intent (Out) :: isampl(m)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05nbf
      End Interface
      Interface
        Subroutine g05ncf(indx,n,state,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: indx(n), state(*)
        End Subroutine g05ncf
      End Interface
      Interface
        Subroutine g05ndf(ipop,n,isampl,m,state,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
!         .. Array Arguments ..
          Integer, Intent (In) :: ipop(n)
          Integer, Intent (Out) :: isampl(m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05ndf
      End Interface
      Interface
        Subroutine g05nef(order,wt,pop,ipop,n,isampl,m,state,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: order, pop
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: wt(n)
          Integer, Intent (In) :: ipop(*)
          Integer, Intent (Out) :: isampl(m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05nef
      End Interface
      Interface
        Subroutine g05paf(mode,xmean,ip,phi,iq,theta,avar,var,n,x,igen,iseed, &
            r,nr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: avar, xmean
          Real (Kind=wp), Intent (Out) :: var
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: phi(ip), theta(iq)
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05paf
      End Interface
      Interface
        Subroutine g05pcf(mode,k,xmean,ip,phi,iq,theta,var,ldvar,n,x,igen, &
            iseed,r,nr,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ip, iq, k, ldvar, liwork, mode, n, nr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: phi(ip*k*k), theta(iq*k*k), xmean(k)
          Real (Kind=wp), Intent (Inout) :: r(nr), var(ldvar,k), x(ldvar,n)
          Integer, Intent (Inout) :: iseed(4)
          Integer, Intent (Out) :: iwork(liwork)
        End Subroutine g05pcf
      End Interface
      Interface
        Subroutine g05pdf(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,r,lr, &
            state,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (In) :: df, ip, iq, lr, num
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pdf
      End Interface
      Interface
        Subroutine g05pef(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,r,lr, &
            state,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (In) :: df, ip, iq, lr, num
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pef
      End Interface
      Interface
        Subroutine g05pff(dist,num,ip,iq,theta,gamma,df,ht,et,fcall,r,lr, &
            state,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (In) :: df, ip, iq, lr, num
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Real (Kind=wp), Intent (In) :: theta(iq+ip+1)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pff
      End Interface
      Interface
        Subroutine g05pgf(dist,num,ip,iq,theta,df,ht,et,fcall,r,lr,state, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, ip, iq, lr, num
          Integer, Intent (Inout) :: ifail
          Logical, Intent (In) :: fcall
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: et(num), ht(num)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Real (Kind=wp), Intent (In) :: theta(2*iq+ip+1)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pgf
      End Interface
      Interface
        Subroutine g05phf(mode,n,xmean,ip,phi,iq,theta,avar,r,lr,state,var,x, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: avar, xmean
          Real (Kind=wp), Intent (Out) :: var
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: phi(ip), theta(iq)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05phf
      End Interface
      Interface
        Subroutine g05pjf(mode,n,k,xmean,ip,phi,iq,theta,var,ldvar,r,lr,state, &
            x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, k, ldvar, ldx, lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: phi(k*k*ip), theta(k*k*iq), &
            var(ldvar,k), xmean(k)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pjf
      End Interface
      Interface
        Subroutine g05pmf(mode,n,itype,p,param,init,var,r,state,e,en,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: var
          Integer, Intent (In) :: en, itype, mode, n, p
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: e(en), init(*), param(*)
          Real (Kind=wp), Intent (Inout) :: r(*)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pmf
      End Interface
      Interface
        Subroutine g05pxf(side,init,m,n,state,a,lda,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: init, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pxf
      End Interface
      Interface
        Subroutine g05pyf(n,d,eps,state,c,ldc,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,n)
          Real (Kind=wp), Intent (In) :: d(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05pyf
      End Interface
      Interface
        Subroutine g05pzf(mode,nrow,ncol,totr,totc,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, lr, mode, ncol, nrow
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*), x(ldx,ncol)
          Integer, Intent (In) :: totc(ncol), totr(nrow)
        End Subroutine g05pzf
      End Interface
      Interface
        Subroutine g05qaf(side,init,m,n,a,lda,igen,iseed,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, lda, m, n
          Character (1), Intent (In) :: init, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,n), wk(*)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05qaf
      End Interface
      Interface
        Subroutine g05qbf(n,d,c,ldc,eps,igen,iseed,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: eps
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ldc, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,n)
          Real (Kind=wp), Intent (In) :: d(n)
          Real (Kind=wp), Intent (Out) :: wk(2*n)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05qbf
      End Interface
      Interface
        Subroutine g05qdf(mode,nrow,ncol,totr,totc,x,ldx,igen,iseed,r,nr,iw, &
            liw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ldx, liw, mode, ncol, nr, nrow
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(nr)
          Integer, Intent (Inout) :: iseed(4), x(ldx,ncol)
          Integer, Intent (Out) :: iw(liw)
          Integer, Intent (In) :: totc(ncol), totr(nrow)
        End Subroutine g05qdf
      End Interface
      Interface
        Subroutine g05raf(mode,m,c,ldc,n,x,ldx,igen,iseed,r,lr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: igen, ldc, ldx, lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05raf
      End Interface
      Interface
        Subroutine g05rbf(mode,df,m,c,ldc,n,x,ldx,igen,iseed,r,lr,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, igen, ldc, ldx, lr, m, mode, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: iseed(4)
        End Subroutine g05rbf
      End Interface
      Interface
        Subroutine g05rcf(mode,n,df,m,c,ldc,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, ldc, ldx, lr, m, mode, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rcf
      End Interface
      Interface
        Subroutine g05rdf(mode,n,m,c,ldc,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, ldx, lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rdf
      End Interface
      Interface
        Subroutine g05ref(n,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05ref
      End Interface
      Interface
        Subroutine g05rff(n,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rff
      End Interface
      Interface
        Subroutine g05rgf(n,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rgf
      End Interface
      Interface
        Subroutine g05rhf(n,m,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rhf
      End Interface
      Interface
        Subroutine g05rjf(n,m,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rjf
      End Interface
      Interface
        Subroutine g05rkf(n,m,theta,sorder,state,x,ldx,sdx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n, sdx, sorder
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: x(ldx,sdx)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rkf
      End Interface
      Interface
        Subroutine g05ryf(mode,n,df,m,xmu,c,ldc,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, ldc, ldx, lr, m, mode, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m), xmu(m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05ryf
      End Interface
      Interface
        Subroutine g05rzf(mode,n,m,xmu,c,ldc,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, ldx, lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc,m), xmu(m)
          Real (Kind=wp), Intent (Inout) :: r(lr), x(ldx,m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05rzf
      End Interface
      Interface
        Subroutine g05saf(n,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05saf
      End Interface
      Interface
        Subroutine g05sbf(n,a,b,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sbf
      End Interface
      Interface
        Subroutine g05scf(n,xmed,semiqr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: semiqr, xmed
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05scf
      End Interface
      Interface
        Subroutine g05sdf(n,df,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sdf
      End Interface
      Interface
        Subroutine g05sef(n,m,a,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldx, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(m)
          Real (Kind=wp), Intent (Inout) :: x(ldx,m)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sef
      End Interface
      Interface
        Subroutine g05sff(n,a,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sff
      End Interface
      Interface
        Subroutine g05sgf(n,nmix,a,wgt,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, nmix
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(nmix), wgt(nmix)
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sgf
      End Interface
      Interface
        Subroutine g05shf(n,df1,df2,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df1, df2, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05shf
      End Interface
      Interface
        Subroutine g05sjf(n,a,b,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sjf
      End Interface
      Interface
        Subroutine g05skf(n,xmu,var,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: var, xmu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05skf
      End Interface
      Interface
        Subroutine g05slf(n,a,b,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05slf
      End Interface
      Interface
        Subroutine g05smf(n,xmu,var,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: var, xmu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05smf
      End Interface
      Interface
        Subroutine g05snf(n,df,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: df, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05snf
      End Interface
      Interface
        Subroutine g05spf(n,xmin,xmed,xmax,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xmax, xmed, xmin
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05spf
      End Interface
      Interface
        Subroutine g05sqf(n,a,b,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05sqf
      End Interface
      Interface
        Subroutine g05srf(n,vk,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: vk
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05srf
      End Interface
      Interface
        Subroutine g05ssf(n,a,b,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a, b
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: x(n)
          Integer, Intent (Inout) :: state(*)
        End Subroutine g05ssf
      End Interface
      Interface
        Subroutine g05taf(mode,n,m,p,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05taf
      End Interface
      Interface
        Subroutine g05tbf(n,p,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(*)
          Logical, Intent (Out) :: x(n)
        End Subroutine g05tbf
      End Interface
      Interface
        Subroutine g05tcf(mode,n,p,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tcf
      End Interface
      Interface
        Subroutine g05tdf(mode,n,p,np,ip1,itype,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip1, itype, lr, mode, n, np
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(np)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tdf
      End Interface
      Interface
        Subroutine g05tef(mode,n,ns,np,m,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, m, mode, n, np, ns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tef
      End Interface
      Interface
        Subroutine g05tff(mode,n,a,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: a
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tff
      End Interface
      Interface
        Subroutine g05tgf(mode,n,m,k,p,r,lr,state,x,ldx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldx, lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: p(k)
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*), x(ldx,k)
        End Subroutine g05tgf
      End Interface
      Interface
        Subroutine g05thf(mode,n,m,p,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, m, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05thf
      End Interface
      Interface
        Subroutine g05tjf(mode,n,lambda,r,lr,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: lambda
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lr, mode, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(lr)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tjf
      End Interface
      Interface
        Subroutine g05tkf(m,vlamda,state,x,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: vlamda(m)
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(m)
        End Subroutine g05tkf
      End Interface
      Interface
        Subroutine g05tlf(n,a,b,state,x,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: a, b, n
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Inout) :: state(*)
          Integer, Intent (Out) :: x(n)
        End Subroutine g05tlf
      End Interface
      Interface
        Subroutine g05ycf(idim,iref,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: idim
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Out) :: iref(406)
        End Subroutine g05ycf
      End Interface
      Interface
        Subroutine g05ydf(n,quasi,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quasi(n,*)
          Integer, Intent (Inout) :: iref(406)
        End Subroutine g05ydf
      End Interface
      Interface
        Subroutine g05yef(idim,iref,iskip,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: idim, iskip
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Out) :: iref(2000)
        End Subroutine g05yef
      End Interface
      Interface
        Subroutine g05yff(n,quasi,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quasi(n,*)
          Integer, Intent (Inout) :: iref(2000)
        End Subroutine g05yff
      End Interface
      Interface
        Subroutine g05ygf(idim,iref,iskip,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: idim, iskip
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Out) :: iref(2000)
        End Subroutine g05ygf
      End Interface
      Interface
        Subroutine g05yhf(n,quasi,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quasi(n,*)
          Integer, Intent (Inout) :: iref(2000)
        End Subroutine g05yhf
      End Interface
      Interface
        Subroutine g05yjf(xmean,std,n,quas,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quas(n,*)
          Real (Kind=wp), Intent (In) :: std(*), xmean(*)
          Integer, Intent (Inout) :: iref(*)
        End Subroutine g05yjf
      End Interface
      Interface
        Subroutine g05ykf(xmean,std,n,quas,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quas(n,*)
          Real (Kind=wp), Intent (In) :: std(*), xmean(*)
          Integer, Intent (Inout) :: iref(*)
        End Subroutine g05ykf
      End Interface
      Interface
        Subroutine g05ylf(genid,idim,iref,liref,iskip,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: genid, idim, iskip, liref
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iref(liref)
        End Subroutine g05ylf
      End Interface
      Interface
        Subroutine g05ymf(n,rcord,quas,ldquas,iref,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldquas, n, rcord
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: quas(ldquas,*)
          Integer, Intent (Inout) :: iref(*)
        End Subroutine g05ymf
      End Interface
      Interface
        Subroutine g05ynf(genid,stype,idim,iref,liref,iskip,nsdigi,state, &
            ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: genid, idim, iskip, liref, nsdigi, stype
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iref(liref), state(*)
        End Subroutine g05ynf
      End Interface
      Interface
        Subroutine g05zbf(m,n,t,a,lda,b,ldb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: t
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldb, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine g05zbf
      End Interface
      Interface
        Subroutine g07aaf(n,k,clevel,pl,pu,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel
          Real (Kind=wp), Intent (Out) :: pl, pu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, n
        End Subroutine g07aaf
      End Interface
      Interface
        Subroutine g07abf(n,xmean,clevel,tl,tu,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel, xmean
          Real (Kind=wp), Intent (Out) :: tl, tu
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
        End Subroutine g07abf
      End Interface
      Interface
        Subroutine g07bbf(method,n,x,xc,ic,xmu,xsig,tol,maxit,sexmu,sexsig, &
            corr,dev,nobs,nit,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: corr, dev, sexmu, sexsig
          Real (Kind=wp), Intent (In) :: tol
          Real (Kind=wp), Intent (Inout) :: xmu, xsig
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit, n
          Integer, Intent (Out) :: nit
          Character (1), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wk(2*n)
          Real (Kind=wp), Intent (In) :: x(n), xc(n)
          Integer, Intent (In) :: ic(n)
          Integer, Intent (Out) :: nobs(4)
        End Subroutine g07bbf
      End Interface
      Interface
        Subroutine g07bef(cens,n,x,ic,beta,gamma,tol,maxit,sebeta,segam,corr, &
            dev,nit,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: beta, corr, dev, sebeta, segam
          Real (Kind=wp), Intent (Inout) :: gamma
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxit, n
          Integer, Intent (Out) :: nit
          Character (1), Intent (In) :: cens
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wk(n)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (In) :: ic(*)
        End Subroutine g07bef
      End Interface
      Interface
        Subroutine g07bff(n,y,optopt,xi,beta,asvc,obsvc,ll,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: beta, ll, xi
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, optopt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: asvc(4), obsvc(4)
          Real (Kind=wp), Intent (In) :: y(n)
        End Subroutine g07bff
      End Interface
      Interface
        Subroutine g07caf(tail,equal,nx,ny,xmean,ymean,xstd,ystd,clevel,t,df, &
            prob,dl,du,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel, xmean, xstd, ymean, ystd
          Real (Kind=wp), Intent (Out) :: df, dl, du, prob, t
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nx, ny
          Character (1), Intent (In) :: equal, tail
        End Subroutine g07caf
      End Interface
      Interface
        Subroutine g07daf(n,x,y,xme,xmd,xsd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: xmd, xme, xsd
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(n)
          Real (Kind=wp), Intent (Out) :: y(n)
        End Subroutine g07daf
      End Interface
      Interface
        Subroutine g07dbf(isigma,n,x,ipsi,c,h1,h2,h3,dchi,theta,sigma,maxit, &
            tol,rs,nit,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, dchi, h1, h2, h3, tol
          Real (Kind=wp), Intent (Inout) :: sigma, theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ipsi, isigma, maxit, n
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rs(n), wrk(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g07dbf
      End Interface
      Interface
        Subroutine g07dcf(chi,psi,isigma,n,x,beta,theta,sigma,maxit,tol,rs, &
            nit,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: beta, tol
          Real (Kind=wp), Intent (Inout) :: sigma, theta
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: isigma, maxit, n
          Integer, Intent (Out) :: nit
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rs(n), wrk(n)
          Real (Kind=wp), Intent (In) :: x(n)
!         .. Interface Blocks ..
          Interface
            Function chi(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: chi
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function chi
          End Interface
          Interface
            Function psi(t)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: psi
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: t
            End Function psi
          End Interface
        End Subroutine g07dcf
      End Interface
      Interface
        Subroutine g07ddf(n,x,alpha,tmean,wmean,tvar,wvar,k,sx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Real (Kind=wp), Intent (Out) :: tmean, tvar, wmean, wvar
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: k
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: sx(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g07ddf
      End Interface
      Interface
        Subroutine g07eaf(method,n,x,clevel,theta,thetal,thetau,estcl,wlower, &
            wupper,wrk,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel
          Real (Kind=wp), Intent (Out) :: estcl, theta, thetal, thetau, &
            wlower, wupper
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wrk(4*n)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Out) :: iwrk(3*n)
        End Subroutine g07eaf
      End Interface
      Interface
        Subroutine g07ebf(method,n,x,m,y,clevel,theta,thetal,thetau,estcl, &
            ulower,uupper,wrk,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: clevel
          Real (Kind=wp), Intent (Out) :: estcl, theta, thetal, thetau, &
            ulower, uupper
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: method
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wrk(3*(m+n))
          Real (Kind=wp), Intent (In) :: x(n), y(m)
          Integer, Intent (Out) :: iwrk(3*n)
        End Subroutine g07ebf
      End Interface
      Interface
        Subroutine g07gaf(n,p,y,mean,var,iout,niout,ldiff,diff,llamb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: mean, var
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldiff, n, p
          Integer, Intent (Out) :: niout
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: diff(ldiff), llamb(ldiff)
          Real (Kind=wp), Intent (In) :: y(n)
          Integer, Intent (Out) :: iout(n)
        End Subroutine g07gaf
      End Interface
      Interface
        Function g07gbf(n,e,var1,var2,x,lx,ux,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: g07gbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: e, var1, var2
          Real (Kind=wp), Intent (Out) :: lx, ux, x
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
        End Function g07gbf
      End Interface
      Interface
        Subroutine g08aaf(x,y,n,isgn,n1,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: isgn, n1
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(n), y(n)
        End Subroutine g08aaf
      End Interface
      Interface
        Subroutine g08acf(x,n,n1,w,i1,i2,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Integer, Intent (Out) :: i1, i2
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, n1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: w(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g08acf
      End Interface
      Interface
        Subroutine g08aef(x,ldx,k,n,w1,w2,fr,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: fr, p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: w1(k), w2(k)
          Real (Kind=wp), Intent (In) :: x(ldx,n)
        End Subroutine g08aef
      End Interface
      Interface
        Subroutine g08aff(x,lx,l,k,w,h,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: h, p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, lx
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: w(lx)
          Real (Kind=wp), Intent (In) :: x(lx)
          Integer, Intent (In) :: l(k)
        End Subroutine g08aff
      End Interface
      Interface
        Subroutine g08agf(n,x,xme,tail,zer,w,wnor,p,n1,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p, w, wnor
          Real (Kind=wp), Intent (In) :: xme
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Integer, Intent (Out) :: n1
          Character (1), Intent (In) :: tail, zer
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wrk(3*n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g08agf
      End Interface
      Interface
        Subroutine g08ahf(n1,x,n2,y,tail,u,unor,p,ties,ranks,wrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p, u, unor
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n1, n2
          Logical, Intent (Out) :: ties
          Character (1), Intent (In) :: tail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ranks(n1+n2), wrk(n1+n2)
          Real (Kind=wp), Intent (In) :: x(n1), y(n2)
        End Subroutine g08ahf
      End Interface
      Interface
        Subroutine g08ajf(n1,n2,tail,u,p,wrk,lwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Real (Kind=wp), Intent (In) :: u
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lwrk, n1, n2
          Character (1), Intent (In) :: tail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: wrk(lwrk)
        End Subroutine g08ajf
      End Interface
      Interface
        Subroutine g08akf(n1,n2,tail,ranks,u,p,wrk,lwrk,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p
          Real (Kind=wp), Intent (In) :: u
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lwrk, n1, n2
          Character (1), Intent (In) :: tail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ranks(n1+n2)
          Real (Kind=wp), Intent (Out) :: wrk(lwrk)
          Integer, Intent (Out) :: iwrk(2*(n1+n2+1))
        End Subroutine g08akf
      End Interface
      Interface
        Subroutine g08alf(n,k,x,ldx,q,prob,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: prob, q
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(ldx,k)
        End Subroutine g08alf
      End Interface
      Interface
        Subroutine g08baf(x,n,n1,r,itest,w,v,pw,pv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pv, pw, v, w
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itest, n, n1
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: r(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g08baf
      End Interface
      Interface
        Subroutine g08cbf(n,x,dist,par,estima,ntype,d,z,p,sx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d, p, z
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, ntype
          Character (*), Intent (In) :: dist
          Character (1), Intent (In) :: estima
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: par(2)
          Real (Kind=wp), Intent (Out) :: sx(n)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g08cbf
      End Interface
      Interface
        Subroutine g08ccf(n,x,cdf,ntype,d,z,p,sx,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d, p, z
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, ntype
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: sx(n)
          Real (Kind=wp), Intent (In) :: x(n)
!         .. Interface Blocks ..
          Interface
            Function cdf(x)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Real (Kind=wp) :: cdf
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: x
            End Function cdf
          End Interface
        End Subroutine g08ccf
      End Interface
      Interface
        Subroutine g08cdf(n1,x,n2,y,ntype,d,z,p,sx,sy,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d, p, z
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n1, n2, ntype
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: sx(n1), sy(n2)
          Real (Kind=wp), Intent (In) :: x(n1), y(n2)
        End Subroutine g08cdf
      End Interface
      Interface
        Subroutine g08cgf(nclass,ifreq,cb,dist,par,npest,prob,chisq,p,ndf, &
            eval,chisqi,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chisq, p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nclass, npest
          Integer, Intent (Out) :: ndf
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: cb(nclass-1), par(2), prob(nclass)
          Real (Kind=wp), Intent (Out) :: chisqi(nclass), eval(nclass)
          Integer, Intent (In) :: ifreq(nclass)
        End Subroutine g08cgf
      End Interface
      Interface
        Function g08chf(n,issort,y,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: g08chf
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: issort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: y(n)
        End Function g08chf
      End Interface
      Interface
        Subroutine g08cjf(n,issort,y,a2,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: a2, p
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: issort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: y(n)
        End Subroutine g08cjf
      End Interface
      Interface
        Subroutine g08ckf(n,issort,y,ybar,yvar,a2,aa2,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: a2, aa2, p, ybar, yvar
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: issort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: y(n)
        End Subroutine g08ckf
      End Interface
      Interface
        Subroutine g08clf(n,issort,y,ybar,a2,aa2,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: a2, aa2, p, ybar
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Logical, Intent (In) :: issort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: y(n)
        End Subroutine g08clf
      End Interface
      Interface
        Subroutine g08daf(x,ldx,k,n,rnk,w,p,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p, w
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, ldx, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rnk(ldx,n)
          Real (Kind=wp), Intent (In) :: x(ldx,n)
        End Subroutine g08daf
      End Interface
      Interface
        Subroutine g08eaf(cl,n,x,m,maxr,nruns,ncount,ex,cov,ldcov,chi,df,prob, &
            wrk,lwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, df, prob
          Integer, Intent (Inout) :: ifail, nruns
          Integer, Intent (In) :: ldcov, lwrk, m, maxr, n
          Character (1), Intent (In) :: cl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cov(ldcov,maxr)
          Real (Kind=wp), Intent (Out) :: ex(maxr), wrk(lwrk)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: ncount(maxr)
        End Subroutine g08eaf
      End Interface
      Interface
        Subroutine g08ebf(cl,n,x,msize,lag,ncount,ldc,ex,chi,df,prob,wrk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, df, ex, prob
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lag, ldc, msize, n
          Character (1), Intent (In) :: cl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: wrk(2*lag)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: ncount(ldc,msize)
        End Subroutine g08ebf
      End Interface
      Interface
        Subroutine g08ecf(cl,n,x,msize,ncount,ldc,ex,chi,df,prob,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, df, ex, prob
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, msize, n
          Character (1), Intent (In) :: cl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: ncount(ldc,ldc,msize)
        End Subroutine g08ecf
      End Interface
      Interface
        Subroutine g08edf(cl,n,x,m,maxg,rlo,rup,totlen,ngaps,ncount,ex,chi,df, &
            prob,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, df, prob
          Real (Kind=wp), Intent (In) :: rlo, rup, totlen
          Integer, Intent (Inout) :: ifail, ngaps
          Integer, Intent (In) :: m, maxg, n
          Character (1), Intent (In) :: cl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ex(maxg)
          Real (Kind=wp), Intent (In) :: x(n)
          Integer, Intent (Inout) :: ncount(maxg)
        End Subroutine g08edf
      End Interface
      Interface
        Subroutine g08raf(ns,nv,nsum,y,ip,x,ldx,idist,nmax,tol,prvr,ldprvr, &
            irank,zin,eta,vapvec,parest,work,lwork,iwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (In) :: idist, ip, ldprvr, ldx, lwork, nmax, ns, &
            nsum
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: eta(nmax), parest(4*ip+1), &
            vapvec(nmax*(nmax+1)/2), work(lwork), zin(nmax)
          Real (Kind=wp), Intent (Inout) :: prvr(ldprvr,ip)
          Real (Kind=wp), Intent (In) :: x(ldx,ip), y(nsum)
          Integer, Intent (Out) :: irank(nmax), iwa(nmax)
          Integer, Intent (Inout) :: nv(ns)
        End Subroutine g08raf
      End Interface
      Interface
        Subroutine g08rbf(ns,nv,nsum,y,ip,x,ldx,icen,gamma,nmax,tol,prvr, &
            ldprvr,irank,zin,eta,vapvec,parest,work,lwork,iwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma, tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldprvr, ldx, lwork, nmax, ns, nsum
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: eta(nmax), parest(4*ip+1), &
            vapvec(nmax*(nmax+1)/2), work(lwork), zin(nmax)
          Real (Kind=wp), Intent (Inout) :: prvr(ldprvr,ip)
          Real (Kind=wp), Intent (In) :: x(ldx,ip), y(nsum)
          Integer, Intent (In) :: icen(nsum), nv(ns)
          Integer, Intent (Out) :: irank(nmax), iwa(4*nmax)
        End Subroutine g08rbf
      End Interface
      Interface
        Subroutine g10abf(mode,weight,n,x,y,wt,rho,yhat,c,ldc,rss,df,res,h,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: df, rss
          Real (Kind=wp), Intent (In) :: rho
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, n
          Character (1), Intent (In) :: mode, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,3), wk(9*n+14)
          Real (Kind=wp), Intent (Out) :: h(n), res(n), yhat(n)
          Real (Kind=wp), Intent (In) :: wt(*), x(n), y(n)
        End Subroutine g10abf
      End Interface
      Interface
        Subroutine g10acf(method,weight,n,x,y,wt,yhat,c,ldc,rss,df,res,h,crit, &
            rho,u,tol,maxcal,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: crit
          Real (Kind=wp), Intent (Out) :: df, rho, rss
          Real (Kind=wp), Intent (In) :: tol, u
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldc, maxcal, n
          Character (1), Intent (In) :: method, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,3)
          Real (Kind=wp), Intent (Out) :: h(n), res(n), wk(7*(n+2)), yhat(n)
          Real (Kind=wp), Intent (In) :: wt(*), x(n), y(n)
        End Subroutine g10acf
      End Interface
      Interface
        Subroutine g10baf(n,x,window,slo,shi,ns,smooth,t,usefft,fft,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: shi, slo, window
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, ns
          Logical, Intent (In) :: usefft
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: fft(ns)
          Real (Kind=wp), Intent (Out) :: smooth(ns), t(ns)
          Real (Kind=wp), Intent (In) :: x(n)
        End Subroutine g10baf
      End Interface
      Interface
        Subroutine g10caf(itype,n,y,smooth,rough,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rough(n), smooth(n)
          Real (Kind=wp), Intent (In) :: y(n)
        End Subroutine g10caf
      End Interface
      Interface
        Subroutine g10zaf(weight,n,x,y,wt,nord,xord,yord,wtord,rss,iwrk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rss
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Integer, Intent (Out) :: nord
          Character (1), Intent (In) :: weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: wt(*), x(n), y(n)
          Real (Kind=wp), Intent (Out) :: wtord(n), xord(n), yord(n)
          Integer, Intent (Out) :: iwrk(n)
        End Subroutine g10zaf
      End Interface
      Interface
        Subroutine g11aaf(nrow,ncol,nobs,ldnobs,expt,chist,prob,chi,g,df, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, df, g, prob
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldnobs, ncol, nrow
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: chist(ldnobs,ncol), &
            expt(ldnobs,ncol)
          Integer, Intent (In) :: nobs(ldnobs,ncol)
        End Subroutine g11aaf
      End Interface
      Interface
        Subroutine g11baf(stat,update,weight,n,nfac,isf,lfac,ifac,ldf,y,wt, &
            table,maxt,ncells,ndim,idim,icount,auxt,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, ncells
          Integer, Intent (In) :: ldf, maxt, n, nfac
          Integer, Intent (Out) :: ndim
          Character (1), Intent (In) :: stat, update, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: auxt(*), table(maxt)
          Real (Kind=wp), Intent (In) :: wt(*), y(n)
          Integer, Intent (Inout) :: icount(maxt)
          Integer, Intent (Out) :: idim(nfac), iwk(2*nfac)
          Integer, Intent (In) :: ifac(ldf,nfac), isf(nfac), lfac(nfac)
        End Subroutine g11baf
      End Interface
      Interface
        Subroutine g11bbf(typ,weight,n,nfac,isf,lfac,ifac,ldf,percnt,y,wt, &
            table,maxt,ncells,ndim,idim,icount,iwk,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: percnt
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldf, maxt, n, nfac
          Integer, Intent (Out) :: ncells, ndim
          Character (1), Intent (In) :: typ, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: table(maxt), wk(2*n)
          Real (Kind=wp), Intent (In) :: wt(*), y(n)
          Integer, Intent (Out) :: icount(maxt), idim(nfac), iwk(2*nfac+n)
          Integer, Intent (In) :: ifac(ldf,nfac), isf(nfac), lfac(nfac)
        End Subroutine g11bbf
      End Interface
      Interface
        Subroutine g11bcf(stat,table,ncells,ndim,idim,isdim,stable,maxst, &
            mcells,mdim,mlevel,auxt,iwk,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: maxst, ncells, ndim
          Integer, Intent (Out) :: mcells, mdim
          Character (1), Intent (In) :: stat
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: auxt(*)
          Real (Kind=wp), Intent (Out) :: stable(maxst), wk(ncells)
          Real (Kind=wp), Intent (In) :: table(ncells)
          Integer, Intent (In) :: idim(ndim), isdim(ndim)
          Integer, Intent (Out) :: iwk(3*ndim), mlevel(ndim)
        End Subroutine g11bcf
      End Interface
      Interface
        Subroutine g11caf(n,m,ns,z,ldz,isz,ip,ic,isi,dev,b,se,sc,cov,nca,nct, &
            tol,maxit,iprint,wk,lwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldz, lwk, m, maxit, n, ns
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ip)
          Real (Kind=wp), Intent (Out) :: cov(ip*(ip+1)/2), sc(ip), se(ip), &
            wk(lwk)
          Real (Kind=wp), Intent (In) :: z(ldz,m)
          Integer, Intent (In) :: ic(n), isi(n), isz(m)
          Integer, Intent (Out) :: nca(ns), nct(ns)
        End Subroutine g11caf
      End Interface
      Interface
        Subroutine g11saf(ip,n,gprob,ns,x,ldx,irl,a,c,iprint,cgetol,maxit, &
            chisqr,ishow,niter,alpha,pigam,cm,ldcm,g,expp,ldexpp,obs,exf,y,xl, &
            iob,rlogl,chi,idf,siglev,w,lw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cgetol
          Real (Kind=wp), Intent (Out) :: chi, rlogl, siglev
          Integer, Intent (Out) :: idf, niter
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ishow, ldcm, ldexpp, ldx, lw, &
            maxit, n, ns
          Logical, Intent (In) :: chisqr, gprob
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(ip), c(ip), cm(ldcm,2*ip), &
            expp(ldexpp,ip), obs(ldexpp,ip)
          Real (Kind=wp), Intent (Out) :: alpha(ip), exf(ns), g(2*ip), &
            pigam(ip), w(lw), xl(ns), y(ns)
          Integer, Intent (Out) :: iob(ns)
          Integer, Intent (Inout) :: irl(ns)
          Logical, Intent (Inout) :: x(ldx,ip)
        End Subroutine g11saf
      End Interface
      Interface
        Subroutine g11sbf(ip,n,ns,x,ldx,irl,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldx, n
          Integer, Intent (Out) :: ns
!         .. Array Arguments ..
          Integer, Intent (Out) :: irl(n)
          Logical, Intent (Inout) :: x(ldx,ip)
        End Subroutine g11sbf
      End Interface
      Interface
        Subroutine g12aaf(n,t,ic,freq,ifreq,nd,tp,p,psig,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Integer, Intent (Out) :: nd
          Character (1), Intent (In) :: freq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: p(n), psig(n), tp(n)
          Real (Kind=wp), Intent (In) :: t(n)
          Integer, Intent (In) :: ic(n), ifreq(*)
          Integer, Intent (Out) :: iwk(n)
        End Subroutine g12aaf
      End Interface
      Interface
        Subroutine g12abf(n,t,ic,grp,ngrp,freq,ifreq,weight,wt,ts,df,p,obsd, &
            expt,nd,di,ni,ldn,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: p, ts
          Integer, Intent (Out) :: df, nd
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldn, n, ngrp
          Character (1), Intent (In) :: freq, weight
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: expt(ngrp), obsd(ngrp)
          Real (Kind=wp), Intent (In) :: t(n), wt(*)
          Integer, Intent (Out) :: di(ldn), ni(ldn)
          Integer, Intent (In) :: grp(n), ic(n), ifreq(*)
        End Subroutine g12abf
      End Interface
      Interface
        Subroutine g12baf(offset,n,m,ns,z,ldz,isz,ip,t,ic,omega,isi,dev,b,se, &
            sc,cov,res,nd,tp,sur,ndmax,tol,maxit,iprint,wk,iwk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dev
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, ldz, m, maxit, n, ndmax, ns
          Integer, Intent (Out) :: nd
          Character (1), Intent (In) :: offset
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ip), sur(ndmax,*)
          Real (Kind=wp), Intent (Out) :: cov(ip*(ip+1)/2), res(n), sc(ip), &
            se(ip), tp(ndmax), wk(ip*(ip+9)/2+n)
          Real (Kind=wp), Intent (In) :: omega(*), t(n), z(ldz,m)
          Integer, Intent (In) :: ic(n), isi(*), isz(m)
          Integer, Intent (Out) :: iwk(2*n)
        End Subroutine g12baf
      End Interface
      Interface
        Subroutine g12zaf(n,m,ns,z,ldz,isz,ip,t,ic,isi,num,ixs,nxs,x,mxn,id, &
            nd,tp,irs,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, ldz, m, mxn, n, ns
          Integer, Intent (Out) :: nd, num, nxs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: t(n), z(ldz,m)
          Real (Kind=wp), Intent (Out) :: tp(n)
          Real (Kind=wp), Intent (Inout) :: x(mxn,ip)
          Integer, Intent (In) :: ic(n), isi(*), isz(m)
          Integer, Intent (Out) :: id(mxn), irs(n), ixs(mxn)
        End Subroutine g12zaf
      End Interface
      Interface
        Subroutine g13aaf(x,nx,nd,nds,ns,xd,nxd,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nd, nds, ns, nx
          Integer, Intent (Out) :: nxd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: x(nx)
          Real (Kind=wp), Intent (Out) :: xd(nx)
        End Subroutine g13aaf
      End Interface
      Interface
        Subroutine g13abf(x,nx,nk,xm,xv,r,stat,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: stat, xm, xv
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nk, nx
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: r(nk)
          Real (Kind=wp), Intent (In) :: x(nx)
        End Subroutine g13abf
      End Interface
      Interface
        Subroutine g13acf(r,nk,nl,p,v,ar,nvl,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nk, nl
          Integer, Intent (Out) :: nvl
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ar(nl), p(nl), v(nl)
          Real (Kind=wp), Intent (In) :: r(nk)
        End Subroutine g13acf
      End Interface
      Interface
        Subroutine g13adf(mr,r,nk,xv,npar,wa,nwa,par,rv,isf,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rv
          Real (Kind=wp), Intent (In) :: xv
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nk, npar, nwa
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: par(npar), wa(nwa)
          Real (Kind=wp), Intent (In) :: r(nk)
          Integer, Intent (Out) :: isf(4)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13adf
      End Interface
      Interface
        Subroutine g13aef(mr,par,npar,c,kfc,x,nx,icount,ex,exr,al,iex,s,g,igh, &
            sd,h,ldh,st,ist,nst,piv,kpiv,nit,itc,zsp,kzsp,isf,wa,iwa,hc,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: c
          Real (Kind=wp), Intent (Out) :: s
          Integer, Intent (In) :: iex, igh, ist, iwa, kfc, kpiv, kzsp, ldh, &
            nit, npar, nx
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: itc, nst
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: al(iex), ex(iex), exr(iex), g(igh), &
            sd(igh), st(ist), wa(iwa)
          Real (Kind=wp), Intent (Inout) :: h(ldh,igh), hc(ldh,igh), &
            par(npar), zsp(4)
          Real (Kind=wp), Intent (In) :: x(nx)
          Integer, Intent (Out) :: icount(6), isf(4)
          Integer, Intent (In) :: mr(7)
!         .. Interface Blocks ..
          Interface
            Subroutine piv(mr,par,npar,c,kfc,icount,s,g,h,ldh,igh,itc,zsp)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: c, s
              Integer, Intent (In) :: igh, itc, kfc, ldh, npar
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: g(igh), h(ldh,igh), par(npar), &
                zsp(4)
              Integer, Intent (In) :: icount(6), mr(7)
            End Subroutine piv
          End Interface
        End Subroutine g13aef
      End Interface
      Interface
        Subroutine g13afz(mr,par,npar,c,kfc,icount,s,g,h,ldh,igh,itc,zsp)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c, s
          Integer, Intent (In) :: igh, itc, kfc, ldh, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: g(igh), h(ldh,igh), par(npar), zsp(4)
          Integer, Intent (In) :: icount(6), mr(7)
        End Subroutine g13afz
      End Interface
      Interface
        Subroutine g13aff(mr,par,npar,c,kfc,x,nx,s,ndf,sd,nppc,cm,ldcm,st,nst, &
            kpiv,nit,itc,isf,res,ires,nres,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: c
          Real (Kind=wp), Intent (Out) :: s
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ires, kfc, kpiv, ldcm, nit, npar, nppc, nx
          Integer, Intent (Out) :: itc, ndf, nres, nst
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cm(ldcm,nppc), par(npar)
          Real (Kind=wp), Intent (Out) :: res(ires), sd(nppc), st(nx)
          Real (Kind=wp), Intent (In) :: x(nx)
          Integer, Intent (Out) :: isf(4)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13aff
      End Interface
      Interface
        Subroutine g13agf(st,nst,mr,par,npar,c,anx,nuv,anexr,wa,nwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: npar, nst, nuv, nwa
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: anexr(nuv), wa(nwa)
          Real (Kind=wp), Intent (In) :: anx(nuv), par(npar)
          Real (Kind=wp), Intent (Inout) :: st(nst)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13agf
      End Interface
      Interface
        Subroutine g13ahf(st,nst,mr,par,npar,c,rms,nfv,fva,fsd,wa,nwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: c
          Real (Kind=wp), Intent (In) :: rms
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nfv, npar, nst, nwa
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fsd(nfv), fva(nfv), wa(nwa)
          Real (Kind=wp), Intent (In) :: par(npar), st(nst)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13ahf
      End Interface
      Interface
        Subroutine g13ajf(mr,par,npar,c,kfc,x,nx,rms,st,ist,nst,nfv,fva,fsd, &
            ifv,isf,w,iw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c
          Real (Kind=wp), Intent (Out) :: rms
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ifv, ist, iw, kfc, nfv, npar, nx
          Integer, Intent (Out) :: nst
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fsd(ifv), fva(ifv), st(ist), w(iw)
          Real (Kind=wp), Intent (In) :: par(npar), x(nx)
          Integer, Intent (Out) :: isf(4)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13ajf
      End Interface
      Interface
        Subroutine g13amf(mode,itype,p,param,n,y,k,init,nf,fv,fse,yhat,res,dv, &
            ad,r,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: ad, dv
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: itype, k, mode, n, nf, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fse(nf), fv(nf), res(n), yhat(n)
          Real (Kind=wp), Intent (Inout) :: init(*), r(*)
          Real (Kind=wp), Intent (In) :: param(*), y(n)
        End Subroutine g13amf
      End Interface
      Interface
        Subroutine g13asf(n,v,mr,m,par,npar,ishow,r,rcm,ldrcm,chi,idf,siglev, &
            iw,liw,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, siglev
          Integer, Intent (Out) :: idf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ishow, ldrcm, liw, lwork, m, n, npar
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: par(npar), v(n)
          Real (Kind=wp), Intent (Out) :: r(m), work(lwork)
          Real (Kind=wp), Intent (Inout) :: rcm(ldrcm,m)
          Integer, Intent (Out) :: iw(liw)
          Integer, Intent (In) :: mr(7)
        End Subroutine g13asf
      End Interface
      Interface
        Subroutine g13auf(n,z,m,ngrps,rs,y,mean,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m, n, ngrps
          Character (1), Intent (In) :: rs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: mean(ngrps), y(ngrps)
          Real (Kind=wp), Intent (In) :: z(n)
        End Subroutine g13auf
      End Interface
      Interface
        Subroutine g13baf(y,ny,mr,nmr,par,npar,cy,wa,nwa,b,nb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cy
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nb, nmr, npar, nwa, ny
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(nb), wa(nwa)
          Real (Kind=wp), Intent (In) :: par(npar), y(ny)
          Integer, Intent (In) :: mr(nmr)
        End Subroutine g13baf
      End Interface
      Interface
        Subroutine g13bbf(y,ny,mr,nmr,par,npar,cy,wa,iwa,b,nb,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cy
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwa, nb, nmr, npar, ny
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: b(nb), wa(iwa)
          Real (Kind=wp), Intent (In) :: par(npar), y(ny)
          Integer, Intent (In) :: mr(nmr)
        End Subroutine g13bbf
      End Interface
      Interface
        Subroutine g13bcf(x,y,nxy,nl,s,r0,r,stat,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: r0, s, stat
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nl, nxy
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: r(nl)
          Real (Kind=wp), Intent (In) :: x(nxy), y(nxy)
        End Subroutine g13bcf
      End Interface
      Interface
        Subroutine g13bdf(r0,r,nl,nna,s,nwds,wa,iwa,wds,isf,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: r0, s
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwa, nl, nwds
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: r(nl)
          Real (Kind=wp), Intent (Out) :: wa(iwa), wds(nwds)
          Integer, Intent (Out) :: isf(2)
          Integer, Intent (In) :: nna(3)
        End Subroutine g13bdf
      End Interface
      Interface
        Subroutine g13bef(mr,nser,mt,para,npara,kfc,nxxy,xxy,ldxxy,kef,nit, &
            kzsp,zsp,itc,sd,cm,ldcm,s,d,ndf,kzef,res,sttf,isttf,nsttf,wa,iwa, &
            mwa,imwa,kpriv,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: d, s
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: imwa, isttf, iwa, kef, kfc, kpriv, kzef, &
            kzsp, ldcm, ldxxy, nit, npara, nser, nxxy
          Integer, Intent (Out) :: itc, ndf, nsttf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cm(ldcm,npara), para(npara), &
            xxy(ldxxy,nser), zsp(4)
          Real (Kind=wp), Intent (Out) :: res(nxxy), sd(npara), sttf(isttf), &
            wa(iwa)
          Integer, Intent (In) :: mr(7), mt(4,nser)
          Integer, Intent (Out) :: mwa(imwa)
        End Subroutine g13bef
      End Interface
      Interface
        Subroutine g13bgf(sttf,nsttf,mr,nser,mt,para,npara,nnv,xxyn,ldxxyn, &
            kzef,res,wa,iwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwa, kzef, ldxxyn, nnv, npara, nser, nsttf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: para(npara)
          Real (Kind=wp), Intent (Out) :: res(nnv), wa(iwa)
          Real (Kind=wp), Intent (Inout) :: sttf(nsttf), xxyn(ldxxyn,nser)
          Integer, Intent (In) :: mr(7), mt(4,nser)
        End Subroutine g13bgf
      End Interface
      Interface
        Subroutine g13bhf(sttf,nsttf,mr,nser,mt,para,npara,nfv,xxyn,ldxxyn, &
            mrx,parx,ldparx,rmsxy,kzef,fva,fsd,wa,iwa,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwa, kzef, ldparx, ldxxyn, nfv, npara, nser, &
            nsttf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fsd(nfv), fva(nfv), wa(iwa)
          Real (Kind=wp), Intent (In) :: para(npara), parx(ldparx,nser), &
            rmsxy(nser), sttf(nsttf)
          Real (Kind=wp), Intent (Inout) :: xxyn(ldxxyn,nser)
          Integer, Intent (Inout) :: mr(7), mrx(7,nser)
          Integer, Intent (In) :: mt(4,nser)
        End Subroutine g13bhf
      End Interface
      Interface
        Subroutine g13bjf(mr,nser,mt,para,npara,kfc,nev,nfv,xxy,ldxxy,kzef, &
            rmsxy,mrx,parx,ldparx,fva,fsd,sttf,isttf,nsttf,wa,iwa,mwa,imwa, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: imwa, isttf, iwa, kfc, kzef, ldparx, ldxxy, &
            nev, nfv, npara, nser
          Integer, Intent (Out) :: nsttf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: fsd(nfv), fva(nfv), sttf(isttf), &
            wa(iwa)
          Real (Kind=wp), Intent (Inout) :: para(npara), rmsxy(nser), &
            xxy(ldxxy,nser)
          Real (Kind=wp), Intent (In) :: parx(ldparx,nser)
          Integer, Intent (Inout) :: mr(7), mrx(7,nser)
          Integer, Intent (In) :: mt(4,nser)
          Integer, Intent (Out) :: mwa(imwa)
        End Subroutine g13bjf
      End Interface
      Interface
        Subroutine g13caf(nx,mtx,px,iw,mw,ic,nc,c,kc,l,lg,nxg,xg,ng,stats, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: px
          Integer, Intent (In) :: ic, iw, kc, l, lg, mtx, mw, nc, nx, nxg
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(nc), xg(nxg)
          Real (Kind=wp), Intent (Out) :: stats(4)
        End Subroutine g13caf
      End Interface
      Interface
        Subroutine g13cbf(nx,mtx,px,mw,pw,l,kc,lg,xg,ng,stats,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pw, px
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kc, l, lg, mtx, mw, nx
          Integer, Intent (Out) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: stats(4)
          Real (Kind=wp), Intent (Inout) :: xg(kc)
        End Subroutine g13cbf
      End Interface
      Interface
        Subroutine g13ccf(nxy,mtxy,pxy,iw,mw,ish,ic,nc,cxy,cyx,kc,l,nxyg,xg, &
            yg,ng,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pxy
          Integer, Intent (In) :: ic, ish, iw, kc, l, mtxy, mw, nc, nxy, nxyg
          Integer, Intent (Inout) :: ifail
          Integer, Intent (Out) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cxy(nc), cyx(nc), xg(nxyg), &
            yg(nxyg)
        End Subroutine g13ccf
      End Interface
      Interface
        Subroutine g13cdf(nxy,mtxy,pxy,mw,ish,pw,l,kc,xg,yg,ng,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: pw, pxy
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ish, kc, l, mtxy, mw, nxy
          Integer, Intent (Out) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: xg(kc), yg(kc)
        End Subroutine g13cdf
      End Interface
      Interface
        Subroutine g13cef(xg,yg,xyrg,xyig,ng,stats,ca,calw,caup,t,sc,sclw, &
            scup,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: t
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ca(ng), calw(ng), caup(ng), sc(ng), &
            sclw(ng), scup(ng)
          Real (Kind=wp), Intent (In) :: stats(4), xg(ng), xyig(ng), xyrg(ng), &
            yg(ng)
        End Subroutine g13cef
      End Interface
      Interface
        Subroutine g13cff(xg,yg,xyrg,xyig,ng,stats,gn,gnlw,gnup,ph,phlw,phup, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: gn(ng), gnlw(ng), gnup(ng), ph(ng), &
            phlw(ng), phup(ng)
          Real (Kind=wp), Intent (In) :: stats(4), xg(ng), xyig(ng), xyrg(ng), &
            yg(ng)
        End Subroutine g13cff
      End Interface
      Interface
        Subroutine g13cgf(xg,yg,xyrg,xyig,ng,stats,l,n,er,erlw,erup,rf,rfse, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: erlw, erup, rfse
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, n, ng
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: er(ng), rf(l)
          Real (Kind=wp), Intent (In) :: stats(4), xg(ng), xyig(ng), xyrg(ng), &
            yg(ng)
        End Subroutine g13cgf
      End Interface
      Interface
        Subroutine g13dbf(c0,c,ldc0,ns,nl,nk,p,v0,v,d,db,w,wb,nvp,wa,iwa, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: v0
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iwa, ldc0, nk, nl, ns
          Integer, Intent (Out) :: nvp
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: c(ldc0,ldc0,nl), c0(ldc0,ns)
          Real (Kind=wp), Intent (Inout) :: d(ldc0,ldc0,nk), db(ldc0,ns), &
            w(ldc0,ldc0,nk), wb(ldc0,ldc0,nk)
          Real (Kind=wp), Intent (Out) :: p(nk), v(nk), wa(iwa)
        End Subroutine g13dbf
      End Interface
      Interface
        Subroutine g13dcf(k,n,ip,iq,mean,par,npar,qq,kmax,w,parhld,exact, &
            iprint,cgetol,maxcal,ishow,niter,rlogl,v,g,cm,ldcm,work,lwork,iw, &
            liw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cgetol
          Real (Kind=wp), Intent (Out) :: rlogl
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, iq, ishow, k, kmax, ldcm, liw, &
            lwork, maxcal, n, npar
          Integer, Intent (Out) :: niter
          Logical, Intent (In) :: exact, mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cm(ldcm,npar), par(npar), &
            qq(kmax,k), v(kmax,n)
          Real (Kind=wp), Intent (Out) :: g(npar)
          Real (Kind=wp), Intent (In) :: w(kmax,n), work(1)
          Integer, Intent (In) :: iw(1)
          Logical, Intent (In) :: parhld(npar)
        End Subroutine g13dcf
      End Interface
      Interface
        Subroutine g13ddf(k,n,ip,iq,mean,par,npar,qq,kmax,w,parhld,exact, &
            iprint,cgetol,maxcal,ishow,niter,rlogl,v,g,cm,ldcm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: cgetol
          Real (Kind=wp), Intent (Out) :: rlogl
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iprint, iq, ishow, k, kmax, ldcm, &
            maxcal, n, npar
          Integer, Intent (Out) :: niter
          Logical, Intent (In) :: exact, mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: cm(ldcm,npar), par(npar), &
            qq(kmax,k), v(kmax,n)
          Real (Kind=wp), Intent (Out) :: g(npar)
          Real (Kind=wp), Intent (In) :: w(kmax,n)
          Logical, Intent (In) :: parhld(npar)
        End Subroutine g13ddf
      End Interface
      Interface
        Subroutine g13djf(k,n,z,kmax,tr,id,delta,ip,iq,mean,par,lpar,qq,v, &
            lmax,predz,sefz,ref,lref,work,lwork,iwork,liwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, k, kmax, liwork, lmax, lpar, lref, &
            lwork, n
          Character (1), Intent (In) :: mean
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: delta(kmax,*), par(lpar), v(kmax,*), &
            z(kmax,n)
          Real (Kind=wp), Intent (Inout) :: predz(kmax,lmax), qq(kmax,k), &
            sefz(kmax,lmax)
          Real (Kind=wp), Intent (Out) :: ref(lref), work(lwork)
          Integer, Intent (In) :: id(k)
          Integer, Intent (Out) :: iwork(liwork)
          Character (1), Intent (In) :: tr(k)
        End Subroutine g13djf
      End Interface
      Interface
        Subroutine g13dkf(k,lmax,m,mlast,z,kmax,ref,lref,v,predz,sefz,work, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail, mlast
          Integer, Intent (In) :: k, kmax, lmax, lref, m
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: predz(kmax,lmax), ref(lref), &
            sefz(kmax,lmax), v(kmax,m)
          Real (Kind=wp), Intent (Out) :: work(k*m)
          Real (Kind=wp), Intent (In) :: z(kmax,m)
        End Subroutine g13dkf
      End Interface
      Interface
        Subroutine g13dlf(k,n,z,kmax,tr,id,delta,w,nd,work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, kmax, n
          Integer, Intent (Out) :: nd
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: delta(kmax,*), z(kmax,n)
          Real (Kind=wp), Intent (Inout) :: w(kmax,*)
          Real (Kind=wp), Intent (Out) :: work(k*n)
          Integer, Intent (In) :: id(k)
          Character (1), Intent (In) :: tr(k)
        End Subroutine g13dlf
      End Interface
      Interface
        Subroutine g13dmf(matrix,k,n,m,w,kmax,wmean,r0,r,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, kmax, m, n
          Character (1), Intent (In) :: matrix
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: r(kmax,kmax,m), r0(kmax,k)
          Real (Kind=wp), Intent (In) :: w(kmax,n)
          Real (Kind=wp), Intent (Out) :: wmean(k)
        End Subroutine g13dmf
      End Interface
      Interface
        Subroutine g13dnf(k,n,m,kmax,r0,r,maxlag,parlag,x,pvalue,work,lwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, kmax, lwork, m, n
          Integer, Intent (Out) :: maxlag
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: parlag(kmax,kmax,m)
          Real (Kind=wp), Intent (Out) :: pvalue(m), work(lwork), x(m)
          Real (Kind=wp), Intent (In) :: r(kmax,kmax,m), r0(kmax,k)
        End Subroutine g13dnf
      End Interface
      Interface
        Subroutine g13dpf(k,n,z,kmax,m,maxlag,parlag,se,qq,x,pvalue,loglhd, &
            work,lwork,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: k, kmax, lwork, m, n
          Integer, Intent (Out) :: maxlag
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: loglhd(m), pvalue(m), work(lwork), &
            x(m)
          Real (Kind=wp), Intent (Inout) :: parlag(kmax,kmax,m), &
            qq(kmax,kmax,m), se(kmax,kmax,m)
          Real (Kind=wp), Intent (In) :: z(kmax,n)
          Integer, Intent (Out) :: iwork(k*m)
        End Subroutine g13dpf
      End Interface
      Interface
        Subroutine g13dsf(k,n,v,kmax,ip,iq,m,par,parhld,qq,ishow,r0,r,rcm, &
            ldrcm,chi,idf,siglev,iw,liw,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: chi, siglev
          Integer, Intent (Out) :: idf
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, ishow, k, kmax, ldrcm, liw, lwork, &
            m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: par((ip+iq)*k*k), v(kmax,n)
          Real (Kind=wp), Intent (Inout) :: qq(kmax,k), r(kmax,kmax,m), &
            r0(kmax,k), rcm(ldrcm,m*k*k)
          Real (Kind=wp), Intent (Out) :: work(lwork)
          Integer, Intent (Out) :: iw(liw)
          Logical, Intent (In) :: parhld((ip+iq)*k*k)
        End Subroutine g13dsf
      End Interface
      Interface
        Subroutine g13dxf(k,ip,par,rr,ri,rmod,work,iwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, k
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: par(ip*k*k)
          Real (Kind=wp), Intent (Out) :: ri(k*ip), rmod(k*ip), rr(k*ip), &
            work(k*k*ip*ip)
          Integer, Intent (Out) :: iwork(k*ip)
        End Subroutine g13dxf
      End Interface
      Interface
        Subroutine g13eaf(n,m,l,a,lds,b,stq,q,ldq,c,ldm,r,s,k,h,tol,iwk,wk, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, ldm, ldq, lds, m, n
          Logical, Intent (In) :: stq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lds,n), b(lds,l), c(ldm,n), &
            q(ldq,*), r(ldm,m)
          Real (Kind=wp), Intent (Inout) :: h(ldm,m), k(lds,m), s(lds,n)
          Real (Kind=wp), Intent (Out) :: wk((n+m)*(n+m+l))
          Integer, Intent (Out) :: iwk(m)
        End Subroutine g13eaf
      End Interface
      Interface
        Subroutine g13ebf(transf,n,m,l,a,lds,b,stq,q,ldq,c,ldm,r,s,k,h,u,tol, &
            iwk,wk,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l, ldm, ldq, lds, m, n
          Logical, Intent (In) :: stq
          Character (1), Intent (In) :: transf
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lds,n), b(lds,l), c(ldm,n), &
            h(ldm,m), k(lds,m), s(lds,n), u(lds,*)
          Real (Kind=wp), Intent (In) :: q(ldq,*), r(ldm,m)
          Real (Kind=wp), Intent (Out) :: wk((n+m)*(n+m+l))
          Integer, Intent (Out) :: iwk(m)
        End Subroutine g13ebf
      End Interface
      Interface
        Subroutine g13faf(dist,yt,x,ldx,num,ip,iq,nreg,mn,isym,npar,theta,se, &
            sc,covr,ldcovr,hp,et,ht,lgf,copts,maxit,tol,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: hp
          Real (Kind=wp), Intent (Out) :: lgf
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, isym, ldcovr, ldx, lwork, maxit, mn, &
            npar, nreg, num
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: covr(ldcovr,npar), theta(npar)
          Real (Kind=wp), Intent (Out) :: et(num), ht(num), sc(npar), &
            se(npar), work(lwork)
          Real (Kind=wp), Intent (In) :: x(ldx,*), yt(num)
          Logical, Intent (In) :: copts(2)
        End Subroutine g13faf
      End Interface
      Interface
        Subroutine g13fbf(num,nt,ip,iq,theta,gamma,fht,ht,et,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, nt, num
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: et(num), ht(num), theta(iq+ip+1)
          Real (Kind=wp), Intent (Out) :: fht(nt)
        End Subroutine g13fbf
      End Interface
      Interface
        Subroutine g13fcf(dist,yt,x,ldx,num,ip,iq,nreg,mn,npar,theta,se,sc, &
            covr,ldcovr,hp,et,ht,lgf,copts,maxit,tol,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: hp
          Real (Kind=wp), Intent (Out) :: lgf
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, ldcovr, ldx, lwork, maxit, mn, npar, &
            nreg, num
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: covr(ldcovr,npar), theta(npar)
          Real (Kind=wp), Intent (Out) :: et(num), ht(num), sc(npar), &
            se(npar), work(lwork)
          Real (Kind=wp), Intent (In) :: x(ldx,*), yt(num)
          Logical, Intent (In) :: copts(2)
        End Subroutine g13fcf
      End Interface
      Interface
        Subroutine g13fdf(num,nt,ip,iq,theta,gamma,fht,ht,et,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, nt, num
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: et(num), ht(num), theta(iq+ip+1)
          Real (Kind=wp), Intent (Out) :: fht(nt)
        End Subroutine g13fdf
      End Interface
      Interface
        Subroutine g13fef(dist,yt,x,ldx,num,ip,iq,nreg,mn,npar,theta,se,sc, &
            covr,ldcovr,hp,et,ht,lgf,copts,maxit,tol,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: hp
          Real (Kind=wp), Intent (Out) :: lgf
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, ldcovr, ldx, lwork, maxit, mn, npar, &
            nreg, num
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: covr(ldcovr,npar), theta(npar)
          Real (Kind=wp), Intent (Out) :: et(num), ht(num), sc(npar), &
            se(npar), work(lwork)
          Real (Kind=wp), Intent (In) :: x(ldx,*), yt(num)
          Logical, Intent (In) :: copts(2)
        End Subroutine g13fef
      End Interface
      Interface
        Subroutine g13fff(num,nt,ip,iq,theta,gamma,fht,ht,et,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, nt, num
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: et(num), ht(num), theta(iq+ip+1)
          Real (Kind=wp), Intent (Out) :: fht(nt)
        End Subroutine g13fff
      End Interface
      Interface
        Subroutine g13fgf(dist,yt,x,ldx,num,ip,iq,nreg,mn,npar,theta,se,sc, &
            covr,ldcovr,hp,et,ht,lgf,copts,maxit,tol,work,lwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: hp
          Real (Kind=wp), Intent (Out) :: lgf
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, ldcovr, ldx, lwork, maxit, mn, npar, &
            nreg, num
          Logical, Intent (In) :: copts
          Character (1), Intent (In) :: dist
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: covr(ldcovr,npar), theta(npar)
          Real (Kind=wp), Intent (Out) :: et(num), ht(num), sc(npar), &
            se(npar), work(lwork)
          Real (Kind=wp), Intent (In) :: x(ldx,*), yt(num)
        End Subroutine g13fgf
      End Interface
      Interface
        Subroutine g13fhf(num,nt,ip,iq,theta,fht,ht,et,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, iq, nt, num
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: et(num), ht(num), theta(2*iq+ip+1)
          Real (Kind=wp), Intent (Out) :: fht(nt)
        End Subroutine g13fhf
      End Interface
      Interface
        Subroutine g13mef(nb,iema,t,tau,m,sinit,inter,pn,rcomm,lrcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tau
          Integer, Intent (Inout) :: ifail, pn
          Integer, Intent (In) :: lrcomm, m, nb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: iema(nb), rcomm(lrcomm)
          Real (Kind=wp), Intent (In) :: sinit(m+2), t(nb)
          Integer, Intent (In) :: inter(2)
        End Subroutine g13mef
      End Interface
      Interface
        Subroutine g13mff(sorder,nb,z,iema,ldiema,t,tau,m1,m2,sinit,inter, &
            ftype,p,x,pn,rcomm,lrcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: p
          Real (Kind=wp), Intent (In) :: tau
          Integer, Intent (In) :: ftype, ldiema, lrcomm, m1, m2, nb, sorder
          Integer, Intent (Inout) :: ifail, pn
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: iema(ldiema,*)
          Real (Kind=wp), Intent (Inout) :: rcomm(lrcomm)
          Real (Kind=wp), Intent (In) :: sinit(m2+2), t(nb), x(*), z(nb)
          Integer, Intent (In) :: inter(2)
        End Subroutine g13mff
      End Interface
      Interface
        Subroutine g13mgf(nb,ma,t,tau,m1,m2,sinit,inter,ftype,p,pn,wma,rcomm, &
            lrcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: p
          Real (Kind=wp), Intent (In) :: tau
          Integer, Intent (In) :: ftype, lrcomm, m1, m2, nb
          Integer, Intent (Inout) :: ifail, pn
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ma(nb), rcomm(lrcomm)
          Real (Kind=wp), Intent (In) :: sinit(*), t(nb)
          Real (Kind=wp), Intent (Out) :: wma(nb)
          Integer, Intent (In) :: inter(2)
        End Subroutine g13mgf
      End Interface
    End Module nag_g_ib
