    Module nag_lapack_ib

!     NAG COPYRIGHT 2011.

!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine dtrttp(uplo,n,a,lda,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
        End Subroutine dtrttp
      End Interface
      Interface
        Subroutine ztrttp(uplo,n,a,lda,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
        End Subroutine ztrttp
      End Interface
      Interface
        Subroutine dtpttr(uplo,n,ap,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
        End Subroutine dtpttr
      End Interface
      Interface
        Subroutine ztpttr(uplo,n,ap,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
        End Subroutine ztpttr
      End Interface
      Interface
        Subroutine dtrttf(transr,uplo,n,a,lda,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine dtrttf
      End Interface
      Interface
        Subroutine ztrttf(transr,uplo,n,a,lda,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine ztrttf
      End Interface
      Interface
        Subroutine dtfttr(transr,uplo,n,arf,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine dtfttr
      End Interface
      Interface
        Subroutine ztfttr(transr,uplo,n,arf,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine ztfttr
      End Interface
      Interface
        Subroutine dtpttf(transr,uplo,n,ap,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
          Real (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine dtpttf
      End Interface
      Interface
        Subroutine ztpttf(transr,uplo,n,ap,arf,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(n*(n+1)/2)
          Complex (Kind=wp), Intent (Out) :: arf(n*(n+1)/2)
        End Subroutine ztpttf
      End Interface
      Interface
        Subroutine dtfttp(transr,uplo,n,arf,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
          Real (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine dtfttp
      End Interface
      Interface
        Subroutine ztfttp(transr,uplo,n,arf,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: ap(n*(n+1)/2)
          Complex (Kind=wp), Intent (In) :: arf(n*(n+1)/2)
        End Subroutine ztfttp
      End Interface
      Interface
        Subroutine zrot(n,cx,incx,cy,incy,c,s)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: s
          Real (Kind=wp), Intent (In) :: c
          Integer, Intent (In) :: incx, incy, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: cx(*), cy(*)
        End Subroutine zrot
      End Interface
      Interface
        Function dlansf(norm,transr,uplo,n,a,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: dlansf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function dlansf
      End Interface
      Interface
        Subroutine dtfsm(transr,side,uplo,trans,diag,m,n,alpha,a,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: ldb, m, n
          Character (1), Intent (In) :: diag, side, trans, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtfsm
      End Interface
      Interface
        Subroutine dsfrk(transr,uplo,trans,n,k,alpha,a,lda,beta,c)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, n
          Character (1), Intent (In) :: trans, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: c(n*(n+1)/2)
        End Subroutine dsfrk
      End Interface
      Interface
        Function zlanhf(norm,transr,uplo,n,a,work)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: zlanhf
!         .. Scalar Arguments ..
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: work(*)
        End Function zlanhf
      End Interface
      Interface
        Subroutine ztfsm(transr,side,uplo,trans,diag,m,n,alpha,a,b,ldb)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: alpha
          Integer, Intent (In) :: ldb, m, n
          Character (1), Intent (In) :: diag, side, trans, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztfsm
      End Interface
      Interface
        Subroutine zhfrk(transr,uplo,trans,n,k,alpha,a,lda,beta,c)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: alpha, beta
          Integer, Intent (In) :: k, lda, n
          Character (1), Intent (In) :: trans, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: c(n*(n+1)/2)
        End Subroutine zhfrk
      End Interface
      Interface
        Subroutine dgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dgesv
      End Interface
      Interface
        Subroutine dgesvx(fact,trans,n,nrhs,a,lda,af,ldaf,ipiv,equed,r,c,b, &
            ldb,x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            c(*), r(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            work(max(1,4*n))
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgesvx
      End Interface
      Interface
        Subroutine dsgesv(n,nrhs,a,lda,ipiv,b,ldb,x,ldx,work,swork,iter,info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
          Real (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Real (Kind=wp), Intent (Out) :: work(n*nrhs)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dsgesv
      End Interface
      Interface
        Subroutine dgetrf(m,n,a,lda,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine dgetrf
      End Interface
      Interface
        Subroutine dgetrs(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dgetrs
      End Interface
      Interface
        Subroutine dgeequ(m,n,a,lda,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine dgeequ
      End Interface
      Interface
        Subroutine dgecon(norm,n,a,lda,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgecon
      End Interface
      Interface
        Subroutine dgerfs(trans,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgerfs
      End Interface
      Interface
        Subroutine dgetri(n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (In) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgetri
      End Interface
      Interface
        Subroutine zgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zgesv
      End Interface
      Interface
        Subroutine zgesvx(fact,trans,n,nrhs,a,lda,af,ldaf,ipiv,equed,r,c,b, &
            ldb,x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            rwork(max(1,2*n))
          Real (Kind=wp), Intent (Inout) :: c(*), r(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgesvx
      End Interface
      Interface
        Subroutine zcgesv(n,nrhs,a,lda,ipiv,b,ldb,x,ldx,work,swork,rwork,iter, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: b(ldb,*)
          Complex (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Complex (Kind=wp), Intent (Out) :: work(n*nrhs)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zcgesv
      End Interface
      Interface
        Subroutine zgetrf(m,n,a,lda,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine zgetrf
      End Interface
      Interface
        Subroutine zgetrs(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgetrs
      End Interface
      Interface
        Subroutine zgeequ(m,n,a,lda,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine zgeequ
      End Interface
      Interface
        Subroutine zgecon(norm,n,a,lda,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
        End Subroutine zgecon
      End Interface
      Interface
        Subroutine zgerfs(trans,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgerfs
      End Interface
      Interface
        Subroutine zgetri(n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (In) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgetri
      End Interface
      Interface
        Subroutine dgbsv(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dgbsv
      End Interface
      Interface
        Subroutine dgbsvx(fact,trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv, &
            equed,r,c,b,ldb,x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), c(*), r(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            work(max(1,3*n))
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgbsvx
      End Interface
      Interface
        Subroutine dgbtrf(m,n,kl,ku,ab,ldab,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine dgbtrf
      End Interface
      Interface
        Subroutine dgbtrs(trans,n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dgbtrs
      End Interface
      Interface
        Subroutine dgbequ(m,n,kl,ku,ab,ldab,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine dgbequ
      End Interface
      Interface
        Subroutine dgbcon(norm,n,kl,ku,ab,ldab,ipiv,anorm,rcond,work,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgbcon
      End Interface
      Interface
        Subroutine dgbrfs(trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgbrfs
      End Interface
      Interface
        Subroutine zgbsv(n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zgbsv
      End Interface
      Interface
        Subroutine zgbsvx(fact,trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv, &
            equed,r,c,b,ldb,x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), &
            rwork(max(1,n))
          Real (Kind=wp), Intent (Inout) :: c(*), r(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgbsvx
      End Interface
      Interface
        Subroutine zgbtrf(m,n,kl,ku,ab,ldab,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*)
          Integer, Intent (Out) :: ipiv(min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine zgbtrf
      End Interface
      Interface
        Subroutine zgbtrs(trans,n,kl,ku,nrhs,ab,ldab,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgbtrs
      End Interface
      Interface
        Subroutine zgbequ(m,n,kl,ku,ab,ldab,r,c,rowcnd,colcnd,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, colcnd, rowcnd
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: c(n), r(m)
        End Subroutine zgbequ
      End Interface
      Interface
        Subroutine zgbcon(norm,n,kl,ku,ab,ldab,ipiv,anorm,rcond,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgbcon
      End Interface
      Interface
        Subroutine zgbrfs(trans,n,kl,ku,nrhs,ab,ldab,afb,ldafb,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgbrfs
      End Interface
      Interface
        Subroutine dgtsv(n,nrhs,dl,d,du,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
        End Subroutine dgtsv
      End Interface
      Interface
        Subroutine dgtsvx(fact,trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb, &
            x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), dl(*), du(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: df(*), dlf(*), du2(*), duf(*), &
            x(ldx,*)
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgtsvx
      End Interface
      Interface
        Subroutine dgttrf(n,dl,d,du,du2,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), dl(*), du(*)
          Real (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dgttrf
      End Interface
      Interface
        Subroutine dgttrs(trans,n,nrhs,dl,d,du,du2,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dgttrs
      End Interface
      Interface
        Subroutine dgtcon(norm,n,dl,d,du,du2,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgtcon
      End Interface
      Interface
        Subroutine dgtrfs(trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), dl(*), dlf(*), &
            du(*), du2(*), duf(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dgtrfs
      End Interface
      Interface
        Subroutine zgtsv(n,nrhs,dl,d,du,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), dl(*), du(*)
        End Subroutine zgtsv
      End Interface
      Interface
        Subroutine zgtsvx(fact,trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb, &
            x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), d(*), dl(*), du(*)
          Complex (Kind=wp), Intent (Inout) :: df(*), dlf(*), du2(*), duf(*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine zgtsvx
      End Interface
      Interface
        Subroutine zgttrf(n,dl,d,du,du2,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: d(*), dl(*), du(*)
          Complex (Kind=wp), Intent (Out) :: du2(n-2)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zgttrf
      End Interface
      Interface
        Subroutine zgttrs(trans,n,nrhs,dl,d,du,du2,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Complex (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgttrs
      End Interface
      Interface
        Subroutine zgtcon(norm,n,dl,d,du,du2,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: norm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: d(*), dl(*), du(*), du2(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgtcon
      End Interface
      Interface
        Subroutine zgtrfs(trans,n,nrhs,dl,d,du,dlf,df,duf,du2,ipiv,b,ldb,x, &
            ldx,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), dl(*), &
            dlf(*), du(*), du2(*), duf(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zgtrfs
      End Interface
      Interface
        Subroutine dposv(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine dposv
      End Interface
      Interface
        Subroutine dposvx(fact,uplo,n,nrhs,a,lda,af,ldaf,equed,s,b,ldb,x,ldx, &
            rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            s(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dposvx
      End Interface
      Interface
        Subroutine dsposv(uplo,n,nrhs,a,lda,b,ldb,x,ldx,work,swork,iter,info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
          Real (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Real (Kind=wp), Intent (Out) :: work(n,nrhs)
        End Subroutine dsposv
      End Interface
      Interface
        Subroutine dpotrf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine dpotrf
      End Interface
      Interface
        Subroutine dpotrs(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dpotrs
      End Interface
      Interface
        Subroutine dpoequ(n,a,lda,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine dpoequ
      End Interface
      Interface
        Subroutine dpocon(uplo,n,a,lda,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dpocon
      End Interface
      Interface
        Subroutine dporfs(uplo,n,nrhs,a,lda,af,ldaf,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dporfs
      End Interface
      Interface
        Subroutine dpotri(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine dpotri
      End Interface
      Interface
        Subroutine zposv(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine zposv
      End Interface
      Interface
        Subroutine zposvx(fact,uplo,n,nrhs,a,lda,af,ldaf,equed,s,b,ldb,x,ldx, &
            rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), af(ldaf,*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine zposvx
      End Interface
      Interface
        Subroutine zcposv(uplo,n,nrhs,a,lda,b,ldb,x,ldx,work,swork,rwork,iter, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: rp, wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, iter
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: b(ldb,*)
          Complex (Kind=rp), Intent (Out) :: swork(n*(n+nrhs))
          Complex (Kind=wp), Intent (Out) :: work(n,nrhs)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zcposv
      End Interface
      Interface
        Subroutine zpotrf(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine zpotrf
      End Interface
      Interface
        Subroutine zpotrs(uplo,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine zpotrs
      End Interface
      Interface
        Subroutine zpoequ(n,a,lda,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine zpoequ
      End Interface
      Interface
        Subroutine zpocon(uplo,n,a,lda,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zpocon
      End Interface
      Interface
        Subroutine zporfs(uplo,n,nrhs,a,lda,af,ldaf,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine zporfs
      End Interface
      Interface
        Subroutine zpotri(uplo,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine zpotri
      End Interface
      Interface
        Subroutine dppsv(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine dppsv
      End Interface
      Interface
        Subroutine dppsvx(fact,uplo,n,nrhs,ap,afp,equed,s,b,ldb,x,ldx,rcond, &
            ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: afp(*), ap(*), b(ldb,*), s(*), &
            x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dppsvx
      End Interface
      Interface
        Subroutine dpptrf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine dpptrf
      End Interface
      Interface
        Subroutine dpptrs(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dpptrs
      End Interface
      Interface
        Subroutine dppequ(uplo,n,ap,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine dppequ
      End Interface
      Interface
        Subroutine dppcon(uplo,n,ap,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dppcon
      End Interface
      Interface
        Subroutine dpprfs(uplo,n,nrhs,ap,afp,b,ldb,x,ldx,ferr,berr,work,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dpprfs
      End Interface
      Interface
        Subroutine dpptri(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine dpptri
      End Interface
      Interface
        Subroutine zppsv(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
        End Subroutine zppsv
      End Interface
      Interface
        Subroutine zppsvx(fact,uplo,n,nrhs,ap,afp,equed,s,b,ldb,x,ldx,rcond, &
            ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), ap(*), b(ldb,*), &
            x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine zppsvx
      End Interface
      Interface
        Subroutine zpptrf(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine zpptrf
      End Interface
      Interface
        Subroutine zpptrs(uplo,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine zpptrs
      End Interface
      Interface
        Subroutine zppequ(uplo,n,ap,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine zppequ
      End Interface
      Interface
        Subroutine zppcon(uplo,n,ap,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zppcon
      End Interface
      Interface
        Subroutine zpprfs(uplo,n,nrhs,ap,afp,b,ldb,x,ldx,ferr,berr,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine zpprfs
      End Interface
      Interface
        Subroutine zpptri(uplo,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine zpptri
      End Interface
      Interface
        Subroutine dpbsv(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine dpbsv
      End Interface
      Interface
        Subroutine dpbsvx(fact,uplo,n,kd,nrhs,ab,ldab,afb,ldafb,equed,s,b,ldb, &
            x,ldx,rcond,ferr,berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), s(*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dpbsvx
      End Interface
      Interface
        Subroutine dpbtrf(uplo,n,kd,ab,ldab,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*)
        End Subroutine dpbtrf
      End Interface
      Interface
        Subroutine dpbtrs(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dpbtrs
      End Interface
      Interface
        Subroutine dpbequ(uplo,n,kd,ab,ldab,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine dpbequ
      End Interface
      Interface
        Subroutine dpbcon(uplo,n,kd,ab,ldab,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dpbcon
      End Interface
      Interface
        Subroutine dpbrfs(uplo,n,kd,nrhs,ab,ldab,afb,ldafb,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dpbrfs
      End Interface
      Interface
        Subroutine zpbsv(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), b(ldb,*)
        End Subroutine zpbsv
      End Interface
      Interface
        Subroutine zpbsvx(fact,uplo,n,kd,nrhs,ab,ldab,afb,ldafb,equed,s,b,ldb, &
            x,ldx,rcond,ferr,berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (Inout) :: equed
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), afb(ldafb,*), &
            b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (Inout) :: s(*)
        End Subroutine zpbsvx
      End Interface
      Interface
        Subroutine zpbtrf(uplo,n,kd,ab,ldab,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*)
        End Subroutine zpbtrf
      End Interface
      Interface
        Subroutine zpbtrs(uplo,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine zpbtrs
      End Interface
      Interface
        Subroutine zpbequ(uplo,n,kd,ab,ldab,s,scond,amax,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: amax, scond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: s(n)
        End Subroutine zpbequ
      End Interface
      Interface
        Subroutine zpbcon(uplo,n,kd,ab,ldab,anorm,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zpbcon
      End Interface
      Interface
        Subroutine zpbrfs(uplo,n,kd,nrhs,ab,ldab,afb,ldafb,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldafb, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), afb(ldafb,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine zpbrfs
      End Interface
      Interface
        Subroutine dptsv(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*), d(*), e(*)
        End Subroutine dptsv
      End Interface
      Interface
        Subroutine dptsvx(fact,n,nrhs,d,e,df,ef,b,ldb,x,ldx,rcond,ferr,berr, &
            work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), e(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(2*n)
          Real (Kind=wp), Intent (Inout) :: df(*), ef(*), x(ldx,*)
        End Subroutine dptsvx
      End Interface
      Interface
        Subroutine dpttrf(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
        End Subroutine dpttrf
      End Interface
      Interface
        Subroutine dpttrs(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Real (Kind=wp), Intent (In) :: d(*), e(*)
        End Subroutine dpttrs
      End Interface
      Interface
        Subroutine dptcon(n,d,e,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine dptcon
      End Interface
      Interface
        Subroutine dptrfs(n,nrhs,d,e,df,ef,b,ldb,x,ldx,ferr,berr,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: b(ldb,*), d(*), df(*), e(*), ef(*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(2*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
        End Subroutine dptrfs
      End Interface
      Interface
        Subroutine zptsv(n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*), e(*)
          Real (Kind=wp), Intent (Inout) :: d(*)
        End Subroutine zptsv
      End Interface
      Interface
        Subroutine zptsvx(fact,n,nrhs,d,e,df,ef,b,ldb,x,ldx,rcond,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), e(*)
          Complex (Kind=wp), Intent (Inout) :: ef(*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Inout) :: df(*)
        End Subroutine zptsvx
      End Interface
      Interface
        Subroutine zpttrf(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: e(*)
          Real (Kind=wp), Intent (Inout) :: d(*)
        End Subroutine zpttrf
      End Interface
      Interface
        Subroutine zpttrs(uplo,n,nrhs,d,e,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Complex (Kind=wp), Intent (In) :: e(*)
          Real (Kind=wp), Intent (In) :: d(*)
        End Subroutine zpttrs
      End Interface
      Interface
        Subroutine zptcon(n,d,e,anorm,rcond,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: e(*)
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zptcon
      End Interface
      Interface
        Subroutine zptrfs(uplo,n,nrhs,d,e,df,ef,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: b(ldb,*), e(*), ef(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Real (Kind=wp), Intent (In) :: d(*), df(*)
        End Subroutine zptrfs
      End Interface
      Interface
        Subroutine dpstrf(uplo,n,a,lda,piv,rank,tol,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (Out) :: piv(n)
        End Subroutine dpstrf
      End Interface
      Interface
        Subroutine zpstrf(uplo,n,a,lda,piv,rank,tol,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tol
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (Out) :: piv(n)
        End Subroutine zpstrf
      End Interface
      Interface
        Subroutine dsysv(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsysv
      End Interface
      Interface
        Subroutine dsysvx(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: af(ldaf,*), berr(*), ferr(*), &
            x(ldx,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*), iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsysvx
      End Interface
      Interface
        Subroutine dsytrf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsytrf
      End Interface
      Interface
        Subroutine dsytrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dsytrs
      End Interface
      Interface
        Subroutine dsycon(uplo,n,a,lda,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dsycon
      End Interface
      Interface
        Subroutine dsyrfs(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dsyrfs
      End Interface
      Interface
        Subroutine dsytri(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dsytri
      End Interface
      Interface
        Subroutine zhesv(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhesv
      End Interface
      Interface
        Subroutine zhesvx(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: af(ldaf,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: berr(*), ferr(*), rwork(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhesvx
      End Interface
      Interface
        Subroutine zhetrf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: ipiv(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhetrf
      End Interface
      Interface
        Subroutine zhetrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhetrs
      End Interface
      Interface
        Subroutine zhecon(uplo,n,a,lda,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhecon
      End Interface
      Interface
        Subroutine zherfs(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zherfs
      End Interface
      Interface
        Subroutine zhetri(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhetri
      End Interface
      Interface
        Subroutine zsysv(uplo,n,nrhs,a,lda,ipiv,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zsysv
      End Interface
      Interface
        Subroutine zsysvx(fact,uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx, &
            rcond,ferr,berr,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, lwork, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: af(ldaf,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: berr(*), ferr(*), rwork(*)
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zsysvx
      End Interface
      Interface
        Subroutine zsytrf(uplo,n,a,lda,ipiv,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: ipiv(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zsytrf
      End Interface
      Interface
        Subroutine zsytrs(uplo,n,nrhs,a,lda,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsytrs
      End Interface
      Interface
        Subroutine zsycon(uplo,n,a,lda,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsycon
      End Interface
      Interface
        Subroutine zsyrfs(uplo,n,nrhs,a,lda,af,ldaf,ipiv,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldaf, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), af(ldaf,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsyrfs
      End Interface
      Interface
        Subroutine zsytri(uplo,n,a,lda,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsytri
      End Interface
      Interface
        Subroutine dspsv(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dspsv
      End Interface
      Interface
        Subroutine dspsvx(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Inout) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dspsvx
      End Interface
      Interface
        Subroutine dsptrf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine dsptrf
      End Interface
      Interface
        Subroutine dsptrs(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dsptrs
      End Interface
      Interface
        Subroutine dspcon(uplo,n,ap,ipiv,anorm,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dspcon
      End Interface
      Interface
        Subroutine dsprfs(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Real (Kind=wp), Intent (Inout) :: x(ldx,*)
          Integer, Intent (In) :: ipiv(*)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dsprfs
      End Interface
      Interface
        Subroutine dsptri(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine dsptri
      End Interface
      Interface
        Subroutine zhpsv(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zhpsv
      End Interface
      Interface
        Subroutine zhpsvx(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine zhpsvx
      End Interface
      Interface
        Subroutine zhptrf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zhptrf
      End Interface
      Interface
        Subroutine zhptrs(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhptrs
      End Interface
      Interface
        Subroutine zhpcon(uplo,n,ap,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhpcon
      End Interface
      Interface
        Subroutine zhprfs(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhprfs
      End Interface
      Interface
        Subroutine zhptri(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zhptri
      End Interface
      Interface
        Subroutine zspsv(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), b(ldb,*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zspsv
      End Interface
      Interface
        Subroutine zspsvx(fact,uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,rcond,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: fact, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: afp(*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (Inout) :: ipiv(*)
        End Subroutine zspsvx
      End Interface
      Interface
        Subroutine zsptrf(uplo,n,ap,ipiv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Integer, Intent (Out) :: ipiv(n)
        End Subroutine zsptrf
      End Interface
      Interface
        Subroutine zsptrs(uplo,n,nrhs,ap,ipiv,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsptrs
      End Interface
      Interface
        Subroutine zspcon(uplo,n,ap,ipiv,anorm,rcond,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: anorm
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zspcon
      End Interface
      Interface
        Subroutine zsprfs(uplo,n,nrhs,ap,afp,ipiv,b,ldb,x,ldx,ferr,berr,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: afp(*), ap(*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Complex (Kind=wp), Intent (Inout) :: x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsprfs
      End Interface
      Interface
        Subroutine zsptri(uplo,n,ap,ipiv,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Integer, Intent (In) :: ipiv(*)
        End Subroutine zsptri
      End Interface
      Interface
        Subroutine dtrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtrtrs
      End Interface
      Interface
        Subroutine dtrcon(norm,uplo,diag,n,a,lda,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtrcon
      End Interface
      Interface
        Subroutine dtrrfs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtrrfs
      End Interface
      Interface
        Subroutine dtrtri(uplo,diag,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine dtrtri
      End Interface
      Interface
        Subroutine ztrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztrtrs
      End Interface
      Interface
        Subroutine ztrcon(norm,uplo,diag,n,a,lda,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine ztrcon
      End Interface
      Interface
        Subroutine ztrrfs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine ztrrfs
      End Interface
      Interface
        Subroutine ztrtri(uplo,diag,n,a,lda,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
        End Subroutine ztrtri
      End Interface
      Interface
        Subroutine dtptrs(uplo,trans,diag,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtptrs
      End Interface
      Interface
        Subroutine dtpcon(norm,uplo,diag,n,ap,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtpcon
      End Interface
      Interface
        Subroutine dtprfs(uplo,trans,diag,n,nrhs,ap,b,ldb,x,ldx,ferr,berr, &
            work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtprfs
      End Interface
      Interface
        Subroutine dtptri(uplo,diag,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine dtptri
      End Interface
      Interface
        Subroutine ztptrs(uplo,trans,diag,n,nrhs,ap,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztptrs
      End Interface
      Interface
        Subroutine ztpcon(norm,uplo,diag,n,ap,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine ztpcon
      End Interface
      Interface
        Subroutine ztprfs(uplo,trans,diag,n,nrhs,ap,b,ldb,x,ldx,ferr,berr, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine ztprfs
      End Interface
      Interface
        Subroutine ztptri(uplo,diag,n,ap,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
        End Subroutine ztptri
      End Interface
      Interface
        Subroutine dtbtrs(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dtbtrs
      End Interface
      Interface
        Subroutine dtbcon(norm,uplo,diag,n,kd,ab,ldab,rcond,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtbcon
      End Interface
      Interface
        Subroutine dtbrfs(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,x,ldx,ferr, &
            berr,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ab(ldab,*), b(ldb,*), x(ldx,*)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), work(3*n)
          Integer, Intent (Out) :: iwork(n)
        End Subroutine dtbrfs
      End Interface
      Interface
        Subroutine ztbtrs(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine ztbtrs
      End Interface
      Interface
        Subroutine ztbcon(norm,uplo,diag,n,kd,ab,ldab,rcond,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rcond
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, n
          Character (1), Intent (In) :: diag, norm, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine ztbcon
      End Interface
      Interface
        Subroutine ztbrfs(uplo,trans,diag,n,kd,nrhs,ab,ldab,b,ldb,x,ldx,ferr, &
            berr,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldb, ldx, n, nrhs
          Character (1), Intent (In) :: diag, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ab(ldab,*), b(ldb,*), x(ldx,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: berr(nrhs), ferr(nrhs), rwork(n)
        End Subroutine ztbrfs
      End Interface
      Interface
        Subroutine dpftrf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine dpftrf
      End Interface
      Interface
        Subroutine dpftrs(transr,uplo,n,nrhs,a,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Real (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine dpftrs
      End Interface
      Interface
        Subroutine dpftri(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine dpftri
      End Interface
      Interface
        Subroutine dtftri(transr,uplo,diag,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, transr, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine dtftri
      End Interface
      Interface
        Subroutine zpftrf(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine zpftrf
      End Interface
      Interface
        Subroutine zpftrs(transr,uplo,n,nrhs,a,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldb, n, nrhs
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(n*(n+1)/2)
          Complex (Kind=wp), Intent (Inout) :: b(ldb,*)
        End Subroutine zpftrs
      End Interface
      Interface
        Subroutine zpftri(transr,uplo,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine zpftri
      End Interface
      Interface
        Subroutine ztftri(transr,uplo,diag,n,a,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, transr, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(n*(n+1)/2)
        End Subroutine ztftri
      End Interface
      Interface
        Subroutine dgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgels
      End Interface
      Interface
        Subroutine dgeqrf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeqrf
      End Interface
      Interface
        Subroutine dorgqr(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorgqr
      End Interface
      Interface
        Subroutine dormqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormqr
      End Interface
      Interface
        Subroutine dgelqf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgelqf
      End Interface
      Interface
        Subroutine dorglq(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorglq
      End Interface
      Interface
        Subroutine dormlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormlq
      End Interface
      Interface
        Subroutine zgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgels
      End Interface
      Interface
        Subroutine zgeqrf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeqrf
      End Interface
      Interface
        Subroutine zungqr(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zungqr
      End Interface
      Interface
        Subroutine zunmqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmqr
      End Interface
      Interface
        Subroutine zgelqf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgelqf
      End Interface
      Interface
        Subroutine zunglq(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunglq
      End Interface
      Interface
        Subroutine zunmlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmlq
      End Interface
      Interface
        Subroutine dgelsy(m,n,nrhs,a,lda,b,ldb,jpvt,rcond,rank,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgelsy
      End Interface
      Interface
        Subroutine dgeqpf(m,n,a,lda,jpvt,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: tau(min(m,n)), work(3*n)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine dgeqpf
      End Interface
      Interface
        Subroutine dgeqp3(m,n,a,lda,jpvt,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeqp3
      End Interface
      Interface
        Subroutine dtzrzf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtzrzf
      End Interface
      Interface
        Subroutine dormrz(side,trans,m,n,k,l,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, l, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormrz
      End Interface
      Interface
        Subroutine zgelsy(m,n,nrhs,a,lda,b,ldb,jpvt,rcond,rank,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgelsy
      End Interface
      Interface
        Subroutine zgeqpf(m,n,a,lda,jpvt,tau,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: tau(min(m,n)), work(n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: min
        End Subroutine zgeqpf
      End Interface
      Interface
        Subroutine zgeqp3(m,n,a,lda,jpvt,tau,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Integer, Intent (Inout) :: jpvt(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeqp3
      End Interface
      Interface
        Subroutine ztzrzf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine ztzrzf
      End Interface
      Interface
        Subroutine zunmrz(side,trans,m,n,k,l,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, l, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmrz
      End Interface
      Interface
        Subroutine dgeqlf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeqlf
      End Interface
      Interface
        Subroutine dorgql(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorgql
      End Interface
      Interface
        Subroutine dormql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormql
      End Interface
      Interface
        Subroutine dgerqf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgerqf
      End Interface
      Interface
        Subroutine dorgrq(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorgrq
      End Interface
      Interface
        Subroutine dormrq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormrq
      End Interface
      Interface
        Subroutine zgeqlf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeqlf
      End Interface
      Interface
        Subroutine zungql(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zungql
      End Interface
      Interface
        Subroutine zunmql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmql
      End Interface
      Interface
        Subroutine zgerqf(m,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgerqf
      End Interface
      Interface
        Subroutine zungrq(m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zungrq
      End Interface
      Interface
        Subroutine zunmrq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmrq
      End Interface
      Interface
        Subroutine dsyev(jobz,uplo,n,a,lda,w,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsyev
      End Interface
      Interface
        Subroutine dsyevx(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,work,lwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*), jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsyevx
      End Interface
      Interface
        Subroutine dsyevd(job,uplo,n,a,lda,w,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsyevd
      End Interface
      Interface
        Subroutine dsyevr(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsyevr
      End Interface
      Interface
        Subroutine dsytrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), d(*), e(*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsytrd
      End Interface
      Interface
        Subroutine dorgtr(uplo,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorgtr
      End Interface
      Interface
        Subroutine dormtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormtr
      End Interface
      Interface
        Subroutine ddisna(job,m,n,d,sep,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: m, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*)
          Real (Kind=wp), Intent (Inout) :: sep(*)
        End Subroutine ddisna
      End Interface
      Interface
        Subroutine zheev(jobz,uplo,n,a,lda,w,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), w(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zheev
      End Interface
      Interface
        Subroutine zheevx(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,work,lwork,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), w(*)
          Integer, Intent (Inout) :: iwork(*), jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zheevx
      End Interface
      Interface
        Subroutine zheevd(job,uplo,n,a,lda,w,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zheevd
      End Interface
      Interface
        Subroutine zheevr(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z, &
            ldz,isuppz,work,lwork,rwork,lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, lda, ldz, liwork, lrwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zheevr
      End Interface
      Interface
        Subroutine zhetrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhetrd
      End Interface
      Interface
        Subroutine zungtr(uplo,n,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zungtr
      End Interface
      Interface
        Subroutine zunmtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmtr
      End Interface
      Interface
        Subroutine dspev(jobz,uplo,n,ap,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine dspev
      End Interface
      Interface
        Subroutine dspevx(jobz,range,uplo,n,ap,vl,vu,il,iu,abstol,m,w,z,ldz, &
            work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(8*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine dspevx
      End Interface
      Interface
        Subroutine dspevd(job,uplo,n,ap,w,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dspevd
      End Interface
      Interface
        Subroutine dsptrd(uplo,n,ap,d,e,tau,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1), tau(n-1)
        End Subroutine dsptrd
      End Interface
      Interface
        Subroutine dopgtr(uplo,n,ap,tau,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: ap(*), tau(*)
          Real (Kind=wp), Intent (Inout) :: q(ldq,*)
          Real (Kind=wp), Intent (Out) :: work(n-1)
        End Subroutine dopgtr
      End Interface
      Interface
        Subroutine dopmtr(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), c(ldc,*), work(*)
          Real (Kind=wp), Intent (In) :: tau(*)
        End Subroutine dopmtr
      End Interface
      Interface
        Subroutine zhpev(jobz,uplo,n,ap,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n-1)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine zhpev
      End Interface
      Interface
        Subroutine zhpevx(jobz,range,uplo,n,ap,vl,vu,il,iu,abstol,m,w,z,ldz, &
            work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine zhpevx
      End Interface
      Interface
        Subroutine zhpevd(job,uplo,n,ap,w,z,ldz,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhpevd
      End Interface
      Interface
        Subroutine zhptrd(uplo,n,ap,d,e,tau,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (Out) :: tau(n-1)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1)
        End Subroutine zhptrd
      End Interface
      Interface
        Subroutine zupgtr(uplo,n,ap,tau,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: ap(*), tau(*)
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(n-1)
        End Subroutine zupgtr
      End Interface
      Interface
        Subroutine zupmtr(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, m, n
          Character (1), Intent (In) :: side, trans, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), c(ldc,*), work(*)
          Complex (Kind=wp), Intent (In) :: tau(*)
        End Subroutine zupmtr
      End Interface
      Interface
        Subroutine dsbev(jobz,uplo,n,kd,ab,ldab,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n-2)
        End Subroutine dsbev
      End Interface
      Interface
        Subroutine dsbevx(jobz,range,uplo,n,kd,ab,ldab,q,ldq,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, kd, ldab, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(7*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine dsbevx
      End Interface
      Interface
        Subroutine dsbevd(job,uplo,n,kd,ab,ldab,w,z,ldz,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, liwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsbevd
      End Interface
      Interface
        Subroutine dsbtrd(vect,uplo,n,kd,ab,ldab,d,e,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldq, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1), work(n)
        End Subroutine dsbtrd
      End Interface
      Interface
        Subroutine zhbev(jobz,uplo,n,kd,ab,ldab,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine zhbev
      End Interface
      Interface
        Subroutine zhbevx(jobz,range,uplo,n,kd,ab,ldab,q,ldq,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, kd, ldab, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine zhbevx
      End Interface
      Interface
        Subroutine zhbevd(job,uplo,n,kd,ab,ldab,w,z,ldz,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: job, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Real (Kind=wp), Intent (Inout) :: w(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhbevd
      End Interface
      Interface
        Subroutine zhbtrd(vect,uplo,n,kd,ab,ldab,d,e,q,ldq,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kd, ldab, ldq, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: d(n), e(n-1)
        End Subroutine zhbtrd
      End Interface
      Interface
        Subroutine dstev(jobz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*), z(ldz,*)
        End Subroutine dstev
      End Interface
      Interface
        Subroutine dstevx(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz,work, &
            iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(5*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine dstevx
      End Interface
      Interface
        Subroutine dstevd(job,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dstevd
      End Interface
      Interface
        Subroutine dstevr(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dstevr
      End Interface
      Interface
        Subroutine dsteqr(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*), z(ldz,*)
        End Subroutine dsteqr
      End Interface
      Interface
        Subroutine dsterf(n,d,e,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
        End Subroutine dsterf
      End Interface
      Interface
        Subroutine dpteqr(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
        End Subroutine dpteqr
      End Interface
      Interface
        Subroutine dstedc(compz,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lwork, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dstedc
      End Interface
      Interface
        Subroutine dstebz(range,order,n,vl,vu,il,iu,abstol,d,e,m,nsplit,w, &
            iblock,isplit,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, n
          Integer, Intent (Out) :: info, m, nsplit
          Character (1), Intent (In) :: order, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: w(n), work(4*n)
          Integer, Intent (Out) :: iblock(n), isplit(n), iwork(3*n)
        End Subroutine dstebz
      End Interface
      Interface
        Subroutine dstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifailv, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(5*n)
          Real (Kind=wp), Intent (Inout) :: z(ldz,*)
          Integer, Intent (In) :: iblock(*), isplit(*)
          Integer, Intent (Out) :: ifailv(m), iwork(n)
        End Subroutine dstein
      End Interface
      Interface
        Subroutine dstegr(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dstegr
      End Interface
      Interface
        Subroutine zsteqr(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*)
        End Subroutine zsteqr
      End Interface
      Interface
        Subroutine zpteqr(compz,n,d,e,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: work(4*n)
        End Subroutine zpteqr
      End Interface
      Interface
        Subroutine zstedc(compz,n,d,e,z,ldz,work,lwork,rwork,lrwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zstedc
      End Interface
      Interface
        Subroutine zstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifailv, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldz, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (In) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(5*n)
          Integer, Intent (In) :: iblock(*), isplit(*)
          Integer, Intent (Out) :: ifailv(m), iwork(n)
        End Subroutine zstein
      End Interface
      Interface
        Subroutine zstegr(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz, &
            isuppz,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: z(ldz,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: isuppz(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zstegr
      End Interface
      Interface
        Subroutine dgelss(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgelss
      End Interface
      Interface
        Subroutine dgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobu, jobvt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), s(*), u(ldu,*), &
            vt(ldvt,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgesvd
      End Interface
      Interface
        Subroutine dgelsd(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgelsd
      End Interface
      Interface
        Subroutine dgesdd(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,iwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Real (Kind=wp), Intent (Out) :: s(min(m,n)), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(8*min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine dgesdd
      End Interface
      Interface
        Subroutine dgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), d(*), e(*), taup(*), &
            tauq(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgebrd
      End Interface
      Interface
        Subroutine dorgbr(vect,m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorgbr
      End Interface
      Interface
        Subroutine dormbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormbr
      End Interface
      Interface
        Subroutine dgejsv(joba,jobu,jobv,jobr,jobt,jobp,m,n,a,lda,sva,u,ldu,v, &
            ldv,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldv, lwork, m, n
          Character (1), Intent (In) :: joba, jobp, jobr, jobt, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: sva(n), work(lwork)
          Integer, Intent (Out) :: iwork(m+3*n)
        End Subroutine dgejsv
      End Interface
      Interface
        Subroutine dgesvj(joba,jobu,jobv,m,n,a,lda,sva,mv,v,ldv,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldv, lwork, m, mv, n
          Character (1), Intent (In) :: joba, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), v(ldv,*), work(lwork)
          Real (Kind=wp), Intent (Out) :: sva(n)
        End Subroutine dgesvj
      End Interface
      Interface
        Subroutine zgelss(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgelss
      End Interface
      Interface
        Subroutine zgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobu, jobvt
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgesvd
      End Interface
      Interface
        Subroutine zgelsd(m,n,nrhs,a,lda,b,ldb,s,rcond,rank,work,lwork,rwork, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: rcond
          Integer, Intent (Out) :: info, rank
          Integer, Intent (In) :: lda, ldb, lwork, m, n, nrhs
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*)
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgelsd
      End Interface
      Interface
        Subroutine zgesdd(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,rwork, &
            iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldu, ldvt, lwork, m, n
          Character (1), Intent (In) :: jobz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), u(ldu,*), vt(ldvt,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Real (Kind=wp), Intent (Out) :: s(min(m,n))
          Integer, Intent (Out) :: iwork(8*min(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine zgesdd
      End Interface
      Interface
        Subroutine zgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, lwork, m, n
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), taup(*), tauq(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: d(*), e(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgebrd
      End Interface
      Interface
        Subroutine zungbr(vect,m,n,k,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, lwork, m, n
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zungbr
      End Interface
      Interface
        Subroutine zunmbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: k, lda, ldc, lwork, m, n
          Character (1), Intent (In) :: side, trans, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmbr
      End Interface
      Interface
        Subroutine dgbbrd(vect,m,n,ncc,kl,ku,ab,ldab,d,e,q,ldq,pt,ldpt,c,ldc, &
            work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldc, ldpt, ldq, m, n, ncc
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), c(ldc,*), pt(ldpt,*), &
            q(ldq,*)
          Real (Kind=wp), Intent (Out) :: d(min(m,n)), e(min(m,n)-1), &
            work(2*max(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine dgbbrd
      End Interface
      Interface
        Subroutine zgbbrd(vect,m,n,ncc,kl,ku,ab,ldab,d,e,q,ldq,pt,ldpt,c,ldc, &
            work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kl, ku, ldab, ldc, ldpt, ldq, m, n, ncc
          Character (1), Intent (In) :: vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), c(ldc,*), &
            pt(ldpt,*), q(ldq,*)
          Complex (Kind=wp), Intent (Out) :: work(max(m,n))
          Real (Kind=wp), Intent (Out) :: d(min(m,n)), e(min(m,n)-1), &
            rwork(max(m,n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine zgbbrd
      End Interface
      Interface
        Subroutine dbdsdc(uplo,compq,n,d,e,u,ldu,vt,ldvt,q,iq,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldu, ldvt, n
          Character (1), Intent (In) :: compq, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), q(*), u(ldu,*), &
            vt(ldvt,*), work(*)
          Integer, Intent (Inout) :: iq(*)
          Integer, Intent (Out) :: iwork(8*n)
        End Subroutine dbdsdc
      End Interface
      Interface
        Subroutine dbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, ldu, ldvt, n, ncc, ncvt, nru
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: c(ldc,*), d(*), e(*), u(ldu,*), &
            vt(ldvt,*), work(*)
        End Subroutine dbdsqr
      End Interface
      Interface
        Subroutine zbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldc, ldu, ldvt, n, ncc, ncvt, nru
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*), u(ldu,*), vt(ldvt,*)
          Real (Kind=wp), Intent (Inout) :: d(*), e(*), work(*)
        End Subroutine zbdsqr
      End Interface
      Interface
        Subroutine dgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), vr(ldvr,*), &
            wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeev
      End Interface
      Interface
        Subroutine dgeevx(balanc,jobvl,jobvr,sense,n,a,lda,wr,wi,vl,ldvl,vr, &
            ldvr,ilo,ihi,scale,abnrm,rconde,rcondv,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), rconde(*), rcondv(*), &
            scale(*), vl(ldvl,*), vr(ldvr,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeevx
      End Interface
      Interface
        Subroutine dgehrd(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgehrd
      End Interface
      Interface
        Subroutine dorghr(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dorghr
      End Interface
      Interface
        Subroutine dormhr(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldc, lwork, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Real (Kind=wp), Intent (In) :: tau(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dormhr
      End Interface
      Interface
        Subroutine dgebal(job,n,a,lda,ilo,ihi,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: scale(n)
        End Subroutine dgebal
      End Interface
      Interface
        Subroutine dgebak(job,side,n,ilo,ihi,scale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: scale(*)
          Real (Kind=wp), Intent (Inout) :: v(ldv,*)
        End Subroutine dgebak
      End Interface
      Interface
        Subroutine zgeev(jobvl,jobvr,n,a,lda,w,vl,ldvl,vr,ldvr,work,lwork, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), &
            vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeev
      End Interface
      Interface
        Subroutine zgeevx(balanc,jobvl,jobvr,sense,n,a,lda,w,vl,ldvl,vr,ldvr, &
            ilo,ihi,scale,abnrm,rconde,rcondv,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vl(ldvl,*), &
            vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rconde(*), rcondv(*), rwork(*), &
            scale(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeevx
      End Interface
      Interface
        Subroutine zgehrd(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgehrd
      End Interface
      Interface
        Subroutine zunghr(n,ilo,ihi,a,lda,tau,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, lwork, n
          Integer, Intent (Out) :: info
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunghr
      End Interface
      Interface
        Subroutine zunmhr(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldc, lwork, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: side, trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), c(ldc,*)
          Complex (Kind=wp), Intent (In) :: tau(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zunmhr
      End Interface
      Interface
        Subroutine zgebal(job,n,a,lda,ilo,ihi,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (Out) :: scale(n)
        End Subroutine zgebal
      End Interface
      Interface
        Subroutine zgebak(job,side,n,ilo,ihi,scale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: v(ldv,*)
          Real (Kind=wp), Intent (In) :: scale(*)
        End Subroutine zgebak
      End Interface
      Interface
        Subroutine dgees(jobvs,sort,select,n,a,lda,sdim,wr,wi,vs,ldvs,work, &
            lwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(wr,wi)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: wi, wr
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgees
      End Interface
      Interface
        Subroutine dgeesx(jobvs,sort,select,sense,n,a,lda,sdim,wr,wi,vs,ldvs, &
            rconde,rcondv,work,lwork,iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rconde, rcondv
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, liwork, lwork, n
          Character (1), Intent (In) :: jobvs, sense, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(wr,wi)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: wi, wr
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgeesx
      End Interface
      Interface
        Subroutine dhseqr(job,compz,n,ilo,ihi,h,ldh,wr,wi,z,ldz,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldh, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compz, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: h(ldh,*), wi(*), wr(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dhseqr
      End Interface
      Interface
        Subroutine dhsein(job,eigsrc,initv,select,n,h,ldh,wr,wi,vl,ldvl,vr, &
            ldvr,mm,m,work,ifaill,ifailr,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldh, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: eigsrc, initv, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: h(ldh,*), wi(*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*), wr(*)
          Real (Kind=wp), Intent (Out) :: work((n+2)*n)
          Integer, Intent (Inout) :: ifaill(*), ifailr(*)
          Logical, Intent (Inout) :: select(*)
        End Subroutine dhsein
      End Interface
      Interface
        Subroutine zgees(jobvs,sort,select,n,a,lda,sdim,w,vs,ldvs,work,lwork, &
            rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(w)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: w
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgees
      End Interface
      Interface
        Subroutine zgeesx(jobvs,sort,select,sense,n,a,lda,sdim,w,vs,ldvs, &
            rconde,rcondv,work,lwork,rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: rconde, rcondv
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldvs, lwork, n
          Character (1), Intent (In) :: jobvs, sense, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), vs(ldvs,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: rwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function select(w)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: select
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: w
            End Function select
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgeesx
      End Interface
      Interface
        Subroutine zhseqr(job,compz,n,ilo,ihi,h,ldh,w,z,ldz,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldh, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compz, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: h(ldh,*), w(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhseqr
      End Interface
      Interface
        Subroutine zhsein(job,eigsrc,initv,select,n,h,ldh,w,vl,ldvl,vr,ldvr, &
            mm,m,work,rwork,ifaill,ifailr,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldh, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: eigsrc, initv, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: h(ldh,*)
          Complex (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(n*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Integer, Intent (Inout) :: ifaill(*), ifailr(*)
          Logical, Intent (In) :: select(*)
        End Subroutine zhsein
      End Interface
      Interface
        Subroutine dtrexc(compq,n,t,ldt,q,ldq,ifst,ilst,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifst, ilst
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ldq, ldt, n
          Character (1), Intent (In) :: compq
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*)
          Real (Kind=wp), Intent (Out) :: work(n)
        End Subroutine dtrexc
      End Interface
      Interface
        Subroutine dtrsen(job,compq,select,n,t,ldt,q,ldq,wr,wi,m,s,sep,work, &
            lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s, sep
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldq, ldt, liwork, lwork, n
          Character (1), Intent (In) :: compq, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*), wi(*), wr(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtrsen
      End Interface
      Interface
        Subroutine dtrsyl(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scale,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: scale
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: isgn, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: trana, tranb
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine dtrsyl
      End Interface
      Interface
        Subroutine dtrevc(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: t(ldt,*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: work(3*n)
          Logical, Intent (Inout) :: select(*)
        End Subroutine dtrevc
      End Interface
      Interface
        Subroutine dtrsna(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,s,sep,mm, &
            m,work,ldwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, ldwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: s(*), sep(*), work(ldwork,*)
          Real (Kind=wp), Intent (In) :: t(ldt,*), vl(ldvl,*), vr(ldvr,*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
        End Subroutine dtrsna
      End Interface
      Interface
        Subroutine ztrexc(compq,n,t,ldt,q,ldq,ifst,ilst,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ifst, ilst, ldq, ldt, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*)
        End Subroutine ztrexc
      End Interface
      Interface
        Subroutine ztrsen(job,compq,select,n,t,ldt,q,ldq,w,m,s,sep,work,lwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: s, sep
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldq, ldt, lwork, n
          Character (1), Intent (In) :: compq, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: q(ldq,*), t(ldt,*), w(*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine ztrsen
      End Interface
      Interface
        Subroutine ztrsyl(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scal,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: scal
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: isgn, lda, ldb, ldc, m, n
          Character (1), Intent (In) :: trana, tranb
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*)
        End Subroutine ztrsyl
      End Interface
      Interface
        Subroutine ztrevc(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work, &
            rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: t(ldt,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
          Logical, Intent (In) :: select(*)
        End Subroutine ztrevc
      End Interface
      Interface
        Subroutine ztrsna(job,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,s,sep,mm, &
            m,work,ldwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: ldt, ldvl, ldvr, ldwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: t(ldt,*), vl(ldvl,*), vr(ldvr,*)
          Complex (Kind=wp), Intent (Inout) :: work(ldwork,*)
          Real (Kind=wp), Intent (Inout) :: rwork(*), s(*), sep(*)
          Logical, Intent (In) :: select(*)
        End Subroutine ztrsna
      End Interface
      Interface
        Subroutine dsygv(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), w(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsygv
      End Interface
      Interface
        Subroutine dsygvx(itype,jobz,range,uplo,n,a,lda,b,ldb,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,lwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, lda, ldb, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsygvx
      End Interface
      Interface
        Subroutine dsygvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsygvd
      End Interface
      Interface
        Subroutine dsygst(itype,uplo,n,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*)
          Real (Kind=wp), Intent (In) :: b(ldb,*)
        End Subroutine dsygst
      End Interface
      Interface
        Subroutine zhegv(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhegv
      End Interface
      Interface
        Subroutine zhegvx(itype,jobz,range,uplo,n,a,lda,b,ldb,vl,vu,il,iu, &
            abstol,m,w,z,ldz,work,lwork,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, lda, ldb, ldz, lwork, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhegvx
      End Interface
      Interface
        Subroutine zhegvd(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhegvd
      End Interface
      Interface
        Subroutine zhegst(itype,uplo,n,a,lda,b,ldb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, lda, ldb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
        End Subroutine zhegst
      End Interface
      Interface
        Subroutine dspgv(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine dspgv
      End Interface
      Interface
        Subroutine dspgvx(itype,jobz,range,uplo,n,ap,bp,vl,vu,il,iu,abstol,m, &
            w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(8*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine dspgvx
      End Interface
      Interface
        Subroutine dspgvd(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,lwork,iwork, &
            liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dspgvd
      End Interface
      Interface
        Subroutine dspgst(itype,uplo,n,ap,bp,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ap(*)
          Real (Kind=wp), Intent (In) :: bp(*)
        End Subroutine dspgst
      End Interface
      Interface
        Subroutine zhpgv(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n-1)
          Real (Kind=wp), Intent (Out) :: rwork(3*n-2), w(n)
        End Subroutine zhpgv
      End Interface
      Interface
        Subroutine zhpgvx(itype,jobz,range,uplo,n,ap,bp,vl,vu,il,iu,abstol,m, &
            w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, itype, iu, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine zhpgvx
      End Interface
      Interface
        Subroutine zhpgvd(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,lwork,rwork, &
            lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, ldz, liwork, lrwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*), bp(*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhpgvd
      End Interface
      Interface
        Subroutine zhpgst(itype,uplo,n,ap,bp,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: itype, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ap(*)
          Complex (Kind=wp), Intent (In) :: bp(*)
        End Subroutine zhpgst
      End Interface
      Interface
        Subroutine dsbgv(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(3*n)
        End Subroutine dsbgv
      End Interface
      Interface
        Subroutine dsbgvx(jobz,range,uplo,n,ka,kb,ab,ldab,bb,ldbb,q,ldq,vl,vu, &
            il,iu,abstol,m,w,z,ldz,work,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ka, kb, ldab, ldbb, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(7*n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine dsbgvx
      End Interface
      Interface
        Subroutine dsbgvd(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work, &
            lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, liwork, lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: w(n), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dsbgvd
      End Interface
      Interface
        Subroutine dsbgst(vect,uplo,n,ka,kb,ab,ldab,bb,ldbb,x,ldx,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldx, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: ab(ldab,*), x(ldx,*)
          Real (Kind=wp), Intent (In) :: bb(ldbb,*)
          Real (Kind=wp), Intent (Out) :: work(2*n)
        End Subroutine dsbgst
      End Interface
      Interface
        Subroutine dpbstf(uplo,n,kb,bb,ldbb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kb, ldbb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bb(ldbb,*)
        End Subroutine dpbstf
      End Interface
      Interface
        Subroutine zhbgv(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(3*n), w(n)
        End Subroutine zhbgv
      End Interface
      Interface
        Subroutine zhbgvx(jobz,range,uplo,n,ka,kb,ab,ldab,bb,ldbb,q,ldq,vl,vu, &
            il,iu,abstol,m,w,z,ldz,work,rwork,iwork,jfail,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: abstol, vl, vu
          Integer, Intent (In) :: il, iu, ka, kb, ldab, ldbb, ldq, ldz, n
          Integer, Intent (Out) :: info, m
          Character (1), Intent (In) :: jobz, range, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            q(ldq,*), z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(7*n), w(n)
          Integer, Intent (Out) :: iwork(5*n)
          Integer, Intent (Inout) :: jfail(*)
        End Subroutine zhbgvx
      End Interface
      Interface
        Subroutine zhbgvd(jobz,uplo,n,ka,kb,ab,ldab,bb,ldbb,w,z,ldz,work, &
            lwork,rwork,lrwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldz, liwork, lrwork, &
            lwork, n
          Character (1), Intent (In) :: jobz, uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), bb(ldbb,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,lrwork)), w(n)
          Integer, Intent (Out) :: iwork(max(1,liwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhbgvd
      End Interface
      Interface
        Subroutine zhbgst(vect,uplo,n,ka,kb,ab,ldab,bb,ldbb,x,ldx,work,rwork, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: ka, kb, ldab, ldbb, ldx, n
          Character (1), Intent (In) :: uplo, vect
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: ab(ldab,*), x(ldx,*)
          Complex (Kind=wp), Intent (In) :: bb(ldbb,*)
          Complex (Kind=wp), Intent (Out) :: work(n)
          Real (Kind=wp), Intent (Out) :: rwork(n)
        End Subroutine zhbgst
      End Interface
      Interface
        Subroutine zpbstf(uplo,n,kb,bb,ldbb,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: kb, ldbb, n
          Character (1), Intent (In) :: uplo
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: bb(ldbb,*)
        End Subroutine zpbstf
      End Interface
      Interface
        Subroutine dggsvd(jobu,jobv,jobq,m,n,p,k,l,a,lda,b,ldb,alpha,beta,u, &
            ldu,v,ldv,q,ldq,work,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(3*n,m,p)+n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggsvd
      End Interface
      Interface
        Subroutine dggsvp(jobu,jobv,jobq,m,p,n,a,lda,b,ldb,tola,tolb,k,l,u, &
            ldu,v,ldv,q,ldq,iwork,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: tau(n), work(max(3*n,m,p))
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggsvp
      End Interface
      Interface
        Subroutine zggsvd(jobu,jobv,jobq,m,n,p,k,l,a,lda,b,ldb,alpha,beta,u, &
            ldu,v,ldv,q,ldq,work,rwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: work(max(3*n,m,p)+n)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), rwork(2*n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggsvd
      End Interface
      Interface
        Subroutine zggsvp(jobu,jobv,jobq,m,p,n,a,lda,b,ldb,tola,tolb,k,l,u, &
            ldu,v,ldv,q,ldq,iwork,rwork,tau,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, k, l
          Integer, Intent (In) :: lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: tau(n), work(max(3*n,m,p))
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Integer, Intent (Out) :: iwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggsvp
      End Interface
      Interface
        Subroutine dggev(jobvl,jobvr,n,a,lda,b,ldb,alphar,alphai,beta,vl,ldvl, &
            vr,ldvr,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggev
      End Interface
      Interface
        Subroutine dggevx(balanc,jobvl,jobvr,sense,n,a,lda,b,ldb,alphar, &
            alphai,beta,vl,ldvl,vr,ldvr,ilo,ihi,lscale,rscale,abnrm,bbnrm, &
            rconde,rcondv,work,lwork,iwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm, bbnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), rconde(*), &
            rcondv(*), vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            lscale(n), rscale(n), work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggevx
      End Interface
      Interface
        Subroutine dgghrd(compq,compz,n,ilo,ihi,a,lda,b,ldb,q,ldq,z,ldz,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine dgghrd
      End Interface
      Interface
        Subroutine dggbal(job,n,a,lda,b,ldb,ilo,ihi,lscale,rscale,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), work(*)
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n)
        End Subroutine dggbal
      End Interface
      Interface
        Subroutine dggbak(job,side,n,ilo,ihi,lscale,rscale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: lscale(*), rscale(*)
          Real (Kind=wp), Intent (Inout) :: v(ldv,*)
        End Subroutine dggbak
      End Interface
      Interface
        Subroutine zggev(jobvl,jobvr,n,a,lda,b,ldb,alpha,beta,vl,ldvl,vr,ldvr, &
            work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: jobvl, jobvr
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,8*n))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggev
      End Interface
      Interface
        Subroutine zggevx(balanc,jobvl,jobvr,sense,n,a,lda,b,ldb,alpha,beta, &
            vl,ldvl,vr,ldvr,ilo,ihi,lscale,rscale,abnrm,bbnrm,rconde,rcondv, &
            work,lwork,rwork,iwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: abnrm, bbnrm
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, n
          Character (1), Intent (In) :: balanc, jobvl, jobvr, sense
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n), rwork(6*n)
          Real (Kind=wp), Intent (Inout) :: rconde(*), rcondv(*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (Inout) :: bwork(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggevx
      End Interface
      Interface
        Subroutine zgghrd(compq,compz,n,ilo,ihi,a,lda,b,ldb,q,ldq,z,ldz,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine zgghrd
      End Interface
      Interface
        Subroutine zggbal(job,n,a,lda,b,ldb,ilo,ihi,lscale,rscale,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: ihi, ilo, info
          Integer, Intent (In) :: lda, ldb, n
          Character (1), Intent (In) :: job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: lscale(n), rscale(n), work(6*n)
        End Subroutine zggbal
      End Interface
      Interface
        Subroutine zggbak(job,side,n,ilo,ihi,lscale,rscale,m,v,ldv,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, ldv, m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: job, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: v(ldv,*)
          Real (Kind=wp), Intent (In) :: lscale(*), rscale(*)
        End Subroutine zggbak
      End Interface
      Interface
        Subroutine dgges(jobvsl,jobvsr,sort,selctg,n,a,lda,b,ldb,sdim,alphar, &
            alphai,beta,vsl,ldvsl,vsr,ldvsr,work,lwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vsl(ldvsl,*), &
            vsr(ldvsr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(ar,ai,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: ai, ar, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgges
      End Interface
      Interface
        Subroutine dggesx(jobvsl,jobvsr,sort,selctg,sense,n,a,lda,b,ldb,sdim, &
            alphar,alphai,beta,vsl,ldvsl,vsr,ldvsr,rconde,rcondv,work,lwork, &
            iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, liwork, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sense, sort
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), vsl(ldvsl,*), &
            vsr(ldvsr,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            rconde(2), rcondv(2), work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(ar,ai,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (In) :: ai, ar, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggesx
      End Interface
      Interface
        Subroutine dhgeqz(job,compq,compz,n,ilo,ihi,a,lda,b,ldb,alphar,alphai, &
            beta,q,ldq,z,ldz,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dhgeqz
      End Interface
      Interface
        Subroutine zgges(jobvsl,jobvsr,sort,selctg,n,a,lda,b,ldb,sdim,alpha, &
            beta,vsl,ldvsl,vsr,ldvsr,work,lwork,rwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), &
            vsl(ldvsl,*), vsr(ldvsr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(max(1,8*n))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(a,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: a, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgges
      End Interface
      Interface
        Subroutine zggesx(jobvsl,jobvsr,sort,selctg,sense,n,a,lda,b,ldb,sdim, &
            alpha,beta,vsl,ldvsl,vsr,ldvsr,rconde,rcondv,work,lwork,rwork, &
            iwork,liwork,bwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, sdim
          Integer, Intent (In) :: lda, ldb, ldvsl, ldvsr, liwork, lwork, n
          Character (1), Intent (In) :: jobvsl, jobvsr, sense, sort
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), &
            vsl(ldvsl,*), vsr(ldvsr,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rconde(2), rcondv(2), &
            rwork(max(1,8*n))
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (Inout) :: bwork(*)
!         .. Interface Blocks ..
          Interface
            Function selctg(a,b)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: selctg
!             .. Scalar Arguments ..
              Complex (Kind=wp), Intent (In) :: a, b
            End Function selctg
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggesx
      End Interface
      Interface
        Subroutine zhgeqz(job,compq,compz,n,ilo,ihi,a,lda,b,ldb,alpha,beta,q, &
            ldq,z,ldz,work,lwork,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ihi, ilo, lda, ldb, ldq, ldz, lwork, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: compq, compz, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Out) :: rwork(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zhgeqz
      End Interface
      Interface
        Subroutine dtgsja(jobu,jobv,jobq,m,p,n,k,l,a,lda,b,ldb,tola,tolb, &
            alpha,beta,u,ldu,v,ldv,q,ldq,work,ncycle,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, ncycle
          Integer, Intent (In) :: k, l, lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n), work(2*n)
        End Subroutine dtgsja
      End Interface
      Interface
        Subroutine dtgexc(wantq,wantz,n,a,lda,b,ldb,q,ldq,z,ldz,ifst,ilst, &
            work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifst, ilst
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, ldq, ldz, lwork, n
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtgexc
      End Interface
      Interface
        Subroutine dtgsen(ijob,wantq,wantz,select,n,a,lda,b,ldb,alphar,alphai, &
            beta,q,ldq,z,ldz,m,pl,pr,dif,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pl, pr
          Integer, Intent (In) :: ijob, lda, ldb, ldq, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), dif(*), &
            q(ldq,*), z(ldz,*)
          Real (Kind=wp), Intent (Out) :: alphai(n), alphar(n), beta(n), &
            work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtgsen
      End Interface
      Interface
        Subroutine dtgsyl(trans,ijob,m,n,a,lda,b,ldb,c,ldc,d,ldd,e,lde,f,ldf, &
            scale,dif,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dif, scale
          Integer, Intent (In) :: ijob, lda, ldb, ldc, ldd, lde, ldf, lwork, &
            m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), d(ldd,*), &
            e(lde,*)
          Real (Kind=wp), Intent (Inout) :: c(ldc,*), f(ldf,*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(max(1,m+n+6))
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtgsyl
      End Interface
      Interface
        Subroutine dtgevc(side,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,mm, &
            m,work,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, side
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Real (Kind=wp), Intent (Out) :: work(6*n)
          Logical, Intent (In) :: select(*)
        End Subroutine dtgevc
      End Interface
      Interface
        Subroutine dtgsna(job,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,s, &
            dif,mm,m,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Real (Kind=wp), Intent (Inout) :: dif(*), s(*)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dtgsna
      End Interface
      Interface
        Subroutine ztgsja(jobu,jobv,jobq,m,p,n,k,l,a,lda,b,ldb,tola,tolb, &
            alpha,beta,u,ldu,v,ldv,q,ldq,work,ncycle,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: tola, tolb
          Integer, Intent (Out) :: info, ncycle
          Integer, Intent (In) :: k, l, lda, ldb, ldq, ldu, ldv, m, n, p
          Character (1), Intent (In) :: jobq, jobu, jobv
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            u(ldu,*), v(ldv,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: alpha(n), beta(n)
        End Subroutine ztgsja
      End Interface
      Interface
        Subroutine ztgexc(wantq,wantz,n,a,lda,b,ldb,q,ldq,z,ldz,ifst,ilst, &
            info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: ifst, lda, ldb, ldq, ldz, n
          Integer, Intent (Inout) :: ilst
          Integer, Intent (Out) :: info
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
        End Subroutine ztgexc
      End Interface
      Interface
        Subroutine ztgsen(ijob,wantq,wantz,select,n,a,lda,b,ldb,alpha,beta,q, &
            ldq,z,ldz,m,pl,pr,dif,work,lwork,iwork,liwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: pl, pr
          Integer, Intent (In) :: ijob, lda, ldb, ldq, ldz, liwork, lwork, n
          Integer, Intent (Out) :: info, m
          Logical, Intent (In) :: wantq, wantz
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), q(ldq,*), &
            z(ldz,*)
          Complex (Kind=wp), Intent (Out) :: alpha(n), beta(n), &
            work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: dif(*)
          Integer, Intent (Out) :: iwork(max(1,liwork))
          Logical, Intent (In) :: select(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine ztgsen
      End Interface
      Interface
        Subroutine ztgsyl(trans,ijob,m,n,a,lda,b,ldb,c,ldc,d,ldd,e,lde,f,ldf, &
            scale,dif,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: dif, scale
          Integer, Intent (In) :: ijob, lda, ldb, ldc, ldd, lde, ldf, lwork, &
            m, n
          Integer, Intent (Out) :: info
          Character (1), Intent (In) :: trans
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), d(ldd,*), &
            e(lde,*)
          Complex (Kind=wp), Intent (Inout) :: c(ldc,*), f(ldf,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Integer, Intent (Out) :: iwork(m+n+2)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine ztgsyl
      End Interface
      Interface
        Subroutine ztgevc(side,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,mm, &
            m,work,rwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, mm, n
          Character (1), Intent (In) :: howmny, side
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Inout) :: vl(ldvl,*), vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(2*n)
          Real (Kind=wp), Intent (Out) :: rwork(2*n)
          Logical, Intent (In) :: select(*)
        End Subroutine ztgevc
      End Interface
      Interface
        Subroutine ztgsna(job,howmny,select,n,a,lda,b,ldb,vl,ldvl,vr,ldvr,s, &
            dif,mm,m,work,lwork,iwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info, m
          Integer, Intent (In) :: lda, ldb, ldvl, ldvr, lwork, mm, n
          Character (1), Intent (In) :: howmny, job
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*), b(ldb,*), vl(ldvl,*), &
            vr(ldvr,*)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork))
          Real (Kind=wp), Intent (Inout) :: dif(*), s(*)
          Integer, Intent (Inout) :: iwork(*)
          Logical, Intent (In) :: select(*)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine ztgsna
      End Interface
      Interface
        Subroutine dgglse(m,n,p,a,lda,b,ldb,c,d,x,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), c(m), d(p)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dgglse
      End Interface
      Interface
        Subroutine dggglm(m,n,p,a,lda,b,ldb,d,x,y,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), d(m)
          Real (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n), y(p)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine dggglm
      End Interface
      Interface
        Subroutine dggqrf(n,m,p,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: taua(min(n,m)), taub(min(n,p)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine dggqrf
      End Interface
      Interface
        Subroutine dggrqf(m,p,n,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Real (Kind=wp), Intent (Out) :: taua(min(m,n)), taub(min(p,n)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine dggrqf
      End Interface
      Interface
        Subroutine zgglse(m,n,p,a,lda,b,ldb,c,d,x,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), c(m), d(p)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zgglse
      End Interface
      Interface
        Subroutine zggglm(m,n,p,a,lda,b,ldb,d,x,y,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*), d(m)
          Complex (Kind=wp), Intent (Out) :: work(max(1,lwork)), x(n), y(p)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine zggglm
      End Interface
      Interface
        Subroutine zggqrf(n,m,p,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: taua(min(n,m)), taub(min(n,p)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine zggqrf
      End Interface
      Interface
        Subroutine zggrqf(m,p,n,a,lda,taua,b,ldb,taub,work,lwork,info)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: info
          Integer, Intent (In) :: lda, ldb, lwork, m, n, p
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: a(lda,*), b(ldb,*)
          Complex (Kind=wp), Intent (Out) :: taua(min(m,n)), taub(min(p,n)), &
            work(max(1,lwork))
!         .. Intrinsic Procedures ..
          Intrinsic :: max, min
        End Subroutine zggrqf
      End Interface
    End Module nag_lapack_ib
